/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         nft_parse
#define yylex           nft_lex
#define yyerror         nft_error
#define yydebug         nft_debug
#define yynerrs         nft_nerrs

/* First part of user prologue.  */
#line 11 "parser_bison.y"


#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <syslog.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/if_ether.h>
#include <linux/netfilter.h>
#include <linux/netfilter/nf_tables.h>
#include <linux/netfilter/nf_conntrack_tuple_common.h>
#include <linux/netfilter/nf_nat.h>
#include <linux/netfilter/nf_log.h>
#include <linux/netfilter/nfnetlink_osf.h>
#include <linux/netfilter/nf_synproxy.h>
#include <linux/xfrm.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <libnftnl/common.h>
#include <libnftnl/set.h>
#include <libnftnl/udata.h>

#include <rule.h>
#include <statement.h>
#include <expression.h>
#include <headers.h>
#include <utils.h>
#include <parser.h>
#include <erec.h>
#include <sctp_chunk.h>

#include "parser_bison.h"

void parser_init(struct nft_ctx *nft, struct parser_state *state,
		 struct list_head *msgs, struct list_head *cmds,
		 struct scope *top_scope)
{
	memset(state, 0, sizeof(*state));
	state->msgs = msgs;
	state->cmds = cmds;
	state->scopes[0] = scope_init(top_scope, NULL);
	init_list_head(&state->indesc_list);
}

static void yyerror(struct location *loc, struct nft_ctx *nft, void *scanner,
		    struct parser_state *state, const char *s)
{
	erec_queue(error(loc, "%s", s), state->msgs);
}

static struct scope *current_scope(const struct parser_state *state)
{
	return state->scopes[state->scope];
}

static void open_scope(struct parser_state *state, struct scope *scope)
{
	assert(state->scope < array_size(state->scopes) - 1);
	scope_init(scope, current_scope(state));
	state->scopes[++state->scope] = scope;
}

static void close_scope(struct parser_state *state)
{
	assert(state->scope > 0);
	state->scope--;
}

static void location_init(void *scanner, struct parser_state *state,
			  struct location *loc)
{
	memset(loc, 0, sizeof(*loc));
	loc->indesc = state->indesc;
}

static void location_update(struct location *loc, struct location *rhs, int n)
{
	if (n) {
		loc->indesc       = rhs[n].indesc;
		loc->token_offset = rhs[1].token_offset;
		loc->line_offset  = rhs[1].line_offset;
		loc->first_line   = rhs[1].first_line;
		loc->first_column = rhs[1].first_column;
		loc->last_line    = rhs[n].last_line;
		loc->last_column  = rhs[n].last_column;
	} else {
		loc->indesc       = rhs[0].indesc;
		loc->token_offset = rhs[0].token_offset;
		loc->line_offset  = rhs[0].line_offset;
		loc->first_line   = loc->last_line   = rhs[0].last_line;
		loc->first_column = loc->last_column = rhs[0].last_column;
	}
}

static struct expr *handle_concat_expr(const struct location *loc,
					 struct expr *expr,
					 struct expr *expr_l, struct expr *expr_r,
					 struct location loc_rhs[3])
{
	if (expr->etype != EXPR_CONCAT) {
		expr = concat_expr_alloc(loc);
		compound_expr_add(expr, expr_l);
	} else {
		location_update(&expr_r->location, loc_rhs, 2);

		expr = expr_l;
		expr->location = *loc;
	}

	compound_expr_add(expr, expr_r);
	return expr;
}

static bool already_set(const void *attr, const struct location *loc,
			struct parser_state *state)
{
	if (!attr)
		return false;

	erec_queue(error(loc, "You can only specify this once. This statement is duplicated."),
		   state->msgs);
	return true;
}

#define YYLLOC_DEFAULT(Current, Rhs, N)	location_update(&Current, Rhs, N)

#define symbol_value(loc, str) \
	symbol_expr_alloc(loc, SYMBOL_VALUE, current_scope(state), str)

/* Declare those here to avoid compiler warnings */
void nft_set_debug(int, void *);
int nft_lex(void *, void *, void *);

#line 212 "parser_bison.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_NFT_PARSER_BISON_H_INCLUDED
# define YY_NFT_PARSER_BISON_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int nft_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    TOKEN_EOF = 0,                 /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    JUNK = 258,                    /* "junk"  */
    NEWLINE = 259,                 /* "newline"  */
    COLON = 260,                   /* "colon"  */
    SEMICOLON = 261,               /* "semicolon"  */
    COMMA = 262,                   /* "comma"  */
    DOT = 263,                     /* "."  */
    EQ = 264,                      /* "=="  */
    NEQ = 265,                     /* "!="  */
    LT = 266,                      /* "<"  */
    GT = 267,                      /* ">"  */
    GTE = 268,                     /* ">="  */
    LTE = 269,                     /* "<="  */
    LSHIFT = 270,                  /* "<<"  */
    RSHIFT = 271,                  /* ">>"  */
    AMPERSAND = 272,               /* "&"  */
    CARET = 273,                   /* "^"  */
    NOT = 274,                     /* "!"  */
    SLASH = 275,                   /* "/"  */
    ASTERISK = 276,                /* "*"  */
    DASH = 277,                    /* "-"  */
    AT = 278,                      /* "@"  */
    VMAP = 279,                    /* "vmap"  */
    PLUS = 280,                    /* "+"  */
    INCLUDE = 281,                 /* "include"  */
    DEFINE = 282,                  /* "define"  */
    REDEFINE = 283,                /* "redefine"  */
    UNDEFINE = 284,                /* "undefine"  */
    FIB = 285,                     /* "fib"  */
    SOCKET = 286,                  /* "socket"  */
    TRANSPARENT = 287,             /* "transparent"  */
    WILDCARD = 288,                /* "wildcard"  */
    CGROUPV2 = 289,                /* "cgroupv2"  */
    TPROXY = 290,                  /* "tproxy"  */
    OSF = 291,                     /* "osf"  */
    SYNPROXY = 292,                /* "synproxy"  */
    MSS = 293,                     /* "mss"  */
    WSCALE = 294,                  /* "wscale"  */
    TYPEOF = 295,                  /* "typeof"  */
    HOOK = 296,                    /* "hook"  */
    HOOKS = 297,                   /* "hooks"  */
    DEVICE = 298,                  /* "device"  */
    DEVICES = 299,                 /* "devices"  */
    TABLE = 300,                   /* "table"  */
    TABLES = 301,                  /* "tables"  */
    CHAIN = 302,                   /* "chain"  */
    CHAINS = 303,                  /* "chains"  */
    RULE = 304,                    /* "rule"  */
    RULES = 305,                   /* "rules"  */
    SETS = 306,                    /* "sets"  */
    SET = 307,                     /* "set"  */
    ELEMENT = 308,                 /* "element"  */
    MAP = 309,                     /* "map"  */
    MAPS = 310,                    /* "maps"  */
    FLOWTABLE = 311,               /* "flowtable"  */
    HANDLE = 312,                  /* "handle"  */
    RULESET = 313,                 /* "ruleset"  */
    TRACE = 314,                   /* "trace"  */
    INET = 315,                    /* "inet"  */
    NETDEV = 316,                  /* "netdev"  */
    ADD = 317,                     /* "add"  */
    UPDATE = 318,                  /* "update"  */
    REPLACE = 319,                 /* "replace"  */
    CREATE = 320,                  /* "create"  */
    INSERT = 321,                  /* "insert"  */
    DELETE = 322,                  /* "delete"  */
    GET = 323,                     /* "get"  */
    LIST = 324,                    /* "list"  */
    RESET = 325,                   /* "reset"  */
    FLUSH = 326,                   /* "flush"  */
    RENAME = 327,                  /* "rename"  */
    DESCRIBE = 328,                /* "describe"  */
    IMPORT = 329,                  /* "import"  */
    EXPORT = 330,                  /* "export"  */
    MONITOR = 331,                 /* "monitor"  */
    ALL = 332,                     /* "all"  */
    ACCEPT = 333,                  /* "accept"  */
    DROP = 334,                    /* "drop"  */
    CONTINUE = 335,                /* "continue"  */
    JUMP = 336,                    /* "jump"  */
    GOTO = 337,                    /* "goto"  */
    RETURN = 338,                  /* "return"  */
    TO = 339,                      /* "to"  */
    CONSTANT = 340,                /* "constant"  */
    INTERVAL = 341,                /* "interval"  */
    DYNAMIC = 342,                 /* "dynamic"  */
    AUTOMERGE = 343,               /* "auto-merge"  */
    TIMEOUT = 344,                 /* "timeout"  */
    GC_INTERVAL = 345,             /* "gc-interval"  */
    ELEMENTS = 346,                /* "elements"  */
    EXPIRES = 347,                 /* "expires"  */
    POLICY = 348,                  /* "policy"  */
    MEMORY = 349,                  /* "memory"  */
    PERFORMANCE = 350,             /* "performance"  */
    SIZE = 351,                    /* "size"  */
    FLOW = 352,                    /* "flow"  */
    OFFLOAD = 353,                 /* "offload"  */
    METER = 354,                   /* "meter"  */
    METERS = 355,                  /* "meters"  */
    FLOWTABLES = 356,              /* "flowtables"  */
    NUM = 357,                     /* "number"  */
    STRING = 358,                  /* "string"  */
    QUOTED_STRING = 359,           /* "quoted string"  */
    ASTERISK_STRING = 360,         /* "string with a trailing asterisk"  */
    LL_HDR = 361,                  /* "ll"  */
    NETWORK_HDR = 362,             /* "nh"  */
    TRANSPORT_HDR = 363,           /* "th"  */
    BRIDGE = 364,                  /* "bridge"  */
    ETHER = 365,                   /* "ether"  */
    SADDR = 366,                   /* "saddr"  */
    DADDR = 367,                   /* "daddr"  */
    TYPE = 368,                    /* "type"  */
    VLAN = 369,                    /* "vlan"  */
    ID = 370,                      /* "id"  */
    CFI = 371,                     /* "cfi"  */
    DEI = 372,                     /* "dei"  */
    PCP = 373,                     /* "pcp"  */
    ARP = 374,                     /* "arp"  */
    HTYPE = 375,                   /* "htype"  */
    PTYPE = 376,                   /* "ptype"  */
    HLEN = 377,                    /* "hlen"  */
    PLEN = 378,                    /* "plen"  */
    OPERATION = 379,               /* "operation"  */
    IP = 380,                      /* "ip"  */
    HDRVERSION = 381,              /* "version"  */
    HDRLENGTH = 382,               /* "hdrlength"  */
    DSCP = 383,                    /* "dscp"  */
    ECN = 384,                     /* "ecn"  */
    LENGTH = 385,                  /* "length"  */
    FRAG_OFF = 386,                /* "frag-off"  */
    TTL = 387,                     /* "ttl"  */
    PROTOCOL = 388,                /* "protocol"  */
    CHECKSUM = 389,                /* "checksum"  */
    PTR = 390,                     /* "ptr"  */
    VALUE = 391,                   /* "value"  */
    LSRR = 392,                    /* "lsrr"  */
    RR = 393,                      /* "rr"  */
    SSRR = 394,                    /* "ssrr"  */
    RA = 395,                      /* "ra"  */
    ICMP = 396,                    /* "icmp"  */
    CODE = 397,                    /* "code"  */
    SEQUENCE = 398,                /* "seq"  */
    GATEWAY = 399,                 /* "gateway"  */
    MTU = 400,                     /* "mtu"  */
    IGMP = 401,                    /* "igmp"  */
    MRT = 402,                     /* "mrt"  */
    OPTIONS = 403,                 /* "options"  */
    IP6 = 404,                     /* "ip6"  */
    PRIORITY = 405,                /* "priority"  */
    FLOWLABEL = 406,               /* "flowlabel"  */
    NEXTHDR = 407,                 /* "nexthdr"  */
    HOPLIMIT = 408,                /* "hoplimit"  */
    ICMP6 = 409,                   /* "icmpv6"  */
    PPTR = 410,                    /* "param-problem"  */
    MAXDELAY = 411,                /* "max-delay"  */
    AH = 412,                      /* "ah"  */
    RESERVED = 413,                /* "reserved"  */
    SPI = 414,                     /* "spi"  */
    ESP = 415,                     /* "esp"  */
    COMP = 416,                    /* "comp"  */
    FLAGS = 417,                   /* "flags"  */
    CPI = 418,                     /* "cpi"  */
    PORT = 419,                    /* "port"  */
    UDP = 420,                     /* "udp"  */
    SPORT = 421,                   /* "sport"  */
    DPORT = 422,                   /* "dport"  */
    UDPLITE = 423,                 /* "udplite"  */
    CSUMCOV = 424,                 /* "csumcov"  */
    TCP = 425,                     /* "tcp"  */
    ACKSEQ = 426,                  /* "ackseq"  */
    DOFF = 427,                    /* "doff"  */
    WINDOW = 428,                  /* "window"  */
    URGPTR = 429,                  /* "urgptr"  */
    OPTION = 430,                  /* "option"  */
    ECHO = 431,                    /* "echo"  */
    EOL = 432,                     /* "eol"  */
    NOP = 433,                     /* "nop"  */
    SACK = 434,                    /* "sack"  */
    SACK0 = 435,                   /* "sack0"  */
    SACK1 = 436,                   /* "sack1"  */
    SACK2 = 437,                   /* "sack2"  */
    SACK3 = 438,                   /* "sack3"  */
    SACK_PERM = 439,               /* "sack-permitted"  */
    TIMESTAMP = 440,               /* "timestamp"  */
    KIND = 441,                    /* "kind"  */
    COUNT = 442,                   /* "count"  */
    LEFT = 443,                    /* "left"  */
    RIGHT = 444,                   /* "right"  */
    TSVAL = 445,                   /* "tsval"  */
    TSECR = 446,                   /* "tsecr"  */
    DCCP = 447,                    /* "dccp"  */
    SCTP = 448,                    /* "sctp"  */
    CHUNK = 449,                   /* "chunk"  */
    DATA = 450,                    /* "data"  */
    INIT = 451,                    /* "init"  */
    INIT_ACK = 452,                /* "init-ack"  */
    HEARTBEAT = 453,               /* "heartbeat"  */
    HEARTBEAT_ACK = 454,           /* "heartbeat-ack"  */
    ABORT = 455,                   /* "abort"  */
    SHUTDOWN = 456,                /* "shutdown"  */
    SHUTDOWN_ACK = 457,            /* "shutdown-ack"  */
    ERROR = 458,                   /* "error"  */
    COOKIE_ECHO = 459,             /* "cookie-echo"  */
    COOKIE_ACK = 460,              /* "cookie-ack"  */
    ECNE = 461,                    /* "ecne"  */
    CWR = 462,                     /* "cwr"  */
    SHUTDOWN_COMPLETE = 463,       /* "shutdown-complete"  */
    ASCONF_ACK = 464,              /* "asconf-ack"  */
    FORWARD_TSN = 465,             /* "forward-tsn"  */
    ASCONF = 466,                  /* "asconf"  */
    TSN = 467,                     /* "tsn"  */
    STREAM = 468,                  /* "stream"  */
    SSN = 469,                     /* "ssn"  */
    PPID = 470,                    /* "ppid"  */
    INIT_TAG = 471,                /* "init-tag"  */
    A_RWND = 472,                  /* "a-rwnd"  */
    NUM_OSTREAMS = 473,            /* "num-outbound-streams"  */
    NUM_ISTREAMS = 474,            /* "num-inbound-streams"  */
    INIT_TSN = 475,                /* "initial-tsn"  */
    CUM_TSN_ACK = 476,             /* "cum-tsn-ack"  */
    NUM_GACK_BLOCKS = 477,         /* "num-gap-ack-blocks"  */
    NUM_DUP_TSNS = 478,            /* "num-dup-tsns"  */
    LOWEST_TSN = 479,              /* "lowest-tsn"  */
    SEQNO = 480,                   /* "seqno"  */
    NEW_CUM_TSN = 481,             /* "new-cum-tsn"  */
    VTAG = 482,                    /* "vtag"  */
    RT = 483,                      /* "rt"  */
    RT0 = 484,                     /* "rt0"  */
    RT2 = 485,                     /* "rt2"  */
    RT4 = 486,                     /* "srh"  */
    SEG_LEFT = 487,                /* "seg-left"  */
    ADDR = 488,                    /* "addr"  */
    LAST_ENT = 489,                /* "last-entry"  */
    TAG = 490,                     /* "tag"  */
    SID = 491,                     /* "sid"  */
    HBH = 492,                     /* "hbh"  */
    FRAG = 493,                    /* "frag"  */
    RESERVED2 = 494,               /* "reserved2"  */
    MORE_FRAGMENTS = 495,          /* "more-fragments"  */
    DST = 496,                     /* "dst"  */
    MH = 497,                      /* "mh"  */
    META = 498,                    /* "meta"  */
    MARK = 499,                    /* "mark"  */
    IIF = 500,                     /* "iif"  */
    IIFNAME = 501,                 /* "iifname"  */
    IIFTYPE = 502,                 /* "iiftype"  */
    OIF = 503,                     /* "oif"  */
    OIFNAME = 504,                 /* "oifname"  */
    OIFTYPE = 505,                 /* "oiftype"  */
    SKUID = 506,                   /* "skuid"  */
    SKGID = 507,                   /* "skgid"  */
    NFTRACE = 508,                 /* "nftrace"  */
    RTCLASSID = 509,               /* "rtclassid"  */
    IBRIPORT = 510,                /* "ibriport"  */
    OBRIPORT = 511,                /* "obriport"  */
    IBRIDGENAME = 512,             /* "ibrname"  */
    OBRIDGENAME = 513,             /* "obrname"  */
    PKTTYPE = 514,                 /* "pkttype"  */
    CPU = 515,                     /* "cpu"  */
    IIFGROUP = 516,                /* "iifgroup"  */
    OIFGROUP = 517,                /* "oifgroup"  */
    CGROUP = 518,                  /* "cgroup"  */
    TIME = 519,                    /* "time"  */
    CLASSID = 520,                 /* "classid"  */
    NEXTHOP = 521,                 /* "nexthop"  */
    CT = 522,                      /* "ct"  */
    L3PROTOCOL = 523,              /* "l3proto"  */
    PROTO_SRC = 524,               /* "proto-src"  */
    PROTO_DST = 525,               /* "proto-dst"  */
    ZONE = 526,                    /* "zone"  */
    DIRECTION = 527,               /* "direction"  */
    EVENT = 528,                   /* "event"  */
    EXPECTATION = 529,             /* "expectation"  */
    EXPIRATION = 530,              /* "expiration"  */
    HELPER = 531,                  /* "helper"  */
    LABEL = 532,                   /* "label"  */
    STATE = 533,                   /* "state"  */
    STATUS = 534,                  /* "status"  */
    ORIGINAL = 535,                /* "original"  */
    REPLY = 536,                   /* "reply"  */
    COUNTER = 537,                 /* "counter"  */
    NAME = 538,                    /* "name"  */
    PACKETS = 539,                 /* "packets"  */
    BYTES = 540,                   /* "bytes"  */
    AVGPKT = 541,                  /* "avgpkt"  */
    COUNTERS = 542,                /* "counters"  */
    QUOTAS = 543,                  /* "quotas"  */
    LIMITS = 544,                  /* "limits"  */
    SYNPROXYS = 545,               /* "synproxys"  */
    HELPERS = 546,                 /* "helpers"  */
    LOG = 547,                     /* "log"  */
    PREFIX = 548,                  /* "prefix"  */
    GROUP = 549,                   /* "group"  */
    SNAPLEN = 550,                 /* "snaplen"  */
    QUEUE_THRESHOLD = 551,         /* "queue-threshold"  */
    LEVEL = 552,                   /* "level"  */
    LIMIT = 553,                   /* "limit"  */
    RATE = 554,                    /* "rate"  */
    BURST = 555,                   /* "burst"  */
    OVER = 556,                    /* "over"  */
    UNTIL = 557,                   /* "until"  */
    QUOTA = 558,                   /* "quota"  */
    USED = 559,                    /* "used"  */
    SECMARK = 560,                 /* "secmark"  */
    SECMARKS = 561,                /* "secmarks"  */
    SECOND = 562,                  /* "second"  */
    MINUTE = 563,                  /* "minute"  */
    HOUR = 564,                    /* "hour"  */
    DAY = 565,                     /* "day"  */
    WEEK = 566,                    /* "week"  */
    _REJECT = 567,                 /* "reject"  */
    WITH = 568,                    /* "with"  */
    ICMPX = 569,                   /* "icmpx"  */
    SNAT = 570,                    /* "snat"  */
    DNAT = 571,                    /* "dnat"  */
    MASQUERADE = 572,              /* "masquerade"  */
    REDIRECT = 573,                /* "redirect"  */
    RANDOM = 574,                  /* "random"  */
    FULLY_RANDOM = 575,            /* "fully-random"  */
    PERSISTENT = 576,              /* "persistent"  */
    QUEUE = 577,                   /* "queue"  */
    QUEUENUM = 578,                /* "num"  */
    BYPASS = 579,                  /* "bypass"  */
    FANOUT = 580,                  /* "fanout"  */
    DUP = 581,                     /* "dup"  */
    FWD = 582,                     /* "fwd"  */
    NUMGEN = 583,                  /* "numgen"  */
    INC = 584,                     /* "inc"  */
    MOD = 585,                     /* "mod"  */
    OFFSET = 586,                  /* "offset"  */
    JHASH = 587,                   /* "jhash"  */
    SYMHASH = 588,                 /* "symhash"  */
    SEED = 589,                    /* "seed"  */
    POSITION = 590,                /* "position"  */
    INDEX = 591,                   /* "index"  */
    COMMENT = 592,                 /* "comment"  */
    XML = 593,                     /* "xml"  */
    JSON = 594,                    /* "json"  */
    VM = 595,                      /* "vm"  */
    NOTRACK = 596,                 /* "notrack"  */
    EXISTS = 597,                  /* "exists"  */
    MISSING = 598,                 /* "missing"  */
    EXTHDR = 599,                  /* "exthdr"  */
    IPSEC = 600,                   /* "ipsec"  */
    REQID = 601,                   /* "reqid"  */
    SPNUM = 602,                   /* "spnum"  */
    IN = 603,                      /* "in"  */
    OUT = 604                      /* "out"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define TOKEN_EOF 0
#define YYerror 256
#define YYUNDEF 257
#define JUNK 258
#define NEWLINE 259
#define COLON 260
#define SEMICOLON 261
#define COMMA 262
#define DOT 263
#define EQ 264
#define NEQ 265
#define LT 266
#define GT 267
#define GTE 268
#define LTE 269
#define LSHIFT 270
#define RSHIFT 271
#define AMPERSAND 272
#define CARET 273
#define NOT 274
#define SLASH 275
#define ASTERISK 276
#define DASH 277
#define AT 278
#define VMAP 279
#define PLUS 280
#define INCLUDE 281
#define DEFINE 282
#define REDEFINE 283
#define UNDEFINE 284
#define FIB 285
#define SOCKET 286
#define TRANSPARENT 287
#define WILDCARD 288
#define CGROUPV2 289
#define TPROXY 290
#define OSF 291
#define SYNPROXY 292
#define MSS 293
#define WSCALE 294
#define TYPEOF 295
#define HOOK 296
#define HOOKS 297
#define DEVICE 298
#define DEVICES 299
#define TABLE 300
#define TABLES 301
#define CHAIN 302
#define CHAINS 303
#define RULE 304
#define RULES 305
#define SETS 306
#define SET 307
#define ELEMENT 308
#define MAP 309
#define MAPS 310
#define FLOWTABLE 311
#define HANDLE 312
#define RULESET 313
#define TRACE 314
#define INET 315
#define NETDEV 316
#define ADD 317
#define UPDATE 318
#define REPLACE 319
#define CREATE 320
#define INSERT 321
#define DELETE 322
#define GET 323
#define LIST 324
#define RESET 325
#define FLUSH 326
#define RENAME 327
#define DESCRIBE 328
#define IMPORT 329
#define EXPORT 330
#define MONITOR 331
#define ALL 332
#define ACCEPT 333
#define DROP 334
#define CONTINUE 335
#define JUMP 336
#define GOTO 337
#define RETURN 338
#define TO 339
#define CONSTANT 340
#define INTERVAL 341
#define DYNAMIC 342
#define AUTOMERGE 343
#define TIMEOUT 344
#define GC_INTERVAL 345
#define ELEMENTS 346
#define EXPIRES 347
#define POLICY 348
#define MEMORY 349
#define PERFORMANCE 350
#define SIZE 351
#define FLOW 352
#define OFFLOAD 353
#define METER 354
#define METERS 355
#define FLOWTABLES 356
#define NUM 357
#define STRING 358
#define QUOTED_STRING 359
#define ASTERISK_STRING 360
#define LL_HDR 361
#define NETWORK_HDR 362
#define TRANSPORT_HDR 363
#define BRIDGE 364
#define ETHER 365
#define SADDR 366
#define DADDR 367
#define TYPE 368
#define VLAN 369
#define ID 370
#define CFI 371
#define DEI 372
#define PCP 373
#define ARP 374
#define HTYPE 375
#define PTYPE 376
#define HLEN 377
#define PLEN 378
#define OPERATION 379
#define IP 380
#define HDRVERSION 381
#define HDRLENGTH 382
#define DSCP 383
#define ECN 384
#define LENGTH 385
#define FRAG_OFF 386
#define TTL 387
#define PROTOCOL 388
#define CHECKSUM 389
#define PTR 390
#define VALUE 391
#define LSRR 392
#define RR 393
#define SSRR 394
#define RA 395
#define ICMP 396
#define CODE 397
#define SEQUENCE 398
#define GATEWAY 399
#define MTU 400
#define IGMP 401
#define MRT 402
#define OPTIONS 403
#define IP6 404
#define PRIORITY 405
#define FLOWLABEL 406
#define NEXTHDR 407
#define HOPLIMIT 408
#define ICMP6 409
#define PPTR 410
#define MAXDELAY 411
#define AH 412
#define RESERVED 413
#define SPI 414
#define ESP 415
#define COMP 416
#define FLAGS 417
#define CPI 418
#define PORT 419
#define UDP 420
#define SPORT 421
#define DPORT 422
#define UDPLITE 423
#define CSUMCOV 424
#define TCP 425
#define ACKSEQ 426
#define DOFF 427
#define WINDOW 428
#define URGPTR 429
#define OPTION 430
#define ECHO 431
#define EOL 432
#define NOP 433
#define SACK 434
#define SACK0 435
#define SACK1 436
#define SACK2 437
#define SACK3 438
#define SACK_PERM 439
#define TIMESTAMP 440
#define KIND 441
#define COUNT 442
#define LEFT 443
#define RIGHT 444
#define TSVAL 445
#define TSECR 446
#define DCCP 447
#define SCTP 448
#define CHUNK 449
#define DATA 450
#define INIT 451
#define INIT_ACK 452
#define HEARTBEAT 453
#define HEARTBEAT_ACK 454
#define ABORT 455
#define SHUTDOWN 456
#define SHUTDOWN_ACK 457
#define ERROR 458
#define COOKIE_ECHO 459
#define COOKIE_ACK 460
#define ECNE 461
#define CWR 462
#define SHUTDOWN_COMPLETE 463
#define ASCONF_ACK 464
#define FORWARD_TSN 465
#define ASCONF 466
#define TSN 467
#define STREAM 468
#define SSN 469
#define PPID 470
#define INIT_TAG 471
#define A_RWND 472
#define NUM_OSTREAMS 473
#define NUM_ISTREAMS 474
#define INIT_TSN 475
#define CUM_TSN_ACK 476
#define NUM_GACK_BLOCKS 477
#define NUM_DUP_TSNS 478
#define LOWEST_TSN 479
#define SEQNO 480
#define NEW_CUM_TSN 481
#define VTAG 482
#define RT 483
#define RT0 484
#define RT2 485
#define RT4 486
#define SEG_LEFT 487
#define ADDR 488
#define LAST_ENT 489
#define TAG 490
#define SID 491
#define HBH 492
#define FRAG 493
#define RESERVED2 494
#define MORE_FRAGMENTS 495
#define DST 496
#define MH 497
#define META 498
#define MARK 499
#define IIF 500
#define IIFNAME 501
#define IIFTYPE 502
#define OIF 503
#define OIFNAME 504
#define OIFTYPE 505
#define SKUID 506
#define SKGID 507
#define NFTRACE 508
#define RTCLASSID 509
#define IBRIPORT 510
#define OBRIPORT 511
#define IBRIDGENAME 512
#define OBRIDGENAME 513
#define PKTTYPE 514
#define CPU 515
#define IIFGROUP 516
#define OIFGROUP 517
#define CGROUP 518
#define TIME 519
#define CLASSID 520
#define NEXTHOP 521
#define CT 522
#define L3PROTOCOL 523
#define PROTO_SRC 524
#define PROTO_DST 525
#define ZONE 526
#define DIRECTION 527
#define EVENT 528
#define EXPECTATION 529
#define EXPIRATION 530
#define HELPER 531
#define LABEL 532
#define STATE 533
#define STATUS 534
#define ORIGINAL 535
#define REPLY 536
#define COUNTER 537
#define NAME 538
#define PACKETS 539
#define BYTES 540
#define AVGPKT 541
#define COUNTERS 542
#define QUOTAS 543
#define LIMITS 544
#define SYNPROXYS 545
#define HELPERS 546
#define LOG 547
#define PREFIX 548
#define GROUP 549
#define SNAPLEN 550
#define QUEUE_THRESHOLD 551
#define LEVEL 552
#define LIMIT 553
#define RATE 554
#define BURST 555
#define OVER 556
#define UNTIL 557
#define QUOTA 558
#define USED 559
#define SECMARK 560
#define SECMARKS 561
#define SECOND 562
#define MINUTE 563
#define HOUR 564
#define DAY 565
#define WEEK 566
#define _REJECT 567
#define WITH 568
#define ICMPX 569
#define SNAT 570
#define DNAT 571
#define MASQUERADE 572
#define REDIRECT 573
#define RANDOM 574
#define FULLY_RANDOM 575
#define PERSISTENT 576
#define QUEUE 577
#define QUEUENUM 578
#define BYPASS 579
#define FANOUT 580
#define DUP 581
#define FWD 582
#define NUMGEN 583
#define INC 584
#define MOD 585
#define OFFSET 586
#define JHASH 587
#define SYMHASH 588
#define SEED 589
#define POSITION 590
#define INDEX 591
#define COMMENT 592
#define XML 593
#define JSON 594
#define VM 595
#define NOTRACK 596
#define EXISTS 597
#define MISSING 598
#define EXTHDR 599
#define IPSEC 600
#define REQID 601
#define SPNUM 602
#define IN 603
#define OUT 604

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 167 "parser_bison.y"

	uint64_t		val;
	uint32_t		val32;
	uint8_t			val8;
	const char *		string;

	struct list_head	*list;
	struct cmd		*cmd;
	struct handle		handle;
	struct table		*table;
	struct chain		*chain;
	struct rule		*rule;
	struct stmt		*stmt;
	struct expr		*expr;
	struct set		*set;
	struct obj		*obj;
	struct flowtable	*flowtable;
	struct ct		*ct;
	const struct datatype	*datatype;
	struct handle_spec	handle_spec;
	struct position_spec	position_spec;
	struct prio_spec	prio_spec;

#line 987 "parser_bison.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif




int nft_parse (struct nft_ctx *nft, void *scanner, struct parser_state *state);


#endif /* !YY_NFT_PARSER_BISON_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_JUNK = 3,                       /* "junk"  */
  YYSYMBOL_NEWLINE = 4,                    /* "newline"  */
  YYSYMBOL_COLON = 5,                      /* "colon"  */
  YYSYMBOL_SEMICOLON = 6,                  /* "semicolon"  */
  YYSYMBOL_COMMA = 7,                      /* "comma"  */
  YYSYMBOL_DOT = 8,                        /* "."  */
  YYSYMBOL_EQ = 9,                         /* "=="  */
  YYSYMBOL_NEQ = 10,                       /* "!="  */
  YYSYMBOL_LT = 11,                        /* "<"  */
  YYSYMBOL_GT = 12,                        /* ">"  */
  YYSYMBOL_GTE = 13,                       /* ">="  */
  YYSYMBOL_LTE = 14,                       /* "<="  */
  YYSYMBOL_LSHIFT = 15,                    /* "<<"  */
  YYSYMBOL_RSHIFT = 16,                    /* ">>"  */
  YYSYMBOL_AMPERSAND = 17,                 /* "&"  */
  YYSYMBOL_CARET = 18,                     /* "^"  */
  YYSYMBOL_NOT = 19,                       /* "!"  */
  YYSYMBOL_SLASH = 20,                     /* "/"  */
  YYSYMBOL_ASTERISK = 21,                  /* "*"  */
  YYSYMBOL_DASH = 22,                      /* "-"  */
  YYSYMBOL_AT = 23,                        /* "@"  */
  YYSYMBOL_VMAP = 24,                      /* "vmap"  */
  YYSYMBOL_PLUS = 25,                      /* "+"  */
  YYSYMBOL_INCLUDE = 26,                   /* "include"  */
  YYSYMBOL_DEFINE = 27,                    /* "define"  */
  YYSYMBOL_REDEFINE = 28,                  /* "redefine"  */
  YYSYMBOL_UNDEFINE = 29,                  /* "undefine"  */
  YYSYMBOL_FIB = 30,                       /* "fib"  */
  YYSYMBOL_SOCKET = 31,                    /* "socket"  */
  YYSYMBOL_TRANSPARENT = 32,               /* "transparent"  */
  YYSYMBOL_WILDCARD = 33,                  /* "wildcard"  */
  YYSYMBOL_CGROUPV2 = 34,                  /* "cgroupv2"  */
  YYSYMBOL_TPROXY = 35,                    /* "tproxy"  */
  YYSYMBOL_OSF = 36,                       /* "osf"  */
  YYSYMBOL_SYNPROXY = 37,                  /* "synproxy"  */
  YYSYMBOL_MSS = 38,                       /* "mss"  */
  YYSYMBOL_WSCALE = 39,                    /* "wscale"  */
  YYSYMBOL_TYPEOF = 40,                    /* "typeof"  */
  YYSYMBOL_HOOK = 41,                      /* "hook"  */
  YYSYMBOL_HOOKS = 42,                     /* "hooks"  */
  YYSYMBOL_DEVICE = 43,                    /* "device"  */
  YYSYMBOL_DEVICES = 44,                   /* "devices"  */
  YYSYMBOL_TABLE = 45,                     /* "table"  */
  YYSYMBOL_TABLES = 46,                    /* "tables"  */
  YYSYMBOL_CHAIN = 47,                     /* "chain"  */
  YYSYMBOL_CHAINS = 48,                    /* "chains"  */
  YYSYMBOL_RULE = 49,                      /* "rule"  */
  YYSYMBOL_RULES = 50,                     /* "rules"  */
  YYSYMBOL_SETS = 51,                      /* "sets"  */
  YYSYMBOL_SET = 52,                       /* "set"  */
  YYSYMBOL_ELEMENT = 53,                   /* "element"  */
  YYSYMBOL_MAP = 54,                       /* "map"  */
  YYSYMBOL_MAPS = 55,                      /* "maps"  */
  YYSYMBOL_FLOWTABLE = 56,                 /* "flowtable"  */
  YYSYMBOL_HANDLE = 57,                    /* "handle"  */
  YYSYMBOL_RULESET = 58,                   /* "ruleset"  */
  YYSYMBOL_TRACE = 59,                     /* "trace"  */
  YYSYMBOL_INET = 60,                      /* "inet"  */
  YYSYMBOL_NETDEV = 61,                    /* "netdev"  */
  YYSYMBOL_ADD = 62,                       /* "add"  */
  YYSYMBOL_UPDATE = 63,                    /* "update"  */
  YYSYMBOL_REPLACE = 64,                   /* "replace"  */
  YYSYMBOL_CREATE = 65,                    /* "create"  */
  YYSYMBOL_INSERT = 66,                    /* "insert"  */
  YYSYMBOL_DELETE = 67,                    /* "delete"  */
  YYSYMBOL_GET = 68,                       /* "get"  */
  YYSYMBOL_LIST = 69,                      /* "list"  */
  YYSYMBOL_RESET = 70,                     /* "reset"  */
  YYSYMBOL_FLUSH = 71,                     /* "flush"  */
  YYSYMBOL_RENAME = 72,                    /* "rename"  */
  YYSYMBOL_DESCRIBE = 73,                  /* "describe"  */
  YYSYMBOL_IMPORT = 74,                    /* "import"  */
  YYSYMBOL_EXPORT = 75,                    /* "export"  */
  YYSYMBOL_MONITOR = 76,                   /* "monitor"  */
  YYSYMBOL_ALL = 77,                       /* "all"  */
  YYSYMBOL_ACCEPT = 78,                    /* "accept"  */
  YYSYMBOL_DROP = 79,                      /* "drop"  */
  YYSYMBOL_CONTINUE = 80,                  /* "continue"  */
  YYSYMBOL_JUMP = 81,                      /* "jump"  */
  YYSYMBOL_GOTO = 82,                      /* "goto"  */
  YYSYMBOL_RETURN = 83,                    /* "return"  */
  YYSYMBOL_TO = 84,                        /* "to"  */
  YYSYMBOL_CONSTANT = 85,                  /* "constant"  */
  YYSYMBOL_INTERVAL = 86,                  /* "interval"  */
  YYSYMBOL_DYNAMIC = 87,                   /* "dynamic"  */
  YYSYMBOL_AUTOMERGE = 88,                 /* "auto-merge"  */
  YYSYMBOL_TIMEOUT = 89,                   /* "timeout"  */
  YYSYMBOL_GC_INTERVAL = 90,               /* "gc-interval"  */
  YYSYMBOL_ELEMENTS = 91,                  /* "elements"  */
  YYSYMBOL_EXPIRES = 92,                   /* "expires"  */
  YYSYMBOL_POLICY = 93,                    /* "policy"  */
  YYSYMBOL_MEMORY = 94,                    /* "memory"  */
  YYSYMBOL_PERFORMANCE = 95,               /* "performance"  */
  YYSYMBOL_SIZE = 96,                      /* "size"  */
  YYSYMBOL_FLOW = 97,                      /* "flow"  */
  YYSYMBOL_OFFLOAD = 98,                   /* "offload"  */
  YYSYMBOL_METER = 99,                     /* "meter"  */
  YYSYMBOL_METERS = 100,                   /* "meters"  */
  YYSYMBOL_FLOWTABLES = 101,               /* "flowtables"  */
  YYSYMBOL_NUM = 102,                      /* "number"  */
  YYSYMBOL_STRING = 103,                   /* "string"  */
  YYSYMBOL_QUOTED_STRING = 104,            /* "quoted string"  */
  YYSYMBOL_ASTERISK_STRING = 105,          /* "string with a trailing asterisk"  */
  YYSYMBOL_LL_HDR = 106,                   /* "ll"  */
  YYSYMBOL_NETWORK_HDR = 107,              /* "nh"  */
  YYSYMBOL_TRANSPORT_HDR = 108,            /* "th"  */
  YYSYMBOL_BRIDGE = 109,                   /* "bridge"  */
  YYSYMBOL_ETHER = 110,                    /* "ether"  */
  YYSYMBOL_SADDR = 111,                    /* "saddr"  */
  YYSYMBOL_DADDR = 112,                    /* "daddr"  */
  YYSYMBOL_TYPE = 113,                     /* "type"  */
  YYSYMBOL_VLAN = 114,                     /* "vlan"  */
  YYSYMBOL_ID = 115,                       /* "id"  */
  YYSYMBOL_CFI = 116,                      /* "cfi"  */
  YYSYMBOL_DEI = 117,                      /* "dei"  */
  YYSYMBOL_PCP = 118,                      /* "pcp"  */
  YYSYMBOL_ARP = 119,                      /* "arp"  */
  YYSYMBOL_HTYPE = 120,                    /* "htype"  */
  YYSYMBOL_PTYPE = 121,                    /* "ptype"  */
  YYSYMBOL_HLEN = 122,                     /* "hlen"  */
  YYSYMBOL_PLEN = 123,                     /* "plen"  */
  YYSYMBOL_OPERATION = 124,                /* "operation"  */
  YYSYMBOL_IP = 125,                       /* "ip"  */
  YYSYMBOL_HDRVERSION = 126,               /* "version"  */
  YYSYMBOL_HDRLENGTH = 127,                /* "hdrlength"  */
  YYSYMBOL_DSCP = 128,                     /* "dscp"  */
  YYSYMBOL_ECN = 129,                      /* "ecn"  */
  YYSYMBOL_LENGTH = 130,                   /* "length"  */
  YYSYMBOL_FRAG_OFF = 131,                 /* "frag-off"  */
  YYSYMBOL_TTL = 132,                      /* "ttl"  */
  YYSYMBOL_PROTOCOL = 133,                 /* "protocol"  */
  YYSYMBOL_CHECKSUM = 134,                 /* "checksum"  */
  YYSYMBOL_PTR = 135,                      /* "ptr"  */
  YYSYMBOL_VALUE = 136,                    /* "value"  */
  YYSYMBOL_LSRR = 137,                     /* "lsrr"  */
  YYSYMBOL_RR = 138,                       /* "rr"  */
  YYSYMBOL_SSRR = 139,                     /* "ssrr"  */
  YYSYMBOL_RA = 140,                       /* "ra"  */
  YYSYMBOL_ICMP = 141,                     /* "icmp"  */
  YYSYMBOL_CODE = 142,                     /* "code"  */
  YYSYMBOL_SEQUENCE = 143,                 /* "seq"  */
  YYSYMBOL_GATEWAY = 144,                  /* "gateway"  */
  YYSYMBOL_MTU = 145,                      /* "mtu"  */
  YYSYMBOL_IGMP = 146,                     /* "igmp"  */
  YYSYMBOL_MRT = 147,                      /* "mrt"  */
  YYSYMBOL_OPTIONS = 148,                  /* "options"  */
  YYSYMBOL_IP6 = 149,                      /* "ip6"  */
  YYSYMBOL_PRIORITY = 150,                 /* "priority"  */
  YYSYMBOL_FLOWLABEL = 151,                /* "flowlabel"  */
  YYSYMBOL_NEXTHDR = 152,                  /* "nexthdr"  */
  YYSYMBOL_HOPLIMIT = 153,                 /* "hoplimit"  */
  YYSYMBOL_ICMP6 = 154,                    /* "icmpv6"  */
  YYSYMBOL_PPTR = 155,                     /* "param-problem"  */
  YYSYMBOL_MAXDELAY = 156,                 /* "max-delay"  */
  YYSYMBOL_AH = 157,                       /* "ah"  */
  YYSYMBOL_RESERVED = 158,                 /* "reserved"  */
  YYSYMBOL_SPI = 159,                      /* "spi"  */
  YYSYMBOL_ESP = 160,                      /* "esp"  */
  YYSYMBOL_COMP = 161,                     /* "comp"  */
  YYSYMBOL_FLAGS = 162,                    /* "flags"  */
  YYSYMBOL_CPI = 163,                      /* "cpi"  */
  YYSYMBOL_PORT = 164,                     /* "port"  */
  YYSYMBOL_UDP = 165,                      /* "udp"  */
  YYSYMBOL_SPORT = 166,                    /* "sport"  */
  YYSYMBOL_DPORT = 167,                    /* "dport"  */
  YYSYMBOL_UDPLITE = 168,                  /* "udplite"  */
  YYSYMBOL_CSUMCOV = 169,                  /* "csumcov"  */
  YYSYMBOL_TCP = 170,                      /* "tcp"  */
  YYSYMBOL_ACKSEQ = 171,                   /* "ackseq"  */
  YYSYMBOL_DOFF = 172,                     /* "doff"  */
  YYSYMBOL_WINDOW = 173,                   /* "window"  */
  YYSYMBOL_URGPTR = 174,                   /* "urgptr"  */
  YYSYMBOL_OPTION = 175,                   /* "option"  */
  YYSYMBOL_ECHO = 176,                     /* "echo"  */
  YYSYMBOL_EOL = 177,                      /* "eol"  */
  YYSYMBOL_NOP = 178,                      /* "nop"  */
  YYSYMBOL_SACK = 179,                     /* "sack"  */
  YYSYMBOL_SACK0 = 180,                    /* "sack0"  */
  YYSYMBOL_SACK1 = 181,                    /* "sack1"  */
  YYSYMBOL_SACK2 = 182,                    /* "sack2"  */
  YYSYMBOL_SACK3 = 183,                    /* "sack3"  */
  YYSYMBOL_SACK_PERM = 184,                /* "sack-permitted"  */
  YYSYMBOL_TIMESTAMP = 185,                /* "timestamp"  */
  YYSYMBOL_KIND = 186,                     /* "kind"  */
  YYSYMBOL_COUNT = 187,                    /* "count"  */
  YYSYMBOL_LEFT = 188,                     /* "left"  */
  YYSYMBOL_RIGHT = 189,                    /* "right"  */
  YYSYMBOL_TSVAL = 190,                    /* "tsval"  */
  YYSYMBOL_TSECR = 191,                    /* "tsecr"  */
  YYSYMBOL_DCCP = 192,                     /* "dccp"  */
  YYSYMBOL_SCTP = 193,                     /* "sctp"  */
  YYSYMBOL_CHUNK = 194,                    /* "chunk"  */
  YYSYMBOL_DATA = 195,                     /* "data"  */
  YYSYMBOL_INIT = 196,                     /* "init"  */
  YYSYMBOL_INIT_ACK = 197,                 /* "init-ack"  */
  YYSYMBOL_HEARTBEAT = 198,                /* "heartbeat"  */
  YYSYMBOL_HEARTBEAT_ACK = 199,            /* "heartbeat-ack"  */
  YYSYMBOL_ABORT = 200,                    /* "abort"  */
  YYSYMBOL_SHUTDOWN = 201,                 /* "shutdown"  */
  YYSYMBOL_SHUTDOWN_ACK = 202,             /* "shutdown-ack"  */
  YYSYMBOL_ERROR = 203,                    /* "error"  */
  YYSYMBOL_COOKIE_ECHO = 204,              /* "cookie-echo"  */
  YYSYMBOL_COOKIE_ACK = 205,               /* "cookie-ack"  */
  YYSYMBOL_ECNE = 206,                     /* "ecne"  */
  YYSYMBOL_CWR = 207,                      /* "cwr"  */
  YYSYMBOL_SHUTDOWN_COMPLETE = 208,        /* "shutdown-complete"  */
  YYSYMBOL_ASCONF_ACK = 209,               /* "asconf-ack"  */
  YYSYMBOL_FORWARD_TSN = 210,              /* "forward-tsn"  */
  YYSYMBOL_ASCONF = 211,                   /* "asconf"  */
  YYSYMBOL_TSN = 212,                      /* "tsn"  */
  YYSYMBOL_STREAM = 213,                   /* "stream"  */
  YYSYMBOL_SSN = 214,                      /* "ssn"  */
  YYSYMBOL_PPID = 215,                     /* "ppid"  */
  YYSYMBOL_INIT_TAG = 216,                 /* "init-tag"  */
  YYSYMBOL_A_RWND = 217,                   /* "a-rwnd"  */
  YYSYMBOL_NUM_OSTREAMS = 218,             /* "num-outbound-streams"  */
  YYSYMBOL_NUM_ISTREAMS = 219,             /* "num-inbound-streams"  */
  YYSYMBOL_INIT_TSN = 220,                 /* "initial-tsn"  */
  YYSYMBOL_CUM_TSN_ACK = 221,              /* "cum-tsn-ack"  */
  YYSYMBOL_NUM_GACK_BLOCKS = 222,          /* "num-gap-ack-blocks"  */
  YYSYMBOL_NUM_DUP_TSNS = 223,             /* "num-dup-tsns"  */
  YYSYMBOL_LOWEST_TSN = 224,               /* "lowest-tsn"  */
  YYSYMBOL_SEQNO = 225,                    /* "seqno"  */
  YYSYMBOL_NEW_CUM_TSN = 226,              /* "new-cum-tsn"  */
  YYSYMBOL_VTAG = 227,                     /* "vtag"  */
  YYSYMBOL_RT = 228,                       /* "rt"  */
  YYSYMBOL_RT0 = 229,                      /* "rt0"  */
  YYSYMBOL_RT2 = 230,                      /* "rt2"  */
  YYSYMBOL_RT4 = 231,                      /* "srh"  */
  YYSYMBOL_SEG_LEFT = 232,                 /* "seg-left"  */
  YYSYMBOL_ADDR = 233,                     /* "addr"  */
  YYSYMBOL_LAST_ENT = 234,                 /* "last-entry"  */
  YYSYMBOL_TAG = 235,                      /* "tag"  */
  YYSYMBOL_SID = 236,                      /* "sid"  */
  YYSYMBOL_HBH = 237,                      /* "hbh"  */
  YYSYMBOL_FRAG = 238,                     /* "frag"  */
  YYSYMBOL_RESERVED2 = 239,                /* "reserved2"  */
  YYSYMBOL_MORE_FRAGMENTS = 240,           /* "more-fragments"  */
  YYSYMBOL_DST = 241,                      /* "dst"  */
  YYSYMBOL_MH = 242,                       /* "mh"  */
  YYSYMBOL_META = 243,                     /* "meta"  */
  YYSYMBOL_MARK = 244,                     /* "mark"  */
  YYSYMBOL_IIF = 245,                      /* "iif"  */
  YYSYMBOL_IIFNAME = 246,                  /* "iifname"  */
  YYSYMBOL_IIFTYPE = 247,                  /* "iiftype"  */
  YYSYMBOL_OIF = 248,                      /* "oif"  */
  YYSYMBOL_OIFNAME = 249,                  /* "oifname"  */
  YYSYMBOL_OIFTYPE = 250,                  /* "oiftype"  */
  YYSYMBOL_SKUID = 251,                    /* "skuid"  */
  YYSYMBOL_SKGID = 252,                    /* "skgid"  */
  YYSYMBOL_NFTRACE = 253,                  /* "nftrace"  */
  YYSYMBOL_RTCLASSID = 254,                /* "rtclassid"  */
  YYSYMBOL_IBRIPORT = 255,                 /* "ibriport"  */
  YYSYMBOL_OBRIPORT = 256,                 /* "obriport"  */
  YYSYMBOL_IBRIDGENAME = 257,              /* "ibrname"  */
  YYSYMBOL_OBRIDGENAME = 258,              /* "obrname"  */
  YYSYMBOL_PKTTYPE = 259,                  /* "pkttype"  */
  YYSYMBOL_CPU = 260,                      /* "cpu"  */
  YYSYMBOL_IIFGROUP = 261,                 /* "iifgroup"  */
  YYSYMBOL_OIFGROUP = 262,                 /* "oifgroup"  */
  YYSYMBOL_CGROUP = 263,                   /* "cgroup"  */
  YYSYMBOL_TIME = 264,                     /* "time"  */
  YYSYMBOL_CLASSID = 265,                  /* "classid"  */
  YYSYMBOL_NEXTHOP = 266,                  /* "nexthop"  */
  YYSYMBOL_CT = 267,                       /* "ct"  */
  YYSYMBOL_L3PROTOCOL = 268,               /* "l3proto"  */
  YYSYMBOL_PROTO_SRC = 269,                /* "proto-src"  */
  YYSYMBOL_PROTO_DST = 270,                /* "proto-dst"  */
  YYSYMBOL_ZONE = 271,                     /* "zone"  */
  YYSYMBOL_DIRECTION = 272,                /* "direction"  */
  YYSYMBOL_EVENT = 273,                    /* "event"  */
  YYSYMBOL_EXPECTATION = 274,              /* "expectation"  */
  YYSYMBOL_EXPIRATION = 275,               /* "expiration"  */
  YYSYMBOL_HELPER = 276,                   /* "helper"  */
  YYSYMBOL_LABEL = 277,                    /* "label"  */
  YYSYMBOL_STATE = 278,                    /* "state"  */
  YYSYMBOL_STATUS = 279,                   /* "status"  */
  YYSYMBOL_ORIGINAL = 280,                 /* "original"  */
  YYSYMBOL_REPLY = 281,                    /* "reply"  */
  YYSYMBOL_COUNTER = 282,                  /* "counter"  */
  YYSYMBOL_NAME = 283,                     /* "name"  */
  YYSYMBOL_PACKETS = 284,                  /* "packets"  */
  YYSYMBOL_BYTES = 285,                    /* "bytes"  */
  YYSYMBOL_AVGPKT = 286,                   /* "avgpkt"  */
  YYSYMBOL_COUNTERS = 287,                 /* "counters"  */
  YYSYMBOL_QUOTAS = 288,                   /* "quotas"  */
  YYSYMBOL_LIMITS = 289,                   /* "limits"  */
  YYSYMBOL_SYNPROXYS = 290,                /* "synproxys"  */
  YYSYMBOL_HELPERS = 291,                  /* "helpers"  */
  YYSYMBOL_LOG = 292,                      /* "log"  */
  YYSYMBOL_PREFIX = 293,                   /* "prefix"  */
  YYSYMBOL_GROUP = 294,                    /* "group"  */
  YYSYMBOL_SNAPLEN = 295,                  /* "snaplen"  */
  YYSYMBOL_QUEUE_THRESHOLD = 296,          /* "queue-threshold"  */
  YYSYMBOL_LEVEL = 297,                    /* "level"  */
  YYSYMBOL_LIMIT = 298,                    /* "limit"  */
  YYSYMBOL_RATE = 299,                     /* "rate"  */
  YYSYMBOL_BURST = 300,                    /* "burst"  */
  YYSYMBOL_OVER = 301,                     /* "over"  */
  YYSYMBOL_UNTIL = 302,                    /* "until"  */
  YYSYMBOL_QUOTA = 303,                    /* "quota"  */
  YYSYMBOL_USED = 304,                     /* "used"  */
  YYSYMBOL_SECMARK = 305,                  /* "secmark"  */
  YYSYMBOL_SECMARKS = 306,                 /* "secmarks"  */
  YYSYMBOL_SECOND = 307,                   /* "second"  */
  YYSYMBOL_MINUTE = 308,                   /* "minute"  */
  YYSYMBOL_HOUR = 309,                     /* "hour"  */
  YYSYMBOL_DAY = 310,                      /* "day"  */
  YYSYMBOL_WEEK = 311,                     /* "week"  */
  YYSYMBOL__REJECT = 312,                  /* "reject"  */
  YYSYMBOL_WITH = 313,                     /* "with"  */
  YYSYMBOL_ICMPX = 314,                    /* "icmpx"  */
  YYSYMBOL_SNAT = 315,                     /* "snat"  */
  YYSYMBOL_DNAT = 316,                     /* "dnat"  */
  YYSYMBOL_MASQUERADE = 317,               /* "masquerade"  */
  YYSYMBOL_REDIRECT = 318,                 /* "redirect"  */
  YYSYMBOL_RANDOM = 319,                   /* "random"  */
  YYSYMBOL_FULLY_RANDOM = 320,             /* "fully-random"  */
  YYSYMBOL_PERSISTENT = 321,               /* "persistent"  */
  YYSYMBOL_QUEUE = 322,                    /* "queue"  */
  YYSYMBOL_QUEUENUM = 323,                 /* "num"  */
  YYSYMBOL_BYPASS = 324,                   /* "bypass"  */
  YYSYMBOL_FANOUT = 325,                   /* "fanout"  */
  YYSYMBOL_DUP = 326,                      /* "dup"  */
  YYSYMBOL_FWD = 327,                      /* "fwd"  */
  YYSYMBOL_NUMGEN = 328,                   /* "numgen"  */
  YYSYMBOL_INC = 329,                      /* "inc"  */
  YYSYMBOL_MOD = 330,                      /* "mod"  */
  YYSYMBOL_OFFSET = 331,                   /* "offset"  */
  YYSYMBOL_JHASH = 332,                    /* "jhash"  */
  YYSYMBOL_SYMHASH = 333,                  /* "symhash"  */
  YYSYMBOL_SEED = 334,                     /* "seed"  */
  YYSYMBOL_POSITION = 335,                 /* "position"  */
  YYSYMBOL_INDEX = 336,                    /* "index"  */
  YYSYMBOL_COMMENT = 337,                  /* "comment"  */
  YYSYMBOL_XML = 338,                      /* "xml"  */
  YYSYMBOL_JSON = 339,                     /* "json"  */
  YYSYMBOL_VM = 340,                       /* "vm"  */
  YYSYMBOL_NOTRACK = 341,                  /* "notrack"  */
  YYSYMBOL_EXISTS = 342,                   /* "exists"  */
  YYSYMBOL_MISSING = 343,                  /* "missing"  */
  YYSYMBOL_EXTHDR = 344,                   /* "exthdr"  */
  YYSYMBOL_IPSEC = 345,                    /* "ipsec"  */
  YYSYMBOL_REQID = 346,                    /* "reqid"  */
  YYSYMBOL_SPNUM = 347,                    /* "spnum"  */
  YYSYMBOL_IN = 348,                       /* "in"  */
  YYSYMBOL_OUT = 349,                      /* "out"  */
  YYSYMBOL_350_ = 350,                     /* '='  */
  YYSYMBOL_351_ = 351,                     /* '{'  */
  YYSYMBOL_352_ = 352,                     /* '}'  */
  YYSYMBOL_353_ = 353,                     /* '('  */
  YYSYMBOL_354_ = 354,                     /* ')'  */
  YYSYMBOL_355_ = 355,                     /* '|'  */
  YYSYMBOL_356_ = 356,                     /* '$'  */
  YYSYMBOL_357_ = 357,                     /* '['  */
  YYSYMBOL_358_ = 358,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 359,                 /* $accept  */
  YYSYMBOL_input = 360,                    /* input  */
  YYSYMBOL_stmt_separator = 361,           /* stmt_separator  */
  YYSYMBOL_opt_newline = 362,              /* opt_newline  */
  YYSYMBOL_close_scope_arp = 363,          /* close_scope_arp  */
  YYSYMBOL_close_scope_ct = 364,           /* close_scope_ct  */
  YYSYMBOL_close_scope_counter = 365,      /* close_scope_counter  */
  YYSYMBOL_close_scope_eth = 366,          /* close_scope_eth  */
  YYSYMBOL_close_scope_fib = 367,          /* close_scope_fib  */
  YYSYMBOL_close_scope_hash = 368,         /* close_scope_hash  */
  YYSYMBOL_close_scope_ip = 369,           /* close_scope_ip  */
  YYSYMBOL_close_scope_ip6 = 370,          /* close_scope_ip6  */
  YYSYMBOL_close_scope_vlan = 371,         /* close_scope_vlan  */
  YYSYMBOL_close_scope_ipsec = 372,        /* close_scope_ipsec  */
  YYSYMBOL_close_scope_list = 373,         /* close_scope_list  */
  YYSYMBOL_close_scope_limit = 374,        /* close_scope_limit  */
  YYSYMBOL_close_scope_numgen = 375,       /* close_scope_numgen  */
  YYSYMBOL_close_scope_quota = 376,        /* close_scope_quota  */
  YYSYMBOL_close_scope_queue = 377,        /* close_scope_queue  */
  YYSYMBOL_close_scope_rt = 378,           /* close_scope_rt  */
  YYSYMBOL_close_scope_sctp = 379,         /* close_scope_sctp  */
  YYSYMBOL_close_scope_sctp_chunk = 380,   /* close_scope_sctp_chunk  */
  YYSYMBOL_close_scope_secmark = 381,      /* close_scope_secmark  */
  YYSYMBOL_close_scope_socket = 382,       /* close_scope_socket  */
  YYSYMBOL_close_scope_log = 383,          /* close_scope_log  */
  YYSYMBOL_common_block = 384,             /* common_block  */
  YYSYMBOL_line = 385,                     /* line  */
  YYSYMBOL_base_cmd = 386,                 /* base_cmd  */
  YYSYMBOL_add_cmd = 387,                  /* add_cmd  */
  YYSYMBOL_replace_cmd = 388,              /* replace_cmd  */
  YYSYMBOL_create_cmd = 389,               /* create_cmd  */
  YYSYMBOL_insert_cmd = 390,               /* insert_cmd  */
  YYSYMBOL_table_or_id_spec = 391,         /* table_or_id_spec  */
  YYSYMBOL_chain_or_id_spec = 392,         /* chain_or_id_spec  */
  YYSYMBOL_set_or_id_spec = 393,           /* set_or_id_spec  */
  YYSYMBOL_obj_or_id_spec = 394,           /* obj_or_id_spec  */
  YYSYMBOL_delete_cmd = 395,               /* delete_cmd  */
  YYSYMBOL_get_cmd = 396,                  /* get_cmd  */
  YYSYMBOL_list_cmd = 397,                 /* list_cmd  */
  YYSYMBOL_basehook_device_name = 398,     /* basehook_device_name  */
  YYSYMBOL_basehook_spec = 399,            /* basehook_spec  */
  YYSYMBOL_reset_cmd = 400,                /* reset_cmd  */
  YYSYMBOL_flush_cmd = 401,                /* flush_cmd  */
  YYSYMBOL_rename_cmd = 402,               /* rename_cmd  */
  YYSYMBOL_import_cmd = 403,               /* import_cmd  */
  YYSYMBOL_export_cmd = 404,               /* export_cmd  */
  YYSYMBOL_monitor_cmd = 405,              /* monitor_cmd  */
  YYSYMBOL_monitor_event = 406,            /* monitor_event  */
  YYSYMBOL_monitor_object = 407,           /* monitor_object  */
  YYSYMBOL_monitor_format = 408,           /* monitor_format  */
  YYSYMBOL_markup_format = 409,            /* markup_format  */
  YYSYMBOL_describe_cmd = 410,             /* describe_cmd  */
  YYSYMBOL_table_block_alloc = 411,        /* table_block_alloc  */
  YYSYMBOL_table_options = 412,            /* table_options  */
  YYSYMBOL_table_block = 413,              /* table_block  */
  YYSYMBOL_chain_block_alloc = 414,        /* chain_block_alloc  */
  YYSYMBOL_chain_block = 415,              /* chain_block  */
  YYSYMBOL_subchain_block = 416,           /* subchain_block  */
  YYSYMBOL_typeof_data_expr = 417,         /* typeof_data_expr  */
  YYSYMBOL_typeof_expr = 418,              /* typeof_expr  */
  YYSYMBOL_set_block_alloc = 419,          /* set_block_alloc  */
  YYSYMBOL_set_block = 420,                /* set_block  */
  YYSYMBOL_set_block_expr = 421,           /* set_block_expr  */
  YYSYMBOL_set_flag_list = 422,            /* set_flag_list  */
  YYSYMBOL_set_flag = 423,                 /* set_flag  */
  YYSYMBOL_map_block_alloc = 424,          /* map_block_alloc  */
  YYSYMBOL_map_block_obj_type = 425,       /* map_block_obj_type  */
  YYSYMBOL_map_block = 426,                /* map_block  */
  YYSYMBOL_set_mechanism = 427,            /* set_mechanism  */
  YYSYMBOL_set_policy_spec = 428,          /* set_policy_spec  */
  YYSYMBOL_flowtable_block_alloc = 429,    /* flowtable_block_alloc  */
  YYSYMBOL_flowtable_block = 430,          /* flowtable_block  */
  YYSYMBOL_flowtable_expr = 431,           /* flowtable_expr  */
  YYSYMBOL_flowtable_list_expr = 432,      /* flowtable_list_expr  */
  YYSYMBOL_flowtable_expr_member = 433,    /* flowtable_expr_member  */
  YYSYMBOL_data_type_atom_expr = 434,      /* data_type_atom_expr  */
  YYSYMBOL_data_type_expr = 435,           /* data_type_expr  */
  YYSYMBOL_obj_block_alloc = 436,          /* obj_block_alloc  */
  YYSYMBOL_counter_block = 437,            /* counter_block  */
  YYSYMBOL_quota_block = 438,              /* quota_block  */
  YYSYMBOL_ct_helper_block = 439,          /* ct_helper_block  */
  YYSYMBOL_ct_timeout_block = 440,         /* ct_timeout_block  */
  YYSYMBOL_ct_expect_block = 441,          /* ct_expect_block  */
  YYSYMBOL_limit_block = 442,              /* limit_block  */
  YYSYMBOL_secmark_block = 443,            /* secmark_block  */
  YYSYMBOL_synproxy_block = 444,           /* synproxy_block  */
  YYSYMBOL_type_identifier = 445,          /* type_identifier  */
  YYSYMBOL_hook_spec = 446,                /* hook_spec  */
  YYSYMBOL_prio_spec = 447,                /* prio_spec  */
  YYSYMBOL_extended_prio_name = 448,       /* extended_prio_name  */
  YYSYMBOL_extended_prio_spec = 449,       /* extended_prio_spec  */
  YYSYMBOL_int_num = 450,                  /* int_num  */
  YYSYMBOL_dev_spec = 451,                 /* dev_spec  */
  YYSYMBOL_flags_spec = 452,               /* flags_spec  */
  YYSYMBOL_policy_spec = 453,              /* policy_spec  */
  YYSYMBOL_policy_expr = 454,              /* policy_expr  */
  YYSYMBOL_chain_policy = 455,             /* chain_policy  */
  YYSYMBOL_identifier = 456,               /* identifier  */
  YYSYMBOL_string = 457,                   /* string  */
  YYSYMBOL_time_spec = 458,                /* time_spec  */
  YYSYMBOL_family_spec = 459,              /* family_spec  */
  YYSYMBOL_family_spec_explicit = 460,     /* family_spec_explicit  */
  YYSYMBOL_table_spec = 461,               /* table_spec  */
  YYSYMBOL_tableid_spec = 462,             /* tableid_spec  */
  YYSYMBOL_chain_spec = 463,               /* chain_spec  */
  YYSYMBOL_chainid_spec = 464,             /* chainid_spec  */
  YYSYMBOL_chain_identifier = 465,         /* chain_identifier  */
  YYSYMBOL_set_spec = 466,                 /* set_spec  */
  YYSYMBOL_setid_spec = 467,               /* setid_spec  */
  YYSYMBOL_set_identifier = 468,           /* set_identifier  */
  YYSYMBOL_flowtable_spec = 469,           /* flowtable_spec  */
  YYSYMBOL_flowtableid_spec = 470,         /* flowtableid_spec  */
  YYSYMBOL_flowtable_identifier = 471,     /* flowtable_identifier  */
  YYSYMBOL_obj_spec = 472,                 /* obj_spec  */
  YYSYMBOL_objid_spec = 473,               /* objid_spec  */
  YYSYMBOL_obj_identifier = 474,           /* obj_identifier  */
  YYSYMBOL_handle_spec = 475,              /* handle_spec  */
  YYSYMBOL_position_spec = 476,            /* position_spec  */
  YYSYMBOL_index_spec = 477,               /* index_spec  */
  YYSYMBOL_rule_position = 478,            /* rule_position  */
  YYSYMBOL_ruleid_spec = 479,              /* ruleid_spec  */
  YYSYMBOL_comment_spec = 480,             /* comment_spec  */
  YYSYMBOL_ruleset_spec = 481,             /* ruleset_spec  */
  YYSYMBOL_rule = 482,                     /* rule  */
  YYSYMBOL_rule_alloc = 483,               /* rule_alloc  */
  YYSYMBOL_stmt_list = 484,                /* stmt_list  */
  YYSYMBOL_stateful_stmt_list = 485,       /* stateful_stmt_list  */
  YYSYMBOL_stateful_stmt = 486,            /* stateful_stmt  */
  YYSYMBOL_stmt = 487,                     /* stmt  */
  YYSYMBOL_chain_stmt_type = 488,          /* chain_stmt_type  */
  YYSYMBOL_chain_stmt = 489,               /* chain_stmt  */
  YYSYMBOL_verdict_stmt = 490,             /* verdict_stmt  */
  YYSYMBOL_verdict_map_stmt = 491,         /* verdict_map_stmt  */
  YYSYMBOL_verdict_map_expr = 492,         /* verdict_map_expr  */
  YYSYMBOL_verdict_map_list_expr = 493,    /* verdict_map_list_expr  */
  YYSYMBOL_verdict_map_list_member_expr = 494, /* verdict_map_list_member_expr  */
  YYSYMBOL_connlimit_stmt = 495,           /* connlimit_stmt  */
  YYSYMBOL_counter_stmt = 496,             /* counter_stmt  */
  YYSYMBOL_counter_stmt_alloc = 497,       /* counter_stmt_alloc  */
  YYSYMBOL_counter_args = 498,             /* counter_args  */
  YYSYMBOL_counter_arg = 499,              /* counter_arg  */
  YYSYMBOL_log_stmt = 500,                 /* log_stmt  */
  YYSYMBOL_log_stmt_alloc = 501,           /* log_stmt_alloc  */
  YYSYMBOL_log_args = 502,                 /* log_args  */
  YYSYMBOL_log_arg = 503,                  /* log_arg  */
  YYSYMBOL_level_type = 504,               /* level_type  */
  YYSYMBOL_log_flags = 505,                /* log_flags  */
  YYSYMBOL_log_flags_tcp = 506,            /* log_flags_tcp  */
  YYSYMBOL_log_flag_tcp = 507,             /* log_flag_tcp  */
  YYSYMBOL_limit_stmt = 508,               /* limit_stmt  */
  YYSYMBOL_quota_mode = 509,               /* quota_mode  */
  YYSYMBOL_quota_unit = 510,               /* quota_unit  */
  YYSYMBOL_quota_used = 511,               /* quota_used  */
  YYSYMBOL_quota_stmt = 512,               /* quota_stmt  */
  YYSYMBOL_limit_mode = 513,               /* limit_mode  */
  YYSYMBOL_limit_burst_pkts = 514,         /* limit_burst_pkts  */
  YYSYMBOL_limit_burst_bytes = 515,        /* limit_burst_bytes  */
  YYSYMBOL_time_unit = 516,                /* time_unit  */
  YYSYMBOL_reject_stmt = 517,              /* reject_stmt  */
  YYSYMBOL_reject_stmt_alloc = 518,        /* reject_stmt_alloc  */
  YYSYMBOL_reject_with_expr = 519,         /* reject_with_expr  */
  YYSYMBOL_reject_opts = 520,              /* reject_opts  */
  YYSYMBOL_nat_stmt = 521,                 /* nat_stmt  */
  YYSYMBOL_nat_stmt_alloc = 522,           /* nat_stmt_alloc  */
  YYSYMBOL_tproxy_stmt = 523,              /* tproxy_stmt  */
  YYSYMBOL_synproxy_stmt = 524,            /* synproxy_stmt  */
  YYSYMBOL_synproxy_stmt_alloc = 525,      /* synproxy_stmt_alloc  */
  YYSYMBOL_synproxy_args = 526,            /* synproxy_args  */
  YYSYMBOL_synproxy_arg = 527,             /* synproxy_arg  */
  YYSYMBOL_synproxy_config = 528,          /* synproxy_config  */
  YYSYMBOL_synproxy_obj = 529,             /* synproxy_obj  */
  YYSYMBOL_synproxy_ts = 530,              /* synproxy_ts  */
  YYSYMBOL_synproxy_sack = 531,            /* synproxy_sack  */
  YYSYMBOL_primary_stmt_expr = 532,        /* primary_stmt_expr  */
  YYSYMBOL_shift_stmt_expr = 533,          /* shift_stmt_expr  */
  YYSYMBOL_and_stmt_expr = 534,            /* and_stmt_expr  */
  YYSYMBOL_exclusive_or_stmt_expr = 535,   /* exclusive_or_stmt_expr  */
  YYSYMBOL_inclusive_or_stmt_expr = 536,   /* inclusive_or_stmt_expr  */
  YYSYMBOL_basic_stmt_expr = 537,          /* basic_stmt_expr  */
  YYSYMBOL_concat_stmt_expr = 538,         /* concat_stmt_expr  */
  YYSYMBOL_map_stmt_expr_set = 539,        /* map_stmt_expr_set  */
  YYSYMBOL_map_stmt_expr = 540,            /* map_stmt_expr  */
  YYSYMBOL_prefix_stmt_expr = 541,         /* prefix_stmt_expr  */
  YYSYMBOL_range_stmt_expr = 542,          /* range_stmt_expr  */
  YYSYMBOL_multiton_stmt_expr = 543,       /* multiton_stmt_expr  */
  YYSYMBOL_stmt_expr = 544,                /* stmt_expr  */
  YYSYMBOL_nat_stmt_args = 545,            /* nat_stmt_args  */
  YYSYMBOL_masq_stmt = 546,                /* masq_stmt  */
  YYSYMBOL_masq_stmt_alloc = 547,          /* masq_stmt_alloc  */
  YYSYMBOL_masq_stmt_args = 548,           /* masq_stmt_args  */
  YYSYMBOL_redir_stmt = 549,               /* redir_stmt  */
  YYSYMBOL_redir_stmt_alloc = 550,         /* redir_stmt_alloc  */
  YYSYMBOL_redir_stmt_arg = 551,           /* redir_stmt_arg  */
  YYSYMBOL_dup_stmt = 552,                 /* dup_stmt  */
  YYSYMBOL_fwd_stmt = 553,                 /* fwd_stmt  */
  YYSYMBOL_nf_nat_flags = 554,             /* nf_nat_flags  */
  YYSYMBOL_nf_nat_flag = 555,              /* nf_nat_flag  */
  YYSYMBOL_queue_stmt = 556,               /* queue_stmt  */
  YYSYMBOL_queue_stmt_compat = 557,        /* queue_stmt_compat  */
  YYSYMBOL_queue_stmt_alloc = 558,         /* queue_stmt_alloc  */
  YYSYMBOL_queue_stmt_args = 559,          /* queue_stmt_args  */
  YYSYMBOL_queue_stmt_arg = 560,           /* queue_stmt_arg  */
  YYSYMBOL_queue_stmt_expr_simple = 561,   /* queue_stmt_expr_simple  */
  YYSYMBOL_queue_stmt_expr = 562,          /* queue_stmt_expr  */
  YYSYMBOL_queue_stmt_flags = 563,         /* queue_stmt_flags  */
  YYSYMBOL_queue_stmt_flag = 564,          /* queue_stmt_flag  */
  YYSYMBOL_set_elem_expr_stmt = 565,       /* set_elem_expr_stmt  */
  YYSYMBOL_set_elem_expr_stmt_alloc = 566, /* set_elem_expr_stmt_alloc  */
  YYSYMBOL_set_stmt = 567,                 /* set_stmt  */
  YYSYMBOL_set_stmt_op = 568,              /* set_stmt_op  */
  YYSYMBOL_map_stmt = 569,                 /* map_stmt  */
  YYSYMBOL_meter_stmt = 570,               /* meter_stmt  */
  YYSYMBOL_flow_stmt_legacy_alloc = 571,   /* flow_stmt_legacy_alloc  */
  YYSYMBOL_flow_stmt_opts = 572,           /* flow_stmt_opts  */
  YYSYMBOL_flow_stmt_opt = 573,            /* flow_stmt_opt  */
  YYSYMBOL_meter_stmt_alloc = 574,         /* meter_stmt_alloc  */
  YYSYMBOL_match_stmt = 575,               /* match_stmt  */
  YYSYMBOL_variable_expr = 576,            /* variable_expr  */
  YYSYMBOL_symbol_expr = 577,              /* symbol_expr  */
  YYSYMBOL_set_ref_expr = 578,             /* set_ref_expr  */
  YYSYMBOL_set_ref_symbol_expr = 579,      /* set_ref_symbol_expr  */
  YYSYMBOL_integer_expr = 580,             /* integer_expr  */
  YYSYMBOL_primary_expr = 581,             /* primary_expr  */
  YYSYMBOL_fib_expr = 582,                 /* fib_expr  */
  YYSYMBOL_fib_result = 583,               /* fib_result  */
  YYSYMBOL_fib_flag = 584,                 /* fib_flag  */
  YYSYMBOL_fib_tuple = 585,                /* fib_tuple  */
  YYSYMBOL_osf_expr = 586,                 /* osf_expr  */
  YYSYMBOL_osf_ttl = 587,                  /* osf_ttl  */
  YYSYMBOL_shift_expr = 588,               /* shift_expr  */
  YYSYMBOL_and_expr = 589,                 /* and_expr  */
  YYSYMBOL_exclusive_or_expr = 590,        /* exclusive_or_expr  */
  YYSYMBOL_inclusive_or_expr = 591,        /* inclusive_or_expr  */
  YYSYMBOL_basic_expr = 592,               /* basic_expr  */
  YYSYMBOL_concat_expr = 593,              /* concat_expr  */
  YYSYMBOL_prefix_rhs_expr = 594,          /* prefix_rhs_expr  */
  YYSYMBOL_range_rhs_expr = 595,           /* range_rhs_expr  */
  YYSYMBOL_multiton_rhs_expr = 596,        /* multiton_rhs_expr  */
  YYSYMBOL_map_expr = 597,                 /* map_expr  */
  YYSYMBOL_expr = 598,                     /* expr  */
  YYSYMBOL_set_expr = 599,                 /* set_expr  */
  YYSYMBOL_set_list_expr = 600,            /* set_list_expr  */
  YYSYMBOL_set_list_member_expr = 601,     /* set_list_member_expr  */
  YYSYMBOL_meter_key_expr = 602,           /* meter_key_expr  */
  YYSYMBOL_meter_key_expr_alloc = 603,     /* meter_key_expr_alloc  */
  YYSYMBOL_set_elem_expr = 604,            /* set_elem_expr  */
  YYSYMBOL_set_elem_key_expr = 605,        /* set_elem_key_expr  */
  YYSYMBOL_set_elem_expr_alloc = 606,      /* set_elem_expr_alloc  */
  YYSYMBOL_set_elem_options = 607,         /* set_elem_options  */
  YYSYMBOL_set_elem_option = 608,          /* set_elem_option  */
  YYSYMBOL_set_elem_expr_options = 609,    /* set_elem_expr_options  */
  YYSYMBOL_set_elem_stmt_list = 610,       /* set_elem_stmt_list  */
  YYSYMBOL_set_elem_stmt = 611,            /* set_elem_stmt  */
  YYSYMBOL_set_elem_expr_option = 612,     /* set_elem_expr_option  */
  YYSYMBOL_set_lhs_expr = 613,             /* set_lhs_expr  */
  YYSYMBOL_set_rhs_expr = 614,             /* set_rhs_expr  */
  YYSYMBOL_initializer_expr = 615,         /* initializer_expr  */
  YYSYMBOL_counter_config = 616,           /* counter_config  */
  YYSYMBOL_counter_obj = 617,              /* counter_obj  */
  YYSYMBOL_quota_config = 618,             /* quota_config  */
  YYSYMBOL_quota_obj = 619,                /* quota_obj  */
  YYSYMBOL_secmark_config = 620,           /* secmark_config  */
  YYSYMBOL_secmark_obj = 621,              /* secmark_obj  */
  YYSYMBOL_ct_obj_type = 622,              /* ct_obj_type  */
  YYSYMBOL_ct_cmd_type = 623,              /* ct_cmd_type  */
  YYSYMBOL_ct_l4protoname = 624,           /* ct_l4protoname  */
  YYSYMBOL_ct_helper_config = 625,         /* ct_helper_config  */
  YYSYMBOL_timeout_states = 626,           /* timeout_states  */
  YYSYMBOL_timeout_state = 627,            /* timeout_state  */
  YYSYMBOL_ct_timeout_config = 628,        /* ct_timeout_config  */
  YYSYMBOL_ct_expect_config = 629,         /* ct_expect_config  */
  YYSYMBOL_ct_obj_alloc = 630,             /* ct_obj_alloc  */
  YYSYMBOL_limit_config = 631,             /* limit_config  */
  YYSYMBOL_limit_obj = 632,                /* limit_obj  */
  YYSYMBOL_relational_expr = 633,          /* relational_expr  */
  YYSYMBOL_list_rhs_expr = 634,            /* list_rhs_expr  */
  YYSYMBOL_rhs_expr = 635,                 /* rhs_expr  */
  YYSYMBOL_shift_rhs_expr = 636,           /* shift_rhs_expr  */
  YYSYMBOL_and_rhs_expr = 637,             /* and_rhs_expr  */
  YYSYMBOL_exclusive_or_rhs_expr = 638,    /* exclusive_or_rhs_expr  */
  YYSYMBOL_inclusive_or_rhs_expr = 639,    /* inclusive_or_rhs_expr  */
  YYSYMBOL_basic_rhs_expr = 640,           /* basic_rhs_expr  */
  YYSYMBOL_concat_rhs_expr = 641,          /* concat_rhs_expr  */
  YYSYMBOL_boolean_keys = 642,             /* boolean_keys  */
  YYSYMBOL_boolean_expr = 643,             /* boolean_expr  */
  YYSYMBOL_keyword_expr = 644,             /* keyword_expr  */
  YYSYMBOL_primary_rhs_expr = 645,         /* primary_rhs_expr  */
  YYSYMBOL_relational_op = 646,            /* relational_op  */
  YYSYMBOL_verdict_expr = 647,             /* verdict_expr  */
  YYSYMBOL_chain_expr = 648,               /* chain_expr  */
  YYSYMBOL_meta_expr = 649,                /* meta_expr  */
  YYSYMBOL_meta_key = 650,                 /* meta_key  */
  YYSYMBOL_meta_key_qualified = 651,       /* meta_key_qualified  */
  YYSYMBOL_meta_key_unqualified = 652,     /* meta_key_unqualified  */
  YYSYMBOL_meta_stmt = 653,                /* meta_stmt  */
  YYSYMBOL_socket_expr = 654,              /* socket_expr  */
  YYSYMBOL_socket_key = 655,               /* socket_key  */
  YYSYMBOL_offset_opt = 656,               /* offset_opt  */
  YYSYMBOL_numgen_type = 657,              /* numgen_type  */
  YYSYMBOL_numgen_expr = 658,              /* numgen_expr  */
  YYSYMBOL_xfrm_spnum = 659,               /* xfrm_spnum  */
  YYSYMBOL_xfrm_dir = 660,                 /* xfrm_dir  */
  YYSYMBOL_xfrm_state_key = 661,           /* xfrm_state_key  */
  YYSYMBOL_xfrm_state_proto_key = 662,     /* xfrm_state_proto_key  */
  YYSYMBOL_xfrm_expr = 663,                /* xfrm_expr  */
  YYSYMBOL_hash_expr = 664,                /* hash_expr  */
  YYSYMBOL_nf_key_proto = 665,             /* nf_key_proto  */
  YYSYMBOL_rt_expr = 666,                  /* rt_expr  */
  YYSYMBOL_rt_key = 667,                   /* rt_key  */
  YYSYMBOL_ct_expr = 668,                  /* ct_expr  */
  YYSYMBOL_ct_dir = 669,                   /* ct_dir  */
  YYSYMBOL_ct_key = 670,                   /* ct_key  */
  YYSYMBOL_ct_key_dir = 671,               /* ct_key_dir  */
  YYSYMBOL_ct_key_proto_field = 672,       /* ct_key_proto_field  */
  YYSYMBOL_ct_key_dir_optional = 673,      /* ct_key_dir_optional  */
  YYSYMBOL_symbol_stmt_expr = 674,         /* symbol_stmt_expr  */
  YYSYMBOL_list_stmt_expr = 675,           /* list_stmt_expr  */
  YYSYMBOL_ct_stmt = 676,                  /* ct_stmt  */
  YYSYMBOL_payload_stmt = 677,             /* payload_stmt  */
  YYSYMBOL_payload_expr = 678,             /* payload_expr  */
  YYSYMBOL_payload_raw_expr = 679,         /* payload_raw_expr  */
  YYSYMBOL_payload_base_spec = 680,        /* payload_base_spec  */
  YYSYMBOL_eth_hdr_expr = 681,             /* eth_hdr_expr  */
  YYSYMBOL_eth_hdr_field = 682,            /* eth_hdr_field  */
  YYSYMBOL_vlan_hdr_expr = 683,            /* vlan_hdr_expr  */
  YYSYMBOL_vlan_hdr_field = 684,           /* vlan_hdr_field  */
  YYSYMBOL_arp_hdr_expr = 685,             /* arp_hdr_expr  */
  YYSYMBOL_arp_hdr_field = 686,            /* arp_hdr_field  */
  YYSYMBOL_ip_hdr_expr = 687,              /* ip_hdr_expr  */
  YYSYMBOL_ip_hdr_field = 688,             /* ip_hdr_field  */
  YYSYMBOL_ip_option_type = 689,           /* ip_option_type  */
  YYSYMBOL_ip_option_field = 690,          /* ip_option_field  */
  YYSYMBOL_icmp_hdr_expr = 691,            /* icmp_hdr_expr  */
  YYSYMBOL_icmp_hdr_field = 692,           /* icmp_hdr_field  */
  YYSYMBOL_igmp_hdr_expr = 693,            /* igmp_hdr_expr  */
  YYSYMBOL_igmp_hdr_field = 694,           /* igmp_hdr_field  */
  YYSYMBOL_ip6_hdr_expr = 695,             /* ip6_hdr_expr  */
  YYSYMBOL_ip6_hdr_field = 696,            /* ip6_hdr_field  */
  YYSYMBOL_icmp6_hdr_expr = 697,           /* icmp6_hdr_expr  */
  YYSYMBOL_icmp6_hdr_field = 698,          /* icmp6_hdr_field  */
  YYSYMBOL_auth_hdr_expr = 699,            /* auth_hdr_expr  */
  YYSYMBOL_auth_hdr_field = 700,           /* auth_hdr_field  */
  YYSYMBOL_esp_hdr_expr = 701,             /* esp_hdr_expr  */
  YYSYMBOL_esp_hdr_field = 702,            /* esp_hdr_field  */
  YYSYMBOL_comp_hdr_expr = 703,            /* comp_hdr_expr  */
  YYSYMBOL_comp_hdr_field = 704,           /* comp_hdr_field  */
  YYSYMBOL_udp_hdr_expr = 705,             /* udp_hdr_expr  */
  YYSYMBOL_udp_hdr_field = 706,            /* udp_hdr_field  */
  YYSYMBOL_udplite_hdr_expr = 707,         /* udplite_hdr_expr  */
  YYSYMBOL_udplite_hdr_field = 708,        /* udplite_hdr_field  */
  YYSYMBOL_tcp_hdr_expr = 709,             /* tcp_hdr_expr  */
  YYSYMBOL_tcp_hdr_field = 710,            /* tcp_hdr_field  */
  YYSYMBOL_tcp_hdr_option_type = 711,      /* tcp_hdr_option_type  */
  YYSYMBOL_tcp_hdr_option_field = 712,     /* tcp_hdr_option_field  */
  YYSYMBOL_dccp_hdr_expr = 713,            /* dccp_hdr_expr  */
  YYSYMBOL_dccp_hdr_field = 714,           /* dccp_hdr_field  */
  YYSYMBOL_sctp_chunk_type = 715,          /* sctp_chunk_type  */
  YYSYMBOL_sctp_chunk_common_field = 716,  /* sctp_chunk_common_field  */
  YYSYMBOL_sctp_chunk_data_field = 717,    /* sctp_chunk_data_field  */
  YYSYMBOL_sctp_chunk_init_field = 718,    /* sctp_chunk_init_field  */
  YYSYMBOL_sctp_chunk_sack_field = 719,    /* sctp_chunk_sack_field  */
  YYSYMBOL_sctp_chunk_alloc = 720,         /* sctp_chunk_alloc  */
  YYSYMBOL_sctp_hdr_expr = 721,            /* sctp_hdr_expr  */
  YYSYMBOL_sctp_hdr_field = 722,           /* sctp_hdr_field  */
  YYSYMBOL_th_hdr_expr = 723,              /* th_hdr_expr  */
  YYSYMBOL_th_hdr_field = 724,             /* th_hdr_field  */
  YYSYMBOL_exthdr_expr = 725,              /* exthdr_expr  */
  YYSYMBOL_hbh_hdr_expr = 726,             /* hbh_hdr_expr  */
  YYSYMBOL_hbh_hdr_field = 727,            /* hbh_hdr_field  */
  YYSYMBOL_rt_hdr_expr = 728,              /* rt_hdr_expr  */
  YYSYMBOL_rt_hdr_field = 729,             /* rt_hdr_field  */
  YYSYMBOL_rt0_hdr_expr = 730,             /* rt0_hdr_expr  */
  YYSYMBOL_rt0_hdr_field = 731,            /* rt0_hdr_field  */
  YYSYMBOL_rt2_hdr_expr = 732,             /* rt2_hdr_expr  */
  YYSYMBOL_rt2_hdr_field = 733,            /* rt2_hdr_field  */
  YYSYMBOL_rt4_hdr_expr = 734,             /* rt4_hdr_expr  */
  YYSYMBOL_rt4_hdr_field = 735,            /* rt4_hdr_field  */
  YYSYMBOL_frag_hdr_expr = 736,            /* frag_hdr_expr  */
  YYSYMBOL_frag_hdr_field = 737,           /* frag_hdr_field  */
  YYSYMBOL_dst_hdr_expr = 738,             /* dst_hdr_expr  */
  YYSYMBOL_dst_hdr_field = 739,            /* dst_hdr_field  */
  YYSYMBOL_mh_hdr_expr = 740,              /* mh_hdr_expr  */
  YYSYMBOL_mh_hdr_field = 741,             /* mh_hdr_field  */
  YYSYMBOL_exthdr_exists_expr = 742,       /* exthdr_exists_expr  */
  YYSYMBOL_exthdr_key = 743                /* exthdr_key  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   7711

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  359
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  385
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1227
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2070

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   604


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   356,     2,     2,     2,
     353,   354,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   350,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   357,     2,   358,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   351,   355,   352,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   897,   897,   898,   907,   908,   911,   912,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   936,   938,
     946,   961,   968,   980,   988,   989,   990,   991,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1028,  1032,  1039,  1043,  1051,  1055,  1059,
    1066,  1073,  1077,  1084,  1093,  1097,  1101,  1105,  1109,  1113,
    1117,  1121,  1125,  1129,  1133,  1137,  1141,  1147,  1153,  1157,
    1164,  1168,  1176,  1183,  1190,  1194,  1201,  1210,  1214,  1218,
    1222,  1226,  1230,  1234,  1238,  1244,  1250,  1251,  1254,  1255,
    1258,  1259,  1262,  1263,  1266,  1270,  1274,  1278,  1282,  1286,
    1290,  1294,  1298,  1305,  1309,  1313,  1319,  1323,  1327,  1333,
    1339,  1343,  1347,  1351,  1355,  1359,  1363,  1367,  1371,  1375,
    1379,  1383,  1387,  1391,  1395,  1399,  1403,  1407,  1411,  1415,
    1419,  1423,  1427,  1431,  1435,  1439,  1443,  1447,  1451,  1455,
    1459,  1463,  1467,  1471,  1477,  1483,  1487,  1497,  1501,  1505,
    1509,  1513,  1517,  1523,  1527,  1531,  1535,  1539,  1543,  1547,
    1553,  1560,  1566,  1574,  1580,  1588,  1597,  1598,  1601,  1602,
    1603,  1604,  1605,  1606,  1607,  1608,  1611,  1612,  1615,  1616,
    1617,  1620,  1629,  1635,  1650,  1660,  1661,  1662,  1663,  1664,
    1675,  1685,  1696,  1706,  1717,  1728,  1737,  1746,  1755,  1766,
    1777,  1791,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1808,
    1818,  1819,  1820,  1827,  1848,  1859,  1870,  1883,  1888,  1889,
    1890,  1891,  1896,  1902,  1907,  1912,  1917,  1923,  1928,  1933,
    1934,  1945,  1946,  1949,  1953,  1956,  1957,  1958,  1959,  1963,
    1968,  1969,  1970,  1971,  1974,  1975,  1976,  1977,  1982,  1992,
    2003,  2014,  2026,  2035,  2040,  2046,  2051,  2060,  2063,  2067,
    2073,  2074,  2078,  2083,  2084,  2085,  2086,  2100,  2104,  2108,
    2114,  2119,  2126,  2131,  2136,  2139,  2146,  2153,  2166,  2173,
    2174,  2186,  2191,  2192,  2193,  2194,  2198,  2208,  2209,  2210,
    2211,  2215,  2225,  2226,  2227,  2228,  2232,  2243,  2248,  2249,
    2250,  2254,  2264,  2265,  2266,  2267,  2271,  2281,  2282,  2283,
    2284,  2288,  2298,  2299,  2300,  2301,  2305,  2315,  2316,  2317,
    2318,  2322,  2332,  2333,  2334,  2335,  2336,  2339,  2370,  2377,
    2381,  2384,  2394,  2401,  2412,  2425,  2440,  2441,  2444,  2456,
    2462,  2466,  2469,  2475,  2488,  2493,  2502,  2503,  2506,  2509,
    2510,  2511,  2514,  2529,  2530,  2533,  2534,  2535,  2536,  2537,
    2538,  2541,  2550,  2559,  2567,  2575,  2583,  2591,  2599,  2607,
    2615,  2623,  2631,  2639,  2647,  2655,  2663,  2671,  2679,  2683,
    2688,  2696,  2703,  2710,  2724,  2728,  2735,  2739,  2745,  2757,
    2763,  2770,  2776,  2783,  2784,  2785,  2786,  2789,  2790,  2791,
    2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,  2800,  2801,
    2802,  2803,  2804,  2805,  2806,  2807,  2808,  2811,  2812,  2815,
    2824,  2828,  2834,  2840,  2845,  2848,  2853,  2858,  2861,  2867,
    2872,  2880,  2881,  2883,  2887,  2895,  2899,  2902,  2906,  2912,
    2913,  2916,  2922,  2926,  2929,  3054,  3059,  3064,  3069,  3074,
    3080,  3110,  3114,  3118,  3122,  3126,  3132,  3136,  3139,  3143,
    3149,  3163,  3188,  3196,  3197,  3198,  3201,  3202,  3205,  3206,
    3221,  3237,  3245,  3246,  3247,  3250,  3251,  3254,  3255,  3256,
    3271,  3272,  3273,  3274,  3275,  3278,  3281,  3287,  3293,  3297,
    3301,  3308,  3315,  3322,  3329,  3335,  3341,  3347,  3350,  3351,
    3354,  3360,  3366,  3372,  3379,  3386,  3394,  3395,  3398,  3402,
    3410,  3414,  3417,  3422,  3427,  3431,  3437,  3453,  3472,  3478,
    3479,  3485,  3486,  3492,  3493,  3494,  3495,  3496,  3497,  3498,
    3499,  3500,  3501,  3502,  3503,  3504,  3507,  3508,  3512,  3518,
    3519,  3525,  3526,  3532,  3533,  3539,  3542,  3543,  3554,  3555,
    3558,  3562,  3565,  3571,  3577,  3578,  3581,  3582,  3583,  3586,
    3590,  3594,  3599,  3604,  3609,  3615,  3619,  3623,  3627,  3633,
    3638,  3642,  3650,  3659,  3660,  3663,  3666,  3670,  3675,  3681,
    3682,  3685,  3688,  3692,  3696,  3700,  3705,  3712,  3717,  3725,
    3730,  3739,  3740,  3746,  3747,  3748,  3751,  3752,  3756,  3760,
    3766,  3767,  3770,  3776,  3780,  3783,  3788,  3794,  3795,  3798,
    3799,  3800,  3803,  3804,  3810,  3811,  3814,  3815,  3818,  3824,
    3831,  3838,  3849,  3850,  3851,  3854,  3862,  3874,  3881,  3884,
    3890,  3894,  3897,  3903,  3912,  3923,  3929,  3955,  3956,  3965,
    3966,  3969,  3978,  3989,  3990,  3991,  3992,  3993,  3994,  3995,
    3996,  3997,  3998,  3999,  4000,  4001,  4002,  4003,  4006,  4029,
    4030,  4031,  4034,  4035,  4036,  4037,  4038,  4041,  4045,  4048,
    4052,  4059,  4062,  4078,  4079,  4083,  4089,  4090,  4096,  4097,
    4103,  4104,  4110,  4113,  4114,  4125,  4131,  4137,  4138,  4141,
    4147,  4148,  4149,  4152,  4159,  4164,  4169,  4172,  4176,  4180,
    4186,  4187,  4194,  4200,  4201,  4204,  4205,  4208,  4214,  4220,
    4224,  4227,  4231,  4235,  4245,  4249,  4252,  4258,  4265,  4269,
    4275,  4289,  4313,  4318,  4326,  4330,  4334,  4344,  4347,  4348,
    4351,  4352,  4353,  4354,  4365,  4376,  4382,  4403,  4409,  4426,
    4432,  4433,  4434,  4437,  4438,  4439,  4442,  4443,  4446,  4469,
    4475,  4481,  4488,  4502,  4510,  4518,  4524,  4528,  4532,  4536,
    4540,  4547,  4552,  4563,  4586,  4592,  4596,  4600,  4604,  4608,
    4612,  4616,  4620,  4626,  4632,  4640,  4641,  4642,  4645,  4646,
    4650,  4656,  4657,  4663,  4664,  4670,  4671,  4677,  4680,  4681,
    4682,  4691,  4702,  4703,  4706,  4714,  4715,  4716,  4717,  4718,
    4719,  4720,  4721,  4722,  4723,  4724,  4725,  4728,  4729,  4730,
    4731,  4732,  4739,  4746,  4753,  4760,  4767,  4774,  4781,  4788,
    4795,  4802,  4809,  4816,  4819,  4820,  4821,  4822,  4823,  4824,
    4825,  4828,  4832,  4836,  4840,  4844,  4848,  4854,  4855,  4865,
    4869,  4873,  4889,  4890,  4893,  4894,  4895,  4896,  4897,  4900,
    4901,  4902,  4903,  4904,  4905,  4906,  4907,  4908,  4909,  4910,
    4911,  4912,  4913,  4914,  4915,  4916,  4917,  4918,  4919,  4920,
    4921,  4922,  4923,  4926,  4946,  4950,  4965,  4969,  4973,  4979,
    4983,  4989,  4990,  4991,  4994,  4995,  4998,  4999,  5002,  5008,
    5009,  5012,  5013,  5016,  5017,  5020,  5021,  5024,  5032,  5059,
    5064,  5069,  5075,  5076,  5079,  5083,  5103,  5104,  5105,  5106,
    5109,  5113,  5117,  5123,  5124,  5127,  5128,  5129,  5130,  5131,
    5132,  5133,  5134,  5135,  5136,  5137,  5138,  5139,  5140,  5141,
    5142,  5143,  5146,  5147,  5148,  5149,  5150,  5151,  5152,  5155,
    5156,  5157,  5158,  5161,  5162,  5163,  5164,  5167,  5168,  5171,
    5177,  5185,  5198,  5205,  5211,  5217,  5226,  5227,  5228,  5229,
    5230,  5231,  5232,  5233,  5234,  5235,  5236,  5237,  5238,  5239,
    5240,  5241,  5242,  5243,  5246,  5262,  5263,  5264,  5267,  5273,
    5274,  5275,  5278,  5284,  5285,  5286,  5287,  5288,  5291,  5297,
    5298,  5299,  5300,  5301,  5302,  5303,  5304,  5305,  5308,  5312,
    5320,  5327,  5328,  5329,  5330,  5331,  5332,  5333,  5334,  5335,
    5336,  5337,  5338,  5341,  5342,  5343,  5344,  5347,  5348,  5349,
    5350,  5351,  5354,  5360,  5361,  5362,  5363,  5364,  5365,  5366,
    5369,  5375,  5376,  5377,  5378,  5381,  5387,  5388,  5389,  5390,
    5391,  5392,  5393,  5394,  5395,  5397,  5403,  5404,  5405,  5406,
    5407,  5408,  5409,  5410,  5413,  5419,  5420,  5421,  5422,  5423,
    5426,  5432,  5433,  5436,  5442,  5443,  5444,  5447,  5453,  5454,
    5455,  5456,  5459,  5465,  5466,  5467,  5468,  5471,  5475,  5479,
    5484,  5491,  5492,  5493,  5494,  5495,  5496,  5497,  5498,  5499,
    5500,  5503,  5504,  5505,  5506,  5507,  5508,  5509,  5510,  5511,
    5512,  5513,  5514,  5515,  5524,  5525,  5526,  5527,  5528,  5529,
    5530,  5531,  5534,  5540,  5541,  5542,  5545,  5546,  5547,  5548,
    5549,  5550,  5551,  5552,  5553,  5554,  5555,  5556,  5557,  5558,
    5559,  5560,  5561,  5562,  5565,  5566,  5567,  5570,  5571,  5572,
    5573,  5576,  5577,  5578,  5579,  5580,  5583,  5584,  5585,  5586,
    5589,  5594,  5598,  5602,  5606,  5610,  5614,  5619,  5624,  5629,
    5634,  5639,  5646,  5650,  5656,  5657,  5658,  5659,  5662,  5670,
    5671,  5674,  5675,  5676,  5677,  5678,  5679,  5680,  5681,  5684,
    5690,  5691,  5694,  5700,  5701,  5702,  5703,  5706,  5712,  5718,
    5724,  5727,  5733,  5734,  5735,  5736,  5742,  5748,  5749,  5750,
    5751,  5752,  5753,  5756,  5762,  5763,  5766,  5772,  5773,  5774,
    5775,  5776,  5779,  5793,  5794,  5795,  5796,  5797
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"junk\"",
  "\"newline\"", "\"colon\"", "\"semicolon\"", "\"comma\"", "\".\"",
  "\"==\"", "\"!=\"", "\"<\"", "\">\"", "\">=\"", "\"<=\"", "\"<<\"",
  "\">>\"", "\"&\"", "\"^\"", "\"!\"", "\"/\"", "\"*\"", "\"-\"", "\"@\"",
  "\"vmap\"", "\"+\"", "\"include\"", "\"define\"", "\"redefine\"",
  "\"undefine\"", "\"fib\"", "\"socket\"", "\"transparent\"",
  "\"wildcard\"", "\"cgroupv2\"", "\"tproxy\"", "\"osf\"", "\"synproxy\"",
  "\"mss\"", "\"wscale\"", "\"typeof\"", "\"hook\"", "\"hooks\"",
  "\"device\"", "\"devices\"", "\"table\"", "\"tables\"", "\"chain\"",
  "\"chains\"", "\"rule\"", "\"rules\"", "\"sets\"", "\"set\"",
  "\"element\"", "\"map\"", "\"maps\"", "\"flowtable\"", "\"handle\"",
  "\"ruleset\"", "\"trace\"", "\"inet\"", "\"netdev\"", "\"add\"",
  "\"update\"", "\"replace\"", "\"create\"", "\"insert\"", "\"delete\"",
  "\"get\"", "\"list\"", "\"reset\"", "\"flush\"", "\"rename\"",
  "\"describe\"", "\"import\"", "\"export\"", "\"monitor\"", "\"all\"",
  "\"accept\"", "\"drop\"", "\"continue\"", "\"jump\"", "\"goto\"",
  "\"return\"", "\"to\"", "\"constant\"", "\"interval\"", "\"dynamic\"",
  "\"auto-merge\"", "\"timeout\"", "\"gc-interval\"", "\"elements\"",
  "\"expires\"", "\"policy\"", "\"memory\"", "\"performance\"", "\"size\"",
  "\"flow\"", "\"offload\"", "\"meter\"", "\"meters\"", "\"flowtables\"",
  "\"number\"", "\"string\"", "\"quoted string\"",
  "\"string with a trailing asterisk\"", "\"ll\"", "\"nh\"", "\"th\"",
  "\"bridge\"", "\"ether\"", "\"saddr\"", "\"daddr\"", "\"type\"",
  "\"vlan\"", "\"id\"", "\"cfi\"", "\"dei\"", "\"pcp\"", "\"arp\"",
  "\"htype\"", "\"ptype\"", "\"hlen\"", "\"plen\"", "\"operation\"",
  "\"ip\"", "\"version\"", "\"hdrlength\"", "\"dscp\"", "\"ecn\"",
  "\"length\"", "\"frag-off\"", "\"ttl\"", "\"protocol\"", "\"checksum\"",
  "\"ptr\"", "\"value\"", "\"lsrr\"", "\"rr\"", "\"ssrr\"", "\"ra\"",
  "\"icmp\"", "\"code\"", "\"seq\"", "\"gateway\"", "\"mtu\"", "\"igmp\"",
  "\"mrt\"", "\"options\"", "\"ip6\"", "\"priority\"", "\"flowlabel\"",
  "\"nexthdr\"", "\"hoplimit\"", "\"icmpv6\"", "\"param-problem\"",
  "\"max-delay\"", "\"ah\"", "\"reserved\"", "\"spi\"", "\"esp\"",
  "\"comp\"", "\"flags\"", "\"cpi\"", "\"port\"", "\"udp\"", "\"sport\"",
  "\"dport\"", "\"udplite\"", "\"csumcov\"", "\"tcp\"", "\"ackseq\"",
  "\"doff\"", "\"window\"", "\"urgptr\"", "\"option\"", "\"echo\"",
  "\"eol\"", "\"nop\"", "\"sack\"", "\"sack0\"", "\"sack1\"", "\"sack2\"",
  "\"sack3\"", "\"sack-permitted\"", "\"timestamp\"", "\"kind\"",
  "\"count\"", "\"left\"", "\"right\"", "\"tsval\"", "\"tsecr\"",
  "\"dccp\"", "\"sctp\"", "\"chunk\"", "\"data\"", "\"init\"",
  "\"init-ack\"", "\"heartbeat\"", "\"heartbeat-ack\"", "\"abort\"",
  "\"shutdown\"", "\"shutdown-ack\"", "\"error\"", "\"cookie-echo\"",
  "\"cookie-ack\"", "\"ecne\"", "\"cwr\"", "\"shutdown-complete\"",
  "\"asconf-ack\"", "\"forward-tsn\"", "\"asconf\"", "\"tsn\"",
  "\"stream\"", "\"ssn\"", "\"ppid\"", "\"init-tag\"", "\"a-rwnd\"",
  "\"num-outbound-streams\"", "\"num-inbound-streams\"", "\"initial-tsn\"",
  "\"cum-tsn-ack\"", "\"num-gap-ack-blocks\"", "\"num-dup-tsns\"",
  "\"lowest-tsn\"", "\"seqno\"", "\"new-cum-tsn\"", "\"vtag\"", "\"rt\"",
  "\"rt0\"", "\"rt2\"", "\"srh\"", "\"seg-left\"", "\"addr\"",
  "\"last-entry\"", "\"tag\"", "\"sid\"", "\"hbh\"", "\"frag\"",
  "\"reserved2\"", "\"more-fragments\"", "\"dst\"", "\"mh\"", "\"meta\"",
  "\"mark\"", "\"iif\"", "\"iifname\"", "\"iiftype\"", "\"oif\"",
  "\"oifname\"", "\"oiftype\"", "\"skuid\"", "\"skgid\"", "\"nftrace\"",
  "\"rtclassid\"", "\"ibriport\"", "\"obriport\"", "\"ibrname\"",
  "\"obrname\"", "\"pkttype\"", "\"cpu\"", "\"iifgroup\"", "\"oifgroup\"",
  "\"cgroup\"", "\"time\"", "\"classid\"", "\"nexthop\"", "\"ct\"",
  "\"l3proto\"", "\"proto-src\"", "\"proto-dst\"", "\"zone\"",
  "\"direction\"", "\"event\"", "\"expectation\"", "\"expiration\"",
  "\"helper\"", "\"label\"", "\"state\"", "\"status\"", "\"original\"",
  "\"reply\"", "\"counter\"", "\"name\"", "\"packets\"", "\"bytes\"",
  "\"avgpkt\"", "\"counters\"", "\"quotas\"", "\"limits\"",
  "\"synproxys\"", "\"helpers\"", "\"log\"", "\"prefix\"", "\"group\"",
  "\"snaplen\"", "\"queue-threshold\"", "\"level\"", "\"limit\"",
  "\"rate\"", "\"burst\"", "\"over\"", "\"until\"", "\"quota\"",
  "\"used\"", "\"secmark\"", "\"secmarks\"", "\"second\"", "\"minute\"",
  "\"hour\"", "\"day\"", "\"week\"", "\"reject\"", "\"with\"", "\"icmpx\"",
  "\"snat\"", "\"dnat\"", "\"masquerade\"", "\"redirect\"", "\"random\"",
  "\"fully-random\"", "\"persistent\"", "\"queue\"", "\"num\"",
  "\"bypass\"", "\"fanout\"", "\"dup\"", "\"fwd\"", "\"numgen\"",
  "\"inc\"", "\"mod\"", "\"offset\"", "\"jhash\"", "\"symhash\"",
  "\"seed\"", "\"position\"", "\"index\"", "\"comment\"", "\"xml\"",
  "\"json\"", "\"vm\"", "\"notrack\"", "\"exists\"", "\"missing\"",
  "\"exthdr\"", "\"ipsec\"", "\"reqid\"", "\"spnum\"", "\"in\"", "\"out\"",
  "'='", "'{'", "'}'", "'('", "')'", "'|'", "'$'", "'['", "']'", "$accept",
  "input", "stmt_separator", "opt_newline", "close_scope_arp",
  "close_scope_ct", "close_scope_counter", "close_scope_eth",
  "close_scope_fib", "close_scope_hash", "close_scope_ip",
  "close_scope_ip6", "close_scope_vlan", "close_scope_ipsec",
  "close_scope_list", "close_scope_limit", "close_scope_numgen",
  "close_scope_quota", "close_scope_queue", "close_scope_rt",
  "close_scope_sctp", "close_scope_sctp_chunk", "close_scope_secmark",
  "close_scope_socket", "close_scope_log", "common_block", "line",
  "base_cmd", "add_cmd", "replace_cmd", "create_cmd", "insert_cmd",
  "table_or_id_spec", "chain_or_id_spec", "set_or_id_spec",
  "obj_or_id_spec", "delete_cmd", "get_cmd", "list_cmd",
  "basehook_device_name", "basehook_spec", "reset_cmd", "flush_cmd",
  "rename_cmd", "import_cmd", "export_cmd", "monitor_cmd", "monitor_event",
  "monitor_object", "monitor_format", "markup_format", "describe_cmd",
  "table_block_alloc", "table_options", "table_block", "chain_block_alloc",
  "chain_block", "subchain_block", "typeof_data_expr", "typeof_expr",
  "set_block_alloc", "set_block", "set_block_expr", "set_flag_list",
  "set_flag", "map_block_alloc", "map_block_obj_type", "map_block",
  "set_mechanism", "set_policy_spec", "flowtable_block_alloc",
  "flowtable_block", "flowtable_expr", "flowtable_list_expr",
  "flowtable_expr_member", "data_type_atom_expr", "data_type_expr",
  "obj_block_alloc", "counter_block", "quota_block", "ct_helper_block",
  "ct_timeout_block", "ct_expect_block", "limit_block", "secmark_block",
  "synproxy_block", "type_identifier", "hook_spec", "prio_spec",
  "extended_prio_name", "extended_prio_spec", "int_num", "dev_spec",
  "flags_spec", "policy_spec", "policy_expr", "chain_policy", "identifier",
  "string", "time_spec", "family_spec", "family_spec_explicit",
  "table_spec", "tableid_spec", "chain_spec", "chainid_spec",
  "chain_identifier", "set_spec", "setid_spec", "set_identifier",
  "flowtable_spec", "flowtableid_spec", "flowtable_identifier", "obj_spec",
  "objid_spec", "obj_identifier", "handle_spec", "position_spec",
  "index_spec", "rule_position", "ruleid_spec", "comment_spec",
  "ruleset_spec", "rule", "rule_alloc", "stmt_list", "stateful_stmt_list",
  "stateful_stmt", "stmt", "chain_stmt_type", "chain_stmt", "verdict_stmt",
  "verdict_map_stmt", "verdict_map_expr", "verdict_map_list_expr",
  "verdict_map_list_member_expr", "connlimit_stmt", "counter_stmt",
  "counter_stmt_alloc", "counter_args", "counter_arg", "log_stmt",
  "log_stmt_alloc", "log_args", "log_arg", "level_type", "log_flags",
  "log_flags_tcp", "log_flag_tcp", "limit_stmt", "quota_mode",
  "quota_unit", "quota_used", "quota_stmt", "limit_mode",
  "limit_burst_pkts", "limit_burst_bytes", "time_unit", "reject_stmt",
  "reject_stmt_alloc", "reject_with_expr", "reject_opts", "nat_stmt",
  "nat_stmt_alloc", "tproxy_stmt", "synproxy_stmt", "synproxy_stmt_alloc",
  "synproxy_args", "synproxy_arg", "synproxy_config", "synproxy_obj",
  "synproxy_ts", "synproxy_sack", "primary_stmt_expr", "shift_stmt_expr",
  "and_stmt_expr", "exclusive_or_stmt_expr", "inclusive_or_stmt_expr",
  "basic_stmt_expr", "concat_stmt_expr", "map_stmt_expr_set",
  "map_stmt_expr", "prefix_stmt_expr", "range_stmt_expr",
  "multiton_stmt_expr", "stmt_expr", "nat_stmt_args", "masq_stmt",
  "masq_stmt_alloc", "masq_stmt_args", "redir_stmt", "redir_stmt_alloc",
  "redir_stmt_arg", "dup_stmt", "fwd_stmt", "nf_nat_flags", "nf_nat_flag",
  "queue_stmt", "queue_stmt_compat", "queue_stmt_alloc", "queue_stmt_args",
  "queue_stmt_arg", "queue_stmt_expr_simple", "queue_stmt_expr",
  "queue_stmt_flags", "queue_stmt_flag", "set_elem_expr_stmt",
  "set_elem_expr_stmt_alloc", "set_stmt", "set_stmt_op", "map_stmt",
  "meter_stmt", "flow_stmt_legacy_alloc", "flow_stmt_opts",
  "flow_stmt_opt", "meter_stmt_alloc", "match_stmt", "variable_expr",
  "symbol_expr", "set_ref_expr", "set_ref_symbol_expr", "integer_expr",
  "primary_expr", "fib_expr", "fib_result", "fib_flag", "fib_tuple",
  "osf_expr", "osf_ttl", "shift_expr", "and_expr", "exclusive_or_expr",
  "inclusive_or_expr", "basic_expr", "concat_expr", "prefix_rhs_expr",
  "range_rhs_expr", "multiton_rhs_expr", "map_expr", "expr", "set_expr",
  "set_list_expr", "set_list_member_expr", "meter_key_expr",
  "meter_key_expr_alloc", "set_elem_expr", "set_elem_key_expr",
  "set_elem_expr_alloc", "set_elem_options", "set_elem_option",
  "set_elem_expr_options", "set_elem_stmt_list", "set_elem_stmt",
  "set_elem_expr_option", "set_lhs_expr", "set_rhs_expr",
  "initializer_expr", "counter_config", "counter_obj", "quota_config",
  "quota_obj", "secmark_config", "secmark_obj", "ct_obj_type",
  "ct_cmd_type", "ct_l4protoname", "ct_helper_config", "timeout_states",
  "timeout_state", "ct_timeout_config", "ct_expect_config", "ct_obj_alloc",
  "limit_config", "limit_obj", "relational_expr", "list_rhs_expr",
  "rhs_expr", "shift_rhs_expr", "and_rhs_expr", "exclusive_or_rhs_expr",
  "inclusive_or_rhs_expr", "basic_rhs_expr", "concat_rhs_expr",
  "boolean_keys", "boolean_expr", "keyword_expr", "primary_rhs_expr",
  "relational_op", "verdict_expr", "chain_expr", "meta_expr", "meta_key",
  "meta_key_qualified", "meta_key_unqualified", "meta_stmt", "socket_expr",
  "socket_key", "offset_opt", "numgen_type", "numgen_expr", "xfrm_spnum",
  "xfrm_dir", "xfrm_state_key", "xfrm_state_proto_key", "xfrm_expr",
  "hash_expr", "nf_key_proto", "rt_expr", "rt_key", "ct_expr", "ct_dir",
  "ct_key", "ct_key_dir", "ct_key_proto_field", "ct_key_dir_optional",
  "symbol_stmt_expr", "list_stmt_expr", "ct_stmt", "payload_stmt",
  "payload_expr", "payload_raw_expr", "payload_base_spec", "eth_hdr_expr",
  "eth_hdr_field", "vlan_hdr_expr", "vlan_hdr_field", "arp_hdr_expr",
  "arp_hdr_field", "ip_hdr_expr", "ip_hdr_field", "ip_option_type",
  "ip_option_field", "icmp_hdr_expr", "icmp_hdr_field", "igmp_hdr_expr",
  "igmp_hdr_field", "ip6_hdr_expr", "ip6_hdr_field", "icmp6_hdr_expr",
  "icmp6_hdr_field", "auth_hdr_expr", "auth_hdr_field", "esp_hdr_expr",
  "esp_hdr_field", "comp_hdr_expr", "comp_hdr_field", "udp_hdr_expr",
  "udp_hdr_field", "udplite_hdr_expr", "udplite_hdr_field", "tcp_hdr_expr",
  "tcp_hdr_field", "tcp_hdr_option_type", "tcp_hdr_option_field",
  "dccp_hdr_expr", "dccp_hdr_field", "sctp_chunk_type",
  "sctp_chunk_common_field", "sctp_chunk_data_field",
  "sctp_chunk_init_field", "sctp_chunk_sack_field", "sctp_chunk_alloc",
  "sctp_hdr_expr", "sctp_hdr_field", "th_hdr_expr", "th_hdr_field",
  "exthdr_expr", "hbh_hdr_expr", "hbh_hdr_field", "rt_hdr_expr",
  "rt_hdr_field", "rt0_hdr_expr", "rt0_hdr_field", "rt2_hdr_expr",
  "rt2_hdr_field", "rt4_hdr_expr", "rt4_hdr_field", "frag_hdr_expr",
  "frag_hdr_field", "dst_hdr_expr", "dst_hdr_field", "mh_hdr_expr",
  "mh_hdr_field", "exthdr_exists_expr", "exthdr_key", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1727)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-959)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1727,  7155, -1727,   244, -1727, -1727,   106,   211,   211,   211,
    1373,  1373,  1373,  1373,  1373,  1373,  1373,  1373, -1727, -1727,
    2921,   283,  2072,   324,  2005,   332,  6693,   824,  1553,   355,
    6618,    82,   186,   361, -1727, -1727, -1727, -1727,   112,  1373,
    1373,  1373,  1373, -1727, -1727, -1727,   784, -1727,   211, -1727,
     211,   165,  6008, -1727,   244, -1727,   153,   169,   244,   211,
   -1727,   107,   190,  6008,   211, -1727,   363, -1727,   211, -1727,
   -1727,  1373, -1727,  1373,  1373,  1373,  1373,  1373,  1373,  1373,
     364,  1373,  1373,  1373,  1373, -1727,  1373, -1727,  1373,  1373,
    1373,  1373,  1373,  1373,  1373,  1373,   415,  1373,  1373,  1373,
    1373, -1727,  1373, -1727,  1373,  1373,  1373,  1373,  1373,  1373,
    1272,  1373,  1373,  1373,  1373,  1373,   638,  1373,  1373,  1373,
     290,  1373,  1341,  1350,  1355,  1418,  1373,  1373,  1373,  1446,
   -1727,  1373,  1572,  1663,  1373, -1727,  1373,  1373,  1373,  1373,
    1373,   503,  1373, -1727,  1373, -1727,   952,   620,   277,   430,
   -1727, -1727, -1727, -1727,   529,   611,   976,  1748,  2340,  1921,
     461,  1577,   743,  1296,   202,   720,   505,   912,  2365,   185,
     878,  2008,   346,   357,   411,   127,   863,   222,  1187,  5969,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727,  2544, -1727, -1727,   224,  6263,   279,   600,   476,  6618,
     211, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727,   800, -1727, -1727,   284,
   -1727, -1727,   800, -1727, -1727, -1727, -1727,  1611, -1727, -1727,
   -1727,  1373,  1373,  1373,   -49, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,   552,   558,   560, -1727, -1727, -1727,   167,   353,
     733, -1727, -1727, -1727, -1727, -1727, -1727,    31,    31, -1727,
     199,   211,  7366,  4685,   391, -1727,    59,   368, -1727, -1727,
   -1727, -1727, -1727,   124,   627,   281, -1727,   739, -1727,   399,
    6008, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,   696,
   -1727,   613, -1727, -1727, -1727,   440, -1727,  4583, -1727, -1727,
     225, -1727,   273, -1727,   311, -1727, -1727, -1727, -1727,   897,
   -1727,   133, -1727, -1727,   723, -1727, -1727, -1727,   991,   763,
     774,   452, -1727,   314, -1727,  5573, -1727, -1727, -1727,   757,
   -1727, -1727, -1727,   766, -1727,  5840,  5840, -1727, -1727,    95,
     485,   499, -1727, -1727,   508, -1727, -1727, -1727,   522, -1727,
     533,   775,  6008, -1727,   107,   190, -1727,   363, -1727, -1727,
    1373,  1373,  1373,   619, -1727, -1727, -1727,  6008, -1727,   196,
   -1727, -1727, -1727,   209, -1727, -1727, -1727,   267, -1727, -1727,
   -1727, -1727,   333, -1727, -1727,   363, -1727,   457,   568, -1727,
   -1727, -1727, -1727,  1373, -1727, -1727, -1727, -1727,   363, -1727,
   -1727, -1727,   888, -1727, -1727, -1727, -1727,  1373, -1727, -1727,
   -1727, -1727, -1727, -1727,  1373,  1373, -1727, -1727, -1727,   876,
     900, -1727,  1373,   905, -1727,  1373, -1727,  1373, -1727,  1373,
   -1727,  1373, -1727, -1727, -1727, -1727,  1373, -1727, -1727, -1727,
    1373, -1727,  1373, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
    1373, -1727,   211, -1727, -1727, -1727,   957, -1727, -1727, -1727,
   -1727, -1727,   984,    71, -1727, -1727,   686, -1727, -1727,   892,
      52, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,   331,   534, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,   981, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727,  2874, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
    3095, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727,    30, -1727, -1727,   644, -1727, -1727, -1727,
   -1727, -1727, -1727,   671, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727,  2458, -1727, -1727, -1727,
   -1727,   713,   524,   735,   928, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,   722,   719, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727,   800, -1727, -1727,
   -1727, -1727,   -46,   -63,   -21,   179, -1727, -1727, -1727,  4781,
    1002,  6784,  6618, -1727, -1727, -1727, -1727,  1078,  1090,    33,
    1064,  1071,  1073,    91,  1079,  2458,  1081,  6784,  6784,   781,
    6784, -1727, -1727,  1034,  6618,   842,  6784,  6784,  1058, -1727,
    5642,   108, -1727,  1168, -1727, -1727,   793, -1727,  1046,  1052,
     696, -1727, -1727,   183,  1168,  1062,  1082,  1085,  1168,   613,
   -1727,    85, -1727,  6784, -1727,  4979,  1076,   611,   976,  1748,
    2340, -1727,  1577,   678, -1727, -1727, -1727,  1089, -1727, -1727,
   -1727, -1727,  6784, -1727,  1093,  1164,  1176,   882,   407,   562,
   -1727, -1727, -1727, -1727,  1228,  1030,  1233, -1727, -1727, -1727,
   -1727,  1241, -1727, -1727, -1727, -1727,   321, -1727, -1727,  1243,
    1245, -1727,  1140,  1157, -1727, -1727,   225, -1727,  1260, -1727,
   -1727, -1727, -1727,  1274, -1727,  5177, -1727,  1274, -1727,  7251,
   -1727, -1727,   897, -1727,  1276, -1727,   211, -1727,   916, -1727,
     211,    87, -1727,  7251,  7251,  7251,  7251,  7251,  6618,    93,
    6982, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727,  7251, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727,   516, -1727,  1162,  1269,  1281,   953,   695,
    1305, -1727, -1727, -1727,  6982,  6784,  6784,  1214,   105,   244,
    1331, -1727,   980,   244,  1239, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,  1308,   996,  1005,  1016, -1727,  1019,
    1026, -1727, -1727, -1727, -1727,  1080,  1086,   898,  1168, -1727,
    1278,  1290,  1292,  1302, -1727,  1303,  1027, -1727, -1727, -1727,
   -1727, -1727, -1727,  1295, -1727, -1727, -1727, -1727, -1727,  1373,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727,  1304,   620, -1727, -1727, -1727,
   -1727,  1306, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727,   685, -1727, -1727,
    2926, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,  2232,   975,  1348,  1209,  1209, -1727,
   -1727, -1727,  1191, -1727, -1727, -1727, -1727,  1185,  1190, -1727,
    1192,  1193,  1195,   420, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,  1311,  1329, -1727, -1727, -1727, -1727,  1091, -1727,
    1114, -1727, -1727, -1727, -1727, -1727, -1727, -1727,  1330,  1333,
    1111, -1727,  1343,    66, -1727, -1727, -1727,  1095,  1096,  1100,
    1360, -1727, -1727,   781, -1727, -1727, -1727,  1365, -1727, -1727,
   -1727, -1727,  6784,  2340,  1577,  1463,  5375, -1727,   133,    80,
    1462,  1168,  1168,  1369,  6618,  6784,  6784,  6784, -1727,  1370,
    6784,  1424,  6784, -1727, -1727, -1727, -1727,  1379, -1727,    40,
   -1727,   524, -1727,   120,   216,   119,  1441, -1727,  6784, -1727,
     739,  1225,   481,    81, -1727,   417,  1305,   739, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727,  1337,   662, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727,   827,   839,  1417,
     852, -1727,  6784,  1484,  6784, -1727, -1727, -1727,   513,   540,
    6784,  1141, -1727, -1727,  6784,  6784,  6784,  6784,  6784,  1392,
    6784,  6784,    94,  6784,  1274,  6784,  1421,  1493,  1425,  2733,
    2733, -1727, -1727, -1727,  6784,  1030,  6784,  1030, -1727,   130,
   -1727,  1489, -1727,   842, -1727,  6618, -1727,  6618, -1727, -1727,
   -1727,  1162,  1269,  1281, -1727,   739, -1727, -1727, -1727, -1727,
   -1727, -1727,  1158,  7251,  7251,  7251,  7251,  7251,  7251,  7251,
    7251,  7321,  7251,  7251,   584, -1727,  1028, -1727, -1727, -1727,
   -1727, -1727,  1413, -1727,   616,   738,   700,  3319,   681,  2620,
     161, -1727, -1727, -1727, -1727, -1727, -1727,  1170,  1172,  1174,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,  1523, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,  1524,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,  1175,  1180,
   -1727, -1727, -1727, -1727, -1727, -1727,  1111,     0,  1437, -1727,
   -1727, -1727, -1727, -1727,  1133, -1727, -1727, -1727,  1255,  1716,
   -1727,  1442,   886, -1727,   397,    40, -1727,   482, -1727, -1727,
    6784,  6784,  1544, -1727,  1447,  1447, -1727,    80, -1727, -1727,
   -1727,  1201,  1462,  6008,    80, -1727, -1727, -1727, -1727, -1727,
   -1727,  6784, -1727, -1727,   184, -1727, -1727, -1727,  1249, -1727,
    6618,  7251,  6784,  1511, -1727,  7203, -1727,  1382,  1286,  1277,
     481, -1727,  1447,  1447, -1727,    81, -1727,  5642, -1727,  4319,
   -1727, -1727, -1727, -1727,  1566, -1727, -1727,  1188, -1727, -1727,
    1188, -1727, -1727,  1188, -1727, -1727,  6784, -1727, -1727, -1727,
   -1727, -1727,  1093,  1164,  1176, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,  1570,  6784,  1419,  6784, -1727, -1727, -1727, -1727,
    1030, -1727,  1030,  1274, -1727,   298,  6008,  5711,   117, -1727,
   -1727, -1727,  1331,  1579, -1727, -1727,  1162,  1269,  1281, -1727,
     104,  1331, -1727, -1727,   417,  7251,  7321, -1727,  1479,  1545,
   -1727, -1727, -1727, -1727, -1727,   211,   211,   211,   211,   211,
    1487,   429,   211,   211,   211,   211, -1727, -1727, -1727,   244,
   -1727,    76,  1491,  1499, -1727, -1727, -1727,   244,   244,   244,
     244,   244,  6618, -1727,  1447,  1447,  1252,  1211,  1501,   732,
     924,  1423, -1727, -1727, -1727,   244,   244,   253, -1727,  6618,
    1447,  1254,   732,   924, -1727, -1727, -1727,   244,   244,   253,
    1503,  1258,  1517, -1727, -1727, -1727, -1727,  1070,  3653,  2143,
    4164,   511, -1727, -1727, -1727, -1727, -1727, -1727, -1727,   785,
   -1727, -1727,  1514, -1727, -1727,  1516, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727,  1519, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,   652,   300,  1235,  1520, -1727, -1727, -1727, -1727,
   -1727,   197, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,  1249, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
    6784, -1727, -1727, -1727, -1727,  6618,  1267,    80, -1727, -1727,
   -1727, -1727, -1727,  1452,  1324,  1526, -1727, -1727, -1727, -1727,
    6784,    31,    31,   739,  1305, -1727,   114,  1528, -1727,   781,
   -1727, -1727, -1727, -1727, -1727, -1727,   244, -1727,   662, -1727,
   -1727, -1727, -1727,  6784, -1727,  1547, -1727,  1274,  1274,  6618,
   -1727,   345,  1287,  1633,   739, -1727,  1331,  1331,  1456,  1540,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
     211,   211,   211, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727,  1612, -1727, -1727, -1727, -1727, -1727, -1727,
     594, -1727,   244,   244,   363, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727,   896, -1727, -1727, -1727,
   -1727, -1727,  1049, -1727, -1727, -1727, -1727, -1727,   752,   244,
     363,   930,  1049, -1727, -1727, -1727,  1508,   519,   244, -1727,
   -1727, -1727, -1727, -1727, -1727,  1900,   933,  1283, -1727, -1727,
    1656, -1727,  1111, -1727, -1727,  1314,   726,  1373, -1727, -1727,
   -1727, -1727, -1727,  1447,  1564,   726,  1575,  1373, -1727, -1727,
   -1727, -1727, -1727,  1582,  1373, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,  1452,  1324, -1727, -1727, -1727, -1727, -1727,  6008,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727,  1378,  1581, -1727,
      40, -1727, -1727, -1727, -1727, -1727, -1727,  1588,  1408,  1594,
   -1727, -1727, -1727,  6784,  1349,  6618, -1727, -1727,  1246,  5711,
   -1727, -1727,  1529,   244,  1359,  1363,  1364,  1368,  1375, -1727,
   -1727, -1727,  1376,  1395,  1398,  1401,  1597,  6618, -1727, -1727,
   -1727, -1727,   732, -1727,   924, -1727,  6452, -1727, -1727,  1551,
   -1727,   173,   244,    41,   244, -1727, -1727, -1727, -1727, -1727,
    1614, -1727,  1402, -1727, -1727,   244,   244, -1727,   244,   244,
     244,   244,   244, -1727,  1634,   244, -1727,  1378, -1727,  1414,
    1666, -1727,    79, -1727, -1727, -1727, -1727,  1672,   210, -1727,
   -1727,  1426,   739, -1727, -1727,  1456, -1727, -1727, -1727, -1727,
   -1727,  1428,  1429,  1430, -1727, -1727, -1727, -1727,  1291, -1727,
   -1727, -1727,  6618,   244,  1777,  1778,   732, -1727, -1727, -1727,
   -1727,   244,   896,  1685, -1727, -1727, -1727,   944, -1727, -1727,
   -1727, -1727, -1727,   118, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,  1686, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
     726, -1727, -1727, -1727,  1506, -1727, -1727, -1727, -1727, -1727,
    1452,  1324, -1727, -1727,  1529,  1932,  3987,  3837,  4255,  1013,
   -1727, -1727, -1727,  2386,  2367,   945,  1189,   116,  1444,  1508,
     594, -1727,  6618,   896, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727,  1696,  1701,    96, -1727,  1800,   132, -1727,   244, -1727,
   -1727,  1378, -1727, -1727,   244,   244,   244,   244,   244,  2160,
    1913,  1838,   244,   244,   244,   244, -1727, -1727,   519, -1727,
   -1727,  1798, -1727, -1727, -1727, -1727, -1727,  1706,  1686,   244,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,   244,   244,
     244, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     4,     5,     0,     0,     0,     0,
     363,   363,   363,   363,   363,   363,   363,   363,   367,   370,
     363,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   176,   369,     8,    14,    15,     0,   363,
     363,   363,   363,    35,    34,     3,     0,    38,     0,   364,
       0,   388,     0,    33,     0,   358,     0,     0,     0,     0,
     528,    53,    55,     0,     0,   227,     0,   249,     0,   272,
      39,   363,    40,   363,   363,   363,   363,   363,   363,   363,
       0,   363,   363,   363,   363,    41,   363,    42,   363,   363,
     363,   363,   363,   363,   363,   363,     0,   363,   363,   363,
     363,    43,   363,    44,   363,   394,   363,   394,   363,   394,
     394,   363,   363,   394,   363,   394,     0,   363,   394,   394,
       0,   363,   394,   394,   394,   394,   363,   363,   363,   394,
      18,   363,   394,   394,   363,    46,   363,   363,   363,   363,
     394,     0,   363,    47,   363,    48,     0,     0,     0,   681,
     652,   359,   360,   361,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     880,     0,   882,   881,     0,     0,     0,     0,    17,     0,
       0,    52,   648,   647,   653,   654,   191,   664,   665,   658,
     850,   659,   662,   666,   663,   660,   661,   655,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,   656,  1181,  1182,  1183,
    1184,  1185,  1186,  1187,  1188,   657,     0,   188,   189,     0,
      49,   172,     0,    50,   174,   177,    51,   178,   368,   365,
     366,   363,   363,   363,    10,   774,   747,   749,    37,    36,
     371,   373,     0,     0,     0,   390,   389,   391,     0,   518,
       0,   632,   633,   634,   841,   842,   843,   427,   428,   846,
     639,     0,     0,     0,   443,   451,     0,   475,   496,   508,
     509,   585,   591,   612,     0,     0,   886,     7,    58,   396,
     398,   411,   399,   211,   426,   407,   431,   406,    10,   441,
      28,   449,   404,   405,   414,   499,   415,     0,   416,   425,
     516,   419,   584,   420,   590,   421,   422,   417,    22,   610,
     423,     0,   424,   409,     0,   638,   408,   683,   686,   688,
     690,   692,   693,   700,   702,     0,   701,   645,   430,   850,
     412,   418,   410,   655,    29,     0,     0,    32,   382,     0,
       0,     0,    57,   376,     0,    61,   242,   241,     0,   379,
       0,     0,     0,   528,    78,    80,   227,     0,   249,   272,
     363,   363,   363,    10,   774,   747,   749,     0,   118,     0,
     102,   103,   104,     0,    96,    97,   105,     0,    98,    99,
     106,   107,     0,   100,   101,     0,   108,     0,   110,   111,
     751,   752,   750,   363,    10,    19,    21,    26,     0,   141,
     153,   395,   155,   120,   121,   122,   123,   363,   124,   126,
     150,   149,   148,   142,   363,   394,   146,   145,   147,   751,
     752,   753,   363,     0,    10,   363,   127,   363,   130,   363,
     133,   363,   139,    19,    21,    26,   363,   136,    45,    10,
     363,   157,   363,   160,    21,   163,   164,   165,   166,   169,
     363,   168,     0,   985,   986,   987,     0,   672,   673,   674,
     675,   676,   678,     0,   891,   893,     0,   892,    27,     0,
       0,  1179,  1180,  1178,   989,   990,   991,    11,   997,   993,
     994,   995,   996,    16,     0,     0,   999,  1000,  1001,  1002,
    1003,     8,  1021,  1022,  1016,  1011,  1012,  1013,  1014,  1015,
    1017,  1018,  1019,  1020,     0,    14,  1033,  1036,  1035,  1034,
    1037,  1038,  1039,  1032,  1041,  1042,  1043,  1044,  1040,  1053,
    1054,  1046,  1047,  1048,  1050,  1049,  1051,  1052,    15,  1056,
    1061,  1058,  1057,  1062,  1060,  1059,  1063,  1055,  1066,  1069,
    1065,  1067,  1068,  1064,  1072,  1071,  1070,  1074,  1075,  1076,
    1073,  1080,  1081,  1078,  1079,  1077,  1086,  1083,  1084,  1085,
    1082,  1099,  1093,  1096,  1097,  1091,  1092,  1094,  1095,  1098,
    1100,     0,  1087,  1125,  1123,  1124,  1122,  1177,  1174,  1175,
       0,  1176,    24,  1195,    14,  1194,   918,    15,  1193,  1196,
     916,   917,    17,     0,    23,    23,     0,  1197,  1200,  1199,
    1203,  1202,  1204,     0,  1201,  1191,  1190,  1189,  1212,  1209,
    1207,  1208,  1210,  1211,  1206,  1215,  1214,  1213,  1219,  1218,
    1221,  1217,  1220,  1216,   851,   854,   855,   856,    26,   857,
      17,   849,   852,   853,   933,   934,   940,   926,   927,   925,
     935,   936,   956,   929,   938,   931,   932,   937,   928,   930,
     923,   924,   954,   953,   955,    26,     0,     9,   941,   897,
     896,     0,   700,     0,     0,    23,  1223,  1225,  1226,  1227,
    1222,   901,   902,   879,   900,     0,   646,   171,   190,   173,
     179,   180,   182,   181,   184,   185,   183,   186,   771,   771,
     771,    63,     0,     0,   475,     0,   385,   386,   387,     0,
       0,     0,     0,   848,   847,   844,   845,     0,     0,     0,
     851,   849,     0,     0,     0,     0,     9,     0,     0,   484,
       0,   473,   474,     0,     0,     0,     0,     0,     0,     6,
       0,     0,   704,     0,   397,   400,     0,   403,     0,     0,
     442,   445,   413,     0,     0,     0,     0,     0,     0,   450,
     452,     0,   495,     0,   813,     0,     0,    11,    16,     8,
      14,   812,    15,     0,   816,   814,   815,     0,   811,   810,
     802,   803,     0,   546,   549,   551,   553,   555,   556,   561,
     566,   564,   565,   567,   569,   507,   533,   534,   544,   804,
     535,   542,   536,   543,   539,   540,     0,   537,   538,     0,
     568,   541,     0,     0,   525,   524,   517,   520,     0,   603,
     604,   605,   583,   588,   601,     0,   589,   594,   606,     0,
     624,   625,   611,   613,   616,   622,     0,   650,     0,   649,
       0,     0,   640,     0,     0,     0,     0,     0,     0,     0,
       0,   834,   835,   836,   837,   838,   839,   840,    11,    16,
       8,    14,   826,   827,    15,   828,   825,   824,   829,   822,
     823,   821,   830,    24,   832,     0,   817,   787,   818,   697,
     698,   799,   786,   776,   775,   791,   793,   795,   797,   798,
     785,   819,   820,   788,     0,     0,     0,     0,     7,     0,
     741,   740,   798,     0,     0,   327,    75,   195,   212,   228,
     254,   273,   392,    77,     0,     0,     0,     0,    84,     0,
       0,   771,   771,   771,    86,     0,     0,   475,     0,    95,
       0,     0,     0,     0,   109,     0,     0,   771,   113,   116,
     114,   117,   119,     0,   156,   125,   144,   143,     9,   363,
     129,   128,   131,   134,   140,   135,   132,   138,   137,   159,
     158,   161,   162,   167,   170,     0,     0,   671,   669,   670,
      12,     0,   889,   682,   679,   680,   988,   992,    11,    14,
      11,    14,   998,  1023,  1024,  1025,  1026,    14,  1008,  1045,
       0,  1103,  1113,  1104,  1111,  1101,  1102,  1106,  1107,  1108,
    1109,  1110,  1105,  1112,  1089,  1129,  1126,  1127,  1128,  1130,
    1131,  1132,  1133,  1134,  1135,  1136,  1137,  1138,  1139,  1140,
    1141,  1142,  1143,  1160,    25,  1172,   912,   913,   919,    23,
     914,  1192,     0,     0,   858,   939,   942,   943,     0,   945,
       0,   944,   946,   947,     9,     9,   948,   920,     0,     0,
     894,  1224,     0,     0,   667,   175,   187,     0,     0,     0,
       0,   292,    10,   484,   317,    19,   297,     0,    21,   322,
     748,    26,     0,    14,    15,   510,     0,   519,     0,   626,
     628,     0,     0,     0,     0,     0,     0,     0,     9,     0,
       0,   948,     0,   444,    19,   482,   483,     0,    21,     0,
      22,     0,   621,   619,   620,     0,   597,   599,     0,   716,
       7,     7,   718,   713,   715,   798,   737,     7,   703,   393,
     220,   447,   448,   446,   465,    11,     0,     0,   463,   459,
     454,   455,   456,   457,   460,   458,   453,     0,     0,     0,
       0,   575,     0,   570,     0,   805,   808,   809,   806,   807,
       0,     0,   533,   542,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   577,     0,     0,     0,     0,     0,
       0,   522,   523,   521,     0,     0,     0,   592,   615,   617,
     618,     0,   614,     0,   651,     0,   642,     0,   641,   684,
     685,   687,   689,   691,   694,     7,   432,   434,   699,   806,
     807,   831,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   782,   781,   798,   884,   965,   743,
     742,    30,     0,    31,     0,     0,     0,     0,     0,     0,
       0,    94,   195,   212,   228,   254,   273,     0,     0,     0,
      10,    19,    21,    26,   383,   372,   374,   377,   380,   273,
       9,   154,   151,     9,     0,   677,   668,    27,  1004,  1006,
    1005,  1007,  1027,  1028,  1030,  1029,  1031,  1010,    14,     0,
    1116,  1115,  1114,  1117,  1118,  1119,  1120,  1121,  1088,  1157,
    1156,  1158,  1159,  1165,  1147,  1148,  1149,  1150,  1162,  1151,
    1152,  1153,  1154,  1155,  1163,  1164,  1166,  1167,  1168,  1169,
    1170,  1171,  1144,  1146,  1145,  1161,    24,   915,     0,     0,
      14,    14,    15,    15,   921,   922,   894,   894,     0,    13,
     899,   903,   904,    17,     0,   307,   312,   302,     0,     0,
      64,     0,     0,    71,     0,     0,    66,     0,    73,   512,
       0,     0,   511,   629,     0,     0,   723,   627,   719,   888,
     887,     0,   712,     0,   710,   885,   883,     9,   439,     9,
       9,     0,     9,   472,     0,   481,   477,   476,   478,   607,
       0,     0,     0,     0,   707,     0,   708,     0,    10,     0,
     717,   726,     0,     0,   736,   714,   724,   706,   705,     0,
     464,    14,   468,   469,   461,   467,   497,     0,   501,   498,
       0,   503,   506,     0,   505,   576,     0,   580,   582,   545,
     547,   548,   550,   552,   554,   562,   563,   557,   560,   559,
     558,   572,   571,     0,     0,     0,   957,   958,   959,   960,
     586,   602,   593,   595,   623,     0,     0,     0,     0,   435,
     833,   784,   778,     0,   789,   790,   792,   794,   796,   783,
     695,   777,   696,   800,   801,     0,     0,   695,     0,     0,
      76,   329,   328,   331,   330,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    54,   197,   196,     0,
     194,     0,     0,     0,    56,   214,   213,     0,     0,     0,
       0,     0,     0,   238,     0,     0,     0,     0,     0,     0,
       0,     0,    59,   230,   229,     0,     0,     0,   401,     0,
       0,     0,     0,     0,    60,   256,   255,     0,     0,     0,
       0,     0,     0,    10,    62,   275,   274,     0,     0,     0,
       0,     0,   307,   312,   302,    87,    92,    88,    93,     0,
     115,   152,     0,   890,  1009,     0,  1173,  1198,  1205,   949,
     950,   951,   952,    20,     0,    13,   895,   911,   907,   906,
     905,    17,     0,     0,     0,     0,    10,   294,   293,   296,
     295,     0,    19,   319,   318,   321,   320,    21,   299,   298,
     301,   300,   478,    26,   324,   323,   326,   325,   513,   515,
       0,   362,   721,   722,   720,     0,     0,   711,   962,   440,
     963,     9,   961,     0,   487,     0,    21,    22,    22,   598,
       0,     0,     0,     7,   738,   739,     0,     0,   728,   484,
     727,   734,   735,   725,   429,   221,     0,   462,     0,   500,
     502,   504,   573,     0,   579,     0,   581,   587,   596,     0,
     630,     0,     0,     0,     7,   433,   780,   779,   529,     0,
     384,   291,   375,   211,   378,   227,   249,   381,   272,   193,
       0,     0,     0,   291,   291,   291,   291,   198,   356,   357,
     353,   355,   354,     0,   352,   215,   217,   216,   219,   218,
       0,   225,     0,     0,     0,   271,   270,   268,   269,   332,
     334,   335,   333,   288,   336,   289,     0,   287,   245,   246,
     248,   247,     0,   244,   239,   240,   236,   402,     0,     0,
       0,     0,     0,   267,   266,   264,     0,     0,     0,   278,
      79,    81,    82,    83,    85,     0,     0,     0,   112,   984,
       0,   898,   894,   910,   908,     0,     0,     0,     9,   309,
     308,   311,   310,     0,     0,     0,     0,     0,     9,   314,
     313,   316,   315,     0,     0,     9,   304,   303,   306,   305,
     744,    65,     0,   487,    72,    67,   746,    74,   514,     0,
     643,   964,   490,   491,   492,   493,   494,   485,     0,    19,
       0,   480,   608,   609,   600,   709,     9,     0,     0,     0,
     222,   466,   574,     0,     0,     0,   631,   637,     0,   437,
     436,   530,   531,     0,     0,     0,     0,     0,     0,   291,
     291,   291,     0,     0,     0,     0,     0,     0,   232,   234,
     235,   237,     0,   231,     0,   233,     0,   257,   265,     0,
     263,     0,     0,     0,     0,   281,   279,     9,     9,     9,
       0,    13,     0,   757,   756,     0,     0,    69,     0,     0,
       0,     0,     0,    70,     0,     0,    68,   485,   773,     0,
       0,    19,     0,   471,   479,   732,     9,     0,     0,   578,
     635,     0,     7,   532,   526,   529,   327,   212,   228,   254,
     273,     0,     0,     0,   292,   317,   297,   322,   351,   226,
     290,   243,     0,     0,     0,   223,     0,    10,    19,    21,
      26,     0,     0,     0,   346,   340,   339,   343,   338,   341,
     342,   276,   285,     0,   282,   286,   277,    90,    91,    89,
    1090,   909,     0,   763,   765,   768,   769,   766,   767,   770,
       0,   759,   772,   644,     0,   470,   489,   488,   733,    10,
       0,   487,   636,   438,   531,     0,     0,     0,     0,     0,
     307,   312,   302,     0,     0,     0,     0,     0,     0,     0,
       0,   260,     0,     0,   250,   252,   251,   253,   262,   258,
     347,     0,     0,     7,   280,     0,     0,   760,     0,   486,
     729,   485,    19,   527,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   348,   349,     0,   337,
     261,   224,   259,   345,   344,   284,   283,     0,     0,     0,
     758,    19,   731,   210,   199,   200,   201,   202,     0,     0,
       0,    10,    19,    21,    26,   350,   762,   761,   764,   730,
       9,     9,     9,   203,   208,   204,   209,   206,   207,   205
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1727, -1727,    -1, -1033,    26,  -911,  -293,  -461, -1727, -1458,
     -18,   -24,  1288,  -603, -1727,  -467, -1727,  -464, -1062,  -563,
    -830, -1727,  -472,   526, -1727,    20, -1727, -1727,  1789, -1727,
   -1727, -1727, -1727, -1727, -1727,  1574, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
       6, -1727,  1420, -1727,   555,  -314, -1231, -1727, -1727, -1445,
    -381, -1218,  -378,   276,   -34,  -384, -1727, -1221, -1219, -1727,
    -387, -1217,  -205, -1727,  -177,   -15, -1455,  -815,   -86,   -82,
   -1489, -1478, -1474,   -77,   -76,   -66, -1727, -1727,  -144, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727,   150,  -718, -1282,
    1757,   -27,  3063, -1727,  1039, -1727, -1727,   135, -1727,   349,
     702, -1727, -1727,  2911, -1727,  -837,  1457, -1727, -1727,   181,
    1759,  1041,  2325,   -36, -1727, -1727, -1220, -1216,  -313, -1727,
   -1727, -1727, -1727, -1727, -1727,   178, -1727, -1727, -1727, -1727,
    1075, -1727, -1727, -1727,  1068, -1727, -1727, -1727,   195, -1727,
    1555, -1294,   246, -1727, -1028, -1726, -1612, -1551, -1727, -1727,
    -899, -1727, -1727, -1727, -1727, -1727, -1727, -1727,  1036,  -327,
    1480,   -22,   -89,  -153,   701,   699,   703, -1727,  -722, -1727,
   -1727, -1727, -1727, -1727, -1727,  1827, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727,  -280,   683, -1727, -1727, -1727,
   -1727,  1032,   488,   490,  1127,   687, -1164, -1727, -1727,  1608,
   -1727, -1727, -1727, -1727,  1031, -1727, -1727,    57,   -29,  -694,
    -321,   859,   -25, -1727, -1727, -1727,   903,   -26, -1727, -1727,
   -1727, -1727, -1727,  -178,  -181, -1727,  -790,   664,  -714,  1703,
     -58, -1727,   762, -1138, -1727, -1368, -1727, -1727,   527, -1211,
   -1727, -1727,   502,   498, -1727, -1727,  1539,  -579,  1513,  -574,
    1518,  -567,  1515,  1804, -1727, -1578, -1727, -1727,  -113, -1727,
   -1727,   110,  -556,  1530, -1727,  -340,  -311,  -774,  -764,  -759,
   -1727,  -317,  -742, -1727,  1460,  1319,  -770, -1727, -1331,  -287,
     226,  1635, -1727,   -30, -1727,   285, -1727, -1270, -1727,   410,
   -1727, -1727, -1727, -1727, -1727,   688,  -252,   923,  1310,  1244,
    1632,  1641, -1727, -1727,  -490,   144, -1727, -1727, -1727,  1268,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727,   932, -1727, -1727, -1727, -1727, -1727, -1727,   910,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727, -1727,
   -1727, -1727, -1727, -1727, -1727
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,  1555,   770,  1177,  1077,   731,  1175,  1286,  1587,
    1229,  1230,  1176,   713,   478,   969,  1761,   970,   858,  1060,
    1055,  1336,   971,  1002,   782,  1556,    45,    46,    47,    72,
      85,    87,   412,   416,   421,   408,   101,   103,   130,   974,
     440,   135,   143,   145,   260,   263,   266,   267,   727,  1085,
     261,   211,   380,  1509,  1256,   381,  1257,  1419,  1923,  1710,
     384,  1258,   385,  1732,  1733,   388,  1931,  1259,  1535,  1717,
     390,  1260,  1864,  1943,  1944,  1725,  1726,  1834,  1359,  1364,
    1594,  1592,  1593,  1362,  1367,  1255,  1727,  1517,  1862,  1937,
    1938,  1939,  1989,  1518,  1519,  1700,  1701,  1680,   212,  1622,
      48,    49,    59,   415,    51,   419,  1683,    65,   424,  1685,
      69,   429,  1688,   410,   411,  1681,   285,   286,   287,    52,
     392,  1376,   442,  1521,   319,   320,  1537,   321,   322,   323,
     324,   325,   326,  1226,  1468,  1469,   327,   328,   329,   780,
     781,   330,   331,   789,   790,  1165,  1159,  1424,  1425,   332,
    1097,  1398,  1636,   333,  1127,  1891,  1809,  1807,   334,   335,
    1428,   792,   336,   337,   338,   339,   340,   846,   847,  1494,
     379,  1832,  1904,   813,   814,   815,   816,   817,   818,   819,
    1448,   820,   821,   822,   823,   824,   825,   341,   342,   852,
     343,   344,   856,   345,   346,   853,   854,   347,   348,   349,
     862,   863,  1208,  1130,   864,   865,  1108,  1109,   350,   351,
     352,   353,   354,   871,   872,   355,   356,   213,   826,   868,
     907,   827,   357,   217,  1000,   502,   503,   828,   510,   358,
     359,   360,   361,   362,   363,   909,   910,   911,   364,   365,
     366,   771,   772,  1383,  1384,  1141,  1142,  1143,  1377,  1378,
    1415,  1410,  1411,  1416,  1144,  1643,   929,  1600,   732,  1611,
     734,  1617,   735,   433,   463,  1875,  1789,  2006,  2007,  1772,
    1782,  1087,  1606,   733,   367,   930,   931,   915,   916,   917,
     918,  1145,   920,   829,   830,   831,   923,   924,   368,   745,
     832,   671,   672,   220,   370,   833,   508,  1349,   701,   834,
    1083,   714,  1353,  1591,   223,   835,   633,   837,   634,   838,
     696,   697,  1074,  1075,   698,   839,   840,   371,   372,   841,
     228,   496,   229,   517,   230,   523,   231,   531,   232,   545,
    1017,  1298,   233,   553,   234,   558,   235,   568,   236,   577,
     237,   583,   238,   586,   239,   590,   240,   595,   241,   600,
     242,   612,  1034,  1308,   243,   616,  1053,  1335,  1318,  1324,
    1313,  1054,   244,   622,   245,   513,   246,   247,   647,   248,
     635,   249,   637,   250,   639,   251,   644,   252,   654,   253,
     657,   254,   663,   255,   710
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,   214,    53,   987,   218,   216,   985,   775,   387,   776,
     986,   746,   950,   270,   949,   947,   318,  1100,   269,   948,
     992,    44,   369,   214,   702,   913,   218,   382,  1146,  1058,
     869,   715,  1558,   369,   214,   777,   740,   218,   264,  1549,
    1547,   966,  1538,  1538,  1560,   279,  1559,   964,   919,  1561,
    1132,  1465,   936,   374,   914,  1149,  1006,   377,   932,   932,
     972,   268,  1569,   768,   857,  1361,  1160,  1282,  1399,  1210,
    1164,  1612,  1061,  1231,  1645,  1757,  1583,  1585,   441,  1466,
     441,   946,   441,   441,  1755,   836,   441,  1741,   441,  1756,
    1181,   441,   441,  1623,  1738,   441,   441,   441,   441,  1673,
     769,  1221,   441,  1219,  1220,   441,   441,  1404,  1406,   769,
     954,  -652,  1222,   441,  1417,  1147,   866,   866,  1223,  -652,
    -652,  -652,  -652,   386,  1674,  2003,  1213,  1763,  -662,  1113,
    1651,  1652,   870,   934,    55,  -662,  -662,  -662,  -662,  2038,
     256,   968,  1081,  1396,  1942,  -818,  -818,  -818,  -818,   673,
      66,    67,  -818,  1092,  1698,  1699,   866,    56,    57,    58,
    1098,  1962,     3,  1344,  1345,     4,  1624,     5,  1101,  1374,
    1412,   980,  1375,  1413,  -662,   626,   214,  1095,  1004,   218,
     214,  1888,  1966,   218,   997,  1227,   989,     6,     7,     8,
       9,   624,  1467,  1118,    63,  1933,  1064,  1880,   280,  1942,
     281,   271,  1550,  1400,  1633,  1551,  1076,  1388,   764,   378,
      54,   396,   397,   398,   383,   627,  1816,  1792,   389,   151,
     152,   153,   282,  1065,  -663,  1351,  1167,   423,   425,   426,
    1970,  -663,  -663,  -663,  -663,  -745,  1093,   438,  1090,  1168,
    1100,  1887,  1712,  1713,   262,  1671,   449,   450,     4,  1538,
       5,   739,   456,   960,   645,  1169,   219,     4,  1739,     5,
    1154,   747,   717,   842,   843,  1121,   961,   407,   719,  1431,
    -663,  1434,   673,   487,   488,  1934,  1935,   491,   219,   646,
     761,   762,   151,   152,   153,  2041,   765,  1634,  1094,   219,
     369,   214,   624,  1155,   218,   630,   631,   748,   613,    55,
    1793,     3,  -745,  1669,     4,  1091,     5,   912,  1156,   504,
     505,   506,    55,  1971,    55,   221,   627,   912,   912,   998,
     999,  1737,   878,  1552,   962,  1397,     6,     7,     8,     9,
    1096,  1348,    71,  1737,  1584,  1005,   906,   221,   879,   387,
    1549,  1547,   758,  1538,  1538,   584,   906,   906,   221,   655,
    1825,   614,   615,  1157,   744,   744,   943,   848,   759,  2012,
     716,   585,   369,   214,  1967,   767,   218,   387,   880,  1570,
      55,   959,  1571,    86,   656,   632,  1270,   369,   214,   459,
     387,   218,  2008,  1272,  1114,   102,   272,   210,   273,  1773,
     963,  1273,  1119,  1379,  1380,   855,  1774,   210,     3,  1170,
    1271,     4,   144,     5,  1932,  1195,   624,  1196,   867,   844,
     845,  1924,  1352,  1951,  1373,  1817,  1624,   773,   773,  2011,
     257,   258,   259,     6,     7,     8,     9,  1189,   441,  1190,
     627,   219,   210,  1775,  1158,   219,    55,  1252,  1217,  1242,
     222,  1008,  1401,  1553,  1225,   317,   935,   743,   743,   210,
     210,   749,   210,   400,   386,  1737,  1009,  1250,  -192,  -652,
    1148,  1673,   222,  1476,   265,  1474,  1475,  1776,  1446,  1675,
    2004,  1993,   210,   222,  1477,  -662,  1628,  1990,  1629,  1630,
    1478,  1632,   386,     3,  2039,  -818,     4,  1799,     5,   210,
     221,  1878,  1871,  2021,   221,   386,  1337,  1902,  1449,  -475,
     283,   284,  2019,   375,   430,  1824,  1576,  2020,     6,     7,
       8,     9,     3,  1554,   965,     4,  1894,     5,  1690,   376,
    1531,   507,  1936,  1233,   257,   258,   259,  1018,  1659,   210,
    1099,  1660,   878,  1332,  1661,   304,  1234,     6,     7,     8,
       9,  -211,  1211,   699,  1019,  1194,   219,  1288,   490,  1290,
    1333,   306,  1550,   700,  1197,  1551,   307,  1012,   869,   378,
      55,  1110,   509,   280,   460,  1531,   432,   281,  1777,  1228,
    1191,  -663,   383,   640,   554,  1812,  1813,   389,   880,   636,
     304,   461,  1334,  1131,  1244,   151,   152,   153,  1232,   976,
     638,  1233,   849,   850,   851,   555,   306,  -912,     4,  -912,
       5,   307,  1847,  1057,  1485,   221,  1056,  1246,   556,   704,
    1815,  1210,  1531,  1245,  1198,   222,  1192,  1261,   219,   222,
       4,  1819,     5,   718,  -913,   993,  -913,   304,  1363,  1368,
     849,   850,   851,   219,  1366,   591,   741,   773,   401,   592,
     402,  1829,   994,   306,  1010,   641,   642,   643,   307,  1100,
    1670,   760,  1778,     3,   736,  1488,     4,  1393,     5,  1011,
     737,  1901,   738,  1644,  1395,  1693,  1694,  1695,  1696,   761,
     762,   593,   594,  1552,   757,  1146,  1976,   221,     6,     7,
       8,     9,     3,   454,   455,     4,  1132,     5,  1978,   431,
    1977,   432,   221,  1979,  1420,   511,   512,  1826,   761,   762,
    1224,     3,  1240,  1691,     4,  1692,     5,     6,     7,     8,
       9,   766,  1140,   214,   317,  1241,   218,  1242,   224,   210,
    1801,  1522,   514,   515,   516,  1146,     6,     7,     8,     9,
     222,   497,   498,  1086,   773,   214,   773,  1495,   218,     3,
     224,   906,     4,   769,     5,  1765,  -912,  1496,  1407,  1607,
    1588,   224,  1497,   791,  1498,   557,  1499,  1856,  1549,  1547,
    1847,  1538,  1538,  1408,     6,     7,     8,     9,   870,  1523,
    1524,  1525,  1526,  -913,  1527,   783,   934,  1528,  1179,  1409,
     875,   399,  1178,  1182,   278,  1766,     3,   869,     4,     4,
       5,     5,   876,  1553,  1529,   291,   292,   428,  1292,  1360,
     293,  1568,   222,   624,  1566,  1422,  -912,   877,  1567,   925,
    1423,     6,     7,     8,     9,  1293,   452,   222,   926,   773,
    1294,  1295,   912,   626,   711,   712,  1550,   627,   705,  1551,
     906,  1354,   282,  -913,  1613,  1719,   937,   706,   707,  1088,
    1089,   708,   709,  1530,   906,   906,   906,   906,   906,   214,
     938,   906,   218,  1839,  1840,  1841,   569,  1877,   570,   939,
    1720,  1721,  1500,  1754,   499,   500,   912,  1883,   501,  1973,
    1863,   869,   587,   940,  1886,   210,   906,   571,  1842,  1843,
    1844,  1845,   588,   589,   941,   572,   573,     3,   574,   215,
       4,  1873,     5,   224,  1472,   906,  1874,   224,   575,   576,
       4,  1481,     5,  -745,  1852,  1895,   784,   785,   786,   787,
     788,   215,     6,     7,     8,     9,  1471,  1473,  1296,  -272,
    1767,  -754,   215,  1479,  1473,  1482,  1484,  1463,  1251,   150,
    1426,   973,  1253,  1382,     3,  1859,   867,     4,  1852,     5,
    1427,   150,  1426,   630,   631,  -755,     3,  1552,  1531,     4,
     979,     5,  1430,   225,   150,  1426,  1947,  1948,  1949,     6,
       7,     8,     9,   304,   995,  1433,  2001,  1501,   219,  2002,
    2035,     6,     7,     8,     9,   225,  1722,  1565,   648,   306,
     778,   779,  1502,  1001,   307,  1968,   225,  1240,  1764,   773,
     219,  1289,   996,  1291,   649,  1003,  1723,  1724,  1503,  1297,
    1252,  1062,  1242,  1504,  1768,  1505,   873,   874,   224,  1728,
    1729,  1730,   617,  1731,     3,   650,  1214,     4,   773,     5,
    1216,   651,  1773,   632,  1911,  1912,  1913,   221,  1063,  1774,
    1080,  1440,  1441,  1532,  1110,  1240,  1382,   773,  1447,     6,
       7,     8,     9,  1078,   618,   619,   596,  -475,  1486,   221,
    1242,    62,  1506,     4,  1550,     5,  1854,  1551,   493,   494,
     495,  1267,  1268,  1269,   215,  1079,  1775,  1553,   215,  1082,
    1626,     3,   620,  1084,     4,   773,     5,  1280,   597,   598,
     224,   599,  1125,  1126,  1211,   214,  1106,  1146,   218,   518,
    1490,   519,   520,   521,   522,   224,     6,     7,     8,     9,
    1776,  1111,   652,   653,   219,   621,   131,  1495,  1184,  1185,
     391,   132,   133,  1112,   395,  1648,  1115,  1496,  1013,  1014,
    1015,  1016,  1497,  1116,  1498,  1117,  1499,   134,   225,   418,
     391,  1120,   225,  1122,  1450,  1794,  1129,  1758,   257,   258,
     259,  1797,  1138,  1795,  1150,  1676,  1677,   445,  1151,  2067,
    2068,  2069,   222,  1672,  1152,  1182,  1182,  1182,  1182,  1182,
    1174,  1182,  1182,   221,  1161,   867,   860,   861,  1473,  1473,
    1456,  1456,  1811,  1180,  1133,  1552,   486,  1235,  1236,   215,
    1667,  1186,  1668,   492,  1162,  1093,   214,  1163,   214,   218,
       3,   218,  1309,     4,  1187,     5,  1310,  1311,  1312,   761,
     762,  1777,  1340,  1341,   906,   906,   906,   906,   906,   906,
     906,   906,   906,   906,   906,     6,     7,     8,     9,  1131,
     859,   860,   861,   773,   908,  1342,  1343,   369,   214,   769,
    1405,   218,  1500,  1193,   908,   908,     3,  1188,  1602,     4,
    -957,     5,  1201,   225,  1589,  1590,   761,   762,  -958,   867,
    1199,   215,  1200,  1489,  1491,  1507,  1515,  1533,  1545,  1202,
    1749,     6,     7,     8,     9,  1204,   215,  1215,  1100,  2026,
     773,   151,   152,   153,   226,  1492,  1508,  1516,  1534,  1546,
    1574,  1205,   773,  1213,     3,  1868,  1237,     4,   222,     5,
     150,  1426,   151,   152,   153,  1553,   226,  2024,   227,  1238,
     658,  1838,  1837,  1791,  1836,  1715,  1716,   226,  1239,     6,
       7,     8,     9,  1243,   659,   225,  1249,   447,  1581,  1582,
     373,   660,  1579,  1580,   294,   295,   296,  1641,  1642,   299,
     225,   373,    18,    19,  1987,  1988,  1851,  1501,  1233,   661,
     219,  1254,  1893,  1458,  1459,   662,   934,  1262,  1783,   849,
     850,   851,  1502,   369,   214,   746,  1263,   218,  1597,  1140,
     774,  1603,  1858,  1608,  1090,  2018,  1614,  1264,  1503,  1835,
    1265,   214,   906,  1504,   218,  1505,   906,  1266,  1279,  1598,
    1274,    34,  1604,  1656,  1609,  1093,   465,  1615,   906,   369,
     214,    35,  1275,   218,  1276,   467,  1783,    36,  1281,   221,
     469,    18,    19,  1657,  1277,  1278,  1284,   773,  1287,  1327,
      18,    19,  1326,  1338,  1328,    18,    19,  1329,  1655,  1330,
    1331,    37,  1750,   578,  1965,  1319,  1320,  1321,  1322,  1323,
     224,  1339,  1346,    18,    19,  1347,   369,   214,   906,   579,
     218,   219,  1348,   219,  1382,  1350,  1355,  1356,   580,   226,
      34,  1357,  1134,   226,   581,   582,   906,   906,  1997,    34,
      35,  1995,  1358,   471,    34,  1996,    36,  1365,  1370,    35,
     878,  1381,  1389,   227,    35,    36,  1391,   227,    18,    19,
      36,  1394,    34,   219,  1402,  1421,  1889,  1432,  1110,  1436,
      37,   476,    35,   214,  1445,  1439,   218,  1711,    36,    37,
     221,  1454,   221,  1784,    37,  1453,    18,    19,  1697,  1455,
     214,  1242,  1470,   218,  1711,  1487,  1705,  1706,  1707,  1708,
    1709,  1562,    37,  1563,   222,  1564,   773,    34,   369,   214,
    1572,  1575,   218,  1577,  1734,  1735,  1736,    35,  1578,  1586,
    1595,  2025,   221,    36,  1601,  2042,  1743,  1744,  1745,  1620,
    1621,  1784,  1625,  1635,  1640,    34,  1507,  1515,  1533,  1545,
    1314,  1315,  1316,  1317,   226,    35,   224,    37,  1702,  1646,
    1647,    36,   773,  1658,  2059,  1663,  1649,  1508,  1516,  1534,
    1546,  1678,  2066,  1665,  1679,  2064,  1240,  1785,   373,  2065,
    1689,  1769,  1779,  1786,  1703,    37,   214,  1704,   136,   218,
     137,   215,  1714,  1718,  1740,   138,  1746,   139,  1747,   219,
     753,   140,  1770,  1780,  1787,  1748,  1759,   480,  1760,  1800,
     773,  1762,  1790,   215,  1808,   222,   219,   222,  1810,   908,
    1818,  1823,    18,    19,  1994,  1869,   226,  1926,  1828,  1827,
     214,  1831,  1833,   218,  1110,   219,  1682,  1684,  1684,  1687,
     141,   226,   142,  1846,  1719,  1820,   387,   720,  1861,   721,
     373,   722,   723,  1870,  1872,   225,  1879,   222,   221,   724,
     725,   434,   435,   436,   437,   373,  2010,  1881,  1890,  1720,
    1721,    34,   387,  1892,   922,   221,  1884,   225,   559,   560,
    1896,    35,   219,  1897,   922,   922,  1898,    36,   744,   744,
    1918,  1900,   726,   561,   221,   562,   563,   564,   482,  1848,
    1906,  1849,  1850,  1903,  1907,  1908,  1950,     3,  1209,  1909,
       4,    37,     5,    18,    19,  1853,  1910,  1914,   565,   566,
     567,  1855,   908,   908,   908,   908,   908,   215,  1857,   908,
    1876,  1860,     6,     7,     8,     9,  1915,  1866,   219,  1916,
    1882,   221,  1917,  1952,  1769,  1779,  1786,  1885,  2063,  1802,
    1803,  1804,  1805,  1806,   908,   219,  1963,  1960,  1964,   369,
     214,   386,    34,   218,  1969,  1770,  1780,  1787,  1972,  1980,
    1981,  1982,    35,   908,   219,  1992,  -225,  2000,    36,  2005,
    2009,   743,   743,   222,  2028,  1722,   214,   386,  2033,   218,
     906,   225,   224,  2034,  1865,  2037,  -226,   221,  2056,    70,
    1133,  1007,    37,  1573,   945,  1723,  1724,  1557,   214,  1742,
    1921,   218,  1919,  2055,   221,   921,  2036,   214,  1983,   222,
     218,  1925,  1905,  1927,  1985,   921,   921,  1920,  1984,     3,
    1975,  1986,     4,   221,     5,  2029,   413,  1686,   942,  1928,
     420,   219,  1830,  1821,  1929,  1153,  1930,  1166,  1796,   524,
     525,  1941,   763,  1946,     6,     7,     8,     9,   526,   527,
     528,   529,   530,   944,  1953,  1954,   222,  1955,  1956,  1957,
    1958,  1959,  1203,  1974,  1961,  2013,  1443,  1442,  1461,  1638,
    1637,  1444,  1135,   214,  1212,   219,   218,  1711,   742,  1285,
    1464,     3,  1218,   224,     4,   224,     5,  1483,   703,  1418,
     221,  1627,  1650,  1653,     3,   933,   955,     4,  1940,     5,
    1945,   958,  1991,   957,   462,  2057,     6,     7,     8,     9,
    1998,  1999,   222,     3,   956,   755,     4,   751,     5,     6,
       7,     8,     9,  1059,   756,   224,   369,   214,  1325,   222,
     218,  1783,  1299,     0,   221,     0,     0,     0,     6,     7,
       8,     9,     0,   214,     0,     0,   218,  2031,   222,     0,
     934,     0,     0,   215,  1491,  1515,  1533,  1545,     0,     0,
       0,     0,  1597,  1603,  1608,  1614,   226,     0,     0,  2030,
       0,     0,  2032,  1765,     0,  1492,  1516,  1534,  1546,     0,
    1090,     0,  1773,  1598,  1604,  1609,  1615,  2040,   226,  1774,
     227,     0,     0,  2043,  2044,  2045,  2046,  2047,  1769,  1779,
    1786,  2051,  2052,  2053,  2054,   219,  1429,  1429,     0,  1429,
       0,     0,   227,  1766,   546,   222,   547,   225,  2058,  1770,
    1780,  1787,    88,     0,  2027,     0,  1775,  2060,  2061,  2062,
      89,   219,    90,   773,    91,   548,     0,    92,    93,    94,
    1945,    95,     0,   549,   550,   551,   552,     0,  1596,     0,
       0,   224,     0,   219,   215,     0,   215,     0,     0,   222,
    1776,     0,   219,     0,   221,  1865,     0,     0,  1134,   922,
       0,     0,   908,   908,   908,   908,   908,   908,   908,   908,
     908,   908,   908,     0,     0,     0,  1784,   224,     0,    73,
     221,     0,     0,     0,     0,     0,   215,    74,     0,    75,
       0,   623,   226,     0,    76,    77,    78,     0,    79,     0,
       0,  1183,   221,   624,     0,   625,     0,     0,   225,     0,
     225,   221,     0,     0,     3,     0,   227,     4,   219,     5,
       0,     0,     0,   626,   224,     0,     0,   627,     0,     0,
     628,     3,     0,     0,     4,     0,     5,     0,  1767,     6,
       7,     8,     9,     0,     0,   773,     0,     0,   922,     0,
     225,  1777,     0,  1522,  1414,     0,     6,     7,     8,     9,
    2050,     0,   922,   922,   922,   922,   922,     0,     0,   922,
       0,     0,   219,     0,     0,     0,     0,   221,     0,   222,
     224,     0,     0,     0,     0,     0,     0,     0,   219,     0,
       0,     0,     0,     0,   922,     0,     0,   224,     0,     0,
     921,  1523,  1524,  1525,  1526,   222,  1527,   773,     0,  1528,
     629,     0,   215,   922,     0,     0,   224,     0,     0,     0,
     773,     0,  1867,  1765,     0,     0,  1529,   222,     0,   215,
    1209,   221,     0,     0,   908,  2049,   222,     0,     0,   773,
       0,     0,    96,   630,   631,     0,   908,   221,   215,     0,
       0,     0,     0,     0,  2014,     0,  1429,    97,     0,  1429,
       0,     0,  1429,  1766,     0,     0,  1493,  1510,  1520,  1536,
    1548,     0,     0,    98,     0,  1530,   225,     0,    99,     0,
     100,     0,     0,   224,     0,     0,     0,     0,     0,   921,
       0,     0,     0,   225,     0,   215,   908,     0,  1300,     0,
       0,     0,   222,   921,   921,   921,   921,   921,     0,    80,
     921,     0,   225,     0,   908,   908,     0,     0,     0,     0,
       0,     0,     0,   632,    81,     0,     0,   224,   226,     0,
       0,     0,  1301,     0,     0,   921,     0,     0,     3,     0,
      82,     4,     0,     5,     0,    83,     0,    84,     0,     0,
       0,   215,   227,     0,   921,     0,   222,     3,     0,   225,
       4,     0,     5,     6,     7,     8,     9,     0,   215,     0,
    1599,     0,   222,  1605,     0,  1610,     0,     0,  1616,     0,
    1531,     0,     6,     7,     8,     9,     0,   215,  1302,  1303,
    1304,  1305,  1306,  1307,     0,   304,     0,     0,  1767,     0,
       0,     0,   444,     0,   446,   448,     0,     0,   451,     0,
     453,   306,     0,   457,   458,   225,   307,   466,   468,   470,
     472,   532,   533,     0,   477,   534,  1414,   481,   483,   226,
       0,   226,   225,     0,     0,   489,   535,   536,   537,   538,
     539,   540,   541,   542,   543,     0,     0,     0,     0,     0,
     773,   225,     0,   227,   215,   227,     0,   224,     0,     0,
       0,     0,     0,     0,     0,  1752,     0,   773,     0,   601,
       0,   226,     0,  1183,  1183,  1183,  1183,  1183,   602,  1183,
    1183,     0,  2048,   224,     0,   544,     0,     0,  1457,  1457,
       0,     0,     0,   603,     0,   373,     0,   604,   215,     0,
       0,   605,   606,     0,     0,   224,   607,   608,   609,   610,
     611,     0,     0,     0,   224,     0,     0,     0,   225,     0,
       0,     0,   922,   922,   922,   922,   922,   922,   922,   922,
     922,   922,   922,     0,     0,     0,  1105,     0,  1107,  1066,
    1067,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1068,  1123,  1124,     0,  1128,     0,     0,
       0,  1069,   225,  1136,  1137,     0,     0,     0,  1510,  1520,
    1536,  1548,     0,     0,     0,     0,     0,  1070,     0,     0,
     224,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1171,     3,  1173,     0,     4,     0,     5,   226,     0,     0,
       0,     0,     0,  1771,  1781,  1788,     0,     0,     0,     0,
       0,     0,     0,     0,   226,     0,     6,     7,     8,     9,
       0,   373,     0,     0,     0,   674,   675,     0,   215,   676,
    1539,     0,     0,   226,   224,     0,  1093,     0,   227,     0,
    1090,     0,     0,     0,     0,     0,     0,   677,     0,     0,
     224,     0,  1207,     0,   215,     0,     0,   373,   908,     0,
       0,     0,     0,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   773,     0,   215,     0,     0,  1540,
     226,  1541,     0,  1527,     0,   215,  1528,     0,     0,  2023,
     922,     0,   225,   773,   922,     0,  1071,  1072,  1073,   682,
       0,     0,     0,  1542,   373,     0,   922,     0,  2022,     0,
       0,     0,   692,   693,   694,     0,     0,     0,   225,     0,
       0,     0,  1247,  1248,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   226,     0,     0,     0,
     225,     0,     0,     0,     0,     0,     0,     0,     0,   225,
     977,   215,  1543,   226,     0,     0,   922,     0,   678,     0,
     227,     0,     0,     0,     0,     0,  1771,  1781,  1788,     0,
       0,     0,   226,   794,   922,   922,     0,   227,     0,     0,
       0,     0,   679,   680,   681,   682,   683,   684,     0,   685,
     686,   687,   688,   689,   690,   691,   373,     0,   692,   693,
     694,     0,     0,     0,     0,   215,   151,   152,   153,     0,
       0,     0,     0,   888,     0,   225,     0,   889,     0,   695,
       0,   215,   890,     0,     0,     0,     0,     0,   891,     0,
       0,   921,   801,     0,     0,   921,     0,     0,     0,   226,
       0,     0,     0,     0,     0,     0,     0,   921,     0,     0,
       0,     0,   894,     0,     0,     0,     0,  1531,     0,     0,
       0,     0,     0,   227,     0,     0,     0,  1020,     0,   225,
       0,     0,   304,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1021,   226,     0,   225,     0,     0,   306,     0,
       0,    60,     0,   307,     0,     0,     0,   921,     0,  1369,
       0,     0,     0,  1372,     0,     0,     0,   227,     0,     0,
       0,     0,  1385,  1386,  1387,   921,   921,  1390,     0,  1392,
     274,   275,   276,   277,     0,     0,     0,   773,    10,     0,
       0,     0,     0,     0,  1021,  1403,    11,     0,    12,     0,
      13,     0,  1544,    14,    15,    16,  1022,    17,     0,     0,
       0,    18,    19,     0,   393,     0,     0,     0,     0,     0,
       0,     0,   403,   404,   405,   406,     0,     0,     0,  1435,
       0,  1437,     0,     0,     0,     0,     0,  1438,     0,     0,
     804,     0,     0,   805,   806,   439,  1493,  1520,  1536,  1548,
    1451,     0,  1452,     0,  1599,  1605,  1610,  1616,  1022,     0,
      34,  1460,   464,  1462,     0,     0,     0,   473,   474,   475,
      35,     0,   479,   226,     0,   484,    36,  1023,   808,   809,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1771,  1781,  1788,     0,    50,     0,     0,   373,     0,   226,
      37,     0,     0,     0,    61,    50,    50,    64,    64,    64,
      68,     0,     0,    50,     0,     0,     0,     0,     0,   210,
       0,   226,     0,   227,     0,     0,     0,     0,     0,  1023,
     226,     0,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,     0,     0,     0,   227,     0,     0,     0,     0,
       0,     0,     0,     0,   227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,   394,    50,    64,
      64,    64,    68,     0,     0,     0,     0,     0,   922,    50,
       0,   409,   414,   417,    50,   422,    64,    64,   427,     0,
     409,   409,   409,   409,     0,    64,   226,     0,     0,   443,
       0,    50,     0,     0,    64,    64,     0,    68,     0,     0,
      64,     0,   728,   729,   730,     0,     0,     0,    38,     0,
     227,     0,     0,     0,     0,     0,     0,  1618,  1619,   485,
      50,    64,    64,    39,     0,    64,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1631,    40,
     226,     0,     0,     0,    41,     0,    42,     0,     0,  1639,
       0,     0,     0,     0,     0,     0,   226,     0,     0,     0,
       0,     0,     0,     0,   373,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     227,     0,     0,  1662,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1035,     0,     0,     0,     0,     0,
    1664,     0,  1666,     0,     0,     0,     0,     0,     0,   921,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,     0,     0,     0,
       0,   951,   952,   953,     0,     0,     0,     0,     0,     0,
       3,     0,     0,     4,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   146,     0,   967,     6,     7,     8,     9,   147,
     148,     0,     0,     0,   288,   149,   289,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   290,     0,   978,     0,     0,     0,     0,     0,     0,
       0,   291,   292,     0,     0,     0,   293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   294,   295,   296,
     297,   298,   299,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1511,     0,     0,     0,   300,     0,   301,     0,
       0,   150,   151,   152,   153,     0,     0,   154,     0,   155,
       0,     0,  1512,   156,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,   158,     0,     0,  1798,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     159,     0,     0,     0,     0,   160,     0,  1814,   161,     0,
       0,     0,     0,   162,     0,     0,   163,     0,     0,   164,
     165,  1513,     0,     0,   166,     0,     0,   167,     0,   168,
    1822,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     975,   169,   170,     0,     0,     0,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   981,     0,
     982,     0,   983,     0,   984,     0,     0,     0,     0,   988,
       0,     0,     0,   990,     0,   991,     0,   171,   172,   173,
     174,     0,     0,    64,     0,     0,   175,   176,     0,     0,
     177,   178,   302,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,     0,     0,   303,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   304,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   305,     0,     0,     0,     0,     0,   306,     0,     0,
       0,     0,   307,     0,     0,     0,     0,     0,   202,   203,
       0,   308,     0,     0,   309,   310,   311,   312,     0,     0,
       0,   313,     0,     0,     0,   314,   315,   204,     0,     0,
    1899,   205,   206,     0,     3,     0,   773,     4,     0,     5,
     316,     0,     0,   207,   208,     0,     0,     0,     0,     0,
     317,  1514,   209,     0,     0,   210,   146,     0,     0,     6,
       7,     8,     9,   147,   148,     0,     0,     0,   288,   149,
     289,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   290,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   291,   292,     0,     0,     0,
     293,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   294,   295,   296,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1511,     0,     0,     0,
     300,     0,   301,     0,     0,   150,   151,   152,   153,     0,
       0,   154,     0,   155,     0,     0,  1512,   156,     0,     0,
       0,     0,   157,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   159,     0,     0,     0,     0,   160,
       0,     0,   161,     0,     0,     0,     0,   162,     0,     0,
     163,     0,     0,   164,   165,  1513,     0,     0,   166,     0,
       0,   167,     0,   168,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     0,
       0,     4,     0,     5,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     6,     7,     8,     9,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1522,     0,     0,
       0,   171,   172,   173,   174,     0,     0,     0,     0,     0,
     175,   176,     0,     0,   177,   178,   302,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,     0,     0,
     303,     0,     0,     0,     0,  1523,  1524,  1525,  1526,     0,
    1527,     0,     0,  1528,     0,   304,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   305,     0,     0,     0,     0,
    1529,   306,     0,     0,     0,     0,   307,     0,     0,     0,
       0,     0,   202,   203,     0,   308,     0,     0,   309,   310,
     311,   312,     0,     0,     0,   313,     0,     0,     0,   314,
     315,   204,     0,     0,     0,   205,   206,     0,     3,     0,
     773,     4,     0,     5,   316,     0,     0,   207,   208,  1530,
       0,     0,     0,     0,   317,  1751,   209,     0,     0,   210,
     146,     0,     0,     6,     7,     8,     9,   147,   148,     0,
       0,     0,   288,   149,   289,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   290,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,   291,
     292,     0,     0,     0,   293,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   294,   295,   296,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1511,     0,     0,     0,   300,     0,   301,     0,     0,   150,
     151,   152,   153,     0,     0,   154,     0,   155,     0,     0,
    1512,   156,     0,     0,  1531,     0,   157,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,     0,     0,   304,
       0,     0,     0,     0,     0,     0,     0,     0,   159,     0,
       0,     0,     0,   160,     0,   306,   161,     0,     0,     0,
     307,   162,     0,     0,   163,     0,     0,   164,   165,  1513,
       0,     0,   166,     0,     0,   167,     0,   168,     0,     0,
       0,     0,     0,     0,     0,     3,     0,     0,     4,     0,
       5,     0,     0,     0,   773,     0,     0,     0,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,  2016,
       6,     7,     8,     9,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   171,   172,   173,   174,     0,
       0,     0,     0,     0,   175,   176,     0,     0,   177,   178,
     302,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,     0,  1540,   303,  1541,     3,  1527,     0,     4,
    1528,     5,     0,     0,     0,     0,     0,     0,     0,   304,
       0,     0,     0,     0,     0,     0,     0,  1542,     0,   305,
       0,     6,     7,     8,     9,   306,     0,     0,     0,     0,
     307,     0,     0,     0,     0,  1539,   202,   203,     0,   308,
       0,     0,   309,   310,   311,   312,     0,     0,     0,   313,
       0,     0,     0,   314,   315,   204,     0,     0,     0,   205,
     206,     0,     0,     4,   773,     5,  1543,     0,   316,     0,
       0,   207,   208,     0,     0,     0,     0,     0,   317,  2015,
     209,     0,   146,   210,  1540,     0,  1541,     0,  1527,   147,
     148,  1528,     0,     0,   288,   149,   289,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1542,     0,
       0,   290,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   291,   292,     0,     0,     0,   293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   294,   295,   296,
     297,   298,   299,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   300,  1543,   301,     0,
       0,   150,   151,   152,   153,     0,     0,   154,     0,   155,
       0,  1531,     0,   156,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,   158,     0,   304,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     159,     0,   306,     0,     0,   160,     0,   307,   161,     0,
       0,     0,     0,   162,     0,     0,   163,     0,     0,   164,
     165,     0,     0,     0,   166,     0,     0,   167,     0,   168,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   773,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   169,   170,     0,     0,     0,  1753,     0,     0,     0,
       0,     0,  1531,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   304,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,   173,
     174,     0,     0,   306,     0,     0,   175,   176,   307,     0,
     177,   178,   302,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,     0,     0,   303,     0,   793,     0,
       0,     0,   773,     0,     0,     0,     0,     0,     0,     0,
       0,   304,     0,     0,     0,     0,   146,  2017,     0,     0,
       0,   305,     0,     0,   148,     0,     0,   306,     0,   149,
       0,     0,   307,     0,     0,     0,     0,     0,   202,   203,
       0,   308,     0,     0,   309,   310,   311,   312,     0,     0,
       0,   313,     0,     0,     0,   314,   315,   204,     0,     0,
       0,   205,   206,   794,     0,     0,     0,     0,     0,     0,
     316,     0,     0,   207,   208,     0,     0,   795,     0,   796,
     317,  1654,   209,     0,     0,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,   152,   153,     0,
       0,   154,     0,   797,     0,     0,     0,   798,     0,     0,
       0,     0,   799,     0,     0,     0,     0,     0,   800,     0,
       0,     0,   801,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   159,     0,     0,     0,     0,   160,
       0,     0,   802,     0,     0,     0,     0,   162,     0,     0,
     163,     0,     0,   164,   165,     0,     0,     0,   166,     0,
       0,   167,     0,   168,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   752,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   674,   675,     0,     0,
     676,     0,     0,     0,   146,     0,     0,     0,     0,     0,
       0,   803,   148,     0,     0,     0,     0,   149,   677,     0,
       0,     0,     0,     0,     0,     0,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,     0,     0,
     201,   794,     0,     0,     0,     0,     0,     0,     0,     0,
     804,     0,     0,   805,   806,     0,     0,     0,     0,     0,
       0,     0,   753,     0,     0,     0,   807,     0,     0,     0,
       0,     0,     0,   150,   151,   152,   153,     0,     0,   154,
       0,   797,   202,   203,     0,   798,     0,     0,   808,   809,
     799,     0,     0,     0,     0,     0,  1103,     0,     0,     0,
     801,   204,     0,     0,     0,   205,   206,     0,     0,     0,
       0,     0,   159,     0,     0,   810,   811,   160,   670,   678,
    1104,     0,     0,     0,     0,   162,   812,     0,   163,   210,
       0,   164,   165,     0,     0,     0,   166,     0,     0,   167,
       0,   168,     0,   679,   680,   681,   682,   683,   684,   754,
     685,   686,   687,   688,   689,   690,   691,     0,     0,   692,
     693,   694,     0,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1172,     0,     0,     0,     0,     0,
     695,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   146,     0,     0,     0,     0,     0,     0,   803,
     148,     0,     0,     0,     0,   149,     0,     0,     0,     0,
       0,     0,     0,     0,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,     0,     0,   201,   794,
       0,     0,     0,     0,     0,     0,     0,     0,   804,     0,
       0,   805,   806,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,   151,   152,   153,     0,     0,   154,     0,   797,
     202,   203,     0,   798,     0,     0,   808,   809,   799,     0,
       0,     0,     0,     0,  1103,     0,     0,     0,   801,   204,
       0,     0,     0,   205,   206,     0,     0,     0,     0,     0,
     159,     0,     0,   810,   811,   160,   670,     0,  1104,     0,
       0,     0,     0,   162,   812,     0,   163,   210,     0,   164,
     165,     0,     0,     0,   166,     0,     0,   167,     0,   168,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     146,     0,     0,     0,     0,     0,     0,   803,   148,     0,
       0,     0,     0,   149,     0,     0,     0,     0,     0,     0,
       0,     0,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,     0,     0,   201,   794,     0,     0,
       0,     0,     0,     0,     0,     0,   804,     0,     0,   805,
     806,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
     151,   152,   153,     0,     0,   154,     0,   797,   202,   203,
       0,   798,     0,     0,   808,   809,   799,     0,     0,     0,
       0,     0,  1103,     0,     0,     0,   801,   204,     0,     0,
       0,   205,   206,     0,     0,     0,     0,     0,   159,     0,
       0,   810,   811,   160,   670,     0,  1104,     0,     0,     0,
       0,   162,   812,     0,   163,   210,     0,   164,   165,     0,
       0,     0,   166,     0,     0,   167,     0,   168,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1371,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   146,     0,
       0,     0,     0,     0,     0,   803,   148,     0,     0,     0,
       0,   149,     0,     0,     0,     0,     0,     0,     0,     0,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,     0,     0,   201,   794,     0,     0,     0,     0,
       0,     0,     0,     0,   804,     0,     0,   805,   806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   150,   151,   152,
     153,     0,     0,   154,     0,   797,   202,   203,     0,   798,
       0,     0,   808,   809,   799,     0,     0,     0,     0,     0,
    1103,     0,     0,     0,   801,   204,     0,     0,     0,   205,
     206,     0,     0,     0,     0,     0,   159,     0,     0,   810,
     811,   160,   670,     0,  1104,     0,     0,     0,     0,   162,
     812,     0,   163,   210,     0,   164,   165,     0,     0,     0,
     166,     0,     0,   167,     0,   168,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   881,   882,   883,   884,   885,   886,     0,     0,
       0,     0,   887,     0,     0,     0,   866,     0,     0,     0,
       0,     0,     0,   803,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
       0,     0,   201,   794,     0,     0,     0,     0,     0,     0,
       0,     0,   804,     0,     0,   805,   806,     0,     0,     0,
       0,     0,     0,  1139,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,   151,   152,   153,     0,
       0,     0,     0,   888,   202,   203,     0,   889,     0,     0,
     808,   809,   890,     0,     0,     0,     0,     0,   891,     0,
       0,     0,   801,   204,     0,     0,     0,   205,   206,     0,
       0,     0,   794,     0,   892,     0,     0,   810,   811,   893,
     670,     0,   894,     0,     0,     0,     0,   895,   812,     0,
     896,   210,  1139,   897,   898,     0,     0,     0,   899,     0,
       0,   900,     0,   901,   150,   151,   152,   153,     0,     0,
       0,     0,   888,     0,     0,     0,   889,     0,     0,     0,
       0,   890,     0,     0,     0,   902,   903,   891,     0,     0,
       0,   801,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   794,     0,   892,     0,     0,     0,     0,   893,     0,
       0,   894,     0,     0,     0,     0,   895,     0,     0,   896,
       0,     0,   897,   898,     0,     0,     0,   899,     0,     0,
     900,     0,   901,   150,   151,   152,   153,     0,     0,     0,
       0,   888,     0,     0,     0,   889,     0,     0,     0,     0,
     890,     0,     0,     0,   902,   903,   891,     0,     0,     0,
     801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     804,     0,   892,   805,   806,     0,     0,   893,     0,     0,
     894,     0,   927,   866,     0,   895,     0,     0,   896,     0,
       0,   897,   898,     0,     0,     0,   899,     0,     0,   900,
       0,   901,     0,     0,     0,     0,     0,     0,   808,   809,
       0,   904,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   902,   903,     0,     0,     0,     0,     0,
     794,     0,     0,     0,     0,   810,   811,     0,     0,   804,
       0,     0,   805,   806,   317,     0,   905,     0,     0,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,   151,   152,   153,     0,     0,     0,     0,
     888,     0,     0,     0,   889,     0,     0,   808,   809,   890,
     904,     0,     0,     0,     0,   891,     0,     0,     0,   801,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   892,     0,     0,   810,   811,   893,     0,   804,   894,
       0,   805,   806,   317,   895,   905,     0,   896,   210,     0,
     897,   898,     0,     0,     0,   899,     0,     0,   900,     0,
     901,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   808,   809,     0,   904,
       0,   146,   902,   903,     0,     0,     0,     0,   147,   148,
       0,     0,     0,   288,   149,   289,     0,     0,     0,     0,
       0,     0,     0,   810,   811,     0,     0,     0,     0,     0,
     290,     0,     0,     0,   905,     0,     0,   210,     0,     0,
     291,   292,   664,     0,     0,   293,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   294,   295,   296,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   665,
       0,     0,   666,     0,     0,   300,     0,   301,     0,     0,
     150,   151,   152,   153,     0,     0,   154,   804,   155,   667,
     805,   806,   156,     0,     0,     0,     0,   157,     0,     0,
       0,     0,     0,   158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   159,
       0,     0,     0,     0,   160,   808,   809,   161,   904,     0,
       0,     0,   162,     0,     0,   163,     0,     0,   164,   165,
       0,     0,     0,   166,     0,     0,   167,     0,   168,     0,
       0,     0,   810,   811,     0,     0,     0,     0,     0,     0,
       0,   928,     0,   905,     0,     0,   210,     0,     0,     0,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,     0,     0,   171,   172,   173,   174,
       0,     0,     0,     0,     0,   175,   176,     0,     0,   177,
     178,   302,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,     0,   668,   303,     0,     0,   202,   203,
       0,     0,     0,     0,     0,     0,   146,     0,   669,     0,
     304,     0,     0,   147,   148,     0,     0,     0,     0,   149,
     305,     0,     0,     0,     0,     0,   306,     0,     0,     0,
       0,   307,     0,     0,   670,     0,     0,   202,   203,     0,
     308,     0,     0,   309,   310,   311,   312,     0,     0,     0,
     313,     0,     0,     0,   314,   315,   204,     0,     0,     0,
     205,   206,     0,     0,     0,     0,     0,     0,     0,   316,
       0,     0,   207,   208,     0,     0,     0,     0,     0,   317,
       0,   209,     0,     0,   210,   150,   151,   152,   153,     0,
       0,   154,     0,   155,     0,     0,     0,   156,     0,     0,
       0,     0,   157,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   159,     0,     0,     0,     0,   160,
       0,     0,   161,     0,     0,     0,     0,   162,     0,     0,
     163,     0,     0,   164,   165,     0,     0,     0,   166,     0,
       0,   167,     0,   168,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   146,     0,     0,     0,     0,
       0,     0,   147,   148,     0,     0,     0,     0,   149,     0,
       0,   171,   172,   173,   174,     0,     0,     0,     0,     0,
     175,   176,     0,     0,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,     0,     0,
     201,     0,     0,     0,     0,     0,     0,     0,  1922,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,   151,   152,   153,     0,     0,
     154,     0,   155,     0,     0,     0,   156,     0,     0,     0,
       0,   157,   202,   203,     0,     0,     0,   158,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   204,     0,   159,     0,   205,   206,     0,   160,     0,
       0,   161,     0,     0,     0,     0,   162,   207,   208,   163,
       0,     0,   164,   165,   317,     0,   209,   166,     0,   210,
     167,     0,   168,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   146,     0,     0,   169,   170,     0,     0,   147,   148,
       0,     0,     0,     0,   149,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     171,   172,   173,   174,     0,     0,     0,     0,     0,   175,
     176,     0,     0,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,     0,     0,   201,
     150,   151,   152,   153,     0,     0,   154,     0,   155,     0,
     104,     0,   156,     0,     0,   105,     0,   157,   106,   107,
     108,   109,     0,   158,   110,   111,     0,   112,   113,   114,
       0,   115,     0,     0,     0,     0,     0,     0,     0,   159,
       0,   202,   203,     0,   160,     0,     0,   161,     0,     0,
       0,     0,   162,     0,     0,   163,     0,     0,   164,   165,
     204,     0,     0,   166,   205,   206,   167,     0,   168,     0,
     116,     0,   117,   118,   119,     0,   207,   208,     0,     0,
       0,     0,     0,     0,     0,   209,     0,   146,   210,     0,
     169,   170,     0,     0,     0,   148,     0,     0,     0,     0,
     149,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   171,   172,   173,   174,
       0,     0,     0,     0,   794,   175,   176,     0,     0,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,     0,     0,   201,   150,   151,   152,   153,
       0,     0,   154,     0,   797,     0,     0,     0,   798,     0,
       0,     0,     0,   799,     0,     0,     0,     0,     0,  1103,
       0,     0,     0,   801,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   159,     0,   202,   203,     0,
     160,     0,     0,  1104,     0,     0,     0,     0,   162,     0,
       0,   163,     0,     0,   164,   165,   204,     0,     0,   166,
     205,   206,   167,     0,   168,     0,     0,     0,     0,     0,
     120,     0,   207,   208,     0,     0,     0,     0,     0,     0,
       0,   209,     0,     0,   210,   121,   169,   170,     0,     0,
     122,   123,   124,   125,     0,     0,     0,     0,     0,     0,
       0,   126,     0,     0,     0,     0,   127,     0,   128,   129,
       0,     0,     0,     0,     0,   866,     0,     0,     0,     0,
       0,     0,   803,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,     0,
       0,   201,   794,     0,     0,     0,     0,     0,     0,     0,
       0,   804,     0,     0,   805,   806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   150,   151,   152,   153,     0,     0,
       0,     0,   888,   202,   203,     0,   889,     0,     0,   808,
     809,   890,     0,     0,     0,     0,     0,   891,     0,     0,
       0,   801,   204,     0,     0,     0,   205,   206,     0,     0,
       0,     0,     0,   892,     0,     0,   810,   811,   893,   670,
       0,   894,     0,     0,     0,     0,   895,   812,     0,   896,
     210,     0,   897,   898,     0,     0,     0,   899,     0,     0,
     900,     0,   901,     0,     0,     2,     3,     0,     0,     4,
       0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   902,   903,     0,     0,     0,     0,
       0,     6,     7,     8,     9,     0,     0,     0,     0,     0,
       0,     0,    10,     0,     0,     0,     0,     0,     0,     0,
      11,     0,    12,     0,    13,     0,     0,    14,    15,    16,
       0,    17,     0,     0,     0,    18,    19,    20,     0,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -363,   804,
       0,     0,   805,   806,    34,     0,     0,     0,     0,     0,
       0,     0,     0,   794,    35,     0,     0,     0,     0,     0,
      36,   294,   295,   296,  1641,  1642,   299,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   808,   809,     0,
     904,     0,     0,     0,    37,   150,   151,   152,   153,     0,
       0,     0,     0,   888,     0,     0,     0,   889,     0,     0,
       0,   794,   890,     0,   810,   811,     0,     0,   891,     0,
       0,     0,   801,   317,     0,   905,     0,     0,   210,     0,
       0,     0,     0,     0,   892,     0,     0,     0,     0,   893,
       0,     0,   894,   150,   151,   152,   153,   895,     0,     0,
     896,   888,     0,   897,   898,   889,     0,     0,   899,     0,
     890,   900,     0,   901,     0,     0,   891,     0,     0,     0,
     801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   794,   892,     0,     0,   902,   903,   893,     0,     0,
     894,     0,     0,     0,     0,   895,     0,     0,   896,     0,
       0,   897,   898,     0,     0,     0,   899,     0,     0,   900,
       0,   901,    38,  1480,   151,   152,   153,     0,     0,     0,
       0,   888,     0,     0,     0,   889,     0,    39,     0,     0,
     890,     0,     0,   902,   903,     0,   891,     0,     0,     0,
     801,     0,     0,    40,     0,     0,     0,     0,    41,     0,
      42,     0,   892,     0,     0,     0,     0,   893,     0,   750,
     894,     0,     0,     0,     0,   895,     0,     0,   896,     0,
     804,   897,   898,   805,   806,     0,   899,     0,     0,   900,
       0,   901,     0,     0,     0,     0,   665,     0,     0,   666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   902,   903,     0,   667,     0,   808,   809,
       0,   904,     0,     0,     0,     0,     0,     0,   804,     0,
       0,   805,   806,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   810,   811,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   905,     0,     0,   210,
       0,     0,     0,     0,     0,     0,   808,   809,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,   811,     0,     0,     0,   804,     0,
       0,   805,   806,     0,   905,     0,     0,   210,     0,     0,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,     0,     0,     0,     0,     0,   808,   809,     0,   904,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   810,   811,     0,     0,     0,     0,     0,
       0,   668,     0,     0,   905,   202,   203,   210,     0,     0,
       0,     0,     0,     0,     0,   669,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   670
};

static const yytype_int16 yycheck[] =
{
       1,    30,     3,   475,    30,    30,   473,   320,    66,   323,
     474,   298,   399,    37,   398,   396,    52,   735,    36,   397,
     484,     1,    52,    52,   205,   365,    52,    63,   770,   632,
     351,   209,  1263,    63,    63,   328,   288,    63,    32,  1259,
    1259,   428,  1258,  1259,  1265,    46,  1264,   425,   365,  1266,
     764,  1215,   379,    54,   365,   773,   517,    58,   375,   376,
     438,    35,  1279,   315,   344,  1093,   784,   978,  1130,   859,
     788,  1365,   635,   903,  1405,  1564,  1346,  1347,   105,  1217,
     107,   395,   109,   110,  1562,   337,   113,  1542,   115,  1563,
     812,   118,   119,  1375,  1539,   122,   123,   124,   125,  1467,
       4,   875,   129,   873,   874,   132,   133,  1140,  1141,     4,
     403,     7,   876,   140,  1147,     7,    23,    23,   877,    15,
      16,    17,    18,    66,     7,     7,     7,  1585,     8,    96,
    1412,  1413,    45,    38,   103,    15,    16,    17,    18,     7,
      58,   434,   705,   103,   103,    15,    16,    17,    18,   179,
      15,    16,    22,   732,    78,    79,    23,     7,     8,     9,
     734,  1887,     1,  1074,  1075,     4,  1377,     6,   735,    89,
      89,   464,    92,    92,    54,   145,   205,   733,   126,   205,
     209,  1793,   103,   209,   113,   879,   479,    26,    27,    28,
      29,   125,  1225,   102,    13,    22,   668,  1775,    48,   103,
      50,    89,    41,    84,    20,    44,   696,  1118,    84,    59,
     104,    76,    77,    78,    64,   149,   102,    20,    68,   103,
     104,   105,    57,   695,     8,   159,   141,    92,    93,    94,
      20,    15,    16,    17,    18,   284,   299,   102,   284,   154,
     958,  1792,  1524,  1525,    58,  1465,   111,   112,     4,  1465,
       6,    84,   117,    57,   127,   170,    30,     4,  1540,     6,
      77,    62,   256,    38,    39,   755,    57,    86,   262,  1168,
      54,  1170,   302,   138,   139,   102,   103,   142,    52,   152,
     301,   302,   103,   104,   105,  2011,   162,   103,   351,    63,
     320,   320,   125,   110,   320,   265,   266,    98,   113,   103,
     103,     1,   351,     5,     4,   351,     6,   365,   125,    32,
      33,    34,   103,   103,   103,    30,   149,   375,   376,   248,
     249,  1537,     8,   162,    57,   285,    26,    27,    28,    29,
     351,   331,    49,  1549,   334,   283,   365,    52,    24,   397,
    1560,  1560,   283,  1559,  1560,   143,   375,   376,    63,   127,
       5,   166,   167,   170,   297,   298,   392,    84,   299,  1971,
     210,   159,   392,   392,   285,    84,   392,   425,    54,  1280,
     103,   407,  1283,    49,   152,   345,   955,   407,   407,    89,
     438,   407,  1960,   957,   351,    53,   274,   356,   276,    89,
      57,   958,   301,  1111,  1112,    84,    96,   356,     1,   314,
     956,     4,    47,     6,  1859,    84,   125,    86,   351,   184,
     185,  1856,   346,  1871,  1108,   301,  1627,   337,   337,  1970,
     338,   339,   340,    26,    27,    28,    29,    20,   455,    22,
     149,   205,   356,   133,   251,   209,   103,    20,   351,    22,
      30,   110,   323,   282,   351,   351,   351,   297,   298,   356,
     356,   301,   356,    89,   397,  1671,   125,   352,   351,   355,
     352,  1829,    52,  1237,   103,  1235,  1236,   167,  1190,   352,
     352,  1926,   356,    63,  1238,   355,  1387,  1922,  1389,  1390,
    1239,  1392,   425,     1,   352,   355,     4,  1625,     6,   356,
     205,  1773,  1762,  1982,   209,   438,  1059,  1828,  1192,   102,
     335,   336,  1980,   350,    89,  1669,  1336,  1981,    26,    27,
      28,    29,     1,   352,    57,     4,  1810,     6,    89,   350,
     267,   244,   349,     7,   338,   339,   340,   545,  1427,   356,
     351,  1430,     8,   113,  1433,   282,    20,    26,    27,    28,
      29,   351,   859,   319,   568,   825,   320,  1008,    45,  1010,
     130,   298,    41,   329,   233,    44,   303,   531,   879,   409,
     103,   742,   132,   413,   274,   267,   276,   417,   268,   880,
       8,   355,   422,   162,   113,  1637,  1638,   427,    54,   233,
     282,   291,   162,   764,   924,   103,   104,   105,   905,   454,
     233,     7,   319,   320,   321,   134,   298,    84,     4,    86,
       6,   303,     8,   627,    20,   320,   624,   924,   147,   330,
    1643,  1401,   267,   924,   293,   205,    54,   944,   392,   209,
       4,  1649,     6,   339,    84,   490,    86,   282,  1095,  1101,
     319,   320,   321,   407,  1098,   130,   283,   337,   274,   134,
     276,  1674,   492,   298,   110,   234,   235,   236,   303,  1367,
     352,   283,   352,     1,   102,    39,     4,  1124,     6,   125,
     102,  1825,   102,  1405,  1128,  1502,  1503,  1504,  1505,   301,
     302,   166,   167,   162,   283,  1417,  1907,   392,    26,    27,
      28,    29,     1,    45,    46,     4,  1400,     6,  1909,   274,
    1908,   276,   407,  1910,  1155,   166,   167,   352,   301,   302,
     878,     1,     7,   274,     4,   276,     6,    26,    27,    28,
      29,    84,   770,   742,   351,    20,   742,    22,    30,   356,
    1631,    40,   111,   112,   113,  1467,    26,    27,    28,    29,
     320,   111,   112,   727,   337,   764,   337,    37,   764,     1,
      52,   770,     4,     4,     6,    93,   233,    47,   267,   352,
    1353,    63,    52,   313,    54,   294,    56,     5,  1978,  1978,
       8,  1977,  1978,   282,    26,    27,    28,    29,    45,    88,
      89,    90,    91,   233,    93,   162,    38,    96,   802,   298,
      17,    79,   800,   812,     0,   133,     1,  1108,     4,     4,
       6,     6,    18,   282,   113,    62,    63,    95,   113,  1092,
      67,  1273,   392,   125,  1271,   143,   293,   355,  1272,    52,
     148,    26,    27,    28,    29,   130,   114,   407,    52,   337,
     135,   136,   880,   145,   348,   349,    41,   149,   228,    44,
     859,  1083,    57,   293,   352,   103,   351,   237,   238,   729,
     730,   241,   242,   162,   873,   874,   875,   876,   877,   878,
     351,   880,   878,  1690,  1691,  1692,   113,  1768,   115,   351,
     128,   129,   162,   352,   244,   245,   924,  1778,   248,  1902,
     351,  1192,   152,   351,  1785,   356,   905,   134,  1693,  1694,
    1695,  1696,   162,   163,   351,   142,   143,     1,   145,    30,
       4,   165,     6,   205,  1234,   924,   170,   209,   155,   156,
       4,  1241,     6,   284,     8,  1816,   293,   294,   295,   296,
     297,    52,    26,    27,    28,    29,  1233,  1234,   233,   351,
     268,    45,    63,  1240,  1241,  1242,  1243,  1207,   929,   102,
     103,    43,   933,  1114,     1,     5,   879,     4,     8,     6,
     113,   102,   103,   265,   266,    45,     1,   162,   267,     4,
      45,     6,   113,    30,   102,   103,  1867,  1868,  1869,    26,
      27,    28,    29,   282,     7,   113,    22,   267,   742,    25,
    2003,    26,    27,    28,    29,    52,   244,  1270,   115,   298,
     284,   285,   282,   297,   303,  1896,    63,     7,  1591,   337,
     764,  1009,     8,  1011,   131,   103,   264,   265,   298,  1017,
      20,   357,    22,   303,   352,   305,    15,    16,   320,    85,
      86,    87,   134,    89,     1,   152,   866,     4,   337,     6,
     870,   158,    89,   345,  1839,  1840,  1841,   742,   357,    96,
     102,  1184,  1185,   352,  1215,     7,  1217,   337,  1191,    26,
      27,    28,    29,   330,   166,   167,   134,   102,    20,   764,
      22,    12,   352,     4,    41,     6,     7,    44,   106,   107,
     108,   951,   952,   953,   205,   330,   133,   282,   209,   347,
    1383,     1,   194,   354,     4,   337,     6,   967,   166,   167,
     392,   169,   301,   302,  1401,  1114,    84,  1829,  1114,   113,
     352,   115,   116,   117,   118,   407,    26,    27,    28,    29,
     167,    23,   239,   240,   878,   227,   282,    37,    15,    16,
      71,   287,   288,    23,    75,  1408,    52,    47,   137,   138,
     139,   140,    52,    52,    54,    52,    56,   303,   205,    90,
      91,    52,   209,    52,  1192,  1602,   102,   352,   338,   339,
     340,  1613,    84,  1607,   351,  1485,  1486,   108,   102,  2060,
    2061,  2062,   742,  1466,   102,  1184,  1185,  1186,  1187,  1188,
      84,  1190,  1191,   878,   102,  1108,   324,   325,  1485,  1486,
    1199,  1200,  1636,    84,   764,   162,   137,    15,    16,   320,
    1460,    17,  1462,   144,   102,   299,  1215,   102,  1217,  1215,
       1,  1217,   217,     4,    18,     6,   221,   222,   223,   301,
     302,   268,   111,   112,  1233,  1234,  1235,  1236,  1237,  1238,
    1239,  1240,  1241,  1242,  1243,    26,    27,    28,    29,  1400,
     323,   324,   325,   337,   365,   111,   112,  1257,  1257,     4,
       5,  1257,   162,     5,   375,   376,     1,   355,   352,     4,
       7,     6,   102,   320,   111,   112,   301,   302,     7,  1192,
       7,   392,     7,  1254,  1255,  1256,  1257,  1258,  1259,   102,
    1553,    26,    27,    28,    29,     5,   407,   351,  1986,  1987,
     337,   103,   104,   105,    30,  1255,  1256,  1257,  1258,  1259,
    1298,     7,   337,     7,     1,   352,    17,     4,   878,     6,
     102,   103,   103,   104,   105,   282,    52,   352,    30,    18,
     113,  1688,  1686,  1596,  1685,    94,    95,    63,   355,    26,
      27,    28,    29,     8,   127,   392,   102,    45,  1342,  1343,
      52,   134,  1340,  1341,    78,    79,    80,    81,    82,    83,
     407,    63,    60,    61,    43,    44,  1714,   267,     7,   152,
    1114,   102,  1809,  1199,  1200,   158,    38,   351,   113,   319,
     320,   321,   282,  1383,  1383,  1642,   351,  1383,  1359,  1417,
     319,  1362,  1740,  1364,   284,   352,  1367,   351,   298,  1683,
     351,  1400,  1401,   303,  1400,   305,  1405,   351,   351,  1359,
     102,   109,  1362,  1419,  1364,   299,    45,  1367,  1417,  1419,
    1419,   119,   102,  1419,   102,    45,   113,   125,   103,  1114,
      45,    60,    61,  1421,   102,   102,   102,   337,   102,   224,
      60,    61,   221,   102,   224,    60,    61,   225,  1419,   226,
     225,   149,   352,   127,  1891,   216,   217,   218,   219,   220,
     742,   102,   102,    60,    61,   102,  1466,  1466,  1467,   143,
    1466,  1215,   331,  1217,  1625,   102,   351,   351,   152,   205,
     109,   351,   764,   209,   158,   159,  1485,  1486,  1930,   109,
     119,  1928,   102,    45,   109,  1929,   125,   102,     5,   119,
       8,   102,   102,   205,   119,   125,    52,   209,    60,    61,
     125,   102,   109,  1257,    43,   148,  1799,    70,  1669,     5,
     149,    45,   119,  1522,   102,   354,  1522,  1522,   125,   149,
    1215,     8,  1217,   268,   149,    84,    60,    61,  1509,    84,
    1539,    22,   354,  1539,  1539,   102,  1517,  1518,  1519,  1520,
    1521,   351,   149,   351,  1114,   351,   337,   109,  1558,  1558,
       7,     7,  1558,   358,  1535,  1536,  1537,   119,   358,   102,
     285,   352,  1257,   125,   102,  2012,  1547,  1548,  1549,     5,
     103,   268,   351,   304,    43,   109,  1557,  1558,  1559,  1560,
     212,   213,   214,   215,   320,   119,   878,   149,  1511,   187,
     284,   125,   337,     7,  2041,     5,   299,  1557,  1558,  1559,
    1560,   102,  2054,   164,    39,  2052,     7,   352,   320,  2053,
     103,  1592,  1593,  1594,   103,   149,  1625,    98,    45,  1625,
      47,   742,   350,   102,   350,    52,   103,    54,   350,  1383,
     187,    58,  1592,  1593,  1594,    98,   102,    45,   102,   352,
     337,   102,   102,   764,   300,  1215,  1400,  1217,   102,   770,
     102,    84,    60,    61,  1927,   352,   392,    86,     5,   352,
    1669,   185,   102,  1669,  1825,  1419,  1496,  1497,  1498,  1499,
      97,   407,    99,    41,   103,  1656,  1714,    46,   150,    48,
     392,    50,    51,     7,   350,   742,   102,  1257,  1383,    58,
      59,    97,    98,    99,   100,   407,  1969,   102,   300,   128,
     129,   109,  1740,   102,   365,  1400,   104,   764,   111,   112,
     102,   119,  1466,   285,   375,   376,   102,   125,  1641,  1642,
     103,   352,    91,   126,  1419,   128,   129,   130,    45,  1710,
     351,  1712,  1713,   184,   351,   351,   102,     1,   859,   351,
       4,   149,     6,    60,    61,  1726,   351,   351,   151,   152,
     153,  1732,   873,   874,   875,   876,   877,   878,  1739,   880,
    1767,  1742,    26,    27,    28,    29,   351,  1748,  1522,   351,
    1777,  1466,   351,   351,  1755,  1756,  1757,  1784,  2051,   307,
     308,   309,   310,   311,   905,  1539,   352,   133,   102,  1799,
    1799,  1714,   109,  1799,   102,  1755,  1756,  1757,   352,   351,
     351,   351,   119,   924,  1558,     8,     8,   102,   125,   103,
     284,  1641,  1642,  1383,   350,   244,  1825,  1740,   102,  1825,
    1829,   878,  1114,   102,  1747,     5,     8,  1522,   102,    20,
    1400,   523,   149,  1287,   394,   264,   265,  1262,  1847,  1543,
    1854,  1847,  1847,  2028,  1539,   365,  2003,  1856,  1914,  1419,
    1856,  1856,  1833,   282,  1916,   375,   376,  1852,  1915,     1,
    1906,  1917,     4,  1558,     6,  1989,    89,  1498,   391,   298,
      91,  1625,  1674,  1658,   303,   780,   305,   789,  1612,   111,
     112,  1862,   307,  1864,    26,    27,    28,    29,   120,   121,
     122,   123,   124,   393,  1875,  1876,  1466,  1878,  1879,  1880,
    1881,  1882,   846,  1905,  1885,  1974,  1187,  1186,  1205,  1401,
    1400,  1188,   765,  1922,   862,  1669,  1922,  1922,   290,   996,
    1213,     1,   871,  1215,     4,  1217,     6,  1243,   205,  1147,
    1625,  1384,  1410,  1415,     1,   376,   403,     4,  1861,     6,
    1863,   406,  1923,   405,   120,  2038,    26,    27,    28,    29,
    1931,  1932,  1522,     1,   404,   303,     4,   302,     6,    26,
      27,    28,    29,   633,   303,  1257,  1976,  1976,  1038,  1539,
    1976,   113,  1020,    -1,  1669,    -1,    -1,    -1,    26,    27,
      28,    29,    -1,  1992,    -1,    -1,  1992,  1992,  1558,    -1,
      38,    -1,    -1,  1114,  1975,  1976,  1977,  1978,    -1,    -1,
      -1,    -1,  1983,  1984,  1985,  1986,   742,    -1,    -1,  1990,
      -1,    -1,  1993,    93,    -1,  1975,  1976,  1977,  1978,    -1,
     284,    -1,    89,  1983,  1984,  1985,  1986,  2008,   764,    96,
     742,    -1,    -1,  2014,  2015,  2016,  2017,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2025,  1799,  1167,  1168,    -1,  1170,
      -1,    -1,   764,   133,   113,  1625,   115,  1114,  2039,  2019,
    2020,  2021,    37,    -1,  1987,    -1,   133,  2048,  2049,  2050,
      45,  1825,    47,   337,    49,   134,    -1,    52,    53,    54,
    2003,    56,    -1,   142,   143,   144,   145,    -1,   352,    -1,
      -1,  1383,    -1,  1847,  1215,    -1,  1217,    -1,    -1,  1669,
     167,    -1,  1856,    -1,  1799,  2028,    -1,    -1,  1400,   770,
      -1,    -1,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,    -1,    -1,    -1,   268,  1419,    -1,    37,
    1825,    -1,    -1,    -1,    -1,    -1,  1257,    45,    -1,    47,
      -1,   113,   878,    -1,    52,    53,    54,    -1,    56,    -1,
      -1,   812,  1847,   125,    -1,   127,    -1,    -1,  1215,    -1,
    1217,  1856,    -1,    -1,     1,    -1,   878,     4,  1922,     6,
      -1,    -1,    -1,   145,  1466,    -1,    -1,   149,    -1,    -1,
     152,     1,    -1,    -1,     4,    -1,     6,    -1,   268,    26,
      27,    28,    29,    -1,    -1,   337,    -1,    -1,   859,    -1,
    1257,   268,    -1,    40,  1143,    -1,    26,    27,    28,    29,
     352,    -1,   873,   874,   875,   876,   877,    -1,    -1,   880,
      -1,    -1,  1976,    -1,    -1,    -1,    -1,  1922,    -1,  1799,
    1522,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1992,    -1,
      -1,    -1,    -1,    -1,   905,    -1,    -1,  1539,    -1,    -1,
     770,    88,    89,    90,    91,  1825,    93,   337,    -1,    96,
     232,    -1,  1383,   924,    -1,    -1,  1558,    -1,    -1,    -1,
     337,    -1,   352,    93,    -1,    -1,   113,  1847,    -1,  1400,
    1401,  1976,    -1,    -1,  1405,   352,  1856,    -1,    -1,   337,
      -1,    -1,   267,   265,   266,    -1,  1417,  1992,  1419,    -1,
      -1,    -1,    -1,    -1,   352,    -1,  1427,   282,    -1,  1430,
      -1,    -1,  1433,   133,    -1,    -1,  1255,  1256,  1257,  1258,
    1259,    -1,    -1,   298,    -1,   162,  1383,    -1,   303,    -1,
     305,    -1,    -1,  1625,    -1,    -1,    -1,    -1,    -1,   859,
      -1,    -1,    -1,  1400,    -1,  1466,  1467,    -1,    96,    -1,
      -1,    -1,  1922,   873,   874,   875,   876,   877,    -1,   267,
     880,    -1,  1419,    -1,  1485,  1486,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   345,   282,    -1,    -1,  1669,  1114,    -1,
      -1,    -1,   130,    -1,    -1,   905,    -1,    -1,     1,    -1,
     298,     4,    -1,     6,    -1,   303,    -1,   305,    -1,    -1,
      -1,  1522,  1114,    -1,   924,    -1,  1976,     1,    -1,  1466,
       4,    -1,     6,    26,    27,    28,    29,    -1,  1539,    -1,
    1359,    -1,  1992,  1362,    -1,  1364,    -1,    -1,  1367,    -1,
     267,    -1,    26,    27,    28,    29,    -1,  1558,   186,   187,
     188,   189,   190,   191,    -1,   282,    -1,    -1,   268,    -1,
      -1,    -1,   107,    -1,   109,   110,    -1,    -1,   113,    -1,
     115,   298,    -1,   118,   119,  1522,   303,   122,   123,   124,
     125,   111,   112,    -1,   129,   115,  1415,   132,   133,  1215,
      -1,  1217,  1539,    -1,    -1,   140,   126,   127,   128,   129,
     130,   131,   132,   133,   134,    -1,    -1,    -1,    -1,    -1,
     337,  1558,    -1,  1215,  1625,  1217,    -1,  1799,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,   337,    -1,   134,
      -1,  1257,    -1,  1184,  1185,  1186,  1187,  1188,   143,  1190,
    1191,    -1,   352,  1825,    -1,   175,    -1,    -1,  1199,  1200,
      -1,    -1,    -1,   158,    -1,  1257,    -1,   162,  1669,    -1,
      -1,   166,   167,    -1,    -1,  1847,   171,   172,   173,   174,
     175,    -1,    -1,    -1,  1856,    -1,    -1,    -1,  1625,    -1,
      -1,    -1,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,
    1241,  1242,  1243,    -1,    -1,    -1,   739,    -1,   741,   111,
     112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   125,   757,   758,    -1,   760,    -1,    -1,
      -1,   133,  1669,   766,   767,    -1,    -1,    -1,  1557,  1558,
    1559,  1560,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
    1922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     793,     1,   795,    -1,     4,    -1,     6,  1383,    -1,    -1,
      -1,    -1,    -1,  1592,  1593,  1594,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1400,    -1,    26,    27,    28,    29,
      -1,  1383,    -1,    -1,    -1,   111,   112,    -1,  1799,   115,
      40,    -1,    -1,  1419,  1976,    -1,   299,    -1,  1400,    -1,
     284,    -1,    -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,
    1992,    -1,   855,    -1,  1825,    -1,    -1,  1419,  1829,    -1,
      -1,    -1,    -1,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,   337,    -1,  1847,    -1,    -1,    89,
    1466,    91,    -1,    93,    -1,  1856,    96,    -1,    -1,   352,
    1401,    -1,  1799,   337,  1405,    -1,   268,   269,   270,   271,
      -1,    -1,    -1,   113,  1466,    -1,  1417,    -1,   352,    -1,
      -1,    -1,   284,   285,   286,    -1,    -1,    -1,  1825,    -1,
      -1,    -1,   925,   926,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1522,    -1,    -1,    -1,
    1847,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1856,
     455,  1922,   162,  1539,    -1,    -1,  1467,    -1,   244,    -1,
    1522,    -1,    -1,    -1,    -1,    -1,  1755,  1756,  1757,    -1,
      -1,    -1,  1558,    70,  1485,  1486,    -1,  1539,    -1,    -1,
      -1,    -1,   268,   269,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,   281,  1558,    -1,   284,   285,
     286,    -1,    -1,    -1,    -1,  1976,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,    -1,  1922,    -1,   114,    -1,   305,
      -1,  1992,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,  1401,   129,    -1,    -1,  1405,    -1,    -1,    -1,  1625,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1417,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   267,    -1,    -1,
      -1,    -1,    -1,  1625,    -1,    -1,    -1,    23,    -1,  1976,
      -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    38,  1669,    -1,  1992,    -1,    -1,   298,    -1,
      -1,    10,    -1,   303,    -1,    -1,    -1,  1467,    -1,  1102,
      -1,    -1,    -1,  1106,    -1,    -1,    -1,  1669,    -1,    -1,
      -1,    -1,  1115,  1116,  1117,  1485,  1486,  1120,    -1,  1122,
      39,    40,    41,    42,    -1,    -1,    -1,   337,    37,    -1,
      -1,    -1,    -1,    -1,    38,  1138,    45,    -1,    47,    -1,
      49,    -1,   352,    52,    53,    54,   102,    56,    -1,    -1,
      -1,    60,    61,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    81,    82,    83,    84,    -1,    -1,    -1,  1172,
      -1,  1174,    -1,    -1,    -1,    -1,    -1,  1180,    -1,    -1,
     277,    -1,    -1,   280,   281,   104,  1975,  1976,  1977,  1978,
    1193,    -1,  1195,    -1,  1983,  1984,  1985,  1986,   102,    -1,
     109,  1204,   121,  1206,    -1,    -1,    -1,   126,   127,   128,
     119,    -1,   131,  1799,    -1,   134,   125,   173,   315,   316,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
    2019,  2020,  2021,    -1,     1,    -1,    -1,  1799,    -1,  1825,
     149,    -1,    -1,    -1,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,   356,
      -1,  1847,    -1,  1825,    -1,    -1,    -1,    -1,    -1,   173,
    1856,    -1,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,    -1,    -1,    -1,  1847,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1856,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,  1829,    86,
      -1,    88,    89,    90,    91,    92,    93,    94,    95,    -1,
      97,    98,    99,   100,    -1,   102,  1922,    -1,    -1,   106,
      -1,   108,    -1,    -1,   111,   112,    -1,   114,    -1,    -1,
     117,    -1,   271,   272,   273,    -1,    -1,    -1,   267,    -1,
    1922,    -1,    -1,    -1,    -1,    -1,    -1,  1370,  1371,   136,
     137,   138,   139,   282,    -1,   142,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1391,   298,
    1976,    -1,    -1,    -1,   303,    -1,   305,    -1,    -1,  1402,
      -1,    -1,    -1,    -1,    -1,    -1,  1992,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1992,    -1,    -1,  1436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,    -1,    -1,    -1,
    1453,    -1,  1455,    -1,    -1,    -1,    -1,    -1,    -1,  1829,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,    -1,    -1,    -1,
      -1,   400,   401,   402,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,     4,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    -1,   433,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    35,    36,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,   462,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    -1,    99,    -1,
      -1,   102,   103,   104,   105,    -1,    -1,   108,    -1,   110,
      -1,    -1,   113,   114,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,   125,    -1,    -1,  1620,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,   146,    -1,  1640,   149,    -1,
      -1,    -1,    -1,   154,    -1,    -1,   157,    -1,    -1,   160,
     161,   162,    -1,    -1,   165,    -1,    -1,   168,    -1,   170,
    1663,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     447,   192,   193,    -1,    -1,    -1,    -1,   454,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   465,    -1,
     467,    -1,   469,    -1,   471,    -1,    -1,    -1,    -1,   476,
      -1,    -1,    -1,   480,    -1,   482,    -1,   228,   229,   230,
     231,    -1,    -1,   490,    -1,    -1,   237,   238,    -1,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   292,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,
      -1,    -1,   303,    -1,    -1,    -1,    -1,    -1,   309,   310,
      -1,   312,    -1,    -1,   315,   316,   317,   318,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,   327,   328,    -1,    -1,
    1823,   332,   333,    -1,     1,    -1,   337,     4,    -1,     6,
     341,    -1,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,
     351,   352,   353,    -1,    -1,   356,    23,    -1,    -1,    26,
      27,    28,    29,    30,    31,    -1,    -1,    -1,    35,    36,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    -1,    99,    -1,    -1,   102,   103,   104,   105,    -1,
      -1,   108,    -1,   110,    -1,    -1,   113,   114,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,   146,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,
     157,    -1,    -1,   160,   161,   162,    -1,    -1,   165,    -1,
      -1,   168,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,     4,    -1,     6,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    26,    27,    28,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,   228,   229,   230,   231,    -1,    -1,    -1,    -1,    -1,
     237,   238,    -1,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    -1,
      93,    -1,    -1,    96,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   292,    -1,    -1,    -1,    -1,
     113,   298,    -1,    -1,    -1,    -1,   303,    -1,    -1,    -1,
      -1,    -1,   309,   310,    -1,   312,    -1,    -1,   315,   316,
     317,   318,    -1,    -1,    -1,   322,    -1,    -1,    -1,   326,
     327,   328,    -1,    -1,    -1,   332,   333,    -1,     1,    -1,
     337,     4,    -1,     6,   341,    -1,    -1,   344,   345,   162,
      -1,    -1,    -1,    -1,   351,   352,   353,    -1,    -1,   356,
      23,    -1,    -1,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,   979,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    -1,    99,    -1,    -1,   102,
     103,   104,   105,    -1,    -1,   108,    -1,   110,    -1,    -1,
     113,   114,    -1,    -1,   267,    -1,   119,    -1,    -1,    -1,
      -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,   146,    -1,   298,   149,    -1,    -1,    -1,
     303,   154,    -1,    -1,   157,    -1,    -1,   160,   161,   162,
      -1,    -1,   165,    -1,    -1,   168,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,
       6,    -1,    -1,    -1,   337,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   228,   229,   230,   231,    -1,
      -1,    -1,    -1,    -1,   237,   238,    -1,    -1,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    89,   267,    91,     1,    93,    -1,     4,
      96,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,   292,
      -1,    26,    27,    28,    29,   298,    -1,    -1,    -1,    -1,
     303,    -1,    -1,    -1,    -1,    40,   309,   310,    -1,   312,
      -1,    -1,   315,   316,   317,   318,    -1,    -1,    -1,   322,
      -1,    -1,    -1,   326,   327,   328,    -1,    -1,    -1,   332,
     333,    -1,    -1,     4,   337,     6,   162,    -1,   341,    -1,
      -1,   344,   345,    -1,    -1,    -1,    -1,    -1,   351,   352,
     353,    -1,    23,   356,    89,    -1,    91,    -1,    93,    30,
      31,    96,    -1,    -1,    35,    36,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    97,   162,    99,    -1,
      -1,   102,   103,   104,   105,    -1,    -1,   108,    -1,   110,
      -1,   267,    -1,   114,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,   125,    -1,   282,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     141,    -1,   298,    -1,    -1,   146,    -1,   303,   149,    -1,
      -1,    -1,    -1,   154,    -1,    -1,   157,    -1,    -1,   160,
     161,    -1,    -1,    -1,   165,    -1,    -1,   168,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   192,   193,    -1,    -1,    -1,   352,    -1,    -1,    -1,
      -1,    -1,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,   229,   230,
     231,    -1,    -1,   298,    -1,    -1,   237,   238,   303,    -1,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,    -1,     5,    -1,
      -1,    -1,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    23,   352,    -1,    -1,
      -1,   292,    -1,    -1,    31,    -1,    -1,   298,    -1,    36,
      -1,    -1,   303,    -1,    -1,    -1,    -1,    -1,   309,   310,
      -1,   312,    -1,    -1,   315,   316,   317,   318,    -1,    -1,
      -1,   322,    -1,    -1,    -1,   326,   327,   328,    -1,    -1,
      -1,   332,   333,    70,    -1,    -1,    -1,    -1,    -1,    -1,
     341,    -1,    -1,   344,   345,    -1,    -1,    84,    -1,    86,
     351,   352,   353,    -1,    -1,   356,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,
      -1,   108,    -1,   110,    -1,    -1,    -1,   114,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,   146,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,
     157,    -1,    -1,   160,   161,    -1,    -1,    -1,   165,    -1,
      -1,   168,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,    -1,    -1,
     115,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,   228,    31,    -1,    -1,    -1,    -1,    36,   133,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,    -1,   280,   281,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   187,    -1,    -1,    -1,   293,    -1,    -1,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,   108,
      -1,   110,   309,   310,    -1,   114,    -1,    -1,   315,   316,
     119,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,
     129,   328,    -1,    -1,    -1,   332,   333,    -1,    -1,    -1,
      -1,    -1,   141,    -1,    -1,   342,   343,   146,   345,   244,
     149,    -1,    -1,    -1,    -1,   154,   353,    -1,   157,   356,
      -1,   160,   161,    -1,    -1,    -1,   165,    -1,    -1,   168,
      -1,   170,    -1,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,    -1,    -1,   284,
     285,   286,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,   228,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,   280,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   102,   103,   104,   105,    -1,    -1,   108,    -1,   110,
     309,   310,    -1,   114,    -1,    -1,   315,   316,   119,    -1,
      -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,   129,   328,
      -1,    -1,    -1,   332,   333,    -1,    -1,    -1,    -1,    -1,
     141,    -1,    -1,   342,   343,   146,   345,    -1,   149,    -1,
      -1,    -1,    -1,   154,   353,    -1,   157,   356,    -1,   160,
     161,    -1,    -1,    -1,   165,    -1,    -1,   168,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,   228,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,    -1,   280,
     281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,    -1,    -1,   108,    -1,   110,   309,   310,
      -1,   114,    -1,    -1,   315,   316,   119,    -1,    -1,    -1,
      -1,    -1,   125,    -1,    -1,    -1,   129,   328,    -1,    -1,
      -1,   332,   333,    -1,    -1,    -1,    -1,    -1,   141,    -1,
      -1,   342,   343,   146,   345,    -1,   149,    -1,    -1,    -1,
      -1,   154,   353,    -1,   157,   356,    -1,   160,   161,    -1,
      -1,    -1,   165,    -1,    -1,   168,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,   228,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   277,    -1,    -1,   280,   281,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,
     105,    -1,    -1,   108,    -1,   110,   309,   310,    -1,   114,
      -1,    -1,   315,   316,   119,    -1,    -1,    -1,    -1,    -1,
     125,    -1,    -1,    -1,   129,   328,    -1,    -1,    -1,   332,
     333,    -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,   342,
     343,   146,   345,    -1,   149,    -1,    -1,    -1,    -1,   154,
     353,    -1,   157,   356,    -1,   160,   161,    -1,    -1,    -1,
     165,    -1,    -1,   168,    -1,   170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    23,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   277,    -1,    -1,   280,   281,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,   309,   310,    -1,   114,    -1,    -1,
     315,   316,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,    -1,   129,   328,    -1,    -1,    -1,   332,   333,    -1,
      -1,    -1,    70,    -1,   141,    -1,    -1,   342,   343,   146,
     345,    -1,   149,    -1,    -1,    -1,    -1,   154,   353,    -1,
     157,   356,    21,   160,   161,    -1,    -1,    -1,   165,    -1,
      -1,   168,    -1,   170,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,    -1,    -1,    -1,   114,    -1,    -1,    -1,
      -1,   119,    -1,    -1,    -1,   192,   193,   125,    -1,    -1,
      -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,   141,    -1,    -1,    -1,    -1,   146,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,   157,
      -1,    -1,   160,   161,    -1,    -1,    -1,   165,    -1,    -1,
     168,    -1,   170,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,
     119,    -1,    -1,    -1,   192,   193,   125,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     277,    -1,   141,   280,   281,    -1,    -1,   146,    -1,    -1,
     149,    -1,    22,    23,    -1,   154,    -1,    -1,   157,    -1,
      -1,   160,   161,    -1,    -1,    -1,   165,    -1,    -1,   168,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,   315,   316,
      -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,   342,   343,    -1,    -1,   277,
      -1,    -1,   280,   281,   351,    -1,   353,    -1,    -1,   356,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,    -1,    -1,    -1,    -1,
     110,    -1,    -1,    -1,   114,    -1,    -1,   315,   316,   119,
     318,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,   129,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   141,    -1,    -1,   342,   343,   146,    -1,   277,   149,
      -1,   280,   281,   351,   154,   353,    -1,   157,   356,    -1,
     160,   161,    -1,    -1,    -1,   165,    -1,    -1,   168,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   315,   316,    -1,   318,
      -1,    23,   192,   193,    -1,    -1,    -1,    -1,    30,    31,
      -1,    -1,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   342,   343,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,   353,    -1,    -1,   356,    -1,    -1,
      62,    63,   103,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      -1,    -1,   133,    -1,    -1,    97,    -1,    99,    -1,    -1,
     102,   103,   104,   105,    -1,    -1,   108,   277,   110,   150,
     280,   281,   114,    -1,    -1,    -1,    -1,   119,    -1,    -1,
      -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,   146,   315,   316,   149,   318,    -1,
      -1,    -1,   154,    -1,    -1,   157,    -1,    -1,   160,   161,
      -1,    -1,    -1,   165,    -1,    -1,   168,    -1,   170,    -1,
      -1,    -1,   342,   343,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   351,    -1,   353,    -1,    -1,   356,    -1,    -1,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   228,   229,   230,   231,
      -1,    -1,    -1,    -1,    -1,   237,   238,    -1,    -1,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,   305,   267,    -1,    -1,   309,   310,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,   319,    -1,
     282,    -1,    -1,    30,    31,    -1,    -1,    -1,    -1,    36,
     292,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,   303,    -1,    -1,   345,    -1,    -1,   309,   310,    -1,
     312,    -1,    -1,   315,   316,   317,   318,    -1,    -1,    -1,
     322,    -1,    -1,    -1,   326,   327,   328,    -1,    -1,    -1,
     332,   333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   341,
      -1,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,   351,
      -1,   353,    -1,    -1,   356,   102,   103,   104,   105,    -1,
      -1,   108,    -1,   110,    -1,    -1,    -1,   114,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,   146,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,
     157,    -1,    -1,   160,   161,    -1,    -1,    -1,   165,    -1,
      -1,   168,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,   228,   229,   230,   231,    -1,    -1,    -1,    -1,    -1,
     237,   238,    -1,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,
     108,    -1,   110,    -1,    -1,    -1,   114,    -1,    -1,    -1,
      -1,   119,   309,   310,    -1,    -1,    -1,   125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   328,    -1,   141,    -1,   332,   333,    -1,   146,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,   344,   345,   157,
      -1,    -1,   160,   161,   351,    -1,   353,   165,    -1,   356,
     168,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,   192,   193,    -1,    -1,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,   229,   230,   231,    -1,    -1,    -1,    -1,    -1,   237,
     238,    -1,    -1,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     102,   103,   104,   105,    -1,    -1,   108,    -1,   110,    -1,
      37,    -1,   114,    -1,    -1,    42,    -1,   119,    45,    46,
      47,    48,    -1,   125,    51,    52,    -1,    54,    55,    56,
      -1,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,   309,   310,    -1,   146,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,    -1,    -1,   157,    -1,    -1,   160,   161,
     328,    -1,    -1,   165,   332,   333,   168,    -1,   170,    -1,
      97,    -1,    99,   100,   101,    -1,   344,   345,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   353,    -1,    23,   356,    -1,
     192,   193,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,   229,   230,   231,
      -1,    -1,    -1,    -1,    70,   237,   238,    -1,    -1,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,    -1,   267,   102,   103,   104,   105,
      -1,    -1,   108,    -1,   110,    -1,    -1,    -1,   114,    -1,
      -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,   125,
      -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   141,    -1,   309,   310,    -1,
     146,    -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,
      -1,   157,    -1,    -1,   160,   161,   328,    -1,    -1,   165,
     332,   333,   168,    -1,   170,    -1,    -1,    -1,    -1,    -1,
     267,    -1,   344,   345,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   353,    -1,    -1,   356,   282,   192,   193,    -1,    -1,
     287,   288,   289,   290,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   298,    -1,    -1,    -1,    -1,   303,    -1,   305,   306,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
      -1,   267,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   277,    -1,    -1,   280,   281,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,
      -1,    -1,   110,   309,   310,    -1,   114,    -1,    -1,   315,
     316,   119,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,
      -1,   129,   328,    -1,    -1,    -1,   332,   333,    -1,    -1,
      -1,    -1,    -1,   141,    -1,    -1,   342,   343,   146,   345,
      -1,   149,    -1,    -1,    -1,    -1,   154,   353,    -1,   157,
     356,    -1,   160,   161,    -1,    -1,    -1,   165,    -1,    -1,
     168,    -1,   170,    -1,    -1,     0,     1,    -1,    -1,     4,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    47,    -1,    49,    -1,    -1,    52,    53,    54,
      -1,    56,    -1,    -1,    -1,    60,    61,    62,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,   277,
      -1,    -1,   280,   281,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,   119,    -1,    -1,    -1,    -1,    -1,
     125,    78,    79,    80,    81,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,   316,    -1,
     318,    -1,    -1,    -1,   149,   102,   103,   104,   105,    -1,
      -1,    -1,    -1,   110,    -1,    -1,    -1,   114,    -1,    -1,
      -1,    70,   119,    -1,   342,   343,    -1,    -1,   125,    -1,
      -1,    -1,   129,   351,    -1,   353,    -1,    -1,   356,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,   146,
      -1,    -1,   149,   102,   103,   104,   105,   154,    -1,    -1,
     157,   110,    -1,   160,   161,   114,    -1,    -1,   165,    -1,
     119,   168,    -1,   170,    -1,    -1,   125,    -1,    -1,    -1,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,   141,    -1,    -1,   192,   193,   146,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,    -1,    -1,   157,    -1,
      -1,   160,   161,    -1,    -1,    -1,   165,    -1,    -1,   168,
      -1,   170,   267,   102,   103,   104,   105,    -1,    -1,    -1,
      -1,   110,    -1,    -1,    -1,   114,    -1,   282,    -1,    -1,
     119,    -1,    -1,   192,   193,    -1,   125,    -1,    -1,    -1,
     129,    -1,    -1,   298,    -1,    -1,    -1,    -1,   303,    -1,
     305,    -1,   141,    -1,    -1,    -1,    -1,   146,    -1,   103,
     149,    -1,    -1,    -1,    -1,   154,    -1,    -1,   157,    -1,
     277,   160,   161,   280,   281,    -1,   165,    -1,    -1,   168,
      -1,   170,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   192,   193,    -1,   150,    -1,   315,   316,
      -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,   277,    -1,
      -1,   280,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   342,   343,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   353,    -1,    -1,   356,
      -1,    -1,    -1,    -1,    -1,    -1,   315,   316,    -1,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   342,   343,    -1,    -1,    -1,   277,    -1,
      -1,   280,   281,    -1,   353,    -1,    -1,   356,    -1,    -1,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,    -1,    -1,    -1,    -1,   315,   316,    -1,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   342,   343,    -1,    -1,    -1,    -1,    -1,
      -1,   305,    -1,    -1,   353,   309,   310,   356,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   345
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   360,     0,     1,     4,     6,    26,    27,    28,    29,
      37,    45,    47,    49,    52,    53,    54,    56,    60,    61,
      62,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,   109,   119,   125,   149,   267,   282,
     298,   303,   305,   361,   384,   385,   386,   387,   459,   460,
     461,   463,   478,   361,   104,   103,   456,   456,   456,   461,
     472,   461,   463,   478,   461,   466,   466,   466,   461,   469,
     387,    49,   388,    37,    45,    47,    52,    53,    54,    56,
     267,   282,   298,   303,   305,   389,    49,   390,    37,    45,
      47,    49,    52,    53,    54,    56,   267,   282,   298,   303,
     305,   395,    53,   396,    37,    42,    45,    46,    47,    48,
      51,    52,    54,    55,    56,    58,    97,    99,   100,   101,
     267,   282,   287,   288,   289,   290,   298,   303,   305,   306,
     397,   282,   287,   288,   303,   400,    45,    47,    52,    54,
      58,    97,    99,   401,    47,   402,    23,    30,    31,    36,
     102,   103,   104,   105,   108,   110,   114,   119,   125,   141,
     146,   149,   154,   157,   160,   161,   165,   168,   170,   192,
     193,   228,   229,   230,   231,   237,   238,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   267,   309,   310,   328,   332,   333,   344,   345,   353,
     356,   410,   457,   576,   577,   580,   581,   582,   586,   649,
     652,   654,   658,   663,   664,   666,   668,   678,   679,   681,
     683,   685,   687,   691,   693,   695,   697,   699,   701,   703,
     705,   707,   709,   713,   721,   723,   725,   726,   728,   730,
     732,   734,   736,   738,   740,   742,    58,   338,   339,   340,
     403,   409,    58,   404,   409,   103,   405,   406,   363,   369,
     370,    89,   274,   276,   472,   472,   472,   472,     0,   361,
     456,   456,    57,   335,   336,   475,   476,   477,    35,    37,
      52,    62,    63,    67,    78,    79,    80,    81,    82,    83,
      97,    99,   243,   267,   282,   292,   298,   303,   312,   315,
     316,   317,   318,   322,   326,   327,   341,   351,   482,   483,
     484,   486,   487,   488,   489,   490,   491,   495,   496,   497,
     500,   501,   508,   512,   517,   518,   521,   522,   523,   524,
     525,   546,   547,   549,   550,   552,   553,   556,   557,   558,
     567,   568,   569,   570,   571,   574,   575,   581,   588,   589,
     590,   591,   592,   593,   597,   598,   599,   633,   647,   652,
     653,   676,   677,   678,   361,   350,   350,   361,   456,   529,
     411,   414,   482,   456,   419,   421,   576,   599,   424,   456,
     429,   463,   479,   472,   461,   463,   466,   466,   466,   469,
      89,   274,   276,   472,   472,   472,   472,   478,   394,   461,
     472,   473,   391,   459,   461,   462,   392,   461,   463,   464,
     479,   393,   461,   466,   467,   466,   466,   461,   469,   470,
      89,   274,   276,   622,   394,   394,   394,   394,   466,   472,
     399,   460,   481,   461,   481,   463,   481,    45,   481,   466,
     466,   481,   469,   481,    45,    46,   466,   481,   481,    89,
     274,   291,   622,   623,   472,    45,   481,    45,   481,    45,
     481,    45,   481,   472,   472,   472,    45,   481,   373,   472,
      45,   481,    45,   481,   472,   461,   463,   466,   466,   481,
      45,   466,   463,   106,   107,   108,   680,   111,   112,   244,
     245,   248,   584,   585,    32,    33,    34,   244,   655,   132,
     587,   166,   167,   724,   111,   112,   113,   682,   113,   115,
     116,   117,   118,   684,   111,   112,   120,   121,   122,   123,
     124,   686,   111,   112,   115,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   175,   688,   113,   115,   134,   142,
     143,   144,   145,   692,   113,   134,   147,   294,   694,   111,
     112,   126,   128,   129,   130,   151,   152,   153,   696,   113,
     115,   134,   142,   143,   145,   155,   156,   698,   127,   143,
     152,   158,   159,   700,   143,   159,   702,   152,   162,   163,
     704,   130,   134,   166,   167,   706,   134,   166,   167,   169,
     708,   134,   143,   158,   162,   166,   167,   171,   172,   173,
     174,   175,   710,   113,   166,   167,   714,   134,   166,   167,
     194,   227,   722,   113,   125,   127,   145,   149,   152,   232,
     265,   266,   345,   665,   667,   729,   233,   731,   233,   733,
     162,   234,   235,   236,   735,   127,   152,   727,   115,   131,
     152,   158,   239,   240,   737,   127,   152,   739,   113,   127,
     134,   152,   158,   741,   103,   130,   133,   150,   305,   319,
     345,   650,   651,   652,   111,   112,   115,   133,   244,   268,
     269,   270,   271,   272,   273,   275,   276,   277,   278,   279,
     280,   281,   284,   285,   286,   305,   669,   670,   673,   319,
     329,   657,   593,   598,   330,   228,   237,   238,   241,   242,
     743,   348,   349,   372,   660,   592,   456,   409,   339,   409,
      46,    48,    50,    51,    58,    59,    91,   407,   472,   472,
     472,   365,   617,   632,   619,   621,   102,   102,   102,    84,
     665,   283,   568,   456,   576,   648,   648,    62,    98,   456,
     103,   650,    89,   187,   274,   669,   670,   283,   283,   299,
     283,   301,   302,   509,    84,   162,    84,    84,   665,     4,
     362,   600,   601,   337,   480,   487,   414,   365,   284,   285,
     498,   499,   383,   162,   293,   294,   295,   296,   297,   502,
     503,   313,   520,     5,    70,    84,    86,   110,   114,   119,
     125,   129,   149,   228,   277,   280,   281,   293,   315,   316,
     342,   343,   353,   532,   533,   534,   535,   536,   537,   538,
     540,   541,   542,   543,   544,   545,   577,   580,   586,   642,
     643,   644,   649,   654,   658,   664,   665,   666,   668,   674,
     675,   678,    38,    39,   184,   185,   526,   527,    84,   319,
     320,   321,   548,   554,   555,    84,   551,   554,   377,   323,
     324,   325,   559,   560,   563,   564,    23,   576,   578,   579,
      45,   572,   573,    15,    16,    17,    18,   355,     8,    24,
      54,     9,    10,    11,    12,    13,    14,    19,   110,   114,
     119,   125,   141,   146,   149,   154,   157,   160,   161,   165,
     168,   170,   192,   193,   318,   353,   577,   579,   580,   594,
     595,   596,   599,   634,   635,   636,   637,   638,   639,   640,
     641,   643,   644,   645,   646,    52,    52,    22,   351,   615,
     634,   635,   640,   615,    38,   351,   528,   351,   351,   351,
     351,   351,   475,   482,   529,   411,   414,   419,   421,   424,
     429,   472,   472,   472,   365,   617,   632,   619,   621,   482,
      57,    57,    57,    57,   421,    57,   429,   472,   365,   374,
     376,   381,   421,    43,   398,   461,   466,   481,   472,    45,
     365,   461,   461,   461,   461,   374,   376,   381,   461,   365,
     461,   461,   376,   466,   456,     7,     8,   113,   248,   249,
     583,   297,   382,   103,   126,   283,   366,   371,   110,   125,
     110,   125,   363,   137,   138,   139,   140,   689,   369,   370,
      23,    38,   102,   173,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   711,   179,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   715,   720,   379,   369,   370,   372,   667,
     378,   378,   357,   357,   381,   381,   111,   112,   125,   133,
     149,   268,   269,   270,   671,   672,   673,   364,   330,   330,
     102,   378,   347,   659,   354,   408,   409,   630,   630,   630,
     284,   351,   616,   299,   351,   631,   351,   509,   618,   351,
     457,   620,     5,   125,   149,   544,    84,   544,   565,   566,
     593,    23,    23,    96,   351,    52,    52,    52,   102,   301,
      52,   673,    52,   544,   544,   301,   302,   513,   544,   102,
     562,   593,   597,   658,   664,   563,   544,   544,    84,    21,
     599,   604,   605,   606,   613,   640,   641,     7,   352,   457,
     351,   102,   102,   499,    77,   110,   125,   170,   251,   505,
     457,   102,   102,   102,   457,   504,   503,   141,   154,   170,
     314,   544,     5,   544,    84,   366,   371,   363,   369,   370,
      84,   537,   577,   644,    15,    16,    17,    18,   355,    20,
      22,     8,    54,     5,   554,    84,    86,   233,   293,     7,
       7,   102,   102,   527,     5,     7,     5,   544,   561,   580,
     595,   640,   560,     7,   456,   351,   456,   351,   573,   645,
     645,   636,   637,   638,   592,   351,   492,   578,   635,   369,
     370,   379,   640,     7,    20,    15,    16,    17,    18,   355,
       7,    20,    22,     8,   634,   635,   640,   544,   544,   102,
     352,   361,    20,   361,   102,   444,   413,   415,   420,   426,
     430,   528,   351,   351,   351,   351,   351,   630,   630,   630,
     616,   631,   618,   620,   102,   102,   102,   102,   102,   351,
     630,   103,   364,   461,   102,   585,   367,   102,   366,   369,
     366,   369,   113,   130,   135,   136,   233,   369,   690,   711,
      96,   130,   186,   187,   188,   189,   190,   191,   712,   217,
     221,   222,   223,   719,   212,   213,   214,   215,   717,   216,
     217,   218,   219,   220,   718,   718,   221,   224,   224,   225,
     226,   225,   113,   130,   162,   716,   380,   378,   102,   102,
     111,   112,   111,   112,   364,   364,   102,   102,   331,   656,
     102,   159,   346,   661,   665,   351,   351,   351,   102,   437,
     365,   513,   442,   374,   438,   102,   376,   443,   381,   544,
       5,     5,   544,   578,    89,    92,   480,   607,   608,   457,
     457,   102,   593,   602,   603,   544,   544,   544,   364,   102,
     544,    52,   544,   374,   102,   376,   103,   285,   510,   377,
      84,   323,    43,   544,   362,     5,   362,   267,   282,   298,
     610,   611,    89,    92,   480,   609,   612,   362,   601,   416,
     366,   148,   143,   148,   506,   507,   103,   113,   519,   580,
     113,   519,    70,   113,   519,   544,     5,   544,   544,   354,
     532,   532,   533,   534,   535,   102,   537,   532,   539,   578,
     599,   544,   544,    84,     8,    84,   577,   644,   674,   674,
     544,   555,   544,   554,   564,   565,   602,   362,   493,   494,
     354,   640,   634,   640,   645,   645,   636,   637,   638,   640,
     102,   634,   640,   596,   640,    20,    20,   102,    39,   361,
     352,   361,   384,   480,   528,    37,    47,    52,    54,    56,
     162,   267,   282,   298,   303,   305,   352,   361,   384,   412,
     480,    93,   113,   162,   352,   361,   384,   446,   452,   453,
     480,   482,    40,    88,    89,    90,    91,    93,    96,   113,
     162,   267,   352,   361,   384,   427,   480,   485,   486,    40,
      89,    91,   113,   162,   352,   361,   384,   427,   480,   485,
      41,    44,   162,   282,   352,   361,   384,   413,   415,   420,
     426,   430,   351,   351,   351,   365,   374,   376,   381,   430,
     364,   364,     7,   382,   369,     7,   379,   358,   358,   369,
     369,   370,   370,   656,   334,   656,   102,   368,   372,   111,
     112,   662,   440,   441,   439,   285,   352,   361,   384,   480,
     616,   102,   352,   361,   384,   480,   631,   352,   361,   384,
     480,   618,   510,   352,   361,   384,   480,   620,   544,   544,
       5,   103,   458,   458,   608,   351,   487,   607,   364,   364,
     364,   544,   364,    20,   103,   304,   511,   562,   561,   544,
      43,    81,    82,   614,   641,   647,   187,   284,   365,   299,
     611,   458,   458,   612,   352,   361,   482,   369,     7,   519,
     519,   519,   544,     5,   544,   164,   544,   554,   554,     5,
     352,   485,   487,   604,     7,   352,   634,   634,   102,    39,
     456,   474,   456,   465,   456,   468,   468,   456,   471,   103,
      89,   274,   276,   474,   474,   474,   474,   361,    78,    79,
     454,   455,   576,   103,    98,   361,   361,   361,   361,   361,
     418,   581,   458,   458,   350,    94,    95,   428,   102,   103,
     128,   129,   244,   264,   265,   434,   435,   445,    85,    86,
      87,    89,   422,   423,   361,   361,   361,   486,   418,   458,
     350,   435,   422,   361,   361,   361,   103,   350,    98,   365,
     352,   352,   352,   352,   352,   440,   441,   439,   352,   102,
     102,   375,   102,   368,   372,    93,   133,   268,   352,   361,
     384,   480,   628,    89,    96,   133,   167,   268,   352,   361,
     384,   480,   629,   113,   268,   352,   361,   384,   480,   625,
     102,   365,    20,   103,   374,   376,   511,   381,   544,   602,
     352,   364,   307,   308,   309,   310,   311,   516,   300,   515,
     102,   376,   377,   377,   544,   362,   102,   301,   102,   513,
     361,   507,   544,    84,   565,     5,   352,   352,     5,   362,
     494,   185,   530,   102,   436,   414,   419,   424,   429,   474,
     474,   474,   436,   436,   436,   436,    41,     8,   361,   361,
     361,   421,     8,   361,     7,   361,     5,   361,   421,     5,
     361,   150,   447,   351,   431,   576,   361,   352,   352,   352,
       7,   656,   350,   165,   170,   624,   460,   364,   458,   102,
     624,   102,   460,   364,   104,   460,   364,   516,   515,   487,
     300,   514,   102,   374,   510,   364,   102,   285,   102,   544,
     352,   565,   647,   184,   531,   361,   351,   351,   351,   351,
     351,   436,   436,   436,   351,   351,   351,   351,   103,   581,
     434,   423,    86,   417,   418,   581,    86,   282,   298,   303,
     305,   425,   435,    22,   102,   103,   349,   448,   449,   450,
     576,   361,   103,   432,   433,   576,   361,   364,   364,   364,
     102,   368,   351,   361,   361,   361,   361,   361,   361,   361,
     133,   361,   514,   352,   102,   374,   103,   285,   364,   102,
      20,   103,   352,   362,   530,   444,   415,   420,   426,   430,
     351,   351,   351,   437,   442,   438,   443,    43,    44,   451,
     418,   361,     8,   435,   365,   374,   376,   381,   361,   361,
     102,    22,    25,     7,   352,   103,   626,   627,   624,   284,
     365,   516,   515,   531,   352,   352,   352,   352,   352,   440,
     441,   439,   352,   352,   352,   352,   457,   576,   350,   447,
     361,   581,   361,   102,   102,   362,   433,     5,     7,   352,
     361,   514,   374,   361,   361,   361,   361,   361,   352,   352,
     352,   361,   361,   361,   361,   431,   102,   627,   361,   374,
     361,   361,   361,   365,   374,   376,   381,   364,   364,   364
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   359,   360,   360,   361,   361,   362,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     384,   384,   384,   384,   385,   385,   385,   385,   386,   386,
     386,   386,   386,   386,   386,   386,   386,   386,   386,   386,
     386,   386,   386,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     387,   387,   387,   387,   387,   387,   387,   388,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   389,   389,   389,   390,   391,   391,   392,   392,
     393,   393,   394,   394,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   395,   396,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   398,   399,   399,   400,   400,   400,
     400,   400,   400,   401,   401,   401,   401,   401,   401,   401,
     402,   403,   403,   404,   404,   405,   406,   406,   407,   407,
     407,   407,   407,   407,   407,   407,   408,   408,   409,   409,
     409,   410,   411,   412,   412,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   414,   415,   415,   415,   415,   415,   415,   415,   415,
     416,   416,   416,   417,   417,   418,   418,   419,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,   420,   420,
     420,   421,   421,   422,   422,   423,   423,   423,   423,   424,
     425,   425,   425,   425,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   427,   427,
     428,   428,   429,   430,   430,   430,   430,   430,   430,   430,
     431,   431,   432,   432,   432,   433,   433,   434,   434,   435,
     435,   436,   437,   437,   437,   437,   437,   438,   438,   438,
     438,   438,   439,   439,   439,   439,   439,   440,   440,   440,
     440,   440,   441,   441,   441,   441,   441,   442,   442,   442,
     442,   442,   443,   443,   443,   443,   443,   444,   444,   444,
     444,   444,   445,   445,   445,   445,   445,   446,   447,   448,
     448,   449,   449,   449,   449,   449,   450,   450,   451,   451,
     451,   451,   452,   453,   454,   454,   455,   455,   456,   457,
     457,   457,   458,   459,   459,   460,   460,   460,   460,   460,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   478,
     478,   478,   479,   480,   481,   481,   482,   482,   483,   484,
     484,   485,   485,   486,   486,   486,   486,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   488,   488,   489,
     490,   490,   491,   492,   492,   493,   493,   493,   494,   495,
     495,   496,   496,   497,   497,   498,   498,   499,   499,   500,
     500,   501,   502,   502,   503,   503,   503,   503,   503,   503,
     504,   505,   505,   505,   505,   505,   506,   506,   507,   507,
     508,   508,   508,   509,   509,   509,   510,   510,   511,   511,
     512,   512,   513,   513,   513,   514,   514,   515,   515,   515,
     516,   516,   516,   516,   516,   517,   518,   519,   519,   520,
     520,   520,   520,   520,   520,   520,   520,   521,   522,   522,
     523,   523,   523,   523,   523,   523,   524,   524,   525,   525,
     526,   526,   527,   527,   527,   527,   528,   528,   529,   530,
     530,   531,   531,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   533,   533,   533,   534,
     534,   535,   535,   536,   536,   537,   538,   538,   539,   539,
     540,   540,   541,   542,   543,   543,   544,   544,   544,   545,
     545,   545,   545,   545,   545,   545,   545,   545,   545,   545,
     545,   545,   545,   546,   546,   547,   548,   548,   548,   549,
     549,   550,   551,   551,   551,   551,   551,   552,   552,   553,
     553,   554,   554,   555,   555,   555,   556,   556,   556,   556,
     557,   557,   558,   559,   559,   560,   560,   561,   561,   562,
     562,   562,   563,   563,   564,   564,   565,   565,   566,   567,
     567,   567,   568,   568,   568,   569,   569,   570,   570,   571,
     572,   572,   573,   574,   574,   575,   576,   577,   577,   578,
     578,   579,   580,   581,   581,   581,   581,   581,   581,   581,
     581,   581,   581,   581,   581,   581,   581,   581,   582,   583,
     583,   583,   584,   584,   584,   584,   584,   585,   585,   586,
     586,   587,   587,   588,   588,   588,   589,   589,   590,   590,
     591,   591,   592,   593,   593,   594,   595,   596,   596,   597,
     598,   598,   598,   599,   600,   600,   600,   601,   601,   601,
     602,   602,   603,   604,   604,   605,   605,   606,   606,   607,
     607,   608,   608,   608,   609,   609,   610,   610,   611,   611,
     611,   611,   611,   611,   612,   612,   612,   613,   614,   614,
     615,   615,   615,   615,   616,   617,   618,   619,   620,   621,
     622,   622,   622,   623,   623,   623,   624,   624,   625,   625,
     626,   626,   627,   628,   628,   628,   629,   629,   629,   629,
     629,   630,   631,   631,   632,   633,   633,   633,   633,   633,
     633,   633,   633,   634,   634,   635,   635,   635,   636,   636,
     636,   637,   637,   638,   638,   639,   639,   640,   641,   641,
     641,   641,   642,   642,   643,   644,   644,   644,   644,   644,
     644,   644,   644,   644,   644,   644,   644,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   646,   646,   646,   646,   646,   646,
     646,   647,   647,   647,   647,   647,   647,   648,   648,   649,
     649,   649,   650,   650,   651,   651,   651,   651,   651,   652,
     652,   652,   652,   652,   652,   652,   652,   652,   652,   652,
     652,   652,   652,   652,   652,   652,   652,   652,   652,   652,
     652,   652,   652,   653,   653,   653,   653,   653,   653,   654,
     654,   655,   655,   655,   656,   656,   657,   657,   658,   659,
     659,   660,   660,   661,   661,   662,   662,   663,   663,   664,
     664,   664,   665,   665,   666,   666,   667,   667,   667,   667,
     668,   668,   668,   669,   669,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   671,   671,   671,   671,   671,   671,   671,   672,
     672,   672,   672,   673,   673,   673,   673,   674,   674,   675,
     675,   676,   676,   676,   676,   677,   678,   678,   678,   678,
     678,   678,   678,   678,   678,   678,   678,   678,   678,   678,
     678,   678,   678,   678,   679,   680,   680,   680,   681,   682,
     682,   682,   683,   684,   684,   684,   684,   684,   685,   686,
     686,   686,   686,   686,   686,   686,   686,   686,   687,   687,
     687,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   689,   689,   689,   689,   690,   690,   690,
     690,   690,   691,   692,   692,   692,   692,   692,   692,   692,
     693,   694,   694,   694,   694,   695,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   697,   698,   698,   698,   698,
     698,   698,   698,   698,   699,   700,   700,   700,   700,   700,
     701,   702,   702,   703,   704,   704,   704,   705,   706,   706,
     706,   706,   707,   708,   708,   708,   708,   709,   709,   709,
     709,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   711,   711,   711,   711,   711,   711,   711,   711,   711,
     711,   711,   711,   711,   712,   712,   712,   712,   712,   712,
     712,   712,   713,   714,   714,   714,   715,   715,   715,   715,
     715,   715,   715,   715,   715,   715,   715,   715,   715,   715,
     715,   715,   715,   715,   716,   716,   716,   717,   717,   717,
     717,   718,   718,   718,   718,   718,   719,   719,   719,   719,
     720,   720,   720,   720,   720,   720,   720,   720,   720,   720,
     720,   720,   721,   721,   722,   722,   722,   722,   723,   724,
     724,   725,   725,   725,   725,   725,   725,   725,   725,   726,
     727,   727,   728,   729,   729,   729,   729,   730,   731,   732,
     733,   734,   735,   735,   735,   735,   736,   737,   737,   737,
     737,   737,   737,   738,   739,   739,   740,   741,   741,   741,
     741,   741,   742,   743,   743,   743,   743,   743
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       5,     5,     3,     2,     1,     1,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     6,     2,     6,     3,     2,     6,
       6,     3,     6,     3,     5,     7,     5,     7,     8,     8,
       8,     5,     7,     5,     7,     4,     6,     3,     2,     6,
       2,     6,     6,     6,     3,     6,     3,     5,     5,     8,
       8,     8,     5,     5,     4,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     3,
       2,     2,     6,     3,     3,     5,     3,     3,     2,     3,
       2,     2,     2,     2,     2,     3,     2,     2,     3,     3,
       2,     3,     3,     2,     3,     3,     2,     3,     3,     2,
       3,     2,     2,     3,     3,     2,     2,     2,     2,     2,
       2,     4,     5,     2,     2,     1,     2,     2,     3,     3,
       2,     3,     3,     2,     2,     2,     2,     3,     2,     2,
       3,     2,     1,     2,     1,     3,     0,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       2,     1,     0,     2,     1,     0,     2,     2,     3,     8,
       8,     8,     8,     9,     9,    10,    10,    10,     9,     9,
       8,     0,     0,     2,     2,     3,     3,     3,     3,     3,
       0,     2,     3,     1,     3,     1,     3,     0,     0,     2,
       2,     4,     4,     4,     4,     4,     3,     4,     2,     3,
       3,     1,     1,     3,     1,     1,     1,     1,     1,     0,
       2,     2,     2,     2,     0,     2,     2,     4,     6,     7,
       6,     7,     6,     4,     3,     4,     3,     3,     2,     2,
       1,     1,     0,     0,     2,     2,     5,     5,     3,     4,
       3,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       3,     0,     0,     2,     2,     2,     2,     0,     2,     2,
       2,     2,     0,     2,     2,     2,     2,     0,     2,     2,
       2,     2,     0,     2,     2,     2,     2,     0,     2,     2,
       2,     2,     0,     2,     2,     2,     2,     0,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     6,     2,     1,
       1,     1,     1,     1,     3,     3,     1,     2,     2,     2,
       3,     0,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     2,     2,     1,     2,     1,
       1,     2,     3,     2,     3,     1,     2,     3,     1,     2,
       3,     1,     2,     3,     1,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     0,     1,     1,     2,     1,     1,
       2,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       1,     1,     3,     3,     1,     1,     3,     3,     5,     4,
       5,     1,     2,     1,     3,     1,     2,     2,     2,     1,
       2,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       1,     2,     3,     1,     2,     1,     3,     1,     1,     1,
       8,     7,     4,     1,     1,     0,     1,     1,     0,     3,
       6,     4,     1,     1,     0,     0,     3,     0,     3,     3,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     0,
       4,     3,     4,     3,     4,     3,     3,     2,     1,     1,
       3,     4,     4,     5,     6,     5,     1,     2,     1,     3,
       1,     2,     2,     2,     1,     1,     6,     8,     0,     0,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     1,     3,     1,     1,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       2,     3,     3,     4,     5,     2,     3,     2,     6,     4,
       3,     4,     3,     2,     1,     1,     3,     4,     1,     2,
       1,     1,     2,     3,     1,     3,     4,     3,     5,     3,
       6,     1,     3,     1,     1,     1,     2,     4,     6,     6,
       1,     2,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     2,     1,     4,
       5,     6,     1,     1,     1,     7,     8,     6,     1,     1,
       1,     2,     2,     6,     8,     1,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     0,     2,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     1,     3,     3,     3,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     3,     3,     3,     5,
       1,     2,     1,     1,     2,     1,     1,     2,     1,     1,
       2,     2,     2,     1,     1,     2,     1,     2,     2,     6,
       8,     7,     4,     5,     2,     2,     1,     1,     1,     1,
       1,     1,     2,     2,     4,     0,     4,     0,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     3,
       1,     3,     3,     3,     6,     3,     3,     3,     3,     3,
       3,     0,     6,     5,     0,     2,     2,     4,     4,     5,
       5,     3,     3,     3,     3,     1,     1,     1,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     1,     1,
       3,     3,     1,     1,     1,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     4,     3,     4,     1,     4,     4,     3,
       5,     1,     1,     1,     0,     2,     1,     1,     6,     2,
       0,     1,     1,     1,     1,     1,     1,     5,     6,     8,
       6,     5,     2,     2,     3,     4,     1,     1,     1,     2,
       3,     4,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     5,     5,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     5,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     1,     1,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     2,     4,     3,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     5,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     3,     1,     1,     1,     1,     2,     4,     2,
       1,     2,     1,     1,     1,     4,     2,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, nft, scanner, state, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, nft, scanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (nft);
  YY_USE (scanner);
  YY_USE (state);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, nft, scanner, state);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), nft, scanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, nft, scanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (nft);
  YY_USE (scanner);
  YY_USE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* "string"  */
#line 315 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5621 "parser_bison.c"
        break;

    case YYSYMBOL_QUOTED_STRING: /* "quoted string"  */
#line 315 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5627 "parser_bison.c"
        break;

    case YYSYMBOL_ASTERISK_STRING: /* "string with a trailing asterisk"  */
#line 315 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5633 "parser_bison.c"
        break;

    case YYSYMBOL_line: /* line  */
#line 619 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5639 "parser_bison.c"
        break;

    case YYSYMBOL_base_cmd: /* base_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5645 "parser_bison.c"
        break;

    case YYSYMBOL_add_cmd: /* add_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5651 "parser_bison.c"
        break;

    case YYSYMBOL_replace_cmd: /* replace_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5657 "parser_bison.c"
        break;

    case YYSYMBOL_create_cmd: /* create_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5663 "parser_bison.c"
        break;

    case YYSYMBOL_insert_cmd: /* insert_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5669 "parser_bison.c"
        break;

    case YYSYMBOL_table_or_id_spec: /* table_or_id_spec  */
#line 625 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5675 "parser_bison.c"
        break;

    case YYSYMBOL_chain_or_id_spec: /* chain_or_id_spec  */
#line 627 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5681 "parser_bison.c"
        break;

    case YYSYMBOL_set_or_id_spec: /* set_or_id_spec  */
#line 632 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5687 "parser_bison.c"
        break;

    case YYSYMBOL_obj_or_id_spec: /* obj_or_id_spec  */
#line 634 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5693 "parser_bison.c"
        break;

    case YYSYMBOL_delete_cmd: /* delete_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5699 "parser_bison.c"
        break;

    case YYSYMBOL_get_cmd: /* get_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5705 "parser_bison.c"
        break;

    case YYSYMBOL_list_cmd: /* list_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5711 "parser_bison.c"
        break;

    case YYSYMBOL_basehook_device_name: /* basehook_device_name  */
#line 646 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5717 "parser_bison.c"
        break;

    case YYSYMBOL_basehook_spec: /* basehook_spec  */
#line 640 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5723 "parser_bison.c"
        break;

    case YYSYMBOL_reset_cmd: /* reset_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5729 "parser_bison.c"
        break;

    case YYSYMBOL_flush_cmd: /* flush_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5735 "parser_bison.c"
        break;

    case YYSYMBOL_rename_cmd: /* rename_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5741 "parser_bison.c"
        break;

    case YYSYMBOL_import_cmd: /* import_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5747 "parser_bison.c"
        break;

    case YYSYMBOL_export_cmd: /* export_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5753 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_cmd: /* monitor_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5759 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_event: /* monitor_event  */
#line 865 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5765 "parser_bison.c"
        break;

    case YYSYMBOL_describe_cmd: /* describe_cmd  */
#line 622 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5771 "parser_bison.c"
        break;

    case YYSYMBOL_table_block_alloc: /* table_block_alloc  */
#line 652 "parser_bison.y"
            { close_scope(state); table_free(((*yyvaluep).table)); }
#line 5777 "parser_bison.c"
        break;

    case YYSYMBOL_chain_block_alloc: /* chain_block_alloc  */
#line 654 "parser_bison.y"
            { close_scope(state); chain_free(((*yyvaluep).chain)); }
#line 5783 "parser_bison.c"
        break;

    case YYSYMBOL_typeof_data_expr: /* typeof_data_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5789 "parser_bison.c"
        break;

    case YYSYMBOL_typeof_expr: /* typeof_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5795 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_alloc: /* set_block_alloc  */
#line 663 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5801 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_expr: /* set_block_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5807 "parser_bison.c"
        break;

    case YYSYMBOL_map_block_alloc: /* map_block_alloc  */
#line 666 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5813 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_block_alloc: /* flowtable_block_alloc  */
#line 670 "parser_bison.y"
            { flowtable_free(((*yyvaluep).flowtable)); }
#line 5819 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr: /* flowtable_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5825 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_list_expr: /* flowtable_list_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5831 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr_member: /* flowtable_expr_member  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5837 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_atom_expr: /* data_type_atom_expr  */
#line 616 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5843 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_expr: /* data_type_expr  */
#line 616 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5849 "parser_bison.c"
        break;

    case YYSYMBOL_obj_block_alloc: /* obj_block_alloc  */
#line 673 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 5855 "parser_bison.c"
        break;

    case YYSYMBOL_type_identifier: /* type_identifier  */
#line 611 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5861 "parser_bison.c"
        break;

    case YYSYMBOL_extended_prio_name: /* extended_prio_name  */
#line 646 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5867 "parser_bison.c"
        break;

    case YYSYMBOL_dev_spec: /* dev_spec  */
#line 649 "parser_bison.y"
            { xfree(((*yyvaluep).expr)); }
#line 5873 "parser_bison.c"
        break;

    case YYSYMBOL_policy_expr: /* policy_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5879 "parser_bison.c"
        break;

    case YYSYMBOL_identifier: /* identifier  */
#line 611 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5885 "parser_bison.c"
        break;

    case YYSYMBOL_string: /* string  */
#line 611 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5891 "parser_bison.c"
        break;

    case YYSYMBOL_table_spec: /* table_spec  */
#line 625 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5897 "parser_bison.c"
        break;

    case YYSYMBOL_tableid_spec: /* tableid_spec  */
#line 625 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5903 "parser_bison.c"
        break;

    case YYSYMBOL_chain_spec: /* chain_spec  */
#line 627 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5909 "parser_bison.c"
        break;

    case YYSYMBOL_chainid_spec: /* chainid_spec  */
#line 627 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5915 "parser_bison.c"
        break;

    case YYSYMBOL_chain_identifier: /* chain_identifier  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5921 "parser_bison.c"
        break;

    case YYSYMBOL_set_spec: /* set_spec  */
#line 632 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5927 "parser_bison.c"
        break;

    case YYSYMBOL_setid_spec: /* setid_spec  */
#line 632 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5933 "parser_bison.c"
        break;

    case YYSYMBOL_set_identifier: /* set_identifier  */
#line 637 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5939 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_spec: /* flowtable_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5945 "parser_bison.c"
        break;

    case YYSYMBOL_flowtableid_spec: /* flowtableid_spec  */
#line 637 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5951 "parser_bison.c"
        break;

    case YYSYMBOL_obj_spec: /* obj_spec  */
#line 634 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5957 "parser_bison.c"
        break;

    case YYSYMBOL_objid_spec: /* objid_spec  */
#line 634 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5963 "parser_bison.c"
        break;

    case YYSYMBOL_obj_identifier: /* obj_identifier  */
#line 637 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5969 "parser_bison.c"
        break;

    case YYSYMBOL_handle_spec: /* handle_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5975 "parser_bison.c"
        break;

    case YYSYMBOL_position_spec: /* position_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5981 "parser_bison.c"
        break;

    case YYSYMBOL_index_spec: /* index_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5987 "parser_bison.c"
        break;

    case YYSYMBOL_rule_position: /* rule_position  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5993 "parser_bison.c"
        break;

    case YYSYMBOL_ruleid_spec: /* ruleid_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5999 "parser_bison.c"
        break;

    case YYSYMBOL_comment_spec: /* comment_spec  */
#line 611 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 6005 "parser_bison.c"
        break;

    case YYSYMBOL_ruleset_spec: /* ruleset_spec  */
#line 630 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 6011 "parser_bison.c"
        break;

    case YYSYMBOL_rule: /* rule  */
#line 656 "parser_bison.y"
            { rule_free(((*yyvaluep).rule)); }
#line 6017 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_list: /* stmt_list  */
#line 676 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 6023 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt_list: /* stateful_stmt_list  */
#line 676 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 6029 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt: /* stateful_stmt  */
#line 680 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6035 "parser_bison.c"
        break;

    case YYSYMBOL_stmt: /* stmt  */
#line 678 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6041 "parser_bison.c"
        break;

    case YYSYMBOL_chain_stmt: /* chain_stmt  */
#line 703 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6047 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_stmt: /* verdict_stmt  */
#line 678 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6053 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_stmt: /* verdict_map_stmt  */
#line 761 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6059 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_expr: /* verdict_map_expr  */
#line 764 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6065 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_expr: /* verdict_map_list_expr  */
#line 764 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6071 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_member_expr: /* verdict_map_list_member_expr  */
#line 764 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6077 "parser_bison.c"
        break;

    case YYSYMBOL_connlimit_stmt: /* connlimit_stmt  */
#line 691 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6083 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt: /* counter_stmt  */
#line 680 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6089 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt_alloc: /* counter_stmt_alloc  */
#line 680 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6095 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt: /* log_stmt  */
#line 688 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6101 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt_alloc: /* log_stmt_alloc  */
#line 688 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6107 "parser_bison.c"
        break;

    case YYSYMBOL_limit_stmt: /* limit_stmt  */
#line 691 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6113 "parser_bison.c"
        break;

    case YYSYMBOL_quota_unit: /* quota_unit  */
#line 646 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 6119 "parser_bison.c"
        break;

    case YYSYMBOL_quota_stmt: /* quota_stmt  */
#line 691 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6125 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt: /* reject_stmt  */
#line 694 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6131 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt_alloc: /* reject_stmt_alloc  */
#line 694 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6137 "parser_bison.c"
        break;

    case YYSYMBOL_reject_with_expr: /* reject_with_expr  */
#line 709 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6143 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt: /* nat_stmt  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6149 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt_alloc: /* nat_stmt_alloc  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6155 "parser_bison.c"
        break;

    case YYSYMBOL_tproxy_stmt: /* tproxy_stmt  */
#line 699 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6161 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt: /* synproxy_stmt  */
#line 701 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6167 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt_alloc: /* synproxy_stmt_alloc  */
#line 701 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6173 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_obj: /* synproxy_obj  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6179 "parser_bison.c"
        break;

    case YYSYMBOL_primary_stmt_expr: /* primary_stmt_expr  */
#line 748 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6185 "parser_bison.c"
        break;

    case YYSYMBOL_shift_stmt_expr: /* shift_stmt_expr  */
#line 750 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6191 "parser_bison.c"
        break;

    case YYSYMBOL_and_stmt_expr: /* and_stmt_expr  */
#line 752 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6197 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_stmt_expr: /* exclusive_or_stmt_expr  */
#line 752 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6203 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_stmt_expr: /* inclusive_or_stmt_expr  */
#line 752 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6209 "parser_bison.c"
        break;

    case YYSYMBOL_basic_stmt_expr: /* basic_stmt_expr  */
#line 748 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6215 "parser_bison.c"
        break;

    case YYSYMBOL_concat_stmt_expr: /* concat_stmt_expr  */
#line 740 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6221 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr_set: /* map_stmt_expr_set  */
#line 740 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6227 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr: /* map_stmt_expr  */
#line 740 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6233 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_stmt_expr: /* prefix_stmt_expr  */
#line 745 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6239 "parser_bison.c"
        break;

    case YYSYMBOL_range_stmt_expr: /* range_stmt_expr  */
#line 745 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6245 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_stmt_expr: /* multiton_stmt_expr  */
#line 743 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6251 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_expr: /* stmt_expr  */
#line 740 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6257 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt: /* masq_stmt  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6263 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt_alloc: /* masq_stmt_alloc  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6269 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt: /* redir_stmt  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6275 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt_alloc: /* redir_stmt_alloc  */
#line 696 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6281 "parser_bison.c"
        break;

    case YYSYMBOL_dup_stmt: /* dup_stmt  */
#line 712 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6287 "parser_bison.c"
        break;

    case YYSYMBOL_fwd_stmt: /* fwd_stmt  */
#line 714 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6293 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt: /* queue_stmt  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6299 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_compat: /* queue_stmt_compat  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6305 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_alloc: /* queue_stmt_alloc  */
#line 707 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6311 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_expr_simple: /* queue_stmt_expr_simple  */
#line 709 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6317 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_expr: /* queue_stmt_expr  */
#line 709 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6323 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt: /* set_elem_expr_stmt  */
#line 771 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6329 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt_alloc: /* set_elem_expr_stmt_alloc  */
#line 771 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6335 "parser_bison.c"
        break;

    case YYSYMBOL_set_stmt: /* set_stmt  */
#line 716 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6341 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt: /* map_stmt  */
#line 719 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6347 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt: /* meter_stmt  */
#line 721 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6353 "parser_bison.c"
        break;

    case YYSYMBOL_flow_stmt_legacy_alloc: /* flow_stmt_legacy_alloc  */
#line 721 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6359 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt_alloc: /* meter_stmt_alloc  */
#line 721 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6365 "parser_bison.c"
        break;

    case YYSYMBOL_match_stmt: /* match_stmt  */
#line 678 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6371 "parser_bison.c"
        break;

    case YYSYMBOL_variable_expr: /* variable_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6377 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_expr: /* symbol_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6383 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_expr: /* set_ref_expr  */
#line 732 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6389 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_symbol_expr: /* set_ref_symbol_expr  */
#line 732 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6395 "parser_bison.c"
        break;

    case YYSYMBOL_integer_expr: /* integer_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6401 "parser_bison.c"
        break;

    case YYSYMBOL_primary_expr: /* primary_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6407 "parser_bison.c"
        break;

    case YYSYMBOL_fib_expr: /* fib_expr  */
#line 856 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6413 "parser_bison.c"
        break;

    case YYSYMBOL_osf_expr: /* osf_expr  */
#line 861 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6419 "parser_bison.c"
        break;

    case YYSYMBOL_shift_expr: /* shift_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6425 "parser_bison.c"
        break;

    case YYSYMBOL_and_expr: /* and_expr  */
#line 726 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6431 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_expr: /* exclusive_or_expr  */
#line 728 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6437 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_expr: /* inclusive_or_expr  */
#line 728 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6443 "parser_bison.c"
        break;

    case YYSYMBOL_basic_expr: /* basic_expr  */
#line 730 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6449 "parser_bison.c"
        break;

    case YYSYMBOL_concat_expr: /* concat_expr  */
#line 755 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6455 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_rhs_expr: /* prefix_rhs_expr  */
#line 737 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6461 "parser_bison.c"
        break;

    case YYSYMBOL_range_rhs_expr: /* range_rhs_expr  */
#line 737 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6467 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_rhs_expr: /* multiton_rhs_expr  */
#line 735 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6473 "parser_bison.c"
        break;

    case YYSYMBOL_map_expr: /* map_expr  */
#line 758 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6479 "parser_bison.c"
        break;

    case YYSYMBOL_expr: /* expr  */
#line 777 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6485 "parser_bison.c"
        break;

    case YYSYMBOL_set_expr: /* set_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6491 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_expr: /* set_list_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6497 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_member_expr: /* set_list_member_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6503 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr: /* meter_key_expr  */
#line 774 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6509 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr_alloc: /* meter_key_expr_alloc  */
#line 774 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6515 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr: /* set_elem_expr  */
#line 769 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6521 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_key_expr: /* set_elem_key_expr  */
#line 893 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6527 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_alloc: /* set_elem_expr_alloc  */
#line 769 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6533 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt_list: /* set_elem_stmt_list  */
#line 676 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 6539 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt: /* set_elem_stmt  */
#line 678 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6545 "parser_bison.c"
        break;

    case YYSYMBOL_set_lhs_expr: /* set_lhs_expr  */
#line 769 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6551 "parser_bison.c"
        break;

    case YYSYMBOL_set_rhs_expr: /* set_rhs_expr  */
#line 769 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6557 "parser_bison.c"
        break;

    case YYSYMBOL_initializer_expr: /* initializer_expr  */
#line 777 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6563 "parser_bison.c"
        break;

    case YYSYMBOL_counter_obj: /* counter_obj  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6569 "parser_bison.c"
        break;

    case YYSYMBOL_quota_obj: /* quota_obj  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6575 "parser_bison.c"
        break;

    case YYSYMBOL_secmark_obj: /* secmark_obj  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6581 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_states: /* timeout_states  */
#line 886 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6587 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_state: /* timeout_state  */
#line 886 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6593 "parser_bison.c"
        break;

    case YYSYMBOL_ct_obj_alloc: /* ct_obj_alloc  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6599 "parser_bison.c"
        break;

    case YYSYMBOL_limit_obj: /* limit_obj  */
#line 787 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6605 "parser_bison.c"
        break;

    case YYSYMBOL_relational_expr: /* relational_expr  */
#line 790 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6611 "parser_bison.c"
        break;

    case YYSYMBOL_list_rhs_expr: /* list_rhs_expr  */
#line 782 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6617 "parser_bison.c"
        break;

    case YYSYMBOL_rhs_expr: /* rhs_expr  */
#line 780 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6623 "parser_bison.c"
        break;

    case YYSYMBOL_shift_rhs_expr: /* shift_rhs_expr  */
#line 782 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6629 "parser_bison.c"
        break;

    case YYSYMBOL_and_rhs_expr: /* and_rhs_expr  */
#line 784 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6635 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_rhs_expr: /* exclusive_or_rhs_expr  */
#line 784 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6641 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_rhs_expr: /* inclusive_or_rhs_expr  */
#line 784 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6647 "parser_bison.c"
        break;

    case YYSYMBOL_basic_rhs_expr: /* basic_rhs_expr  */
#line 780 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6653 "parser_bison.c"
        break;

    case YYSYMBOL_concat_rhs_expr: /* concat_rhs_expr  */
#line 780 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6659 "parser_bison.c"
        break;

    case YYSYMBOL_boolean_expr: /* boolean_expr  */
#line 876 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6665 "parser_bison.c"
        break;

    case YYSYMBOL_keyword_expr: /* keyword_expr  */
#line 777 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6671 "parser_bison.c"
        break;

    case YYSYMBOL_primary_rhs_expr: /* primary_rhs_expr  */
#line 782 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6677 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_expr: /* verdict_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6683 "parser_bison.c"
        break;

    case YYSYMBOL_chain_expr: /* chain_expr  */
#line 724 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6689 "parser_bison.c"
        break;

    case YYSYMBOL_meta_expr: /* meta_expr  */
#line 838 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6695 "parser_bison.c"
        break;

    case YYSYMBOL_meta_stmt: /* meta_stmt  */
#line 686 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6701 "parser_bison.c"
        break;

    case YYSYMBOL_socket_expr: /* socket_expr  */
#line 842 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6707 "parser_bison.c"
        break;

    case YYSYMBOL_numgen_expr: /* numgen_expr  */
#line 803 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6713 "parser_bison.c"
        break;

    case YYSYMBOL_xfrm_expr: /* xfrm_expr  */
#line 890 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6719 "parser_bison.c"
        break;

    case YYSYMBOL_hash_expr: /* hash_expr  */
#line 803 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6725 "parser_bison.c"
        break;

    case YYSYMBOL_rt_expr: /* rt_expr  */
#line 848 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6731 "parser_bison.c"
        break;

    case YYSYMBOL_ct_expr: /* ct_expr  */
#line 852 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6737 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_stmt_expr: /* symbol_stmt_expr  */
#line 782 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6743 "parser_bison.c"
        break;

    case YYSYMBOL_list_stmt_expr: /* list_stmt_expr  */
#line 750 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6749 "parser_bison.c"
        break;

    case YYSYMBOL_ct_stmt: /* ct_stmt  */
#line 684 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6755 "parser_bison.c"
        break;

    case YYSYMBOL_payload_stmt: /* payload_stmt  */
#line 682 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6761 "parser_bison.c"
        break;

    case YYSYMBOL_payload_expr: /* payload_expr  */
#line 794 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6767 "parser_bison.c"
        break;

    case YYSYMBOL_payload_raw_expr: /* payload_raw_expr  */
#line 794 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6773 "parser_bison.c"
        break;

    case YYSYMBOL_eth_hdr_expr: /* eth_hdr_expr  */
#line 797 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6779 "parser_bison.c"
        break;

    case YYSYMBOL_vlan_hdr_expr: /* vlan_hdr_expr  */
#line 797 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6785 "parser_bison.c"
        break;

    case YYSYMBOL_arp_hdr_expr: /* arp_hdr_expr  */
#line 800 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6791 "parser_bison.c"
        break;

    case YYSYMBOL_ip_hdr_expr: /* ip_hdr_expr  */
#line 803 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6797 "parser_bison.c"
        break;

    case YYSYMBOL_icmp_hdr_expr: /* icmp_hdr_expr  */
#line 803 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6803 "parser_bison.c"
        break;

    case YYSYMBOL_igmp_hdr_expr: /* igmp_hdr_expr  */
#line 803 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6809 "parser_bison.c"
        break;

    case YYSYMBOL_ip6_hdr_expr: /* ip6_hdr_expr  */
#line 807 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6815 "parser_bison.c"
        break;

    case YYSYMBOL_icmp6_hdr_expr: /* icmp6_hdr_expr  */
#line 807 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6821 "parser_bison.c"
        break;

    case YYSYMBOL_auth_hdr_expr: /* auth_hdr_expr  */
#line 810 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6827 "parser_bison.c"
        break;

    case YYSYMBOL_esp_hdr_expr: /* esp_hdr_expr  */
#line 810 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6833 "parser_bison.c"
        break;

    case YYSYMBOL_comp_hdr_expr: /* comp_hdr_expr  */
#line 810 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6839 "parser_bison.c"
        break;

    case YYSYMBOL_udp_hdr_expr: /* udp_hdr_expr  */
#line 813 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6845 "parser_bison.c"
        break;

    case YYSYMBOL_udplite_hdr_expr: /* udplite_hdr_expr  */
#line 813 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6851 "parser_bison.c"
        break;

    case YYSYMBOL_tcp_hdr_expr: /* tcp_hdr_expr  */
#line 871 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6857 "parser_bison.c"
        break;

    case YYSYMBOL_dccp_hdr_expr: /* dccp_hdr_expr  */
#line 816 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6863 "parser_bison.c"
        break;

    case YYSYMBOL_sctp_chunk_alloc: /* sctp_chunk_alloc  */
#line 816 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6869 "parser_bison.c"
        break;

    case YYSYMBOL_sctp_hdr_expr: /* sctp_hdr_expr  */
#line 816 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6875 "parser_bison.c"
        break;

    case YYSYMBOL_th_hdr_expr: /* th_hdr_expr  */
#line 822 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6881 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_expr: /* exthdr_expr  */
#line 826 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6887 "parser_bison.c"
        break;

    case YYSYMBOL_hbh_hdr_expr: /* hbh_hdr_expr  */
#line 828 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6893 "parser_bison.c"
        break;

    case YYSYMBOL_rt_hdr_expr: /* rt_hdr_expr  */
#line 831 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6899 "parser_bison.c"
        break;

    case YYSYMBOL_rt0_hdr_expr: /* rt0_hdr_expr  */
#line 831 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6905 "parser_bison.c"
        break;

    case YYSYMBOL_rt2_hdr_expr: /* rt2_hdr_expr  */
#line 831 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6911 "parser_bison.c"
        break;

    case YYSYMBOL_rt4_hdr_expr: /* rt4_hdr_expr  */
#line 831 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6917 "parser_bison.c"
        break;

    case YYSYMBOL_frag_hdr_expr: /* frag_hdr_expr  */
#line 828 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6923 "parser_bison.c"
        break;

    case YYSYMBOL_dst_hdr_expr: /* dst_hdr_expr  */
#line 828 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6929 "parser_bison.c"
        break;

    case YYSYMBOL_mh_hdr_expr: /* mh_hdr_expr  */
#line 834 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6935 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_exists_expr: /* exthdr_exists_expr  */
#line 880 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6941 "parser_bison.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */


/* User initialization code.  */
#line 159 "parser_bison.y"
{
	location_init(scanner, state, &yylloc);
	if (nft->debug_mask & NFT_DEBUG_SCANNER)
		nft_set_debug(1, scanner);
	if (nft->debug_mask & NFT_DEBUG_PARSER)
		yydebug = 1;
}

#line 7047 "parser_bison.c"

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= TOKEN_EOF)
    {
      yychar = TOKEN_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* input: input line  */
#line 899 "parser_bison.y"
                        {
				if ((yyvsp[0].cmd) != NULL) {
					(yyvsp[0].cmd)->location = (yylsp[0]);
					list_add_tail(&(yyvsp[0].cmd)->list, state->cmds);
				}
			}
#line 7265 "parser_bison.c"
    break;

  case 8: /* close_scope_arp: %empty  */
#line 915 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_ARP); }
#line 7271 "parser_bison.c"
    break;

  case 9: /* close_scope_ct: %empty  */
#line 916 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_CT); }
#line 7277 "parser_bison.c"
    break;

  case 10: /* close_scope_counter: %empty  */
#line 917 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_COUNTER); }
#line 7283 "parser_bison.c"
    break;

  case 11: /* close_scope_eth: %empty  */
#line 918 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_ETH); }
#line 7289 "parser_bison.c"
    break;

  case 12: /* close_scope_fib: %empty  */
#line 919 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_FIB); }
#line 7295 "parser_bison.c"
    break;

  case 13: /* close_scope_hash: %empty  */
#line 920 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_HASH); }
#line 7301 "parser_bison.c"
    break;

  case 14: /* close_scope_ip: %empty  */
#line 921 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_IP); }
#line 7307 "parser_bison.c"
    break;

  case 15: /* close_scope_ip6: %empty  */
#line 922 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_IP6); }
#line 7313 "parser_bison.c"
    break;

  case 16: /* close_scope_vlan: %empty  */
#line 923 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_VLAN); }
#line 7319 "parser_bison.c"
    break;

  case 17: /* close_scope_ipsec: %empty  */
#line 924 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_IPSEC); }
#line 7325 "parser_bison.c"
    break;

  case 18: /* close_scope_list: %empty  */
#line 925 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_CMD_LIST); }
#line 7331 "parser_bison.c"
    break;

  case 19: /* close_scope_limit: %empty  */
#line 926 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_LIMIT); }
#line 7337 "parser_bison.c"
    break;

  case 20: /* close_scope_numgen: %empty  */
#line 927 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_NUMGEN); }
#line 7343 "parser_bison.c"
    break;

  case 21: /* close_scope_quota: %empty  */
#line 928 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_QUOTA); }
#line 7349 "parser_bison.c"
    break;

  case 22: /* close_scope_queue: %empty  */
#line 929 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_QUEUE); }
#line 7355 "parser_bison.c"
    break;

  case 23: /* close_scope_rt: %empty  */
#line 930 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_RT); }
#line 7361 "parser_bison.c"
    break;

  case 24: /* close_scope_sctp: %empty  */
#line 931 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_SCTP); }
#line 7367 "parser_bison.c"
    break;

  case 25: /* close_scope_sctp_chunk: %empty  */
#line 932 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_SCTP_CHUNK); }
#line 7373 "parser_bison.c"
    break;

  case 26: /* close_scope_secmark: %empty  */
#line 933 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_SECMARK); }
#line 7379 "parser_bison.c"
    break;

  case 27: /* close_scope_socket: %empty  */
#line 934 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_EXPR_SOCKET); }
#line 7385 "parser_bison.c"
    break;

  case 28: /* close_scope_log: %empty  */
#line 936 "parser_bison.y"
                          { scanner_pop_start_cond(nft->scanner, PARSER_SC_STMT_LOG); }
#line 7391 "parser_bison.c"
    break;

  case 29: /* common_block: "include" "quoted string" stmt_separator  */
#line 939 "parser_bison.y"
                        {
				if (scanner_include_file(nft, scanner, (yyvsp[-1].string), &(yyloc)) < 0) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 7403 "parser_bison.c"
    break;

  case 30: /* common_block: "define" identifier '=' initializer_expr stmt_separator  */
#line 947 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[-3].string)) != NULL) {
					erec_queue(error(&(yylsp[-3]), "redefinition of symbol '%s'", (yyvsp[-3].string)),
						   state->msgs);
					expr_free((yyvsp[-1].expr));
					xfree((yyvsp[-3].string));
					YYERROR;
				}

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 7422 "parser_bison.c"
    break;

  case 31: /* common_block: "redefine" identifier '=' initializer_expr stmt_separator  */
#line 962 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 7433 "parser_bison.c"
    break;

  case 32: /* common_block: "undefine" identifier stmt_separator  */
#line 969 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_unbind(scope, (yyvsp[-1].string)) < 0) {
					erec_queue(error(&(yylsp[-1]), "undefined symbol '%s'", (yyvsp[-1].string)),
						   state->msgs);
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 7449 "parser_bison.c"
    break;

  case 33: /* common_block: error stmt_separator  */
#line 981 "parser_bison.y"
                        {
				if (++state->nerrs == nft->parser_max_errors)
					YYABORT;
				yyerrok;
			}
#line 7459 "parser_bison.c"
    break;

  case 34: /* line: common_block  */
#line 988 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 7465 "parser_bison.c"
    break;

  case 35: /* line: stmt_separator  */
#line 989 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 7471 "parser_bison.c"
    break;

  case 36: /* line: base_cmd stmt_separator  */
#line 990 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 7477 "parser_bison.c"
    break;

  case 37: /* line: base_cmd "end of file"  */
#line 992 "parser_bison.y"
                        {
				/*
				 * Very hackish workaround for bison >= 2.4: previous versions
				 * terminated parsing after EOF, 2.4+ tries to get further input
				 * in 'input' and calls the scanner again, causing a crash when
				 * the final input buffer has been popped. Terminate manually to
				 * avoid this. The correct fix should be to adjust the grammar
				 * to accept EOF in input, but for unknown reasons it does not
				 * work.
				 */
				if ((yyvsp[-1].cmd) != NULL) {
					(yyvsp[-1].cmd)->location = (yylsp[-1]);
					list_add_tail(&(yyvsp[-1].cmd)->list, state->cmds);
				}
				(yyval.cmd) = NULL;
				YYACCEPT;
			}
#line 7499 "parser_bison.c"
    break;

  case 38: /* base_cmd: add_cmd  */
#line 1011 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7505 "parser_bison.c"
    break;

  case 39: /* base_cmd: "add" add_cmd  */
#line 1012 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7511 "parser_bison.c"
    break;

  case 40: /* base_cmd: "replace" replace_cmd  */
#line 1013 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7517 "parser_bison.c"
    break;

  case 41: /* base_cmd: "create" create_cmd  */
#line 1014 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7523 "parser_bison.c"
    break;

  case 42: /* base_cmd: "insert" insert_cmd  */
#line 1015 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7529 "parser_bison.c"
    break;

  case 43: /* base_cmd: "delete" delete_cmd  */
#line 1016 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7535 "parser_bison.c"
    break;

  case 44: /* base_cmd: "get" get_cmd  */
#line 1017 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7541 "parser_bison.c"
    break;

  case 45: /* base_cmd: "list" list_cmd close_scope_list  */
#line 1018 "parser_bison.y"
                                                                                        { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 7547 "parser_bison.c"
    break;

  case 46: /* base_cmd: "reset" reset_cmd  */
#line 1019 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7553 "parser_bison.c"
    break;

  case 47: /* base_cmd: "flush" flush_cmd  */
#line 1020 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7559 "parser_bison.c"
    break;

  case 48: /* base_cmd: "rename" rename_cmd  */
#line 1021 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7565 "parser_bison.c"
    break;

  case 49: /* base_cmd: "import" import_cmd  */
#line 1022 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7571 "parser_bison.c"
    break;

  case 50: /* base_cmd: "export" export_cmd  */
#line 1023 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7577 "parser_bison.c"
    break;

  case 51: /* base_cmd: "monitor" monitor_cmd  */
#line 1024 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7583 "parser_bison.c"
    break;

  case 52: /* base_cmd: "describe" describe_cmd  */
#line 1025 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7589 "parser_bison.c"
    break;

  case 53: /* add_cmd: "table" table_spec  */
#line 1029 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7597 "parser_bison.c"
    break;

  case 54: /* add_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 1034 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7607 "parser_bison.c"
    break;

  case 55: /* add_cmd: "chain" chain_spec  */
#line 1040 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7615 "parser_bison.c"
    break;

  case 56: /* add_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 1045 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7626 "parser_bison.c"
    break;

  case 57: /* add_cmd: "rule" rule_position rule  */
#line 1052 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7634 "parser_bison.c"
    break;

  case 58: /* add_cmd: rule_position rule  */
#line 1056 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7642 "parser_bison.c"
    break;

  case 59: /* add_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 1061 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7652 "parser_bison.c"
    break;

  case 60: /* add_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 1068 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7662 "parser_bison.c"
    break;

  case 61: /* add_cmd: "element" set_spec set_block_expr  */
#line 1074 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7670 "parser_bison.c"
    break;

  case 62: /* add_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1079 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7680 "parser_bison.c"
    break;

  case 63: /* add_cmd: "counter" obj_spec close_scope_counter  */
#line 1085 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[-1].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), obj);
			}
#line 7693 "parser_bison.c"
    break;

  case 64: /* add_cmd: "counter" obj_spec counter_obj counter_config close_scope_counter  */
#line 1094 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7701 "parser_bison.c"
    break;

  case 65: /* add_cmd: "counter" obj_spec counter_obj '{' counter_block '}' close_scope_counter  */
#line 1098 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7709 "parser_bison.c"
    break;

  case 66: /* add_cmd: "quota" obj_spec quota_obj quota_config close_scope_quota  */
#line 1102 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7717 "parser_bison.c"
    break;

  case 67: /* add_cmd: "quota" obj_spec quota_obj '{' quota_block '}' close_scope_quota  */
#line 1106 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7725 "parser_bison.c"
    break;

  case 68: /* add_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}' close_scope_ct  */
#line 1110 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_HELPER, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7733 "parser_bison.c"
    break;

  case 69: /* add_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}' close_scope_ct  */
#line 1114 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7741 "parser_bison.c"
    break;

  case 70: /* add_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}' close_scope_ct  */
#line 1118 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_EXPECT, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7749 "parser_bison.c"
    break;

  case 71: /* add_cmd: "limit" obj_spec limit_obj limit_config close_scope_limit  */
#line 1122 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7757 "parser_bison.c"
    break;

  case 72: /* add_cmd: "limit" obj_spec limit_obj '{' limit_block '}' close_scope_limit  */
#line 1126 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7765 "parser_bison.c"
    break;

  case 73: /* add_cmd: "secmark" obj_spec secmark_obj secmark_config close_scope_secmark  */
#line 1130 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7773 "parser_bison.c"
    break;

  case 74: /* add_cmd: "secmark" obj_spec secmark_obj '{' secmark_block '}' close_scope_secmark  */
#line 1134 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7781 "parser_bison.c"
    break;

  case 75: /* add_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1138 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7789 "parser_bison.c"
    break;

  case 76: /* add_cmd: "synproxy" obj_spec synproxy_obj '{' synproxy_block '}'  */
#line 1142 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7797 "parser_bison.c"
    break;

  case 77: /* replace_cmd: "rule" ruleid_spec rule  */
#line 1148 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_REPLACE, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7805 "parser_bison.c"
    break;

  case 78: /* create_cmd: "table" table_spec  */
#line 1154 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7813 "parser_bison.c"
    break;

  case 79: /* create_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 1159 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7823 "parser_bison.c"
    break;

  case 80: /* create_cmd: "chain" chain_spec  */
#line 1165 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7831 "parser_bison.c"
    break;

  case 81: /* create_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 1170 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7842 "parser_bison.c"
    break;

  case 82: /* create_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 1178 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7852 "parser_bison.c"
    break;

  case 83: /* create_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 1185 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7862 "parser_bison.c"
    break;

  case 84: /* create_cmd: "element" set_spec set_block_expr  */
#line 1191 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7870 "parser_bison.c"
    break;

  case 85: /* create_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1196 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7880 "parser_bison.c"
    break;

  case 86: /* create_cmd: "counter" obj_spec close_scope_counter  */
#line 1202 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[-1].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), obj);
			}
#line 7893 "parser_bison.c"
    break;

  case 87: /* create_cmd: "counter" obj_spec counter_obj counter_config close_scope_counter  */
#line 1211 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7901 "parser_bison.c"
    break;

  case 88: /* create_cmd: "quota" obj_spec quota_obj quota_config close_scope_quota  */
#line 1215 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_QUOTA, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7909 "parser_bison.c"
    break;

  case 89: /* create_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}' close_scope_ct  */
#line 1219 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_HELPER, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7917 "parser_bison.c"
    break;

  case 90: /* create_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}' close_scope_ct  */
#line 1223 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7925 "parser_bison.c"
    break;

  case 91: /* create_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}' close_scope_ct  */
#line 1227 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_EXPECT, &(yyvsp[-5].handle), &(yyloc), (yyvsp[-4].obj));
			}
#line 7933 "parser_bison.c"
    break;

  case 92: /* create_cmd: "limit" obj_spec limit_obj limit_config close_scope_limit  */
#line 1231 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_LIMIT, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7941 "parser_bison.c"
    break;

  case 93: /* create_cmd: "secmark" obj_spec secmark_obj secmark_config close_scope_secmark  */
#line 1235 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SECMARK, &(yyvsp[-3].handle), &(yyloc), (yyvsp[-2].obj));
			}
#line 7949 "parser_bison.c"
    break;

  case 94: /* create_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1239 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7957 "parser_bison.c"
    break;

  case 95: /* insert_cmd: "rule" rule_position rule  */
#line 1245 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_INSERT, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7965 "parser_bison.c"
    break;

  case 104: /* delete_cmd: "table" table_or_id_spec  */
#line 1267 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7973 "parser_bison.c"
    break;

  case 105: /* delete_cmd: "chain" chain_or_id_spec  */
#line 1271 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7981 "parser_bison.c"
    break;

  case 106: /* delete_cmd: "rule" ruleid_spec  */
#line 1275 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_RULE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7989 "parser_bison.c"
    break;

  case 107: /* delete_cmd: "set" set_or_id_spec  */
#line 1279 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7997 "parser_bison.c"
    break;

  case 108: /* delete_cmd: "map" set_spec  */
#line 1283 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8005 "parser_bison.c"
    break;

  case 109: /* delete_cmd: "element" set_spec set_block_expr  */
#line 1287 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 8013 "parser_bison.c"
    break;

  case 110: /* delete_cmd: "flowtable" flowtable_spec  */
#line 1291 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8021 "parser_bison.c"
    break;

  case 111: /* delete_cmd: "flowtable" flowtableid_spec  */
#line 1295 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8029 "parser_bison.c"
    break;

  case 112: /* delete_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1300 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 8039 "parser_bison.c"
    break;

  case 113: /* delete_cmd: "counter" obj_or_id_spec close_scope_counter  */
#line 1306 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8047 "parser_bison.c"
    break;

  case 114: /* delete_cmd: "quota" obj_or_id_spec close_scope_quota  */
#line 1310 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8055 "parser_bison.c"
    break;

  case 115: /* delete_cmd: "ct" ct_obj_type obj_spec ct_obj_alloc close_scope_ct  */
#line 1314 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_DELETE, (yyvsp[-3].val), &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
				if ((yyvsp[-3].val) == NFT_OBJECT_CT_TIMEOUT)
					init_list_head(&(yyvsp[-1].obj)->ct_timeout.timeout_list);
			}
#line 8065 "parser_bison.c"
    break;

  case 116: /* delete_cmd: "limit" obj_or_id_spec close_scope_limit  */
#line 1320 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8073 "parser_bison.c"
    break;

  case 117: /* delete_cmd: "secmark" obj_or_id_spec close_scope_secmark  */
#line 1324 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SECMARK, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8081 "parser_bison.c"
    break;

  case 118: /* delete_cmd: "synproxy" obj_or_id_spec  */
#line 1328 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8089 "parser_bison.c"
    break;

  case 119: /* get_cmd: "element" set_spec set_block_expr  */
#line 1334 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_GET, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 8097 "parser_bison.c"
    break;

  case 120: /* list_cmd: "table" table_spec  */
#line 1340 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8105 "parser_bison.c"
    break;

  case 121: /* list_cmd: "tables" ruleset_spec  */
#line 1344 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8113 "parser_bison.c"
    break;

  case 122: /* list_cmd: "chain" chain_spec  */
#line 1348 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8121 "parser_bison.c"
    break;

  case 123: /* list_cmd: "chains" ruleset_spec  */
#line 1352 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAINS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8129 "parser_bison.c"
    break;

  case 124: /* list_cmd: "sets" ruleset_spec  */
#line 1356 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8137 "parser_bison.c"
    break;

  case 125: /* list_cmd: "sets" "table" table_spec  */
#line 1360 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8145 "parser_bison.c"
    break;

  case 126: /* list_cmd: "set" set_spec  */
#line 1364 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8153 "parser_bison.c"
    break;

  case 127: /* list_cmd: "counters" ruleset_spec  */
#line 1368 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8161 "parser_bison.c"
    break;

  case 128: /* list_cmd: "counters" "table" table_spec  */
#line 1372 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8169 "parser_bison.c"
    break;

  case 129: /* list_cmd: "counter" obj_spec close_scope_counter  */
#line 1376 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTER, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8177 "parser_bison.c"
    break;

  case 130: /* list_cmd: "quotas" ruleset_spec  */
#line 1380 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8185 "parser_bison.c"
    break;

  case 131: /* list_cmd: "quotas" "table" table_spec  */
#line 1384 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8193 "parser_bison.c"
    break;

  case 132: /* list_cmd: "quota" obj_spec close_scope_quota  */
#line 1388 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTA, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8201 "parser_bison.c"
    break;

  case 133: /* list_cmd: "limits" ruleset_spec  */
#line 1392 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8209 "parser_bison.c"
    break;

  case 134: /* list_cmd: "limits" "table" table_spec  */
#line 1396 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8217 "parser_bison.c"
    break;

  case 135: /* list_cmd: "limit" obj_spec close_scope_limit  */
#line 1400 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMIT, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8225 "parser_bison.c"
    break;

  case 136: /* list_cmd: "secmarks" ruleset_spec  */
#line 1404 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8233 "parser_bison.c"
    break;

  case 137: /* list_cmd: "secmarks" "table" table_spec  */
#line 1408 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8241 "parser_bison.c"
    break;

  case 138: /* list_cmd: "secmark" obj_spec close_scope_secmark  */
#line 1412 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARK, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8249 "parser_bison.c"
    break;

  case 139: /* list_cmd: "synproxys" ruleset_spec  */
#line 1416 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8257 "parser_bison.c"
    break;

  case 140: /* list_cmd: "synproxys" "table" table_spec  */
#line 1420 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8265 "parser_bison.c"
    break;

  case 141: /* list_cmd: "synproxy" obj_spec  */
#line 1424 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8273 "parser_bison.c"
    break;

  case 142: /* list_cmd: "ruleset" ruleset_spec  */
#line 1428 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8281 "parser_bison.c"
    break;

  case 143: /* list_cmd: "flow" "tables" ruleset_spec  */
#line 1432 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8289 "parser_bison.c"
    break;

  case 144: /* list_cmd: "flow" "table" set_spec  */
#line 1436 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8297 "parser_bison.c"
    break;

  case 145: /* list_cmd: "meters" ruleset_spec  */
#line 1440 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8305 "parser_bison.c"
    break;

  case 146: /* list_cmd: "meter" set_spec  */
#line 1444 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8313 "parser_bison.c"
    break;

  case 147: /* list_cmd: "flowtables" ruleset_spec  */
#line 1448 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLES, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8321 "parser_bison.c"
    break;

  case 148: /* list_cmd: "flowtable" flowtable_spec  */
#line 1452 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8329 "parser_bison.c"
    break;

  case 149: /* list_cmd: "maps" ruleset_spec  */
#line 1456 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAPS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8337 "parser_bison.c"
    break;

  case 150: /* list_cmd: "map" set_spec  */
#line 1460 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8345 "parser_bison.c"
    break;

  case 151: /* list_cmd: "ct" ct_obj_type obj_spec close_scope_ct  */
#line 1464 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_LIST, (yyvsp[-2].val), &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8353 "parser_bison.c"
    break;

  case 152: /* list_cmd: "ct" ct_cmd_type "table" table_spec close_scope_ct  */
#line 1468 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, (yyvsp[-3].val), &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8361 "parser_bison.c"
    break;

  case 153: /* list_cmd: "hooks" basehook_spec  */
#line 1472 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_HOOKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8369 "parser_bison.c"
    break;

  case 154: /* basehook_device_name: "device" "string"  */
#line 1478 "parser_bison.y"
                        {
				(yyval.string) = (yyvsp[0].string);
			}
#line 8377 "parser_bison.c"
    break;

  case 155: /* basehook_spec: ruleset_spec  */
#line 1484 "parser_bison.y"
                        {
				(yyval.handle) = (yyvsp[0].handle);
			}
#line 8385 "parser_bison.c"
    break;

  case 156: /* basehook_spec: ruleset_spec basehook_device_name  */
#line 1488 "parser_bison.y"
                        {
				if ((yyvsp[0].string)) {
					(yyvsp[-1].handle).obj.name = (yyvsp[0].string);
					(yyvsp[-1].handle).obj.location = (yylsp[0]);
				}
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 8397 "parser_bison.c"
    break;

  case 157: /* reset_cmd: "counters" ruleset_spec  */
#line 1498 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8405 "parser_bison.c"
    break;

  case 158: /* reset_cmd: "counters" "table" table_spec  */
#line 1502 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8413 "parser_bison.c"
    break;

  case 159: /* reset_cmd: "counter" obj_spec close_scope_counter  */
#line 1506 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTER, &(yyvsp[-1].handle),&(yyloc), NULL);
			}
#line 8421 "parser_bison.c"
    break;

  case 160: /* reset_cmd: "quotas" ruleset_spec  */
#line 1510 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8429 "parser_bison.c"
    break;

  case 161: /* reset_cmd: "quotas" "table" table_spec  */
#line 1514 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8437 "parser_bison.c"
    break;

  case 162: /* reset_cmd: "quota" obj_spec close_scope_quota  */
#line 1518 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTA, &(yyvsp[-1].handle), &(yyloc), NULL);
			}
#line 8445 "parser_bison.c"
    break;

  case 163: /* flush_cmd: "table" table_spec  */
#line 1524 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8453 "parser_bison.c"
    break;

  case 164: /* flush_cmd: "chain" chain_spec  */
#line 1528 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8461 "parser_bison.c"
    break;

  case 165: /* flush_cmd: "set" set_spec  */
#line 1532 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8469 "parser_bison.c"
    break;

  case 166: /* flush_cmd: "map" set_spec  */
#line 1536 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8477 "parser_bison.c"
    break;

  case 167: /* flush_cmd: "flow" "table" set_spec  */
#line 1540 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8485 "parser_bison.c"
    break;

  case 168: /* flush_cmd: "meter" set_spec  */
#line 1544 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8493 "parser_bison.c"
    break;

  case 169: /* flush_cmd: "ruleset" ruleset_spec  */
#line 1548 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8501 "parser_bison.c"
    break;

  case 170: /* rename_cmd: "chain" chain_spec identifier  */
#line 1554 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RENAME, CMD_OBJ_CHAIN, &(yyvsp[-1].handle), &(yyloc), NULL);
				(yyval.cmd)->arg = (yyvsp[0].string);
			}
#line 8510 "parser_bison.c"
    break;

  case 171: /* import_cmd: "ruleset" markup_format  */
#line 1561 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8520 "parser_bison.c"
    break;

  case 172: /* import_cmd: markup_format  */
#line 1567 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8530 "parser_bison.c"
    break;

  case 173: /* export_cmd: "ruleset" markup_format  */
#line 1575 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8540 "parser_bison.c"
    break;

  case 174: /* export_cmd: markup_format  */
#line 1581 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8550 "parser_bison.c"
    break;

  case 175: /* monitor_cmd: monitor_event monitor_object monitor_format  */
#line 1589 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct monitor *m = monitor_alloc((yyvsp[0].val), (yyvsp[-1].val), (yyvsp[-2].string));
				m->location = (yylsp[-2]);
				(yyval.cmd) = cmd_alloc(CMD_MONITOR, CMD_OBJ_MONITOR, &h, &(yyloc), m);
			}
#line 8561 "parser_bison.c"
    break;

  case 176: /* monitor_event: %empty  */
#line 1597 "parser_bison.y"
                                                { (yyval.string) = NULL; }
#line 8567 "parser_bison.c"
    break;

  case 177: /* monitor_event: "string"  */
#line 1598 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 8573 "parser_bison.c"
    break;

  case 178: /* monitor_object: %empty  */
#line 1601 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ANY; }
#line 8579 "parser_bison.c"
    break;

  case 179: /* monitor_object: "tables"  */
#line 1602 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TABLES; }
#line 8585 "parser_bison.c"
    break;

  case 180: /* monitor_object: "chains"  */
#line 1603 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_CHAINS; }
#line 8591 "parser_bison.c"
    break;

  case 181: /* monitor_object: "sets"  */
#line 1604 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_SETS; }
#line 8597 "parser_bison.c"
    break;

  case 182: /* monitor_object: "rules"  */
#line 1605 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULES; }
#line 8603 "parser_bison.c"
    break;

  case 183: /* monitor_object: "elements"  */
#line 1606 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ELEMS; }
#line 8609 "parser_bison.c"
    break;

  case 184: /* monitor_object: "ruleset"  */
#line 1607 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULESET; }
#line 8615 "parser_bison.c"
    break;

  case 185: /* monitor_object: "trace"  */
#line 1608 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TRACE; }
#line 8621 "parser_bison.c"
    break;

  case 186: /* monitor_format: %empty  */
#line 1611 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_DEFAULT; }
#line 8627 "parser_bison.c"
    break;

  case 188: /* markup_format: "xml"  */
#line 1615 "parser_bison.y"
                                                { (yyval.val) = __NFT_OUTPUT_NOTSUPP; }
#line 8633 "parser_bison.c"
    break;

  case 189: /* markup_format: "json"  */
#line 1616 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8639 "parser_bison.c"
    break;

  case 190: /* markup_format: "vm" "json"  */
#line 1617 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8645 "parser_bison.c"
    break;

  case 191: /* describe_cmd: primary_expr  */
#line 1621 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_DESCRIBE, CMD_OBJ_EXPR, &h, &(yyloc), NULL);
				(yyval.cmd)->expr = (yyvsp[0].expr);
			}
#line 8655 "parser_bison.c"
    break;

  case 192: /* table_block_alloc: %empty  */
#line 1629 "parser_bison.y"
                        {
				(yyval.table) = table_alloc();
				open_scope(state, &(yyval.table)->scope);
			}
#line 8664 "parser_bison.c"
    break;

  case 193: /* table_options: "flags" "string"  */
#line 1636 "parser_bison.y"
                        {
				if (strcmp((yyvsp[0].string), "dormant") == 0) {
					(yyvsp[-2].table)->flags |= TABLE_F_DORMANT;
					xfree((yyvsp[0].string));
				} else if (strcmp((yyvsp[0].string), "owner") == 0) {
					(yyvsp[-2].table)->flags |= TABLE_F_OWNER;
					xfree((yyvsp[0].string));
				} else {
					erec_queue(error(&(yylsp[0]), "unknown table option %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
			}
#line 8683 "parser_bison.c"
    break;

  case 194: /* table_options: comment_spec  */
#line 1651 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].table)->comment, &(yyloc), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].table)->comment = (yyvsp[0].string);
			}
#line 8695 "parser_bison.c"
    break;

  case 195: /* table_block: %empty  */
#line 1660 "parser_bison.y"
                                                { (yyval.table) = (yyvsp[(-1) - (0)].table); }
#line 8701 "parser_bison.c"
    break;

  case 199: /* table_block: table_block "chain" chain_identifier chain_block_alloc '{' chain_block '}' stmt_separator  */
#line 1667 "parser_bison.y"
                        {
				(yyvsp[-4].chain)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].chain)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				close_scope(state);
				list_add_tail(&(yyvsp[-4].chain)->list, &(yyvsp[-7].table)->chains);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8714 "parser_bison.c"
    break;

  case 200: /* table_block: table_block "set" set_identifier set_block_alloc '{' set_block '}' stmt_separator  */
#line 1678 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8726 "parser_bison.c"
    break;

  case 201: /* table_block: table_block "map" set_identifier map_block_alloc '{' map_block '}' stmt_separator  */
#line 1688 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8738 "parser_bison.c"
    break;

  case 202: /* table_block: table_block "flowtable" flowtable_identifier flowtable_block_alloc '{' flowtable_block '}' stmt_separator  */
#line 1699 "parser_bison.y"
                        {
				(yyvsp[-4].flowtable)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].flowtable)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].flowtable)->list, &(yyvsp[-7].table)->flowtables);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8750 "parser_bison.c"
    break;

  case 203: /* table_block: table_block "counter" obj_identifier obj_block_alloc '{' counter_block '}' stmt_separator close_scope_counter  */
#line 1709 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_COUNTER;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8763 "parser_bison.c"
    break;

  case 204: /* table_block: table_block "quota" obj_identifier obj_block_alloc '{' quota_block '}' stmt_separator close_scope_quota  */
#line 1720 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_QUOTA;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8776 "parser_bison.c"
    break;

  case 205: /* table_block: table_block "ct" "helper" obj_identifier obj_block_alloc '{' ct_helper_block '}' stmt_separator close_scope_ct  */
#line 1729 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_CT_HELPER;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-9].table)->objs);
				(yyval.table) = (yyvsp[-9].table);
			}
#line 8789 "parser_bison.c"
    break;

  case 206: /* table_block: table_block "ct" "timeout" obj_identifier obj_block_alloc '{' ct_timeout_block '}' stmt_separator close_scope_ct  */
#line 1738 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_CT_TIMEOUT;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-9].table)->objs);
				(yyval.table) = (yyvsp[-9].table);
			}
#line 8802 "parser_bison.c"
    break;

  case 207: /* table_block: table_block "ct" "expectation" obj_identifier obj_block_alloc '{' ct_expect_block '}' stmt_separator close_scope_ct  */
#line 1747 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_CT_EXPECT;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-9].table)->objs);
				(yyval.table) = (yyvsp[-9].table);
			}
#line 8815 "parser_bison.c"
    break;

  case 208: /* table_block: table_block "limit" obj_identifier obj_block_alloc '{' limit_block '}' stmt_separator close_scope_limit  */
#line 1758 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_LIMIT;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8828 "parser_bison.c"
    break;

  case 209: /* table_block: table_block "secmark" obj_identifier obj_block_alloc '{' secmark_block '}' stmt_separator close_scope_secmark  */
#line 1769 "parser_bison.y"
                        {
				(yyvsp[-5].obj)->location = (yylsp[-6]);
				(yyvsp[-5].obj)->type = NFT_OBJECT_SECMARK;
				handle_merge(&(yyvsp[-5].obj)->handle, &(yyvsp[-6].handle));
				handle_free(&(yyvsp[-6].handle));
				list_add_tail(&(yyvsp[-5].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8841 "parser_bison.c"
    break;

  case 210: /* table_block: table_block "synproxy" obj_identifier obj_block_alloc '{' synproxy_block '}' stmt_separator  */
#line 1780 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_SYNPROXY;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8854 "parser_bison.c"
    break;

  case 211: /* chain_block_alloc: %empty  */
#line 1791 "parser_bison.y"
                        {
				(yyval.chain) = chain_alloc(NULL);
				open_scope(state, &(yyval.chain)->scope);
			}
#line 8863 "parser_bison.c"
    break;

  case 212: /* chain_block: %empty  */
#line 1797 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8869 "parser_bison.c"
    break;

  case 218: /* chain_block: chain_block rule stmt_separator  */
#line 1804 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8878 "parser_bison.c"
    break;

  case 219: /* chain_block: chain_block comment_spec stmt_separator  */
#line 1809 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].chain)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].chain)->comment = (yyvsp[-1].string);
			}
#line 8890 "parser_bison.c"
    break;

  case 220: /* subchain_block: %empty  */
#line 1818 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8896 "parser_bison.c"
    break;

  case 222: /* subchain_block: subchain_block rule stmt_separator  */
#line 1821 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8905 "parser_bison.c"
    break;

  case 223: /* typeof_data_expr: primary_expr  */
#line 1828 "parser_bison.y"
                        {
				struct expr *e = (yyvsp[0].expr);

				if (e->etype == EXPR_SYMBOL &&
				    strcmp("verdict", e->identifier) == 0) {
					struct expr *v = verdict_expr_alloc(&(yylsp[0]), NF_ACCEPT, NULL);

					expr_free(e);
					v->flags &= ~EXPR_F_CONSTANT;
					e = v;
				}

				if (expr_ops(e)->build_udata == NULL) {
					erec_queue(error(&(yylsp[0]), "map data type '%s' lacks typeof serialization", expr_ops(e)->name),
						   state->msgs);
					expr_free(e);
					YYERROR;
				}
				(yyval.expr) = e;
			}
#line 8930 "parser_bison.c"
    break;

  case 224: /* typeof_data_expr: typeof_expr "." primary_expr  */
#line 1849 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 8943 "parser_bison.c"
    break;

  case 225: /* typeof_expr: primary_expr  */
#line 1860 "parser_bison.y"
                        {
				if (expr_ops((yyvsp[0].expr))->build_udata == NULL) {
					erec_queue(error(&(yylsp[0]), "primary expression type '%s' lacks typeof serialization", expr_ops((yyvsp[0].expr))->name),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}

				(yyval.expr) = (yyvsp[0].expr);
			}
#line 8958 "parser_bison.c"
    break;

  case 226: /* typeof_expr: typeof_expr "." primary_expr  */
#line 1871 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 8971 "parser_bison.c"
    break;

  case 227: /* set_block_alloc: %empty  */
#line 1883 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 8979 "parser_bison.c"
    break;

  case 228: /* set_block: %empty  */
#line 1888 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 8985 "parser_bison.c"
    break;

  case 231: /* set_block: set_block "type" data_type_expr stmt_separator  */
#line 1892 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8994 "parser_bison.c"
    break;

  case 232: /* set_block: set_block "typeof" typeof_expr stmt_separator  */
#line 1897 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				datatype_set((yyvsp[-3].set)->key, (yyvsp[-1].expr)->dtype);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9004 "parser_bison.c"
    break;

  case 233: /* set_block: set_block "flags" set_flag_list stmt_separator  */
#line 1903 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9013 "parser_bison.c"
    break;

  case 234: /* set_block: set_block "timeout" time_spec stmt_separator  */
#line 1908 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9022 "parser_bison.c"
    break;

  case 235: /* set_block: set_block "gc-interval" time_spec stmt_separator  */
#line 1913 "parser_bison.y"
                        {
				(yyvsp[-3].set)->gc_int = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9031 "parser_bison.c"
    break;

  case 236: /* set_block: set_block stateful_stmt_list stmt_separator  */
#line 1918 "parser_bison.y"
                        {
				list_splice_tail((yyvsp[-1].list), &(yyvsp[-2].set)->stmt_list);
				(yyval.set) = (yyvsp[-2].set);
				free((yyvsp[-1].list));
			}
#line 9041 "parser_bison.c"
    break;

  case 237: /* set_block: set_block "elements" '=' set_block_expr  */
#line 1924 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9050 "parser_bison.c"
    break;

  case 238: /* set_block: set_block "auto-merge"  */
#line 1929 "parser_bison.y"
                        {
				(yyvsp[-1].set)->automerge = true;
				(yyval.set) = (yyvsp[-1].set);
			}
#line 9059 "parser_bison.c"
    break;

  case 240: /* set_block: set_block comment_spec stmt_separator  */
#line 1935 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 9072 "parser_bison.c"
    break;

  case 243: /* set_flag_list: set_flag_list "comma" set_flag  */
#line 1950 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 9080 "parser_bison.c"
    break;

  case 245: /* set_flag: "constant"  */
#line 1956 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_CONSTANT; }
#line 9086 "parser_bison.c"
    break;

  case 246: /* set_flag: "interval"  */
#line 1957 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_INTERVAL; }
#line 9092 "parser_bison.c"
    break;

  case 247: /* set_flag: "timeout"  */
#line 1958 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_TIMEOUT; }
#line 9098 "parser_bison.c"
    break;

  case 248: /* set_flag: "dynamic"  */
#line 1959 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_EVAL; }
#line 9104 "parser_bison.c"
    break;

  case 249: /* map_block_alloc: %empty  */
#line 1963 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 9112 "parser_bison.c"
    break;

  case 250: /* map_block_obj_type: "counter" close_scope_counter  */
#line 1968 "parser_bison.y"
                                                            { (yyval.val) = NFT_OBJECT_COUNTER; }
#line 9118 "parser_bison.c"
    break;

  case 251: /* map_block_obj_type: "quota" close_scope_quota  */
#line 1969 "parser_bison.y"
                                                          { (yyval.val) = NFT_OBJECT_QUOTA; }
#line 9124 "parser_bison.c"
    break;

  case 252: /* map_block_obj_type: "limit" close_scope_limit  */
#line 1970 "parser_bison.y"
                                                          { (yyval.val) = NFT_OBJECT_LIMIT; }
#line 9130 "parser_bison.c"
    break;

  case 253: /* map_block_obj_type: "secmark" close_scope_secmark  */
#line 1971 "parser_bison.y"
                                                            { (yyval.val) = NFT_OBJECT_SECMARK; }
#line 9136 "parser_bison.c"
    break;

  case 254: /* map_block: %empty  */
#line 1974 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 9142 "parser_bison.c"
    break;

  case 257: /* map_block: map_block "timeout" time_spec stmt_separator  */
#line 1978 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9151 "parser_bison.c"
    break;

  case 258: /* map_block: map_block "type" data_type_expr "colon" data_type_expr stmt_separator  */
#line 1985 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 9163 "parser_bison.c"
    break;

  case 259: /* map_block: map_block "type" data_type_expr "colon" "interval" data_type_expr stmt_separator  */
#line 1995 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 9176 "parser_bison.c"
    break;

  case 260: /* map_block: map_block "typeof" typeof_expr "colon" typeof_data_expr stmt_separator  */
#line 2006 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				datatype_set((yyvsp[-5].set)->key, (yyvsp[-3].expr)->dtype);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 9189 "parser_bison.c"
    break;

  case 261: /* map_block: map_block "typeof" typeof_expr "colon" "interval" typeof_expr stmt_separator  */
#line 2017 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				datatype_set((yyvsp[-6].set)->key, (yyvsp[-4].expr)->dtype);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 9203 "parser_bison.c"
    break;

  case 262: /* map_block: map_block "type" data_type_expr "colon" map_block_obj_type stmt_separator  */
#line 2029 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = (yyvsp[-1].val);
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 9214 "parser_bison.c"
    break;

  case 263: /* map_block: map_block "flags" set_flag_list stmt_separator  */
#line 2036 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags |= (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9223 "parser_bison.c"
    break;

  case 264: /* map_block: map_block stateful_stmt_list stmt_separator  */
#line 2041 "parser_bison.y"
                        {
				list_splice_tail((yyvsp[-1].list), &(yyvsp[-2].set)->stmt_list);
				(yyval.set) = (yyvsp[-2].set);
				free((yyvsp[-1].list));
			}
#line 9233 "parser_bison.c"
    break;

  case 265: /* map_block: map_block "elements" '=' set_block_expr  */
#line 2047 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 9242 "parser_bison.c"
    break;

  case 266: /* map_block: map_block comment_spec stmt_separator  */
#line 2052 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 9255 "parser_bison.c"
    break;

  case 268: /* set_mechanism: "policy" set_policy_spec  */
#line 2064 "parser_bison.y"
                        {
				(yyvsp[-2].set)->policy = (yyvsp[0].val);
			}
#line 9263 "parser_bison.c"
    break;

  case 269: /* set_mechanism: "size" "number"  */
#line 2068 "parser_bison.y"
                        {
				(yyvsp[-2].set)->desc.size = (yyvsp[0].val);
			}
#line 9271 "parser_bison.c"
    break;

  case 270: /* set_policy_spec: "performance"  */
#line 2073 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_PERFORMANCE; }
#line 9277 "parser_bison.c"
    break;

  case 271: /* set_policy_spec: "memory"  */
#line 2074 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_MEMORY; }
#line 9283 "parser_bison.c"
    break;

  case 272: /* flowtable_block_alloc: %empty  */
#line 2078 "parser_bison.y"
                        {
				(yyval.flowtable) = flowtable_alloc(NULL);
			}
#line 9291 "parser_bison.c"
    break;

  case 273: /* flowtable_block: %empty  */
#line 2083 "parser_bison.y"
                                                { (yyval.flowtable) = (yyvsp[(-1) - (0)].flowtable); }
#line 9297 "parser_bison.c"
    break;

  case 276: /* flowtable_block: flowtable_block "hook" "string" prio_spec stmt_separator  */
#line 2087 "parser_bison.y"
                        {
				(yyval.flowtable)->hook.loc = (yylsp[-2]);
				(yyval.flowtable)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyval.flowtable)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyval.flowtable)->priority = (yyvsp[-1].prio_spec);
			}
#line 9315 "parser_bison.c"
    break;

  case 277: /* flowtable_block: flowtable_block "devices" '=' flowtable_expr stmt_separator  */
#line 2101 "parser_bison.y"
                        {
				(yyval.flowtable)->dev_expr = (yyvsp[-1].expr);
			}
#line 9323 "parser_bison.c"
    break;

  case 278: /* flowtable_block: flowtable_block "counter" close_scope_counter  */
#line 2105 "parser_bison.y"
                        {
				(yyval.flowtable)->flags |= NFT_FLOWTABLE_COUNTER;
			}
#line 9331 "parser_bison.c"
    break;

  case 279: /* flowtable_block: flowtable_block "flags" "offload" stmt_separator  */
#line 2109 "parser_bison.y"
                        {
				(yyval.flowtable)->flags |= FLOWTABLE_F_HW_OFFLOAD;
			}
#line 9339 "parser_bison.c"
    break;

  case 280: /* flowtable_expr: '{' flowtable_list_expr '}'  */
#line 2115 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 9348 "parser_bison.c"
    break;

  case 281: /* flowtable_expr: variable_expr  */
#line 2120 "parser_bison.y"
                        {
				(yyvsp[0].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9357 "parser_bison.c"
    break;

  case 282: /* flowtable_list_expr: flowtable_expr_member  */
#line 2127 "parser_bison.y"
                        {
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9366 "parser_bison.c"
    break;

  case 283: /* flowtable_list_expr: flowtable_list_expr "comma" flowtable_expr_member  */
#line 2132 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 9375 "parser_bison.c"
    break;

  case 285: /* flowtable_expr_member: "string"  */
#line 2140 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 9386 "parser_bison.c"
    break;

  case 286: /* flowtable_expr_member: variable_expr  */
#line 2147 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9395 "parser_bison.c"
    break;

  case 287: /* data_type_atom_expr: type_identifier  */
#line 2154 "parser_bison.y"
                        {
				const struct datatype *dtype = datatype_lookup_byname((yyvsp[0].string));
				if (dtype == NULL) {
					erec_queue(error(&(yylsp[0]), "unknown datatype %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), dtype, dtype->byteorder,
							 dtype->size, NULL);
				xfree((yyvsp[0].string));
			}
#line 9412 "parser_bison.c"
    break;

  case 288: /* data_type_atom_expr: "time"  */
#line 2167 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), &time_type, time_type.byteorder,
							 time_type.size, NULL);
			}
#line 9421 "parser_bison.c"
    break;

  case 290: /* data_type_expr: data_type_expr "." data_type_atom_expr  */
#line 2175 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 9434 "parser_bison.c"
    break;

  case 291: /* obj_block_alloc: %empty  */
#line 2186 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(NULL);
			}
#line 9442 "parser_bison.c"
    break;

  case 292: /* counter_block: %empty  */
#line 2191 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9448 "parser_bison.c"
    break;

  case 295: /* counter_block: counter_block counter_config  */
#line 2195 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9456 "parser_bison.c"
    break;

  case 296: /* counter_block: counter_block comment_spec  */
#line 2199 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9468 "parser_bison.c"
    break;

  case 297: /* quota_block: %empty  */
#line 2208 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9474 "parser_bison.c"
    break;

  case 300: /* quota_block: quota_block quota_config  */
#line 2212 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9482 "parser_bison.c"
    break;

  case 301: /* quota_block: quota_block comment_spec  */
#line 2216 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9494 "parser_bison.c"
    break;

  case 302: /* ct_helper_block: %empty  */
#line 2225 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9500 "parser_bison.c"
    break;

  case 305: /* ct_helper_block: ct_helper_block ct_helper_config  */
#line 2229 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9508 "parser_bison.c"
    break;

  case 306: /* ct_helper_block: ct_helper_block comment_spec  */
#line 2233 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9520 "parser_bison.c"
    break;

  case 307: /* ct_timeout_block: %empty  */
#line 2243 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[(-1) - (0)].obj);
				init_list_head(&(yyval.obj)->ct_timeout.timeout_list);
				(yyval.obj)->type = NFT_OBJECT_CT_TIMEOUT;
			}
#line 9530 "parser_bison.c"
    break;

  case 310: /* ct_timeout_block: ct_timeout_block ct_timeout_config  */
#line 2251 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9538 "parser_bison.c"
    break;

  case 311: /* ct_timeout_block: ct_timeout_block comment_spec  */
#line 2255 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9550 "parser_bison.c"
    break;

  case 312: /* ct_expect_block: %empty  */
#line 2264 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9556 "parser_bison.c"
    break;

  case 315: /* ct_expect_block: ct_expect_block ct_expect_config  */
#line 2268 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9564 "parser_bison.c"
    break;

  case 316: /* ct_expect_block: ct_expect_block comment_spec  */
#line 2272 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9576 "parser_bison.c"
    break;

  case 317: /* limit_block: %empty  */
#line 2281 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9582 "parser_bison.c"
    break;

  case 320: /* limit_block: limit_block limit_config  */
#line 2285 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9590 "parser_bison.c"
    break;

  case 321: /* limit_block: limit_block comment_spec  */
#line 2289 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9602 "parser_bison.c"
    break;

  case 322: /* secmark_block: %empty  */
#line 2298 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9608 "parser_bison.c"
    break;

  case 325: /* secmark_block: secmark_block secmark_config  */
#line 2302 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9616 "parser_bison.c"
    break;

  case 326: /* secmark_block: secmark_block comment_spec  */
#line 2306 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9628 "parser_bison.c"
    break;

  case 327: /* synproxy_block: %empty  */
#line 2315 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9634 "parser_bison.c"
    break;

  case 330: /* synproxy_block: synproxy_block synproxy_config  */
#line 2319 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9642 "parser_bison.c"
    break;

  case 331: /* synproxy_block: synproxy_block comment_spec  */
#line 2323 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9654 "parser_bison.c"
    break;

  case 332: /* type_identifier: "string"  */
#line 2332 "parser_bison.y"
                                        { (yyval.string) = (yyvsp[0].string); }
#line 9660 "parser_bison.c"
    break;

  case 333: /* type_identifier: "mark"  */
#line 2333 "parser_bison.y"
                                        { (yyval.string) = xstrdup("mark"); }
#line 9666 "parser_bison.c"
    break;

  case 334: /* type_identifier: "dscp"  */
#line 2334 "parser_bison.y"
                                        { (yyval.string) = xstrdup("dscp"); }
#line 9672 "parser_bison.c"
    break;

  case 335: /* type_identifier: "ecn"  */
#line 2335 "parser_bison.y"
                                        { (yyval.string) = xstrdup("ecn"); }
#line 9678 "parser_bison.c"
    break;

  case 336: /* type_identifier: "classid"  */
#line 2336 "parser_bison.y"
                                        { (yyval.string) = xstrdup("classid"); }
#line 9684 "parser_bison.c"
    break;

  case 337: /* hook_spec: "type" "string" "hook" "string" dev_spec prio_spec  */
#line 2340 "parser_bison.y"
                        {
				const char *chain_type = chain_type_name_lookup((yyvsp[-4].string));

				if (chain_type == NULL) {
					erec_queue(error(&(yylsp[-4]), "unknown chain type"),
						   state->msgs);
					xfree((yyvsp[-4].string));
					YYERROR;
				}
				(yyvsp[-6].chain)->type.loc = (yylsp[-4]);
				(yyvsp[-6].chain)->type.str = xstrdup(chain_type);
				xfree((yyvsp[-4].string));

				(yyvsp[-6].chain)->loc = (yyloc);
				(yyvsp[-6].chain)->hook.loc = (yylsp[-2]);
				(yyvsp[-6].chain)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyvsp[-6].chain)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyvsp[-6].chain)->dev_expr	= (yyvsp[-1].expr);
				(yyvsp[-6].chain)->priority	= (yyvsp[0].prio_spec);
				(yyvsp[-6].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 9717 "parser_bison.c"
    break;

  case 338: /* prio_spec: "priority" extended_prio_spec  */
#line 2371 "parser_bison.y"
                        {
				(yyval.prio_spec) = (yyvsp[0].prio_spec);
				(yyval.prio_spec).loc = (yyloc);
			}
#line 9726 "parser_bison.c"
    break;

  case 339: /* extended_prio_name: "out"  */
#line 2378 "parser_bison.y"
                        {
				(yyval.string) = strdup("out");
			}
#line 9734 "parser_bison.c"
    break;

  case 341: /* extended_prio_spec: int_num  */
#line 2385 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &integer_type,
								BYTEORDER_HOST_ENDIAN,
								sizeof(int) *
								BITS_PER_BYTE, &(yyvsp[0].val32));
				(yyval.prio_spec) = spec;
			}
#line 9748 "parser_bison.c"
    break;

  case 342: /* extended_prio_spec: variable_expr  */
#line 2395 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = (yyvsp[0].expr);
				(yyval.prio_spec) = spec;
			}
#line 9759 "parser_bison.c"
    break;

  case 343: /* extended_prio_spec: extended_prio_name  */
#line 2402 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen((yyvsp[0].string)) * BITS_PER_BYTE,
								(yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.prio_spec) = spec;
			}
#line 9774 "parser_bison.c"
    break;

  case 344: /* extended_prio_spec: extended_prio_name "+" "number"  */
#line 2413 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				char str[NFT_NAME_MAXLEN];
				snprintf(str, sizeof(str), "%s + %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9791 "parser_bison.c"
    break;

  case 345: /* extended_prio_spec: extended_prio_name "-" "number"  */
#line 2426 "parser_bison.y"
                        {
				struct prio_spec spec = {0};
				char str[NFT_NAME_MAXLEN];

				snprintf(str, sizeof(str), "%s - %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9808 "parser_bison.c"
    break;

  case 346: /* int_num: "number"  */
#line 2440 "parser_bison.y"
                                                        { (yyval.val32) = (yyvsp[0].val); }
#line 9814 "parser_bison.c"
    break;

  case 347: /* int_num: "-" "number"  */
#line 2441 "parser_bison.y"
                                                        { (yyval.val32) = -(yyvsp[0].val); }
#line 9820 "parser_bison.c"
    break;

  case 348: /* dev_spec: "device" string  */
#line 2445 "parser_bison.y"
                        {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &string_type,
							   BYTEORDER_HOST_ENDIAN,
							   strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), expr);

			}
#line 9836 "parser_bison.c"
    break;

  case 349: /* dev_spec: "device" variable_expr  */
#line 2457 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9846 "parser_bison.c"
    break;

  case 350: /* dev_spec: "devices" '=' flowtable_expr  */
#line 2463 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9854 "parser_bison.c"
    break;

  case 351: /* dev_spec: %empty  */
#line 2466 "parser_bison.y"
                                                        { (yyval.expr) = NULL; }
#line 9860 "parser_bison.c"
    break;

  case 352: /* flags_spec: "flags" "offload"  */
#line 2470 "parser_bison.y"
                        {
				(yyvsp[-2].chain)->flags |= CHAIN_F_HW_OFFLOAD;
			}
#line 9868 "parser_bison.c"
    break;

  case 353: /* policy_spec: "policy" policy_expr  */
#line 2476 "parser_bison.y"
                        {
				if ((yyvsp[-2].chain)->policy) {
					erec_queue(error(&(yyloc), "you cannot set chain policy twice"),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}
				(yyvsp[-2].chain)->policy		= (yyvsp[0].expr);
				(yyvsp[-2].chain)->policy->location	= (yyloc);
			}
#line 9883 "parser_bison.c"
    break;

  case 354: /* policy_expr: variable_expr  */
#line 2489 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &policy_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9892 "parser_bison.c"
    break;

  case 355: /* policy_expr: chain_policy  */
#line 2494 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(int) *
							 BITS_PER_BYTE, &(yyvsp[0].val32));
			}
#line 9903 "parser_bison.c"
    break;

  case 356: /* chain_policy: "accept"  */
#line 2502 "parser_bison.y"
                                                { (yyval.val32) = NF_ACCEPT; }
#line 9909 "parser_bison.c"
    break;

  case 357: /* chain_policy: "drop"  */
#line 2503 "parser_bison.y"
                                                { (yyval.val32) = NF_DROP;   }
#line 9915 "parser_bison.c"
    break;

  case 362: /* time_spec: "string"  */
#line 2515 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t res;

				erec = time_parse(&(yylsp[0]), (yyvsp[0].string), &res);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = res;
			}
#line 9932 "parser_bison.c"
    break;

  case 363: /* family_spec: %empty  */
#line 2529 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV4; }
#line 9938 "parser_bison.c"
    break;

  case 365: /* family_spec_explicit: "ip" close_scope_ip  */
#line 2533 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV4; }
#line 9944 "parser_bison.c"
    break;

  case 366: /* family_spec_explicit: "ip6" close_scope_ip6  */
#line 2534 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV6; }
#line 9950 "parser_bison.c"
    break;

  case 367: /* family_spec_explicit: "inet"  */
#line 2535 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_INET; }
#line 9956 "parser_bison.c"
    break;

  case 368: /* family_spec_explicit: "arp" close_scope_arp  */
#line 2536 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_ARP; }
#line 9962 "parser_bison.c"
    break;

  case 369: /* family_spec_explicit: "bridge"  */
#line 2537 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_BRIDGE; }
#line 9968 "parser_bison.c"
    break;

  case 370: /* family_spec_explicit: "netdev"  */
#line 2538 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_NETDEV; }
#line 9974 "parser_bison.c"
    break;

  case 371: /* table_spec: family_spec identifier  */
#line 2542 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[-1].val);
				(yyval.handle).table.location = (yylsp[0]);
				(yyval.handle).table.name	= (yyvsp[0].string);
			}
#line 9985 "parser_bison.c"
    break;

  case 372: /* tableid_spec: family_spec "handle" "number"  */
#line 2551 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family 		= (yyvsp[-2].val);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
				(yyval.handle).handle.location	= (yylsp[0]);
			}
#line 9996 "parser_bison.c"
    break;

  case 373: /* chain_spec: table_spec identifier  */
#line 2560 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).chain.name	= (yyvsp[0].string);
				(yyval.handle).chain.location = (yylsp[0]);
			}
#line 10006 "parser_bison.c"
    break;

  case 374: /* chainid_spec: table_spec "handle" "number"  */
#line 2568 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 10016 "parser_bison.c"
    break;

  case 375: /* chain_identifier: identifier  */
#line 2576 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).chain.name		= (yyvsp[0].string);
				(yyval.handle).chain.location	= (yylsp[0]);
			}
#line 10026 "parser_bison.c"
    break;

  case 376: /* set_spec: table_spec identifier  */
#line 2584 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 10036 "parser_bison.c"
    break;

  case 377: /* setid_spec: table_spec "handle" "number"  */
#line 2592 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 10046 "parser_bison.c"
    break;

  case 378: /* set_identifier: identifier  */
#line 2600 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 10056 "parser_bison.c"
    break;

  case 379: /* flowtable_spec: table_spec identifier  */
#line 2608 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-1].handle);
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 10066 "parser_bison.c"
    break;

  case 380: /* flowtableid_spec: table_spec "handle" "number"  */
#line 2616 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 10076 "parser_bison.c"
    break;

  case 381: /* flowtable_identifier: identifier  */
#line 2624 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 10086 "parser_bison.c"
    break;

  case 382: /* obj_spec: table_spec identifier  */
#line 2632 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).obj.name	= (yyvsp[0].string);
				(yyval.handle).obj.location	= (yylsp[0]);
			}
#line 10096 "parser_bison.c"
    break;

  case 383: /* objid_spec: table_spec "handle" "number"  */
#line 2640 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 10106 "parser_bison.c"
    break;

  case 384: /* obj_identifier: identifier  */
#line 2648 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).obj.name		= (yyvsp[0].string);
				(yyval.handle).obj.location		= (yylsp[0]);
			}
#line 10116 "parser_bison.c"
    break;

  case 385: /* handle_spec: "handle" "number"  */
#line 2656 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 10126 "parser_bison.c"
    break;

  case 386: /* position_spec: "position" "number"  */
#line 2664 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).position.location	= (yyloc);
				(yyval.handle).position.id		= (yyvsp[0].val);
			}
#line 10136 "parser_bison.c"
    break;

  case 387: /* index_spec: "index" "number"  */
#line 2672 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).index.location	= (yyloc);
				(yyval.handle).index.id		= (yyvsp[0].val) + 1;
			}
#line 10146 "parser_bison.c"
    break;

  case 388: /* rule_position: chain_spec  */
#line 2680 "parser_bison.y"
                        {
				(yyval.handle) = (yyvsp[0].handle);
			}
#line 10154 "parser_bison.c"
    break;

  case 389: /* rule_position: chain_spec position_spec  */
#line 2684 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 10163 "parser_bison.c"
    break;

  case 390: /* rule_position: chain_spec handle_spec  */
#line 2689 "parser_bison.y"
                        {
				(yyvsp[0].handle).position.location = (yyvsp[0].handle).handle.location;
				(yyvsp[0].handle).position.id = (yyvsp[0].handle).handle.id;
				(yyvsp[0].handle).handle.id = 0;
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 10175 "parser_bison.c"
    break;

  case 391: /* rule_position: chain_spec index_spec  */
#line 2697 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 10184 "parser_bison.c"
    break;

  case 392: /* ruleid_spec: chain_spec handle_spec  */
#line 2704 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 10193 "parser_bison.c"
    break;

  case 393: /* comment_spec: "comment" string  */
#line 2711 "parser_bison.y"
                        {
				if (strlen((yyvsp[0].string)) > NFTNL_UDATA_COMMENT_MAXLEN) {
					erec_queue(error(&(yylsp[0]), "comment too long, %d characters maximum allowed",
							 NFTNL_UDATA_COMMENT_MAXLEN),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyval.string) = (yyvsp[0].string);
			}
#line 10208 "parser_bison.c"
    break;

  case 394: /* ruleset_spec: %empty  */
#line 2724 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= NFPROTO_UNSPEC;
			}
#line 10217 "parser_bison.c"
    break;

  case 395: /* ruleset_spec: family_spec_explicit  */
#line 2729 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[0].val);
			}
#line 10226 "parser_bison.c"
    break;

  case 396: /* rule: rule_alloc  */
#line 2736 "parser_bison.y"
                        {
				(yyval.rule)->comment = NULL;
			}
#line 10234 "parser_bison.c"
    break;

  case 397: /* rule: rule_alloc comment_spec  */
#line 2740 "parser_bison.y"
                        {
				(yyval.rule)->comment = (yyvsp[0].string);
			}
#line 10242 "parser_bison.c"
    break;

  case 398: /* rule_alloc: stmt_list  */
#line 2746 "parser_bison.y"
                        {
				struct stmt *i;

				(yyval.rule) = rule_alloc(&(yyloc), NULL);
				list_for_each_entry(i, (yyvsp[0].list), list)
					(yyval.rule)->num_stmts++;
				list_splice_tail((yyvsp[0].list), &(yyval.rule)->stmts);
				xfree((yyvsp[0].list));
			}
#line 10256 "parser_bison.c"
    break;

  case 399: /* stmt_list: stmt  */
#line 2758 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 10266 "parser_bison.c"
    break;

  case 400: /* stmt_list: stmt_list stmt  */
#line 2764 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 10275 "parser_bison.c"
    break;

  case 401: /* stateful_stmt_list: stateful_stmt  */
#line 2771 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 10285 "parser_bison.c"
    break;

  case 402: /* stateful_stmt_list: stateful_stmt_list stateful_stmt  */
#line 2777 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 10294 "parser_bison.c"
    break;

  case 427: /* chain_stmt_type: "jump"  */
#line 2811 "parser_bison.y"
                                        { (yyval.val) = NFT_JUMP; }
#line 10300 "parser_bison.c"
    break;

  case 428: /* chain_stmt_type: "goto"  */
#line 2812 "parser_bison.y"
                                        { (yyval.val) = NFT_GOTO; }
#line 10306 "parser_bison.c"
    break;

  case 429: /* chain_stmt: chain_stmt_type chain_block_alloc '{' subchain_block '}'  */
#line 2816 "parser_bison.y"
                        {
				(yyvsp[-3].chain)->location = (yylsp[-3]);
				close_scope(state);
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				(yyval.stmt) = chain_stmt_alloc(&(yyloc), (yyvsp[-1].chain), (yyvsp[-4].val));
			}
#line 10317 "parser_bison.c"
    break;

  case 430: /* verdict_stmt: verdict_expr  */
#line 2825 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 10325 "parser_bison.c"
    break;

  case 431: /* verdict_stmt: verdict_map_stmt  */
#line 2829 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 10333 "parser_bison.c"
    break;

  case 432: /* verdict_map_stmt: concat_expr "vmap" verdict_map_expr  */
#line 2835 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10341 "parser_bison.c"
    break;

  case 433: /* verdict_map_expr: '{' verdict_map_list_expr '}'  */
#line 2841 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 10350 "parser_bison.c"
    break;

  case 435: /* verdict_map_list_expr: verdict_map_list_member_expr  */
#line 2849 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 10359 "parser_bison.c"
    break;

  case 436: /* verdict_map_list_expr: verdict_map_list_expr "comma" verdict_map_list_member_expr  */
#line 2854 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 10368 "parser_bison.c"
    break;

  case 438: /* verdict_map_list_member_expr: opt_newline set_elem_expr "colon" verdict_expr opt_newline  */
#line 2862 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 10376 "parser_bison.c"
    break;

  case 439: /* connlimit_stmt: "ct" "count" "number" close_scope_ct  */
#line 2868 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count	= (yyvsp[-1].val);
			}
#line 10385 "parser_bison.c"
    break;

  case 440: /* connlimit_stmt: "ct" "count" "over" "number" close_scope_ct  */
#line 2873 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count = (yyvsp[-1].val);
				(yyval.stmt)->connlimit.flags = NFT_CONNLIMIT_F_INV;
			}
#line 10395 "parser_bison.c"
    break;

  case 443: /* counter_stmt_alloc: "counter"  */
#line 2884 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 10403 "parser_bison.c"
    break;

  case 444: /* counter_stmt_alloc: "counter" "name" stmt_expr  */
#line 2888 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_COUNTER;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10413 "parser_bison.c"
    break;

  case 445: /* counter_args: counter_arg  */
#line 2896 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10421 "parser_bison.c"
    break;

  case 447: /* counter_arg: "packets" "number"  */
#line 2903 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.packets = (yyvsp[0].val);
			}
#line 10429 "parser_bison.c"
    break;

  case 448: /* counter_arg: "bytes" "number"  */
#line 2907 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.bytes	 = (yyvsp[0].val);
			}
#line 10437 "parser_bison.c"
    break;

  case 451: /* log_stmt_alloc: "log"  */
#line 2917 "parser_bison.y"
                        {
				(yyval.stmt) = log_stmt_alloc(&(yyloc));
			}
#line 10445 "parser_bison.c"
    break;

  case 452: /* log_args: log_arg  */
#line 2923 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10453 "parser_bison.c"
    break;

  case 454: /* log_arg: "prefix" string  */
#line 2930 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				bool done = false, another_var = false;
				char *start, *end, scratch = '\0';
				struct expr *expr, *item;
				struct symbol *sym;
				enum {
					PARSE_TEXT,
					PARSE_VAR,
				} prefix_state;

				/* No variables in log prefix, skip. */
				if (!strchr((yyvsp[0].string), '$')) {
					expr = constant_expr_alloc(&(yyloc), &string_type,
								   BYTEORDER_HOST_ENDIAN,
								   (strlen((yyvsp[0].string)) + 1) * BITS_PER_BYTE, (yyvsp[0].string));
					xfree((yyvsp[0].string));
					(yyvsp[-2].stmt)->log.prefix = expr;
					(yyvsp[-2].stmt)->log.flags |= STMT_LOG_PREFIX;
					break;
				}

				/* Parse variables in log prefix string using a
				 * state machine parser with two states. This
				 * parser creates list of expressions composed
				 * of constant and variable expressions.
				 */
				expr = compound_expr_alloc(&(yyloc), EXPR_LIST);

				start = (char *)(yyvsp[0].string);

				if (*start != '$') {
					prefix_state = PARSE_TEXT;
				} else {
					prefix_state = PARSE_VAR;
					start++;
				}
				end = start;

				/* Not nice, but works. */
				while (!done) {
					switch (prefix_state) {
					case PARSE_TEXT:
						while (*end != '\0' && *end != '$')
							end++;

						if (*end == '\0')
							done = true;

						*end = '\0';
						item = constant_expr_alloc(&(yyloc), &string_type,
									   BYTEORDER_HOST_ENDIAN,
									   (strlen(start) + 1) * BITS_PER_BYTE,
									   start);
						compound_expr_add(expr, item);

						if (done)
							break;

						start = end + 1;
						end = start;

						/* fall through */
					case PARSE_VAR:
						while (isalnum(*end) || *end == '_')
							end++;

						if (*end == '\0')
							done = true;
						else if (*end == '$')
							another_var = true;
						else
							scratch = *end;

						*end = '\0';

						sym = symbol_get(scope, start);
						if (!sym) {
							sym = symbol_lookup_fuzzy(scope, start);
							if (sym) {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
										 "did you mean identifier ‘%s’?",
										 start, sym->identifier),
									   state->msgs);
							} else {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'",
										 start),
									   state->msgs);
							}
							expr_free(expr);
							xfree((yyvsp[0].string));
							YYERROR;
						}
						item = variable_expr_alloc(&(yyloc), scope, sym);
						compound_expr_add(expr, item);

						if (done)
							break;

						/* Restore original byte after
						 * symbol lookup.
						 */
						if (scratch) {
							*end = scratch;
							scratch = '\0';
						}

						start = end;
						if (another_var) {
							another_var = false;
							start++;
							prefix_state = PARSE_VAR;
						} else {
							prefix_state = PARSE_TEXT;
						}
						end = start;
						break;
					}
				}

				xfree((yyvsp[0].string));
				(yyvsp[-2].stmt)->log.prefix	 = expr;
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_PREFIX;
			}
#line 10582 "parser_bison.c"
    break;

  case 455: /* log_arg: "group" "number"  */
#line 3055 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.group	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_GROUP;
			}
#line 10591 "parser_bison.c"
    break;

  case 456: /* log_arg: "snaplen" "number"  */
#line 3060 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.snaplen	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_SNAPLEN;
			}
#line 10600 "parser_bison.c"
    break;

  case 457: /* log_arg: "queue-threshold" "number"  */
#line 3065 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.qthreshold = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_QTHRESHOLD;
			}
#line 10609 "parser_bison.c"
    break;

  case 458: /* log_arg: "level" level_type  */
#line 3070 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.level	= (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_LEVEL;
			}
#line 10618 "parser_bison.c"
    break;

  case 459: /* log_arg: "flags" log_flags  */
#line 3075 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.logflags	|= (yyvsp[0].val);
			}
#line 10626 "parser_bison.c"
    break;

  case 460: /* level_type: string  */
#line 3081 "parser_bison.y"
                        {
				if (!strcmp("emerg", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_EMERG;
				else if (!strcmp("alert", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ALERT;
				else if (!strcmp("crit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_CRIT;
				else if (!strcmp("err", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ERR;
				else if (!strcmp("warn", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_WARNING;
				else if (!strcmp("notice", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_NOTICE;
				else if (!strcmp("info", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_INFO;
				else if (!strcmp("debug", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_DEBUG;
				else if (!strcmp("audit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_AUDIT;
				else {
					erec_queue(error(&(yylsp[0]), "invalid log level"),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 10658 "parser_bison.c"
    break;

  case 461: /* log_flags: "tcp" log_flags_tcp  */
#line 3111 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[0].val);
			}
#line 10666 "parser_bison.c"
    break;

  case 462: /* log_flags: "ip" "options" close_scope_ip  */
#line 3115 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_IPOPT;
			}
#line 10674 "parser_bison.c"
    break;

  case 463: /* log_flags: "skuid"  */
#line 3119 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_UID;
			}
#line 10682 "parser_bison.c"
    break;

  case 464: /* log_flags: "ether" close_scope_eth  */
#line 3123 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MACDECODE;
			}
#line 10690 "parser_bison.c"
    break;

  case 465: /* log_flags: "all"  */
#line 3127 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MASK;
			}
#line 10698 "parser_bison.c"
    break;

  case 466: /* log_flags_tcp: log_flags_tcp "comma" log_flag_tcp  */
#line 3133 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 10706 "parser_bison.c"
    break;

  case 468: /* log_flag_tcp: "seq"  */
#line 3140 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPSEQ;
			}
#line 10714 "parser_bison.c"
    break;

  case 469: /* log_flag_tcp: "options"  */
#line 3144 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPOPT;
			}
#line 10722 "parser_bison.c"
    break;

  case 470: /* limit_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts close_scope_limit  */
#line 3150 "parser_bison.y"
                        {
				if ((yyvsp[-1].val) == 0) {
					erec_queue(error(&(yylsp[-1]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= (yyvsp[-4].val);
				(yyval.stmt)->limit.unit	= (yyvsp[-2].val);
				(yyval.stmt)->limit.burst	= (yyvsp[-1].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-5].val);
			}
#line 10740 "parser_bison.c"
    break;

  case 471: /* limit_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes close_scope_limit  */
#line 3164 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[-1].val) == 0) {
					erec_queue(error(&(yylsp[-1]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}

				erec = rate_parse(&(yyloc), (yyvsp[-2].string), &rate, &unit);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= rate * (yyvsp[-3].val);
				(yyval.stmt)->limit.unit	= unit;
				(yyval.stmt)->limit.burst	= (yyvsp[-1].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 10769 "parser_bison.c"
    break;

  case 472: /* limit_stmt: "limit" "name" stmt_expr close_scope_limit  */
#line 3189 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_LIMIT;
				(yyval.stmt)->objref.expr = (yyvsp[-1].expr);
			}
#line 10779 "parser_bison.c"
    break;

  case 473: /* quota_mode: "over"  */
#line 3196 "parser_bison.y"
                                                { (yyval.val) = NFT_QUOTA_F_INV; }
#line 10785 "parser_bison.c"
    break;

  case 474: /* quota_mode: "until"  */
#line 3197 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10791 "parser_bison.c"
    break;

  case 475: /* quota_mode: %empty  */
#line 3198 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10797 "parser_bison.c"
    break;

  case 476: /* quota_unit: "bytes"  */
#line 3201 "parser_bison.y"
                                                { (yyval.string) = xstrdup("bytes"); }
#line 10803 "parser_bison.c"
    break;

  case 477: /* quota_unit: "string"  */
#line 3202 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 10809 "parser_bison.c"
    break;

  case 478: /* quota_used: %empty  */
#line 3205 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10815 "parser_bison.c"
    break;

  case 479: /* quota_used: "used" "number" quota_unit  */
#line 3207 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10832 "parser_bison.c"
    break;

  case 480: /* quota_stmt: "quota" quota_mode "number" quota_unit quota_used close_scope_quota  */
#line 3222 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-2].string), &rate);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.stmt) = quota_stmt_alloc(&(yyloc));
				(yyval.stmt)->quota.bytes	= (yyvsp[-3].val) * rate;
				(yyval.stmt)->quota.used = (yyvsp[-1].val);
				(yyval.stmt)->quota.flags	= (yyvsp[-4].val);
			}
#line 10852 "parser_bison.c"
    break;

  case 481: /* quota_stmt: "quota" "name" stmt_expr close_scope_quota  */
#line 3238 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_QUOTA;
				(yyval.stmt)->objref.expr = (yyvsp[-1].expr);
			}
#line 10862 "parser_bison.c"
    break;

  case 482: /* limit_mode: "over"  */
#line 3245 "parser_bison.y"
                                                                { (yyval.val) = NFT_LIMIT_F_INV; }
#line 10868 "parser_bison.c"
    break;

  case 483: /* limit_mode: "until"  */
#line 3246 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10874 "parser_bison.c"
    break;

  case 484: /* limit_mode: %empty  */
#line 3247 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10880 "parser_bison.c"
    break;

  case 485: /* limit_burst_pkts: %empty  */
#line 3250 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10886 "parser_bison.c"
    break;

  case 486: /* limit_burst_pkts: "burst" "number" "packets"  */
#line 3251 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10892 "parser_bison.c"
    break;

  case 487: /* limit_burst_bytes: %empty  */
#line 3254 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10898 "parser_bison.c"
    break;

  case 488: /* limit_burst_bytes: "burst" "number" "bytes"  */
#line 3255 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10904 "parser_bison.c"
    break;

  case 489: /* limit_burst_bytes: "burst" "number" "string"  */
#line 3257 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10921 "parser_bison.c"
    break;

  case 490: /* time_unit: "second"  */
#line 3271 "parser_bison.y"
                                                { (yyval.val) = 1ULL; }
#line 10927 "parser_bison.c"
    break;

  case 491: /* time_unit: "minute"  */
#line 3272 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60; }
#line 10933 "parser_bison.c"
    break;

  case 492: /* time_unit: "hour"  */
#line 3273 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60; }
#line 10939 "parser_bison.c"
    break;

  case 493: /* time_unit: "day"  */
#line 3274 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24; }
#line 10945 "parser_bison.c"
    break;

  case 494: /* time_unit: "week"  */
#line 3275 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24 * 7; }
#line 10951 "parser_bison.c"
    break;

  case 496: /* reject_stmt_alloc: "reject"  */
#line 3282 "parser_bison.y"
                        {
				(yyval.stmt) = reject_stmt_alloc(&(yyloc));
			}
#line 10959 "parser_bison.c"
    break;

  case 497: /* reject_with_expr: "string"  */
#line 3288 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state), (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 10969 "parser_bison.c"
    break;

  case 498: /* reject_with_expr: integer_expr  */
#line 3293 "parser_bison.y"
                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10975 "parser_bison.c"
    break;

  case 499: /* reject_opts: %empty  */
#line 3297 "parser_bison.y"
                        {
				(yyvsp[0].stmt)->reject.type = -1;
				(yyvsp[0].stmt)->reject.icmp_code = -1;
			}
#line 10984 "parser_bison.c"
    break;

  case 500: /* reject_opts: "with" "icmp" "type" reject_with_expr  */
#line 3302 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV4;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmp_code_type);
			}
#line 10995 "parser_bison.c"
    break;

  case 501: /* reject_opts: "with" "icmp" reject_with_expr  */
#line 3309 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.family = NFPROTO_IPV4;
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-3].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-3].stmt)->reject.expr, &icmp_code_type);
			}
#line 11006 "parser_bison.c"
    break;

  case 502: /* reject_opts: "with" "icmpv6" "type" reject_with_expr  */
#line 3316 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV6;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpv6_code_type);
			}
#line 11017 "parser_bison.c"
    break;

  case 503: /* reject_opts: "with" "icmpv6" reject_with_expr  */
#line 3323 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.family = NFPROTO_IPV6;
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-3].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-3].stmt)->reject.expr, &icmpv6_code_type);
			}
#line 11028 "parser_bison.c"
    break;

  case 504: /* reject_opts: "with" "icmpx" "type" reject_with_expr  */
#line 3330 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMPX_UNREACH;
				(yyvsp[-4].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpx_code_type);
			}
#line 11038 "parser_bison.c"
    break;

  case 505: /* reject_opts: "with" "icmpx" reject_with_expr  */
#line 3336 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_ICMPX_UNREACH;
				(yyvsp[-3].stmt)->reject.expr = (yyvsp[0].expr);
				datatype_set((yyvsp[-3].stmt)->reject.expr, &icmpx_code_type);
			}
#line 11048 "parser_bison.c"
    break;

  case 506: /* reject_opts: "with" "tcp" "reset"  */
#line 3342 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_TCP_RST;
			}
#line 11056 "parser_bison.c"
    break;

  case 508: /* nat_stmt_alloc: "snat"  */
#line 3350 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_SNAT); }
#line 11062 "parser_bison.c"
    break;

  case 509: /* nat_stmt_alloc: "dnat"  */
#line 3351 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_DNAT); }
#line 11068 "parser_bison.c"
    break;

  case 510: /* tproxy_stmt: "tproxy" "to" stmt_expr  */
#line 3355 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 11078 "parser_bison.c"
    break;

  case 511: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr  */
#line 3361 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-2].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 11088 "parser_bison.c"
    break;

  case 512: /* tproxy_stmt: "tproxy" "to" "colon" stmt_expr  */
#line 3367 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 11098 "parser_bison.c"
    break;

  case 513: /* tproxy_stmt: "tproxy" "to" stmt_expr "colon" stmt_expr  */
#line 3373 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 11109 "parser_bison.c"
    break;

  case 514: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3380 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-4].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 11120 "parser_bison.c"
    break;

  case 515: /* tproxy_stmt: "tproxy" nf_key_proto "to" "colon" stmt_expr  */
#line 3387 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-3].val);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 11130 "parser_bison.c"
    break;

  case 518: /* synproxy_stmt_alloc: "synproxy"  */
#line 3399 "parser_bison.y"
                        {
				(yyval.stmt) = synproxy_stmt_alloc(&(yyloc));
			}
#line 11138 "parser_bison.c"
    break;

  case 519: /* synproxy_stmt_alloc: "synproxy" "name" stmt_expr  */
#line 3403 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_SYNPROXY;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 11148 "parser_bison.c"
    break;

  case 520: /* synproxy_args: synproxy_arg  */
#line 3411 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11156 "parser_bison.c"
    break;

  case 522: /* synproxy_arg: "mss" "number"  */
#line 3418 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.mss = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_MSS;
			}
#line 11165 "parser_bison.c"
    break;

  case 523: /* synproxy_arg: "wscale" "number"  */
#line 3423 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.wscale = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_WSCALE;
			}
#line 11174 "parser_bison.c"
    break;

  case 524: /* synproxy_arg: "timestamp"  */
#line 3428 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 11182 "parser_bison.c"
    break;

  case 525: /* synproxy_arg: "sack-permitted"  */
#line 3432 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 11190 "parser_bison.c"
    break;

  case 526: /* synproxy_config: "mss" "number" "wscale" "number" synproxy_ts synproxy_sack  */
#line 3438 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-6].obj)->synproxy;
				synproxy->mss = (yyvsp[-4].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-2].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 11210 "parser_bison.c"
    break;

  case 527: /* synproxy_config: "mss" "number" stmt_separator "wscale" "number" stmt_separator synproxy_ts synproxy_sack  */
#line 3454 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-8].obj)->synproxy;
				synproxy->mss = (yyvsp[-6].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-3].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 11230 "parser_bison.c"
    break;

  case 528: /* synproxy_obj: %empty  */
#line 3472 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SYNPROXY;
			}
#line 11239 "parser_bison.c"
    break;

  case 529: /* synproxy_ts: %empty  */
#line 3478 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 11245 "parser_bison.c"
    break;

  case 530: /* synproxy_ts: "timestamp"  */
#line 3480 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 11253 "parser_bison.c"
    break;

  case 531: /* synproxy_sack: %empty  */
#line 3485 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 11259 "parser_bison.c"
    break;

  case 532: /* synproxy_sack: "sack-permitted"  */
#line 3487 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 11267 "parser_bison.c"
    break;

  case 533: /* primary_stmt_expr: symbol_expr  */
#line 3492 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11273 "parser_bison.c"
    break;

  case 534: /* primary_stmt_expr: integer_expr  */
#line 3493 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11279 "parser_bison.c"
    break;

  case 535: /* primary_stmt_expr: boolean_expr  */
#line 3494 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11285 "parser_bison.c"
    break;

  case 536: /* primary_stmt_expr: meta_expr  */
#line 3495 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11291 "parser_bison.c"
    break;

  case 537: /* primary_stmt_expr: rt_expr  */
#line 3496 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11297 "parser_bison.c"
    break;

  case 538: /* primary_stmt_expr: ct_expr  */
#line 3497 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11303 "parser_bison.c"
    break;

  case 539: /* primary_stmt_expr: numgen_expr  */
#line 3498 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11309 "parser_bison.c"
    break;

  case 540: /* primary_stmt_expr: hash_expr  */
#line 3499 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11315 "parser_bison.c"
    break;

  case 541: /* primary_stmt_expr: payload_expr  */
#line 3500 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11321 "parser_bison.c"
    break;

  case 542: /* primary_stmt_expr: keyword_expr  */
#line 3501 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11327 "parser_bison.c"
    break;

  case 543: /* primary_stmt_expr: socket_expr  */
#line 3502 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11333 "parser_bison.c"
    break;

  case 544: /* primary_stmt_expr: osf_expr  */
#line 3503 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11339 "parser_bison.c"
    break;

  case 545: /* primary_stmt_expr: '(' basic_stmt_expr ')'  */
#line 3504 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 11345 "parser_bison.c"
    break;

  case 547: /* shift_stmt_expr: shift_stmt_expr "<<" primary_stmt_expr  */
#line 3509 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11353 "parser_bison.c"
    break;

  case 548: /* shift_stmt_expr: shift_stmt_expr ">>" primary_stmt_expr  */
#line 3513 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11361 "parser_bison.c"
    break;

  case 550: /* and_stmt_expr: and_stmt_expr "&" shift_stmt_expr  */
#line 3520 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11369 "parser_bison.c"
    break;

  case 552: /* exclusive_or_stmt_expr: exclusive_or_stmt_expr "^" and_stmt_expr  */
#line 3527 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11377 "parser_bison.c"
    break;

  case 554: /* inclusive_or_stmt_expr: inclusive_or_stmt_expr '|' exclusive_or_stmt_expr  */
#line 3534 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11385 "parser_bison.c"
    break;

  case 557: /* concat_stmt_expr: concat_stmt_expr "." primary_stmt_expr  */
#line 3544 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 11398 "parser_bison.c"
    break;

  case 560: /* map_stmt_expr: concat_stmt_expr "map" map_stmt_expr_set  */
#line 3559 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11406 "parser_bison.c"
    break;

  case 561: /* map_stmt_expr: concat_stmt_expr  */
#line 3562 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 11412 "parser_bison.c"
    break;

  case 562: /* prefix_stmt_expr: basic_stmt_expr "/" "number"  */
#line 3566 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 11420 "parser_bison.c"
    break;

  case 563: /* range_stmt_expr: basic_stmt_expr "-" basic_stmt_expr  */
#line 3572 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11428 "parser_bison.c"
    break;

  case 569: /* nat_stmt_args: stmt_expr  */
#line 3587 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11436 "parser_bison.c"
    break;

  case 570: /* nat_stmt_args: "to" stmt_expr  */
#line 3591 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11444 "parser_bison.c"
    break;

  case 571: /* nat_stmt_args: nf_key_proto "to" stmt_expr  */
#line 3595 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.family = (yyvsp[-2].val);
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11453 "parser_bison.c"
    break;

  case 572: /* nat_stmt_args: stmt_expr "colon" stmt_expr  */
#line 3600 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11462 "parser_bison.c"
    break;

  case 573: /* nat_stmt_args: "to" stmt_expr "colon" stmt_expr  */
#line 3605 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11471 "parser_bison.c"
    break;

  case 574: /* nat_stmt_args: nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3610 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->nat.family = (yyvsp[-4].val);
				(yyvsp[-5].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11481 "parser_bison.c"
    break;

  case 575: /* nat_stmt_args: "colon" stmt_expr  */
#line 3616 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11489 "parser_bison.c"
    break;

  case 576: /* nat_stmt_args: "to" "colon" stmt_expr  */
#line 3620 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11497 "parser_bison.c"
    break;

  case 577: /* nat_stmt_args: nat_stmt_args nf_nat_flags  */
#line 3624 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11505 "parser_bison.c"
    break;

  case 578: /* nat_stmt_args: nf_key_proto "addr" "." "port" "to" stmt_expr  */
#line 3628 "parser_bison.y"
                        {
				(yyvsp[-6].stmt)->nat.family = (yyvsp[-5].val);
				(yyvsp[-6].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-6].stmt)->nat.type_flags = STMT_NAT_F_CONCAT;
			}
#line 11515 "parser_bison.c"
    break;

  case 579: /* nat_stmt_args: nf_key_proto "interval" "to" stmt_expr  */
#line 3634 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11524 "parser_bison.c"
    break;

  case 580: /* nat_stmt_args: "interval" "to" stmt_expr  */
#line 3639 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 11532 "parser_bison.c"
    break;

  case 581: /* nat_stmt_args: nf_key_proto "prefix" "to" stmt_expr  */
#line 3643 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-4].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX;
				(yyvsp[-4].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11544 "parser_bison.c"
    break;

  case 582: /* nat_stmt_args: "prefix" "to" stmt_expr  */
#line 3651 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-3].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX;
				(yyvsp[-3].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11555 "parser_bison.c"
    break;

  case 585: /* masq_stmt_alloc: "masquerade"  */
#line 3663 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_MASQ); }
#line 11561 "parser_bison.c"
    break;

  case 586: /* masq_stmt_args: "to" "colon" stmt_expr  */
#line 3667 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11569 "parser_bison.c"
    break;

  case 587: /* masq_stmt_args: "to" "colon" stmt_expr nf_nat_flags  */
#line 3671 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11578 "parser_bison.c"
    break;

  case 588: /* masq_stmt_args: nf_nat_flags  */
#line 3676 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11586 "parser_bison.c"
    break;

  case 591: /* redir_stmt_alloc: "redirect"  */
#line 3685 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_REDIR); }
#line 11592 "parser_bison.c"
    break;

  case 592: /* redir_stmt_arg: "to" stmt_expr  */
#line 3689 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11600 "parser_bison.c"
    break;

  case 593: /* redir_stmt_arg: "to" "colon" stmt_expr  */
#line 3693 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11608 "parser_bison.c"
    break;

  case 594: /* redir_stmt_arg: nf_nat_flags  */
#line 3697 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11616 "parser_bison.c"
    break;

  case 595: /* redir_stmt_arg: "to" stmt_expr nf_nat_flags  */
#line 3701 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-3].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11625 "parser_bison.c"
    break;

  case 596: /* redir_stmt_arg: "to" "colon" stmt_expr nf_nat_flags  */
#line 3706 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11634 "parser_bison.c"
    break;

  case 597: /* dup_stmt: "dup" "to" stmt_expr  */
#line 3713 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[0].expr);
			}
#line 11643 "parser_bison.c"
    break;

  case 598: /* dup_stmt: "dup" "to" stmt_expr "device" stmt_expr  */
#line 3718 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[-2].expr);
				(yyval.stmt)->dup.dev = (yyvsp[0].expr);
			}
#line 11653 "parser_bison.c"
    break;

  case 599: /* fwd_stmt: "fwd" "to" stmt_expr  */
#line 3726 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11662 "parser_bison.c"
    break;

  case 600: /* fwd_stmt: "fwd" nf_key_proto "to" stmt_expr "device" stmt_expr  */
#line 3731 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.family = (yyvsp[-4].val);
				(yyval.stmt)->fwd.addr = (yyvsp[-2].expr);
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11673 "parser_bison.c"
    break;

  case 602: /* nf_nat_flags: nf_nat_flags "comma" nf_nat_flag  */
#line 3741 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11681 "parser_bison.c"
    break;

  case 603: /* nf_nat_flag: "random"  */
#line 3746 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM; }
#line 11687 "parser_bison.c"
    break;

  case 604: /* nf_nat_flag: "fully-random"  */
#line 3747 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM_FULLY; }
#line 11693 "parser_bison.c"
    break;

  case 605: /* nf_nat_flag: "persistent"  */
#line 3748 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PERSISTENT; }
#line 11699 "parser_bison.c"
    break;

  case 607: /* queue_stmt: "queue" "to" queue_stmt_expr close_scope_queue  */
#line 3753 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc), (yyvsp[-1].expr), 0);
			}
#line 11707 "parser_bison.c"
    break;

  case 608: /* queue_stmt: "queue" "flags" queue_stmt_flags "to" queue_stmt_expr close_scope_queue  */
#line 3757 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc), (yyvsp[-1].expr), (yyvsp[-3].val));
			}
#line 11715 "parser_bison.c"
    break;

  case 609: /* queue_stmt: "queue" "flags" queue_stmt_flags "num" queue_stmt_expr_simple close_scope_queue  */
#line 3761 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc), (yyvsp[-1].expr), (yyvsp[-3].val));
			}
#line 11723 "parser_bison.c"
    break;

  case 612: /* queue_stmt_alloc: "queue"  */
#line 3771 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc), NULL, 0);
			}
#line 11731 "parser_bison.c"
    break;

  case 613: /* queue_stmt_args: queue_stmt_arg  */
#line 3777 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11739 "parser_bison.c"
    break;

  case 615: /* queue_stmt_arg: "num" queue_stmt_expr_simple  */
#line 3784 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->queue.queue = (yyvsp[0].expr);
				(yyvsp[-2].stmt)->queue.queue->location = (yyloc);
			}
#line 11748 "parser_bison.c"
    break;

  case 616: /* queue_stmt_arg: queue_stmt_flags  */
#line 3789 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->queue.flags |= (yyvsp[0].val);
			}
#line 11756 "parser_bison.c"
    break;

  case 623: /* queue_stmt_flags: queue_stmt_flags "comma" queue_stmt_flag  */
#line 3805 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11764 "parser_bison.c"
    break;

  case 624: /* queue_stmt_flag: "bypass"  */
#line 3810 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_BYPASS; }
#line 11770 "parser_bison.c"
    break;

  case 625: /* queue_stmt_flag: "fanout"  */
#line 3811 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_CPU_FANOUT; }
#line 11776 "parser_bison.c"
    break;

  case 628: /* set_elem_expr_stmt_alloc: concat_expr  */
#line 3819 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 11784 "parser_bison.c"
    break;

  case 629: /* set_stmt: "set" set_stmt_op set_elem_expr_stmt set_ref_expr  */
#line 3825 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-2].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[0].expr);
			}
#line 11795 "parser_bison.c"
    break;

  case 630: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt '}'  */
#line 3832 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-4].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[-3].expr);
			}
#line 11806 "parser_bison.c"
    break;

  case 631: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list '}'  */
#line 3839 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-5].val);
				(yyval.stmt)->set.key = (yyvsp[-2].expr);
				(yyval.stmt)->set.set = (yyvsp[-4].expr);
				list_splice_tail((yyvsp[-1].list), &(yyval.stmt)->set.stmt_list);
				free((yyvsp[-1].list));
			}
#line 11819 "parser_bison.c"
    break;

  case 632: /* set_stmt_op: "add"  */
#line 3849 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_ADD; }
#line 11825 "parser_bison.c"
    break;

  case 633: /* set_stmt_op: "update"  */
#line 3850 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_UPDATE; }
#line 11831 "parser_bison.c"
    break;

  case 634: /* set_stmt_op: "delete"  */
#line 3851 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_DELETE; }
#line 11837 "parser_bison.c"
    break;

  case 635: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt "colon" set_elem_expr_stmt '}'  */
#line 3855 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-6].val);
				(yyval.stmt)->map.key = (yyvsp[-3].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-5].expr);
			}
#line 11849 "parser_bison.c"
    break;

  case 636: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list "colon" set_elem_expr_stmt '}'  */
#line 3863 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-7].val);
				(yyval.stmt)->map.key = (yyvsp[-4].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-6].expr);
				list_splice_tail((yyvsp[-3].list), &(yyval.stmt)->map.stmt_list);
				free((yyvsp[-3].list));
			}
#line 11863 "parser_bison.c"
    break;

  case 637: /* meter_stmt: flow_stmt_legacy_alloc flow_stmt_opts '{' meter_key_expr stmt '}'  */
#line 3875 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->meter.key  = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
				(yyval.stmt) = (yyvsp[-5].stmt);
			}
#line 11874 "parser_bison.c"
    break;

  case 638: /* meter_stmt: meter_stmt_alloc  */
#line 3881 "parser_bison.y"
                                                                { (yyval.stmt) = (yyvsp[0].stmt); }
#line 11880 "parser_bison.c"
    break;

  case 639: /* flow_stmt_legacy_alloc: "flow"  */
#line 3885 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
			}
#line 11888 "parser_bison.c"
    break;

  case 640: /* flow_stmt_opts: flow_stmt_opt  */
#line 3891 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11896 "parser_bison.c"
    break;

  case 642: /* flow_stmt_opt: "table" identifier  */
#line 3898 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->meter.name = (yyvsp[0].string);
			}
#line 11904 "parser_bison.c"
    break;

  case 643: /* meter_stmt_alloc: "meter" identifier '{' meter_key_expr stmt '}'  */
#line 3904 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-4].string);
				(yyval.stmt)->meter.size = 0;
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11917 "parser_bison.c"
    break;

  case 644: /* meter_stmt_alloc: "meter" identifier "size" "number" '{' meter_key_expr stmt '}'  */
#line 3913 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-6].string);
				(yyval.stmt)->meter.size = (yyvsp[-4].val);
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11930 "parser_bison.c"
    break;

  case 645: /* match_stmt: relational_expr  */
#line 3924 "parser_bison.y"
                        {
				(yyval.stmt) = expr_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 11938 "parser_bison.c"
    break;

  case 646: /* variable_expr: '$' identifier  */
#line 3930 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				struct symbol *sym;

				sym = symbol_get(scope, (yyvsp[0].string));
				if (!sym) {
					sym = symbol_lookup_fuzzy(scope, (yyvsp[0].string));
					if (sym) {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
								      "did you mean identifier ‘%s’?",
								      (yyvsp[0].string), sym->identifier),
							   state->msgs);
					} else {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'", (yyvsp[0].string)),
							   state->msgs);
					}
					xfree((yyvsp[0].string));
					YYERROR;
				}

				(yyval.expr) = variable_expr_alloc(&(yyloc), scope, sym);
				xfree((yyvsp[0].string));
			}
#line 11966 "parser_bison.c"
    break;

  case 648: /* symbol_expr: string  */
#line 3957 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11977 "parser_bison.c"
    break;

  case 651: /* set_ref_symbol_expr: "@" identifier  */
#line 3970 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11988 "parser_bison.c"
    break;

  case 652: /* integer_expr: "number"  */
#line 3979 "parser_bison.y"
                        {
				char str[64];

				snprintf(str, sizeof(str), "%" PRIu64, (yyvsp[0].val));
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       str);
			}
#line 12001 "parser_bison.c"
    break;

  case 653: /* primary_expr: symbol_expr  */
#line 3989 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12007 "parser_bison.c"
    break;

  case 654: /* primary_expr: integer_expr  */
#line 3990 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12013 "parser_bison.c"
    break;

  case 655: /* primary_expr: payload_expr  */
#line 3991 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12019 "parser_bison.c"
    break;

  case 656: /* primary_expr: exthdr_expr  */
#line 3992 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12025 "parser_bison.c"
    break;

  case 657: /* primary_expr: exthdr_exists_expr  */
#line 3993 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12031 "parser_bison.c"
    break;

  case 658: /* primary_expr: meta_expr  */
#line 3994 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12037 "parser_bison.c"
    break;

  case 659: /* primary_expr: socket_expr  */
#line 3995 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12043 "parser_bison.c"
    break;

  case 660: /* primary_expr: rt_expr  */
#line 3996 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12049 "parser_bison.c"
    break;

  case 661: /* primary_expr: ct_expr  */
#line 3997 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12055 "parser_bison.c"
    break;

  case 662: /* primary_expr: numgen_expr  */
#line 3998 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12061 "parser_bison.c"
    break;

  case 663: /* primary_expr: hash_expr  */
#line 3999 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12067 "parser_bison.c"
    break;

  case 664: /* primary_expr: fib_expr  */
#line 4000 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12073 "parser_bison.c"
    break;

  case 665: /* primary_expr: osf_expr  */
#line 4001 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12079 "parser_bison.c"
    break;

  case 666: /* primary_expr: xfrm_expr  */
#line 4002 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 12085 "parser_bison.c"
    break;

  case 667: /* primary_expr: '(' basic_expr ')'  */
#line 4003 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 12091 "parser_bison.c"
    break;

  case 668: /* fib_expr: "fib" fib_tuple fib_result close_scope_fib  */
#line 4007 "parser_bison.y"
                        {
				if (((yyvsp[-2].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) == 0) {
					erec_queue(error(&(yylsp[-2]), "fib: need either saddr or daddr"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-2].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) ==
					  (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) {
					erec_queue(error(&(yylsp[-2]), "fib: saddr and daddr are mutually exclusive"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-2].val) & (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) ==
					  (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) {
					erec_queue(error(&(yylsp[-2]), "fib: iif and oif are mutually exclusive"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = fib_expr_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-1].val));
			}
#line 12116 "parser_bison.c"
    break;

  case 669: /* fib_result: "oif"  */
#line 4029 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIF; }
#line 12122 "parser_bison.c"
    break;

  case 670: /* fib_result: "oifname"  */
#line 4030 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIFNAME; }
#line 12128 "parser_bison.c"
    break;

  case 671: /* fib_result: "type"  */
#line 4031 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_ADDRTYPE; }
#line 12134 "parser_bison.c"
    break;

  case 672: /* fib_flag: "saddr"  */
#line 4034 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_SADDR; }
#line 12140 "parser_bison.c"
    break;

  case 673: /* fib_flag: "daddr"  */
#line 4035 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_DADDR; }
#line 12146 "parser_bison.c"
    break;

  case 674: /* fib_flag: "mark"  */
#line 4036 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_MARK; }
#line 12152 "parser_bison.c"
    break;

  case 675: /* fib_flag: "iif"  */
#line 4037 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_IIF; }
#line 12158 "parser_bison.c"
    break;

  case 676: /* fib_flag: "oif"  */
#line 4038 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_OIF; }
#line 12164 "parser_bison.c"
    break;

  case 677: /* fib_tuple: fib_flag "." fib_tuple  */
#line 4042 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 12172 "parser_bison.c"
    break;

  case 679: /* osf_expr: "osf" osf_ttl "version"  */
#line 4049 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), NFT_OSF_F_VERSION);
			}
#line 12180 "parser_bison.c"
    break;

  case 680: /* osf_expr: "osf" osf_ttl "name"  */
#line 4053 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), 0);
			}
#line 12188 "parser_bison.c"
    break;

  case 681: /* osf_ttl: %empty  */
#line 4059 "parser_bison.y"
                        {
				(yyval.val) = NF_OSF_TTL_TRUE;
			}
#line 12196 "parser_bison.c"
    break;

  case 682: /* osf_ttl: "ttl" "string"  */
#line 4063 "parser_bison.y"
                        {
				if (!strcmp((yyvsp[0].string), "loose"))
					(yyval.val) = NF_OSF_TTL_LESS;
				else if (!strcmp((yyvsp[0].string), "skip"))
					(yyval.val) = NF_OSF_TTL_NOCHECK;
				else {
					erec_queue(error(&(yylsp[0]), "invalid ttl option"),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 12214 "parser_bison.c"
    break;

  case 684: /* shift_expr: shift_expr "<<" primary_rhs_expr  */
#line 4080 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12222 "parser_bison.c"
    break;

  case 685: /* shift_expr: shift_expr ">>" primary_rhs_expr  */
#line 4084 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12230 "parser_bison.c"
    break;

  case 687: /* and_expr: and_expr "&" shift_rhs_expr  */
#line 4091 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12238 "parser_bison.c"
    break;

  case 689: /* exclusive_or_expr: exclusive_or_expr "^" and_rhs_expr  */
#line 4098 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12246 "parser_bison.c"
    break;

  case 691: /* inclusive_or_expr: inclusive_or_expr '|' exclusive_or_rhs_expr  */
#line 4105 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12254 "parser_bison.c"
    break;

  case 694: /* concat_expr: concat_expr "." basic_expr  */
#line 4115 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 12267 "parser_bison.c"
    break;

  case 695: /* prefix_rhs_expr: basic_rhs_expr "/" "number"  */
#line 4126 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 12275 "parser_bison.c"
    break;

  case 696: /* range_rhs_expr: basic_rhs_expr "-" basic_rhs_expr  */
#line 4132 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12283 "parser_bison.c"
    break;

  case 699: /* map_expr: concat_expr "map" rhs_expr  */
#line 4142 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12291 "parser_bison.c"
    break;

  case 703: /* set_expr: '{' set_list_expr '}'  */
#line 4153 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12300 "parser_bison.c"
    break;

  case 704: /* set_list_expr: set_list_member_expr  */
#line 4160 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 12309 "parser_bison.c"
    break;

  case 705: /* set_list_expr: set_list_expr "comma" set_list_member_expr  */
#line 4165 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 12318 "parser_bison.c"
    break;

  case 707: /* set_list_member_expr: opt_newline set_expr opt_newline  */
#line 4173 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12326 "parser_bison.c"
    break;

  case 708: /* set_list_member_expr: opt_newline set_elem_expr opt_newline  */
#line 4177 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12334 "parser_bison.c"
    break;

  case 709: /* set_list_member_expr: opt_newline set_elem_expr "colon" set_rhs_expr opt_newline  */
#line 4181 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 12342 "parser_bison.c"
    break;

  case 711: /* meter_key_expr: meter_key_expr_alloc set_elem_options  */
#line 4188 "parser_bison.y"
                        {
				(yyval.expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 12351 "parser_bison.c"
    break;

  case 712: /* meter_key_expr_alloc: concat_expr  */
#line 4195 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 12359 "parser_bison.c"
    break;

  case 715: /* set_elem_key_expr: set_lhs_expr  */
#line 4204 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12365 "parser_bison.c"
    break;

  case 716: /* set_elem_key_expr: "*"  */
#line 4205 "parser_bison.y"
                                                        { (yyval.expr) = set_elem_catchall_expr_alloc(&(yylsp[0])); }
#line 12371 "parser_bison.c"
    break;

  case 717: /* set_elem_expr_alloc: set_elem_key_expr set_elem_stmt_list  */
#line 4209 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[-1]), (yyvsp[-1].expr));
				list_splice_tail((yyvsp[0].list), &(yyval.expr)->stmt_list);
				xfree((yyvsp[0].list));
			}
#line 12381 "parser_bison.c"
    break;

  case 718: /* set_elem_expr_alloc: set_elem_key_expr  */
#line 4215 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 12389 "parser_bison.c"
    break;

  case 719: /* set_elem_options: set_elem_option  */
#line 4221 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 12397 "parser_bison.c"
    break;

  case 721: /* set_elem_option: "timeout" time_spec  */
#line 4228 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 12405 "parser_bison.c"
    break;

  case 722: /* set_elem_option: "expires" time_spec  */
#line 4232 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 12413 "parser_bison.c"
    break;

  case 723: /* set_elem_option: comment_spec  */
#line 4236 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 12425 "parser_bison.c"
    break;

  case 724: /* set_elem_expr_options: set_elem_expr_option  */
#line 4246 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 12433 "parser_bison.c"
    break;

  case 726: /* set_elem_stmt_list: set_elem_stmt  */
#line 4253 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 12443 "parser_bison.c"
    break;

  case 727: /* set_elem_stmt_list: set_elem_stmt_list set_elem_stmt  */
#line 4259 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 12452 "parser_bison.c"
    break;

  case 728: /* set_elem_stmt: "counter" close_scope_counter  */
#line 4266 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 12460 "parser_bison.c"
    break;

  case 729: /* set_elem_stmt: "counter" "packets" "number" "bytes" "number" close_scope_counter  */
#line 4270 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
				(yyval.stmt)->counter.packets = (yyvsp[-3].val);
				(yyval.stmt)->counter.bytes = (yyvsp[-1].val);
			}
#line 12470 "parser_bison.c"
    break;

  case 730: /* set_elem_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts close_scope_limit  */
#line 4276 "parser_bison.y"
                        {
				if ((yyvsp[-1].val) == 0) {
					erec_queue(error(&(yylsp[-1]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = (yyvsp[-4].val);
				(yyval.stmt)->limit.unit  = (yyvsp[-2].val);
				(yyval.stmt)->limit.burst = (yyvsp[-1].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-5].val);
			}
#line 12488 "parser_bison.c"
    break;

  case 731: /* set_elem_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes close_scope_limit  */
#line 4290 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[-1].val) == 0) {
					erec_queue(error(&(yylsp[-1]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				erec = rate_parse(&(yyloc), (yyvsp[-2].string), &rate, &unit);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = rate * (yyvsp[-3].val);
				(yyval.stmt)->limit.unit  = unit;
				(yyval.stmt)->limit.burst = (yyvsp[-1].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
                        }
#line 12516 "parser_bison.c"
    break;

  case 732: /* set_elem_stmt: "ct" "count" "number" close_scope_ct  */
#line 4314 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count	= (yyvsp[-1].val);
			}
#line 12525 "parser_bison.c"
    break;

  case 733: /* set_elem_stmt: "ct" "count" "over" "number" close_scope_ct  */
#line 4319 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count = (yyvsp[-1].val);
				(yyval.stmt)->connlimit.flags = NFT_CONNLIMIT_F_INV;
			}
#line 12535 "parser_bison.c"
    break;

  case 734: /* set_elem_expr_option: "timeout" time_spec  */
#line 4327 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 12543 "parser_bison.c"
    break;

  case 735: /* set_elem_expr_option: "expires" time_spec  */
#line 4331 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 12551 "parser_bison.c"
    break;

  case 736: /* set_elem_expr_option: comment_spec  */
#line 4335 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 12563 "parser_bison.c"
    break;

  case 742: /* initializer_expr: '{' '}'  */
#line 4353 "parser_bison.y"
                                                { (yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_SET); }
#line 12569 "parser_bison.c"
    break;

  case 743: /* initializer_expr: "-" "number"  */
#line 4355 "parser_bison.y"
                        {
				int32_t num = -(yyvsp[0].val);

				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(num) * BITS_PER_BYTE,
							 &num);
			}
#line 12582 "parser_bison.c"
    break;

  case 744: /* counter_config: "packets" "number" "bytes" "number"  */
#line 4366 "parser_bison.y"
                        {
				struct counter *counter;

				counter = &(yyvsp[-4].obj)->counter;
				counter->packets = (yyvsp[-2].val);
				counter->bytes = (yyvsp[0].val);
			}
#line 12594 "parser_bison.c"
    break;

  case 745: /* counter_obj: %empty  */
#line 4376 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_COUNTER;
			}
#line 12603 "parser_bison.c"
    break;

  case 746: /* quota_config: quota_mode "number" quota_unit quota_used  */
#line 4383 "parser_bison.y"
                        {
				struct error_record *erec;
				struct quota *quota;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				quota = &(yyvsp[-4].obj)->quota;
				quota->bytes	= (yyvsp[-2].val) * rate;
				quota->used	= (yyvsp[0].val);
				quota->flags	= (yyvsp[-3].val);
			}
#line 12625 "parser_bison.c"
    break;

  case 747: /* quota_obj: %empty  */
#line 4403 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_QUOTA;
			}
#line 12634 "parser_bison.c"
    break;

  case 748: /* secmark_config: string  */
#line 4410 "parser_bison.y"
                        {
				int ret;
				struct secmark *secmark;

				secmark = &(yyvsp[-1].obj)->secmark;
				ret = snprintf(secmark->ctx, sizeof(secmark->ctx), "%s", (yyvsp[0].string));
				if (ret <= 0 || ret >= (int)sizeof(secmark->ctx)) {
					erec_queue(error(&(yylsp[0]), "invalid context '%s', max length is %u\n", (yyvsp[0].string), (int)sizeof(secmark->ctx)), state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 12652 "parser_bison.c"
    break;

  case 749: /* secmark_obj: %empty  */
#line 4426 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SECMARK;
			}
#line 12661 "parser_bison.c"
    break;

  case 750: /* ct_obj_type: "helper"  */
#line 4432 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_HELPER; }
#line 12667 "parser_bison.c"
    break;

  case 751: /* ct_obj_type: "timeout"  */
#line 4433 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_TIMEOUT; }
#line 12673 "parser_bison.c"
    break;

  case 752: /* ct_obj_type: "expectation"  */
#line 4434 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_EXPECT; }
#line 12679 "parser_bison.c"
    break;

  case 753: /* ct_cmd_type: "helpers"  */
#line 4437 "parser_bison.y"
                                                { (yyval.val) = CMD_OBJ_CT_HELPERS; }
#line 12685 "parser_bison.c"
    break;

  case 754: /* ct_cmd_type: "timeout"  */
#line 4438 "parser_bison.y"
                                                { (yyval.val) = CMD_OBJ_CT_TIMEOUT; }
#line 12691 "parser_bison.c"
    break;

  case 755: /* ct_cmd_type: "expectation"  */
#line 4439 "parser_bison.y"
                                                { (yyval.val) = CMD_OBJ_CT_EXPECT; }
#line 12697 "parser_bison.c"
    break;

  case 756: /* ct_l4protoname: "tcp"  */
#line 4442 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_TCP; }
#line 12703 "parser_bison.c"
    break;

  case 757: /* ct_l4protoname: "udp"  */
#line 4443 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_UDP; }
#line 12709 "parser_bison.c"
    break;

  case 758: /* ct_helper_config: "type" "quoted string" "protocol" ct_l4protoname stmt_separator  */
#line 4447 "parser_bison.y"
                        {
				struct ct_helper *ct;
				int ret;

				ct = &(yyvsp[-5].obj)->ct_helper;

				if (ct->l4proto) {
					erec_queue(error(&(yylsp[-3]), "You can only specify this once. This statement is already set for %s.", ct->name), state->msgs);
					xfree((yyvsp[-3].string));
					YYERROR;
				}

				ret = snprintf(ct->name, sizeof(ct->name), "%s", (yyvsp[-3].string));
				if (ret <= 0 || ret >= (int)sizeof(ct->name)) {
					erec_queue(error(&(yylsp[-3]), "invalid name '%s', max length is %u\n", (yyvsp[-3].string), (int)sizeof(ct->name)), state->msgs);
					xfree((yyvsp[-3].string));
					YYERROR;
				}
				xfree((yyvsp[-3].string));

				ct->l4proto = (yyvsp[-1].val);
			}
#line 12736 "parser_bison.c"
    break;

  case 759: /* ct_helper_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4470 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_helper.l3proto = (yyvsp[-1].val);
			}
#line 12744 "parser_bison.c"
    break;

  case 760: /* timeout_states: timeout_state  */
#line 4476 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail((yyvsp[0].list), (yyval.list));
			}
#line 12754 "parser_bison.c"
    break;

  case 761: /* timeout_states: timeout_states "comma" timeout_state  */
#line 4482 "parser_bison.y"
                        {
				list_add_tail((yyvsp[0].list), (yyvsp[-2].list));
				(yyval.list) = (yyvsp[-2].list);
			}
#line 12763 "parser_bison.c"
    break;

  case 762: /* timeout_state: "string" "colon" "number"  */
#line 4490 "parser_bison.y"
                        {
				struct timeout_state *ts;

				ts = xzalloc(sizeof(*ts));
				ts->timeout_str = (yyvsp[-2].string);
				ts->timeout_value = (yyvsp[0].val);
				ts->location = (yylsp[-2]);
				init_list_head(&ts->head);
				(yyval.list) = &ts->head;
			}
#line 12778 "parser_bison.c"
    break;

  case 763: /* ct_timeout_config: "protocol" ct_l4protoname stmt_separator  */
#line 4503 "parser_bison.y"
                        {
				struct ct_timeout *ct;
				int l4proto = (yyvsp[-1].val);

				ct = &(yyvsp[-3].obj)->ct_timeout;
				ct->l4proto = l4proto;
			}
#line 12790 "parser_bison.c"
    break;

  case 764: /* ct_timeout_config: "policy" '=' '{' timeout_states '}' stmt_separator  */
#line 4511 "parser_bison.y"
                        {
				struct ct_timeout *ct;

				ct = &(yyvsp[-6].obj)->ct_timeout;
				list_splice_tail((yyvsp[-2].list), &ct->timeout_list);
				xfree((yyvsp[-2].list));
			}
#line 12802 "parser_bison.c"
    break;

  case 765: /* ct_timeout_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4519 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_timeout.l3proto = (yyvsp[-1].val);
			}
#line 12810 "parser_bison.c"
    break;

  case 766: /* ct_expect_config: "protocol" ct_l4protoname stmt_separator  */
#line 4525 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l4proto = (yyvsp[-1].val);
			}
#line 12818 "parser_bison.c"
    break;

  case 767: /* ct_expect_config: "dport" "number" stmt_separator  */
#line 4529 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.dport = (yyvsp[-1].val);
			}
#line 12826 "parser_bison.c"
    break;

  case 768: /* ct_expect_config: "timeout" time_spec stmt_separator  */
#line 4533 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.timeout = (yyvsp[-1].val);
			}
#line 12834 "parser_bison.c"
    break;

  case 769: /* ct_expect_config: "size" "number" stmt_separator  */
#line 4537 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.size = (yyvsp[-1].val);
			}
#line 12842 "parser_bison.c"
    break;

  case 770: /* ct_expect_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4541 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l3proto = (yyvsp[-1].val);
			}
#line 12850 "parser_bison.c"
    break;

  case 771: /* ct_obj_alloc: %empty  */
#line 4547 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
			}
#line 12858 "parser_bison.c"
    break;

  case 772: /* limit_config: "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 4553 "parser_bison.y"
                        {
				struct limit *limit;

				limit = &(yyvsp[-6].obj)->limit;
				limit->rate	= (yyvsp[-3].val);
				limit->unit	= (yyvsp[-1].val);
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKTS;
				limit->flags	= (yyvsp[-4].val);
			}
#line 12873 "parser_bison.c"
    break;

  case 773: /* limit_config: "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 4564 "parser_bison.y"
                        {
				struct limit *limit;
				struct error_record *erec;
				uint64_t rate, unit;

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				limit = &(yyvsp[-5].obj)->limit;
				limit->rate	= rate * (yyvsp[-2].val);
				limit->unit	= unit;
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKT_BYTES;
				limit->flags	= (yyvsp[-3].val);
			}
#line 12897 "parser_bison.c"
    break;

  case 774: /* limit_obj: %empty  */
#line 4586 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_LIMIT;
			}
#line 12906 "parser_bison.c"
    break;

  case 775: /* relational_expr: expr rhs_expr  */
#line 4593 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12914 "parser_bison.c"
    break;

  case 776: /* relational_expr: expr list_rhs_expr  */
#line 4597 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12922 "parser_bison.c"
    break;

  case 777: /* relational_expr: expr basic_rhs_expr "/" list_rhs_expr  */
#line 4601 "parser_bison.y"
                        {
				(yyval.expr) = flagcmp_expr_alloc(&(yyloc), OP_EQ, (yyvsp[-3].expr), (yyvsp[0].expr), (yyvsp[-2].expr));
			}
#line 12930 "parser_bison.c"
    break;

  case 778: /* relational_expr: expr list_rhs_expr "/" list_rhs_expr  */
#line 4605 "parser_bison.y"
                        {
				(yyval.expr) = flagcmp_expr_alloc(&(yyloc), OP_EQ, (yyvsp[-3].expr), (yyvsp[0].expr), (yyvsp[-2].expr));
			}
#line 12938 "parser_bison.c"
    break;

  case 779: /* relational_expr: expr relational_op basic_rhs_expr "/" list_rhs_expr  */
#line 4609 "parser_bison.y"
                        {
				(yyval.expr) = flagcmp_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-4].expr), (yyvsp[0].expr), (yyvsp[-2].expr));
			}
#line 12946 "parser_bison.c"
    break;

  case 780: /* relational_expr: expr relational_op list_rhs_expr "/" list_rhs_expr  */
#line 4613 "parser_bison.y"
                        {
				(yyval.expr) = flagcmp_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-4].expr), (yyvsp[0].expr), (yyvsp[-2].expr));
			}
#line 12954 "parser_bison.c"
    break;

  case 781: /* relational_expr: expr relational_op rhs_expr  */
#line 4617 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12962 "parser_bison.c"
    break;

  case 782: /* relational_expr: expr relational_op list_rhs_expr  */
#line 4621 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12970 "parser_bison.c"
    break;

  case 783: /* list_rhs_expr: basic_rhs_expr "comma" basic_rhs_expr  */
#line 4627 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 12980 "parser_bison.c"
    break;

  case 784: /* list_rhs_expr: list_rhs_expr "comma" basic_rhs_expr  */
#line 4633 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 12990 "parser_bison.c"
    break;

  case 785: /* rhs_expr: concat_rhs_expr  */
#line 4640 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12996 "parser_bison.c"
    break;

  case 786: /* rhs_expr: set_expr  */
#line 4641 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13002 "parser_bison.c"
    break;

  case 787: /* rhs_expr: set_ref_symbol_expr  */
#line 4642 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13008 "parser_bison.c"
    break;

  case 789: /* shift_rhs_expr: shift_rhs_expr "<<" primary_rhs_expr  */
#line 4647 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13016 "parser_bison.c"
    break;

  case 790: /* shift_rhs_expr: shift_rhs_expr ">>" primary_rhs_expr  */
#line 4651 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13024 "parser_bison.c"
    break;

  case 792: /* and_rhs_expr: and_rhs_expr "&" shift_rhs_expr  */
#line 4658 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13032 "parser_bison.c"
    break;

  case 794: /* exclusive_or_rhs_expr: exclusive_or_rhs_expr "^" and_rhs_expr  */
#line 4665 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13040 "parser_bison.c"
    break;

  case 796: /* inclusive_or_rhs_expr: inclusive_or_rhs_expr '|' exclusive_or_rhs_expr  */
#line 4672 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13048 "parser_bison.c"
    break;

  case 800: /* concat_rhs_expr: concat_rhs_expr "." multiton_rhs_expr  */
#line 4683 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 13061 "parser_bison.c"
    break;

  case 801: /* concat_rhs_expr: concat_rhs_expr "." basic_rhs_expr  */
#line 4692 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 13074 "parser_bison.c"
    break;

  case 802: /* boolean_keys: "exists"  */
#line 4702 "parser_bison.y"
                                                { (yyval.val8) = true; }
#line 13080 "parser_bison.c"
    break;

  case 803: /* boolean_keys: "missing"  */
#line 4703 "parser_bison.y"
                                                { (yyval.val8) = false; }
#line 13086 "parser_bison.c"
    break;

  case 804: /* boolean_expr: boolean_keys  */
#line 4707 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &boolean_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof((yyvsp[0].val8)) * BITS_PER_BYTE, &(yyvsp[0].val8));
			}
#line 13096 "parser_bison.c"
    break;

  case 805: /* keyword_expr: "ether" close_scope_eth  */
#line 4714 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ether"); }
#line 13102 "parser_bison.c"
    break;

  case 806: /* keyword_expr: "ip" close_scope_ip  */
#line 4715 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip"); }
#line 13108 "parser_bison.c"
    break;

  case 807: /* keyword_expr: "ip6" close_scope_ip6  */
#line 4716 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip6"); }
#line 13114 "parser_bison.c"
    break;

  case 808: /* keyword_expr: "vlan" close_scope_vlan  */
#line 4717 "parser_bison.y"
                                                         { (yyval.expr) = symbol_value(&(yyloc), "vlan"); }
#line 13120 "parser_bison.c"
    break;

  case 809: /* keyword_expr: "arp" close_scope_arp  */
#line 4718 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "arp"); }
#line 13126 "parser_bison.c"
    break;

  case 810: /* keyword_expr: "dnat"  */
#line 4719 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "dnat"); }
#line 13132 "parser_bison.c"
    break;

  case 811: /* keyword_expr: "snat"  */
#line 4720 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "snat"); }
#line 13138 "parser_bison.c"
    break;

  case 812: /* keyword_expr: "ecn"  */
#line 4721 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ecn"); }
#line 13144 "parser_bison.c"
    break;

  case 813: /* keyword_expr: "reset"  */
#line 4722 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reset"); }
#line 13150 "parser_bison.c"
    break;

  case 814: /* keyword_expr: "original"  */
#line 4723 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "original"); }
#line 13156 "parser_bison.c"
    break;

  case 815: /* keyword_expr: "reply"  */
#line 4724 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reply"); }
#line 13162 "parser_bison.c"
    break;

  case 816: /* keyword_expr: "label"  */
#line 4725 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "label"); }
#line 13168 "parser_bison.c"
    break;

  case 817: /* primary_rhs_expr: symbol_expr  */
#line 4728 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13174 "parser_bison.c"
    break;

  case 818: /* primary_rhs_expr: integer_expr  */
#line 4729 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13180 "parser_bison.c"
    break;

  case 819: /* primary_rhs_expr: boolean_expr  */
#line 4730 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13186 "parser_bison.c"
    break;

  case 820: /* primary_rhs_expr: keyword_expr  */
#line 4731 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 13192 "parser_bison.c"
    break;

  case 821: /* primary_rhs_expr: "tcp"  */
#line 4733 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_TCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13203 "parser_bison.c"
    break;

  case 822: /* primary_rhs_expr: "udp"  */
#line 4740 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13214 "parser_bison.c"
    break;

  case 823: /* primary_rhs_expr: "udplite"  */
#line 4747 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDPLITE;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13225 "parser_bison.c"
    break;

  case 824: /* primary_rhs_expr: "esp"  */
#line 4754 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ESP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13236 "parser_bison.c"
    break;

  case 825: /* primary_rhs_expr: "ah"  */
#line 4761 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_AH;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13247 "parser_bison.c"
    break;

  case 826: /* primary_rhs_expr: "icmp"  */
#line 4768 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13258 "parser_bison.c"
    break;

  case 827: /* primary_rhs_expr: "igmp"  */
#line 4775 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_IGMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13269 "parser_bison.c"
    break;

  case 828: /* primary_rhs_expr: "icmpv6"  */
#line 4782 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMPV6;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13280 "parser_bison.c"
    break;

  case 829: /* primary_rhs_expr: "comp"  */
#line 4789 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_COMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13291 "parser_bison.c"
    break;

  case 830: /* primary_rhs_expr: "dccp"  */
#line 4796 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_DCCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13302 "parser_bison.c"
    break;

  case 831: /* primary_rhs_expr: "sctp" close_scope_sctp  */
#line 4803 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_SCTP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13313 "parser_bison.c"
    break;

  case 832: /* primary_rhs_expr: "redirect"  */
#line 4810 "parser_bison.y"
                        {
				uint8_t data = ICMP_REDIRECT;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &icmp_type_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 13324 "parser_bison.c"
    break;

  case 833: /* primary_rhs_expr: '(' basic_rhs_expr ')'  */
#line 4816 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 13330 "parser_bison.c"
    break;

  case 834: /* relational_op: "=="  */
#line 4819 "parser_bison.y"
                                                { (yyval.val) = OP_EQ; }
#line 13336 "parser_bison.c"
    break;

  case 835: /* relational_op: "!="  */
#line 4820 "parser_bison.y"
                                                { (yyval.val) = OP_NEQ; }
#line 13342 "parser_bison.c"
    break;

  case 836: /* relational_op: "<"  */
#line 4821 "parser_bison.y"
                                                { (yyval.val) = OP_LT; }
#line 13348 "parser_bison.c"
    break;

  case 837: /* relational_op: ">"  */
#line 4822 "parser_bison.y"
                                                { (yyval.val) = OP_GT; }
#line 13354 "parser_bison.c"
    break;

  case 838: /* relational_op: ">="  */
#line 4823 "parser_bison.y"
                                                { (yyval.val) = OP_GTE; }
#line 13360 "parser_bison.c"
    break;

  case 839: /* relational_op: "<="  */
#line 4824 "parser_bison.y"
                                                { (yyval.val) = OP_LTE; }
#line 13366 "parser_bison.c"
    break;

  case 840: /* relational_op: "!"  */
#line 4825 "parser_bison.y"
                                                { (yyval.val) = OP_NEG; }
#line 13372 "parser_bison.c"
    break;

  case 841: /* verdict_expr: "accept"  */
#line 4829 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_ACCEPT, NULL);
			}
#line 13380 "parser_bison.c"
    break;

  case 842: /* verdict_expr: "drop"  */
#line 4833 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_DROP, NULL);
			}
#line 13388 "parser_bison.c"
    break;

  case 843: /* verdict_expr: "continue"  */
#line 4837 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_CONTINUE, NULL);
			}
#line 13396 "parser_bison.c"
    break;

  case 844: /* verdict_expr: "jump" chain_expr  */
#line 4841 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_JUMP, (yyvsp[0].expr));
			}
#line 13404 "parser_bison.c"
    break;

  case 845: /* verdict_expr: "goto" chain_expr  */
#line 4845 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_GOTO, (yyvsp[0].expr));
			}
#line 13412 "parser_bison.c"
    break;

  case 846: /* verdict_expr: "return"  */
#line 4849 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_RETURN, NULL);
			}
#line 13420 "parser_bison.c"
    break;

  case 848: /* chain_expr: identifier  */
#line 4856 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE,
							 (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 13432 "parser_bison.c"
    break;

  case 849: /* meta_expr: "meta" meta_key  */
#line 4866 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13440 "parser_bison.c"
    break;

  case 850: /* meta_expr: meta_key_unqualified  */
#line 4870 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13448 "parser_bison.c"
    break;

  case 851: /* meta_expr: "meta" "string"  */
#line 4874 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[0].string), &key);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.expr) = meta_expr_alloc(&(yyloc), key);
			}
#line 13466 "parser_bison.c"
    break;

  case 854: /* meta_key_qualified: "length"  */
#line 4893 "parser_bison.y"
                                                { (yyval.val) = NFT_META_LEN; }
#line 13472 "parser_bison.c"
    break;

  case 855: /* meta_key_qualified: "protocol"  */
#line 4894 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PROTOCOL; }
#line 13478 "parser_bison.c"
    break;

  case 856: /* meta_key_qualified: "priority"  */
#line 4895 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRIORITY; }
#line 13484 "parser_bison.c"
    break;

  case 857: /* meta_key_qualified: "random"  */
#line 4896 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRANDOM; }
#line 13490 "parser_bison.c"
    break;

  case 858: /* meta_key_qualified: "secmark" close_scope_secmark  */
#line 4897 "parser_bison.y"
                                                            { (yyval.val) = NFT_META_SECMARK; }
#line 13496 "parser_bison.c"
    break;

  case 859: /* meta_key_unqualified: "mark"  */
#line 4900 "parser_bison.y"
                                                { (yyval.val) = NFT_META_MARK; }
#line 13502 "parser_bison.c"
    break;

  case 860: /* meta_key_unqualified: "iif"  */
#line 4901 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIF; }
#line 13508 "parser_bison.c"
    break;

  case 861: /* meta_key_unqualified: "iifname"  */
#line 4902 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFNAME; }
#line 13514 "parser_bison.c"
    break;

  case 862: /* meta_key_unqualified: "iiftype"  */
#line 4903 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFTYPE; }
#line 13520 "parser_bison.c"
    break;

  case 863: /* meta_key_unqualified: "oif"  */
#line 4904 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIF; }
#line 13526 "parser_bison.c"
    break;

  case 864: /* meta_key_unqualified: "oifname"  */
#line 4905 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFNAME; }
#line 13532 "parser_bison.c"
    break;

  case 865: /* meta_key_unqualified: "oiftype"  */
#line 4906 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFTYPE; }
#line 13538 "parser_bison.c"
    break;

  case 866: /* meta_key_unqualified: "skuid"  */
#line 4907 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKUID; }
#line 13544 "parser_bison.c"
    break;

  case 867: /* meta_key_unqualified: "skgid"  */
#line 4908 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKGID; }
#line 13550 "parser_bison.c"
    break;

  case 868: /* meta_key_unqualified: "nftrace"  */
#line 4909 "parser_bison.y"
                                                { (yyval.val) = NFT_META_NFTRACE; }
#line 13556 "parser_bison.c"
    break;

  case 869: /* meta_key_unqualified: "rtclassid"  */
#line 4910 "parser_bison.y"
                                                { (yyval.val) = NFT_META_RTCLASSID; }
#line 13562 "parser_bison.c"
    break;

  case 870: /* meta_key_unqualified: "ibriport"  */
#line 4911 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 13568 "parser_bison.c"
    break;

  case 871: /* meta_key_unqualified: "obriport"  */
#line 4912 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 13574 "parser_bison.c"
    break;

  case 872: /* meta_key_unqualified: "ibrname"  */
#line 4913 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 13580 "parser_bison.c"
    break;

  case 873: /* meta_key_unqualified: "obrname"  */
#line 4914 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 13586 "parser_bison.c"
    break;

  case 874: /* meta_key_unqualified: "pkttype"  */
#line 4915 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PKTTYPE; }
#line 13592 "parser_bison.c"
    break;

  case 875: /* meta_key_unqualified: "cpu"  */
#line 4916 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CPU; }
#line 13598 "parser_bison.c"
    break;

  case 876: /* meta_key_unqualified: "iifgroup"  */
#line 4917 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFGROUP; }
#line 13604 "parser_bison.c"
    break;

  case 877: /* meta_key_unqualified: "oifgroup"  */
#line 4918 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFGROUP; }
#line 13610 "parser_bison.c"
    break;

  case 878: /* meta_key_unqualified: "cgroup"  */
#line 4919 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CGROUP; }
#line 13616 "parser_bison.c"
    break;

  case 879: /* meta_key_unqualified: "ipsec" close_scope_ipsec  */
#line 4920 "parser_bison.y"
                                                          { (yyval.val) = NFT_META_SECPATH; }
#line 13622 "parser_bison.c"
    break;

  case 880: /* meta_key_unqualified: "time"  */
#line 4921 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_NS; }
#line 13628 "parser_bison.c"
    break;

  case 881: /* meta_key_unqualified: "day"  */
#line 4922 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_DAY; }
#line 13634 "parser_bison.c"
    break;

  case 882: /* meta_key_unqualified: "hour"  */
#line 4923 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_HOUR; }
#line 13640 "parser_bison.c"
    break;

  case 883: /* meta_stmt: "meta" meta_key "set" stmt_expr  */
#line 4927 "parser_bison.y"
                        {
				switch ((yyvsp[-2].val)) {
				case NFT_META_SECMARK:
					switch ((yyvsp[0].expr)->etype) {
					case EXPR_CT:
						(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
						break;
					default:
						(yyval.stmt) = objref_stmt_alloc(&(yyloc));
						(yyval.stmt)->objref.type = NFT_OBJECT_SECMARK;
						(yyval.stmt)->objref.expr = (yyvsp[0].expr);
						break;
					}
					break;
				default:
					(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
					break;
				}
			}
#line 13664 "parser_bison.c"
    break;

  case 884: /* meta_stmt: meta_key_unqualified "set" stmt_expr  */
#line 4947 "parser_bison.y"
                        {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 13672 "parser_bison.c"
    break;

  case 885: /* meta_stmt: "meta" "string" "set" stmt_expr  */
#line 4951 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[-2].string), &key);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}

				(yyval.stmt) = meta_stmt_alloc(&(yyloc), key, (yyvsp[0].expr));
			}
#line 13691 "parser_bison.c"
    break;

  case 886: /* meta_stmt: "notrack"  */
#line 4966 "parser_bison.y"
                        {
				(yyval.stmt) = notrack_stmt_alloc(&(yyloc));
			}
#line 13699 "parser_bison.c"
    break;

  case 887: /* meta_stmt: "flow" "offload" "@" string  */
#line 4970 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13707 "parser_bison.c"
    break;

  case 888: /* meta_stmt: "flow" "add" "@" string  */
#line 4974 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13715 "parser_bison.c"
    break;

  case 889: /* socket_expr: "socket" socket_key close_scope_socket  */
#line 4980 "parser_bison.y"
                        {
				(yyval.expr) = socket_expr_alloc(&(yyloc), (yyvsp[-1].val), 0);
			}
#line 13723 "parser_bison.c"
    break;

  case 890: /* socket_expr: "socket" "cgroupv2" "level" "number" close_scope_socket  */
#line 4984 "parser_bison.y"
                        {
				(yyval.expr) = socket_expr_alloc(&(yyloc), NFT_SOCKET_CGROUPV2, (yyvsp[-1].val));
			}
#line 13731 "parser_bison.c"
    break;

  case 891: /* socket_key: "transparent"  */
#line 4989 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_TRANSPARENT; }
#line 13737 "parser_bison.c"
    break;

  case 892: /* socket_key: "mark"  */
#line 4990 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_MARK; }
#line 13743 "parser_bison.c"
    break;

  case 893: /* socket_key: "wildcard"  */
#line 4991 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_WILDCARD; }
#line 13749 "parser_bison.c"
    break;

  case 894: /* offset_opt: %empty  */
#line 4994 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 13755 "parser_bison.c"
    break;

  case 895: /* offset_opt: "offset" "number"  */
#line 4995 "parser_bison.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 13761 "parser_bison.c"
    break;

  case 896: /* numgen_type: "inc"  */
#line 4998 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_INCREMENTAL; }
#line 13767 "parser_bison.c"
    break;

  case 897: /* numgen_type: "random"  */
#line 4999 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_RANDOM; }
#line 13773 "parser_bison.c"
    break;

  case 898: /* numgen_expr: "numgen" numgen_type "mod" "number" offset_opt close_scope_numgen  */
#line 5003 "parser_bison.y"
                        {
				(yyval.expr) = numgen_expr_alloc(&(yyloc), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[-1].val));
			}
#line 13781 "parser_bison.c"
    break;

  case 899: /* xfrm_spnum: "spnum" "number"  */
#line 5008 "parser_bison.y"
                                            { (yyval.val) = (yyvsp[0].val); }
#line 13787 "parser_bison.c"
    break;

  case 900: /* xfrm_spnum: %empty  */
#line 5009 "parser_bison.y"
                                            { (yyval.val) = 0; }
#line 13793 "parser_bison.c"
    break;

  case 901: /* xfrm_dir: "in"  */
#line 5012 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_IN; }
#line 13799 "parser_bison.c"
    break;

  case 902: /* xfrm_dir: "out"  */
#line 5013 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_OUT; }
#line 13805 "parser_bison.c"
    break;

  case 903: /* xfrm_state_key: "spi"  */
#line 5016 "parser_bison.y"
                                    { (yyval.val) = NFT_XFRM_KEY_SPI; }
#line 13811 "parser_bison.c"
    break;

  case 904: /* xfrm_state_key: "reqid"  */
#line 5017 "parser_bison.y"
                                      { (yyval.val) = NFT_XFRM_KEY_REQID; }
#line 13817 "parser_bison.c"
    break;

  case 905: /* xfrm_state_proto_key: "daddr"  */
#line 5020 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_DADDR_IP4; }
#line 13823 "parser_bison.c"
    break;

  case 906: /* xfrm_state_proto_key: "saddr"  */
#line 5021 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_SADDR_IP4; }
#line 13829 "parser_bison.c"
    break;

  case 907: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum xfrm_state_key close_scope_ipsec  */
#line 5025 "parser_bison.y"
                        {
				if ((yyvsp[-2].val) > 255) {
					erec_queue(error(&(yylsp[-2]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-2].val), (yyvsp[-1].val));
			}
#line 13841 "parser_bison.c"
    break;

  case 908: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum nf_key_proto xfrm_state_proto_key close_scope_ipsec  */
#line 5033 "parser_bison.y"
                        {
				enum nft_xfrm_keys xfrmk = (yyvsp[-1].val);

				switch ((yyvsp[-2].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[-1].val) == NFT_XFRM_KEY_SADDR_IP4)
						xfrmk = NFT_XFRM_KEY_SADDR_IP6;
					else if ((yyvsp[-1].val) == NFT_XFRM_KEY_DADDR_IP4)
						xfrmk = NFT_XFRM_KEY_DADDR_IP6;
					break;
				default:
					YYERROR;
					break;
				}

				if ((yyvsp[-3].val) > 255) {
					erec_queue(error(&(yylsp[-3]), "value too large"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-4].val), (yyvsp[-3].val), xfrmk);
			}
#line 13870 "parser_bison.c"
    break;

  case 909: /* hash_expr: "jhash" expr "mod" "number" "seed" "number" offset_opt close_scope_hash  */
#line 5060 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-4].val), true, (yyvsp[-2].val), (yyvsp[-1].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-6].expr);
			}
#line 13879 "parser_bison.c"
    break;

  case 910: /* hash_expr: "jhash" expr "mod" "number" offset_opt close_scope_hash  */
#line 5065 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-2].val), false, 0, (yyvsp[-1].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-4].expr);
			}
#line 13888 "parser_bison.c"
    break;

  case 911: /* hash_expr: "symhash" "mod" "number" offset_opt close_scope_hash  */
#line 5070 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-2].val), false, 0, (yyvsp[-1].val), NFT_HASH_SYM);
			}
#line 13896 "parser_bison.c"
    break;

  case 912: /* nf_key_proto: "ip" close_scope_ip  */
#line 5075 "parser_bison.y"
                                                       { (yyval.val) = NFPROTO_IPV4; }
#line 13902 "parser_bison.c"
    break;

  case 913: /* nf_key_proto: "ip6" close_scope_ip6  */
#line 5076 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV6; }
#line 13908 "parser_bison.c"
    break;

  case 914: /* rt_expr: "rt" rt_key close_scope_rt  */
#line 5080 "parser_bison.y"
                        {
				(yyval.expr) = rt_expr_alloc(&(yyloc), (yyvsp[-1].val), true);
			}
#line 13916 "parser_bison.c"
    break;

  case 915: /* rt_expr: "rt" nf_key_proto rt_key close_scope_rt  */
#line 5084 "parser_bison.y"
                        {
				enum nft_rt_keys rtk = (yyvsp[-1].val);

				switch ((yyvsp[-2].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[-1].val) == NFT_RT_NEXTHOP4)
						rtk = NFT_RT_NEXTHOP6;
					break;
				default:
					YYERROR;
					break;
				}

				(yyval.expr) = rt_expr_alloc(&(yyloc), rtk, false);
			}
#line 13938 "parser_bison.c"
    break;

  case 916: /* rt_key: "classid"  */
#line 5103 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_CLASSID; }
#line 13944 "parser_bison.c"
    break;

  case 917: /* rt_key: "nexthop"  */
#line 5104 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_NEXTHOP4; }
#line 13950 "parser_bison.c"
    break;

  case 918: /* rt_key: "mtu"  */
#line 5105 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_TCPMSS; }
#line 13956 "parser_bison.c"
    break;

  case 919: /* rt_key: "ipsec" close_scope_ipsec  */
#line 5106 "parser_bison.y"
                                                          { (yyval.val) = NFT_RT_XFRM; }
#line 13962 "parser_bison.c"
    break;

  case 920: /* ct_expr: "ct" ct_key close_scope_ct  */
#line 5110 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[-1].val), -1);
			}
#line 13970 "parser_bison.c"
    break;

  case 921: /* ct_expr: "ct" ct_dir ct_key_dir close_scope_ct  */
#line 5114 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[-2].val));
			}
#line 13978 "parser_bison.c"
    break;

  case 922: /* ct_expr: "ct" ct_dir ct_key_proto_field close_scope_ct  */
#line 5118 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[-2].val));
			}
#line 13986 "parser_bison.c"
    break;

  case 923: /* ct_dir: "original"  */
#line 5123 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_ORIGINAL; }
#line 13992 "parser_bison.c"
    break;

  case 924: /* ct_dir: "reply"  */
#line 5124 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_REPLY; }
#line 13998 "parser_bison.c"
    break;

  case 925: /* ct_key: "l3proto"  */
#line 5127 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 14004 "parser_bison.c"
    break;

  case 926: /* ct_key: "protocol"  */
#line 5128 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 14010 "parser_bison.c"
    break;

  case 927: /* ct_key: "mark"  */
#line 5129 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_MARK; }
#line 14016 "parser_bison.c"
    break;

  case 928: /* ct_key: "state"  */
#line 5130 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATE; }
#line 14022 "parser_bison.c"
    break;

  case 929: /* ct_key: "direction"  */
#line 5131 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DIRECTION; }
#line 14028 "parser_bison.c"
    break;

  case 930: /* ct_key: "status"  */
#line 5132 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATUS; }
#line 14034 "parser_bison.c"
    break;

  case 931: /* ct_key: "expiration"  */
#line 5133 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EXPIRATION; }
#line 14040 "parser_bison.c"
    break;

  case 932: /* ct_key: "helper"  */
#line 5134 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_HELPER; }
#line 14046 "parser_bison.c"
    break;

  case 933: /* ct_key: "saddr"  */
#line 5135 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 14052 "parser_bison.c"
    break;

  case 934: /* ct_key: "daddr"  */
#line 5136 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 14058 "parser_bison.c"
    break;

  case 935: /* ct_key: "proto-src"  */
#line 5137 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 14064 "parser_bison.c"
    break;

  case 936: /* ct_key: "proto-dst"  */
#line 5138 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 14070 "parser_bison.c"
    break;

  case 937: /* ct_key: "label"  */
#line 5139 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_LABELS; }
#line 14076 "parser_bison.c"
    break;

  case 938: /* ct_key: "event"  */
#line 5140 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EVENTMASK; }
#line 14082 "parser_bison.c"
    break;

  case 939: /* ct_key: "secmark" close_scope_secmark  */
#line 5141 "parser_bison.y"
                                                            { (yyval.val) = NFT_CT_SECMARK; }
#line 14088 "parser_bison.c"
    break;

  case 940: /* ct_key: "id"  */
#line 5142 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ID; }
#line 14094 "parser_bison.c"
    break;

  case 942: /* ct_key_dir: "saddr"  */
#line 5146 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 14100 "parser_bison.c"
    break;

  case 943: /* ct_key_dir: "daddr"  */
#line 5147 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 14106 "parser_bison.c"
    break;

  case 944: /* ct_key_dir: "l3proto"  */
#line 5148 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 14112 "parser_bison.c"
    break;

  case 945: /* ct_key_dir: "protocol"  */
#line 5149 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 14118 "parser_bison.c"
    break;

  case 946: /* ct_key_dir: "proto-src"  */
#line 5150 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 14124 "parser_bison.c"
    break;

  case 947: /* ct_key_dir: "proto-dst"  */
#line 5151 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 14130 "parser_bison.c"
    break;

  case 949: /* ct_key_proto_field: "ip" "saddr" close_scope_ip  */
#line 5155 "parser_bison.y"
                                                               { (yyval.val) = NFT_CT_SRC_IP; }
#line 14136 "parser_bison.c"
    break;

  case 950: /* ct_key_proto_field: "ip" "daddr" close_scope_ip  */
#line 5156 "parser_bison.y"
                                                               { (yyval.val) = NFT_CT_DST_IP; }
#line 14142 "parser_bison.c"
    break;

  case 951: /* ct_key_proto_field: "ip6" "saddr" close_scope_ip6  */
#line 5157 "parser_bison.y"
                                                                { (yyval.val) = NFT_CT_SRC_IP6; }
#line 14148 "parser_bison.c"
    break;

  case 952: /* ct_key_proto_field: "ip6" "daddr" close_scope_ip6  */
#line 5158 "parser_bison.y"
                                                                { (yyval.val) = NFT_CT_DST_IP6; }
#line 14154 "parser_bison.c"
    break;

  case 953: /* ct_key_dir_optional: "bytes"  */
#line 5161 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_BYTES; }
#line 14160 "parser_bison.c"
    break;

  case 954: /* ct_key_dir_optional: "packets"  */
#line 5162 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PKTS; }
#line 14166 "parser_bison.c"
    break;

  case 955: /* ct_key_dir_optional: "avgpkt"  */
#line 5163 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_AVGPKT; }
#line 14172 "parser_bison.c"
    break;

  case 956: /* ct_key_dir_optional: "zone"  */
#line 5164 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ZONE; }
#line 14178 "parser_bison.c"
    break;

  case 959: /* list_stmt_expr: symbol_stmt_expr "comma" symbol_stmt_expr  */
#line 5172 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 14188 "parser_bison.c"
    break;

  case 960: /* list_stmt_expr: list_stmt_expr "comma" symbol_stmt_expr  */
#line 5178 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 14198 "parser_bison.c"
    break;

  case 961: /* ct_stmt: "ct" ct_key "set" stmt_expr close_scope_ct  */
#line 5186 "parser_bison.y"
                        {
				switch ((yyvsp[-3].val)) {
				case NFT_CT_HELPER:
					(yyval.stmt) = objref_stmt_alloc(&(yyloc));
					(yyval.stmt)->objref.type = NFT_OBJECT_CT_HELPER;
					(yyval.stmt)->objref.expr = (yyvsp[-1].expr);
					break;
				default:
					(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-3].val), -1, (yyvsp[-1].expr));
					break;
				}
			}
#line 14215 "parser_bison.c"
    break;

  case 962: /* ct_stmt: "ct" "timeout" "set" stmt_expr close_scope_ct  */
#line 5199 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_TIMEOUT;
				(yyval.stmt)->objref.expr = (yyvsp[-1].expr);

			}
#line 14226 "parser_bison.c"
    break;

  case 963: /* ct_stmt: "ct" "expectation" "set" stmt_expr close_scope_ct  */
#line 5206 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_EXPECT;
				(yyval.stmt)->objref.expr = (yyvsp[-1].expr);
			}
#line 14236 "parser_bison.c"
    break;

  case 964: /* ct_stmt: "ct" ct_dir ct_key_dir_optional "set" stmt_expr close_scope_ct  */
#line 5212 "parser_bison.y"
                        {
				(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-4].val), (yyvsp[-1].expr));
			}
#line 14244 "parser_bison.c"
    break;

  case 965: /* payload_stmt: payload_expr "set" stmt_expr  */
#line 5218 "parser_bison.y"
                        {
				if ((yyvsp[-2].expr)->etype == EXPR_EXTHDR)
					(yyval.stmt) = exthdr_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
				else
					(yyval.stmt) = payload_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 14255 "parser_bison.c"
    break;

  case 984: /* payload_raw_expr: "@" payload_base_spec "comma" "number" "comma" "number"  */
#line 5247 "parser_bison.y"
                        {
				if ((yyvsp[0].val) > NFT_MAX_EXPR_LEN_BITS) {
					erec_queue(error(&(yylsp[-5]), "raw payload length %u exceeds upper limit of %u",
							 (yyvsp[0].val), NFT_MAX_EXPR_LEN_BITS),
							 state->msgs);
					YYERROR;
				}

				(yyval.expr) = payload_expr_alloc(&(yyloc), NULL, 0);
				payload_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val));
				(yyval.expr)->byteorder		= BYTEORDER_BIG_ENDIAN;
				(yyval.expr)->payload.is_raw	= true;
			}
#line 14273 "parser_bison.c"
    break;

  case 985: /* payload_base_spec: "ll"  */
#line 5262 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_LL_HDR; }
#line 14279 "parser_bison.c"
    break;

  case 986: /* payload_base_spec: "nh"  */
#line 5263 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_NETWORK_HDR; }
#line 14285 "parser_bison.c"
    break;

  case 987: /* payload_base_spec: "th"  */
#line 5264 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_TRANSPORT_HDR; }
#line 14291 "parser_bison.c"
    break;

  case 988: /* eth_hdr_expr: "ether" eth_hdr_field close_scope_eth  */
#line 5268 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_eth, (yyvsp[-1].val));
			}
#line 14299 "parser_bison.c"
    break;

  case 989: /* eth_hdr_field: "saddr"  */
#line 5273 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_SADDR; }
#line 14305 "parser_bison.c"
    break;

  case 990: /* eth_hdr_field: "daddr"  */
#line 5274 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_DADDR; }
#line 14311 "parser_bison.c"
    break;

  case 991: /* eth_hdr_field: "type"  */
#line 5275 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_TYPE; }
#line 14317 "parser_bison.c"
    break;

  case 992: /* vlan_hdr_expr: "vlan" vlan_hdr_field close_scope_vlan  */
#line 5279 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_vlan, (yyvsp[-1].val));
			}
#line 14325 "parser_bison.c"
    break;

  case 993: /* vlan_hdr_field: "id"  */
#line 5284 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_VID; }
#line 14331 "parser_bison.c"
    break;

  case 994: /* vlan_hdr_field: "cfi"  */
#line 5285 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_CFI; }
#line 14337 "parser_bison.c"
    break;

  case 995: /* vlan_hdr_field: "dei"  */
#line 5286 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_DEI; }
#line 14343 "parser_bison.c"
    break;

  case 996: /* vlan_hdr_field: "pcp"  */
#line 5287 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_PCP; }
#line 14349 "parser_bison.c"
    break;

  case 997: /* vlan_hdr_field: "type"  */
#line 5288 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_TYPE; }
#line 14355 "parser_bison.c"
    break;

  case 998: /* arp_hdr_expr: "arp" arp_hdr_field close_scope_arp  */
#line 5292 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_arp, (yyvsp[-1].val));
			}
#line 14363 "parser_bison.c"
    break;

  case 999: /* arp_hdr_field: "htype"  */
#line 5297 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HRD; }
#line 14369 "parser_bison.c"
    break;

  case 1000: /* arp_hdr_field: "ptype"  */
#line 5298 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PRO; }
#line 14375 "parser_bison.c"
    break;

  case 1001: /* arp_hdr_field: "hlen"  */
#line 5299 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HLN; }
#line 14381 "parser_bison.c"
    break;

  case 1002: /* arp_hdr_field: "plen"  */
#line 5300 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PLN; }
#line 14387 "parser_bison.c"
    break;

  case 1003: /* arp_hdr_field: "operation"  */
#line 5301 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_OP; }
#line 14393 "parser_bison.c"
    break;

  case 1004: /* arp_hdr_field: "saddr" "ether" close_scope_eth  */
#line 5302 "parser_bison.y"
                                                                { (yyval.val) = ARPHDR_SADDR_ETHER; }
#line 14399 "parser_bison.c"
    break;

  case 1005: /* arp_hdr_field: "daddr" "ether" close_scope_eth  */
#line 5303 "parser_bison.y"
                                                                { (yyval.val) = ARPHDR_DADDR_ETHER; }
#line 14405 "parser_bison.c"
    break;

  case 1006: /* arp_hdr_field: "saddr" "ip" close_scope_ip  */
#line 5304 "parser_bison.y"
                                                                { (yyval.val) = ARPHDR_SADDR_IP; }
#line 14411 "parser_bison.c"
    break;

  case 1007: /* arp_hdr_field: "daddr" "ip" close_scope_ip  */
#line 5305 "parser_bison.y"
                                                                { (yyval.val) = ARPHDR_DADDR_IP; }
#line 14417 "parser_bison.c"
    break;

  case 1008: /* ip_hdr_expr: "ip" ip_hdr_field close_scope_ip  */
#line 5309 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip, (yyvsp[-1].val));
			}
#line 14425 "parser_bison.c"
    break;

  case 1009: /* ip_hdr_expr: "ip" "option" ip_option_type ip_option_field close_scope_ip  */
#line 5313 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-1].val), 0);
                               if (!(yyval.expr)) {
                                       erec_queue(error(&(yylsp[-4]), "unknown ip option type/field"), state->msgs);
                                       YYERROR;
                       }
			}
#line 14437 "parser_bison.c"
    break;

  case 1010: /* ip_hdr_expr: "ip" "option" ip_option_type close_scope_ip  */
#line 5321 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[-1].val), IPOPT_FIELD_TYPE, 0);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14446 "parser_bison.c"
    break;

  case 1011: /* ip_hdr_field: "version"  */
#line 5327 "parser_bison.y"
                                                { (yyval.val) = IPHDR_VERSION; }
#line 14452 "parser_bison.c"
    break;

  case 1012: /* ip_hdr_field: "hdrlength"  */
#line 5328 "parser_bison.y"
                                                { (yyval.val) = IPHDR_HDRLENGTH; }
#line 14458 "parser_bison.c"
    break;

  case 1013: /* ip_hdr_field: "dscp"  */
#line 5329 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DSCP; }
#line 14464 "parser_bison.c"
    break;

  case 1014: /* ip_hdr_field: "ecn"  */
#line 5330 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ECN; }
#line 14470 "parser_bison.c"
    break;

  case 1015: /* ip_hdr_field: "length"  */
#line 5331 "parser_bison.y"
                                                { (yyval.val) = IPHDR_LENGTH; }
#line 14476 "parser_bison.c"
    break;

  case 1016: /* ip_hdr_field: "id"  */
#line 5332 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ID; }
#line 14482 "parser_bison.c"
    break;

  case 1017: /* ip_hdr_field: "frag-off"  */
#line 5333 "parser_bison.y"
                                                { (yyval.val) = IPHDR_FRAG_OFF; }
#line 14488 "parser_bison.c"
    break;

  case 1018: /* ip_hdr_field: "ttl"  */
#line 5334 "parser_bison.y"
                                                { (yyval.val) = IPHDR_TTL; }
#line 14494 "parser_bison.c"
    break;

  case 1019: /* ip_hdr_field: "protocol"  */
#line 5335 "parser_bison.y"
                                                { (yyval.val) = IPHDR_PROTOCOL; }
#line 14500 "parser_bison.c"
    break;

  case 1020: /* ip_hdr_field: "checksum"  */
#line 5336 "parser_bison.y"
                                                { (yyval.val) = IPHDR_CHECKSUM; }
#line 14506 "parser_bison.c"
    break;

  case 1021: /* ip_hdr_field: "saddr"  */
#line 5337 "parser_bison.y"
                                                { (yyval.val) = IPHDR_SADDR; }
#line 14512 "parser_bison.c"
    break;

  case 1022: /* ip_hdr_field: "daddr"  */
#line 5338 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DADDR; }
#line 14518 "parser_bison.c"
    break;

  case 1023: /* ip_option_type: "lsrr"  */
#line 5341 "parser_bison.y"
                                                { (yyval.val) = IPOPT_LSRR; }
#line 14524 "parser_bison.c"
    break;

  case 1024: /* ip_option_type: "rr"  */
#line 5342 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RR; }
#line 14530 "parser_bison.c"
    break;

  case 1025: /* ip_option_type: "ssrr"  */
#line 5343 "parser_bison.y"
                                                { (yyval.val) = IPOPT_SSRR; }
#line 14536 "parser_bison.c"
    break;

  case 1026: /* ip_option_type: "ra"  */
#line 5344 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RA; }
#line 14542 "parser_bison.c"
    break;

  case 1027: /* ip_option_field: "type"  */
#line 5347 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_TYPE; }
#line 14548 "parser_bison.c"
    break;

  case 1028: /* ip_option_field: "length"  */
#line 5348 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_LENGTH; }
#line 14554 "parser_bison.c"
    break;

  case 1029: /* ip_option_field: "value"  */
#line 5349 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_VALUE; }
#line 14560 "parser_bison.c"
    break;

  case 1030: /* ip_option_field: "ptr"  */
#line 5350 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_PTR; }
#line 14566 "parser_bison.c"
    break;

  case 1031: /* ip_option_field: "addr"  */
#line 5351 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_ADDR_0; }
#line 14572 "parser_bison.c"
    break;

  case 1032: /* icmp_hdr_expr: "icmp" icmp_hdr_field  */
#line 5355 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp, (yyvsp[0].val));
			}
#line 14580 "parser_bison.c"
    break;

  case 1033: /* icmp_hdr_field: "type"  */
#line 5360 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_TYPE; }
#line 14586 "parser_bison.c"
    break;

  case 1034: /* icmp_hdr_field: "code"  */
#line 5361 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CODE; }
#line 14592 "parser_bison.c"
    break;

  case 1035: /* icmp_hdr_field: "checksum"  */
#line 5362 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CHECKSUM; }
#line 14598 "parser_bison.c"
    break;

  case 1036: /* icmp_hdr_field: "id"  */
#line 5363 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_ID; }
#line 14604 "parser_bison.c"
    break;

  case 1037: /* icmp_hdr_field: "seq"  */
#line 5364 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_SEQ; }
#line 14610 "parser_bison.c"
    break;

  case 1038: /* icmp_hdr_field: "gateway"  */
#line 5365 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_GATEWAY; }
#line 14616 "parser_bison.c"
    break;

  case 1039: /* icmp_hdr_field: "mtu"  */
#line 5366 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_MTU; }
#line 14622 "parser_bison.c"
    break;

  case 1040: /* igmp_hdr_expr: "igmp" igmp_hdr_field  */
#line 5370 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_igmp, (yyvsp[0].val));
			}
#line 14630 "parser_bison.c"
    break;

  case 1041: /* igmp_hdr_field: "type"  */
#line 5375 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_TYPE; }
#line 14636 "parser_bison.c"
    break;

  case 1042: /* igmp_hdr_field: "checksum"  */
#line 5376 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_CHECKSUM; }
#line 14642 "parser_bison.c"
    break;

  case 1043: /* igmp_hdr_field: "mrt"  */
#line 5377 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_MRT; }
#line 14648 "parser_bison.c"
    break;

  case 1044: /* igmp_hdr_field: "group"  */
#line 5378 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_GROUP; }
#line 14654 "parser_bison.c"
    break;

  case 1045: /* ip6_hdr_expr: "ip6" ip6_hdr_field close_scope_ip6  */
#line 5382 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip6, (yyvsp[-1].val));
			}
#line 14662 "parser_bison.c"
    break;

  case 1046: /* ip6_hdr_field: "version"  */
#line 5387 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_VERSION; }
#line 14668 "parser_bison.c"
    break;

  case 1047: /* ip6_hdr_field: "dscp"  */
#line 5388 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DSCP; }
#line 14674 "parser_bison.c"
    break;

  case 1048: /* ip6_hdr_field: "ecn"  */
#line 5389 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_ECN; }
#line 14680 "parser_bison.c"
    break;

  case 1049: /* ip6_hdr_field: "flowlabel"  */
#line 5390 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_FLOWLABEL; }
#line 14686 "parser_bison.c"
    break;

  case 1050: /* ip6_hdr_field: "length"  */
#line 5391 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_LENGTH; }
#line 14692 "parser_bison.c"
    break;

  case 1051: /* ip6_hdr_field: "nexthdr"  */
#line 5392 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_NEXTHDR; }
#line 14698 "parser_bison.c"
    break;

  case 1052: /* ip6_hdr_field: "hoplimit"  */
#line 5393 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_HOPLIMIT; }
#line 14704 "parser_bison.c"
    break;

  case 1053: /* ip6_hdr_field: "saddr"  */
#line 5394 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_SADDR; }
#line 14710 "parser_bison.c"
    break;

  case 1054: /* ip6_hdr_field: "daddr"  */
#line 5395 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DADDR; }
#line 14716 "parser_bison.c"
    break;

  case 1055: /* icmp6_hdr_expr: "icmpv6" icmp6_hdr_field  */
#line 5398 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp6, (yyvsp[0].val));
			}
#line 14724 "parser_bison.c"
    break;

  case 1056: /* icmp6_hdr_field: "type"  */
#line 5403 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_TYPE; }
#line 14730 "parser_bison.c"
    break;

  case 1057: /* icmp6_hdr_field: "code"  */
#line 5404 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CODE; }
#line 14736 "parser_bison.c"
    break;

  case 1058: /* icmp6_hdr_field: "checksum"  */
#line 5405 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CHECKSUM; }
#line 14742 "parser_bison.c"
    break;

  case 1059: /* icmp6_hdr_field: "param-problem"  */
#line 5406 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_PPTR; }
#line 14748 "parser_bison.c"
    break;

  case 1060: /* icmp6_hdr_field: "mtu"  */
#line 5407 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MTU; }
#line 14754 "parser_bison.c"
    break;

  case 1061: /* icmp6_hdr_field: "id"  */
#line 5408 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_ID; }
#line 14760 "parser_bison.c"
    break;

  case 1062: /* icmp6_hdr_field: "seq"  */
#line 5409 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_SEQ; }
#line 14766 "parser_bison.c"
    break;

  case 1063: /* icmp6_hdr_field: "max-delay"  */
#line 5410 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MAXDELAY; }
#line 14772 "parser_bison.c"
    break;

  case 1064: /* auth_hdr_expr: "ah" auth_hdr_field  */
#line 5414 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ah, (yyvsp[0].val));
			}
#line 14780 "parser_bison.c"
    break;

  case 1065: /* auth_hdr_field: "nexthdr"  */
#line 5419 "parser_bison.y"
                                                { (yyval.val) = AHHDR_NEXTHDR; }
#line 14786 "parser_bison.c"
    break;

  case 1066: /* auth_hdr_field: "hdrlength"  */
#line 5420 "parser_bison.y"
                                                { (yyval.val) = AHHDR_HDRLENGTH; }
#line 14792 "parser_bison.c"
    break;

  case 1067: /* auth_hdr_field: "reserved"  */
#line 5421 "parser_bison.y"
                                                { (yyval.val) = AHHDR_RESERVED; }
#line 14798 "parser_bison.c"
    break;

  case 1068: /* auth_hdr_field: "spi"  */
#line 5422 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SPI; }
#line 14804 "parser_bison.c"
    break;

  case 1069: /* auth_hdr_field: "seq"  */
#line 5423 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SEQUENCE; }
#line 14810 "parser_bison.c"
    break;

  case 1070: /* esp_hdr_expr: "esp" esp_hdr_field  */
#line 5427 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_esp, (yyvsp[0].val));
			}
#line 14818 "parser_bison.c"
    break;

  case 1071: /* esp_hdr_field: "spi"  */
#line 5432 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SPI; }
#line 14824 "parser_bison.c"
    break;

  case 1072: /* esp_hdr_field: "seq"  */
#line 5433 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SEQUENCE; }
#line 14830 "parser_bison.c"
    break;

  case 1073: /* comp_hdr_expr: "comp" comp_hdr_field  */
#line 5437 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_comp, (yyvsp[0].val));
			}
#line 14838 "parser_bison.c"
    break;

  case 1074: /* comp_hdr_field: "nexthdr"  */
#line 5442 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_NEXTHDR; }
#line 14844 "parser_bison.c"
    break;

  case 1075: /* comp_hdr_field: "flags"  */
#line 5443 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_FLAGS; }
#line 14850 "parser_bison.c"
    break;

  case 1076: /* comp_hdr_field: "cpi"  */
#line 5444 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_CPI; }
#line 14856 "parser_bison.c"
    break;

  case 1077: /* udp_hdr_expr: "udp" udp_hdr_field  */
#line 5448 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udp, (yyvsp[0].val));
			}
#line 14864 "parser_bison.c"
    break;

  case 1078: /* udp_hdr_field: "sport"  */
#line 5453 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14870 "parser_bison.c"
    break;

  case 1079: /* udp_hdr_field: "dport"  */
#line 5454 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14876 "parser_bison.c"
    break;

  case 1080: /* udp_hdr_field: "length"  */
#line 5455 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14882 "parser_bison.c"
    break;

  case 1081: /* udp_hdr_field: "checksum"  */
#line 5456 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14888 "parser_bison.c"
    break;

  case 1082: /* udplite_hdr_expr: "udplite" udplite_hdr_field  */
#line 5460 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udplite, (yyvsp[0].val));
			}
#line 14896 "parser_bison.c"
    break;

  case 1083: /* udplite_hdr_field: "sport"  */
#line 5465 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14902 "parser_bison.c"
    break;

  case 1084: /* udplite_hdr_field: "dport"  */
#line 5466 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14908 "parser_bison.c"
    break;

  case 1085: /* udplite_hdr_field: "csumcov"  */
#line 5467 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14914 "parser_bison.c"
    break;

  case 1086: /* udplite_hdr_field: "checksum"  */
#line 5468 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14920 "parser_bison.c"
    break;

  case 1087: /* tcp_hdr_expr: "tcp" tcp_hdr_field  */
#line 5472 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_tcp, (yyvsp[0].val));
			}
#line 14928 "parser_bison.c"
    break;

  case 1088: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type tcp_hdr_option_field  */
#line 5476 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 14936 "parser_bison.c"
    break;

  case 1089: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type  */
#line 5480 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[0].val), TCPOPT_COMMON_KIND);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14945 "parser_bison.c"
    break;

  case 1090: /* tcp_hdr_expr: "tcp" "option" "@" tcp_hdr_option_type "comma" "number" "comma" "number"  */
#line 5485 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-4].val), 0);
				tcpopt_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val), 0);
			}
#line 14954 "parser_bison.c"
    break;

  case 1091: /* tcp_hdr_field: "sport"  */
#line 5491 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SPORT; }
#line 14960 "parser_bison.c"
    break;

  case 1092: /* tcp_hdr_field: "dport"  */
#line 5492 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DPORT; }
#line 14966 "parser_bison.c"
    break;

  case 1093: /* tcp_hdr_field: "seq"  */
#line 5493 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SEQ; }
#line 14972 "parser_bison.c"
    break;

  case 1094: /* tcp_hdr_field: "ackseq"  */
#line 5494 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_ACKSEQ; }
#line 14978 "parser_bison.c"
    break;

  case 1095: /* tcp_hdr_field: "doff"  */
#line 5495 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DOFF; }
#line 14984 "parser_bison.c"
    break;

  case 1096: /* tcp_hdr_field: "reserved"  */
#line 5496 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_RESERVED; }
#line 14990 "parser_bison.c"
    break;

  case 1097: /* tcp_hdr_field: "flags"  */
#line 5497 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_FLAGS; }
#line 14996 "parser_bison.c"
    break;

  case 1098: /* tcp_hdr_field: "window"  */
#line 5498 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_WINDOW; }
#line 15002 "parser_bison.c"
    break;

  case 1099: /* tcp_hdr_field: "checksum"  */
#line 5499 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_CHECKSUM; }
#line 15008 "parser_bison.c"
    break;

  case 1100: /* tcp_hdr_field: "urgptr"  */
#line 5500 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_URGPTR; }
#line 15014 "parser_bison.c"
    break;

  case 1101: /* tcp_hdr_option_type: "eol"  */
#line 5503 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_EOL; }
#line 15020 "parser_bison.c"
    break;

  case 1102: /* tcp_hdr_option_type: "nop"  */
#line 5504 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_NOP; }
#line 15026 "parser_bison.c"
    break;

  case 1103: /* tcp_hdr_option_type: "mss"  */
#line 5505 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_MAXSEG; }
#line 15032 "parser_bison.c"
    break;

  case 1104: /* tcp_hdr_option_type: "window"  */
#line 5506 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_WINDOW; }
#line 15038 "parser_bison.c"
    break;

  case 1105: /* tcp_hdr_option_type: "sack-permitted"  */
#line 5507 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK_PERMITTED; }
#line 15044 "parser_bison.c"
    break;

  case 1106: /* tcp_hdr_option_type: "sack"  */
#line 5508 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 15050 "parser_bison.c"
    break;

  case 1107: /* tcp_hdr_option_type: "sack0"  */
#line 5509 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 15056 "parser_bison.c"
    break;

  case 1108: /* tcp_hdr_option_type: "sack1"  */
#line 5510 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK1; }
#line 15062 "parser_bison.c"
    break;

  case 1109: /* tcp_hdr_option_type: "sack2"  */
#line 5511 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK2; }
#line 15068 "parser_bison.c"
    break;

  case 1110: /* tcp_hdr_option_type: "sack3"  */
#line 5512 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK3; }
#line 15074 "parser_bison.c"
    break;

  case 1111: /* tcp_hdr_option_type: "echo"  */
#line 5513 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_ECHO; }
#line 15080 "parser_bison.c"
    break;

  case 1112: /* tcp_hdr_option_type: "timestamp"  */
#line 5514 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_TIMESTAMP; }
#line 15086 "parser_bison.c"
    break;

  case 1113: /* tcp_hdr_option_type: "number"  */
#line 5515 "parser_bison.y"
                                                {
				if ((yyvsp[0].val) > 255) {
					erec_queue(error(&(yylsp[0]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[0].val);
			}
#line 15098 "parser_bison.c"
    break;

  case 1114: /* tcp_hdr_option_field: "kind"  */
#line 5524 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_KIND; }
#line 15104 "parser_bison.c"
    break;

  case 1115: /* tcp_hdr_option_field: "length"  */
#line 5525 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_LENGTH; }
#line 15110 "parser_bison.c"
    break;

  case 1116: /* tcp_hdr_option_field: "size"  */
#line 5526 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_MAXSEG_SIZE; }
#line 15116 "parser_bison.c"
    break;

  case 1117: /* tcp_hdr_option_field: "count"  */
#line 5527 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_WINDOW_COUNT; }
#line 15122 "parser_bison.c"
    break;

  case 1118: /* tcp_hdr_option_field: "left"  */
#line 5528 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_LEFT; }
#line 15128 "parser_bison.c"
    break;

  case 1119: /* tcp_hdr_option_field: "right"  */
#line 5529 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_RIGHT; }
#line 15134 "parser_bison.c"
    break;

  case 1120: /* tcp_hdr_option_field: "tsval"  */
#line 5530 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSVAL; }
#line 15140 "parser_bison.c"
    break;

  case 1121: /* tcp_hdr_option_field: "tsecr"  */
#line 5531 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSECR; }
#line 15146 "parser_bison.c"
    break;

  case 1122: /* dccp_hdr_expr: "dccp" dccp_hdr_field  */
#line 5535 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_dccp, (yyvsp[0].val));
			}
#line 15154 "parser_bison.c"
    break;

  case 1123: /* dccp_hdr_field: "sport"  */
#line 5540 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_SPORT; }
#line 15160 "parser_bison.c"
    break;

  case 1124: /* dccp_hdr_field: "dport"  */
#line 5541 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_DPORT; }
#line 15166 "parser_bison.c"
    break;

  case 1125: /* dccp_hdr_field: "type"  */
#line 5542 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_TYPE; }
#line 15172 "parser_bison.c"
    break;

  case 1126: /* sctp_chunk_type: "data"  */
#line 5545 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_DATA; }
#line 15178 "parser_bison.c"
    break;

  case 1127: /* sctp_chunk_type: "init"  */
#line 5546 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_INIT; }
#line 15184 "parser_bison.c"
    break;

  case 1128: /* sctp_chunk_type: "init-ack"  */
#line 5547 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_INIT_ACK; }
#line 15190 "parser_bison.c"
    break;

  case 1129: /* sctp_chunk_type: "sack"  */
#line 5548 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SACK; }
#line 15196 "parser_bison.c"
    break;

  case 1130: /* sctp_chunk_type: "heartbeat"  */
#line 5549 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_HEARTBEAT; }
#line 15202 "parser_bison.c"
    break;

  case 1131: /* sctp_chunk_type: "heartbeat-ack"  */
#line 5550 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_HEARTBEAT_ACK; }
#line 15208 "parser_bison.c"
    break;

  case 1132: /* sctp_chunk_type: "abort"  */
#line 5551 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ABORT; }
#line 15214 "parser_bison.c"
    break;

  case 1133: /* sctp_chunk_type: "shutdown"  */
#line 5552 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN; }
#line 15220 "parser_bison.c"
    break;

  case 1134: /* sctp_chunk_type: "shutdown-ack"  */
#line 5553 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN_ACK; }
#line 15226 "parser_bison.c"
    break;

  case 1135: /* sctp_chunk_type: "error"  */
#line 5554 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ERROR; }
#line 15232 "parser_bison.c"
    break;

  case 1136: /* sctp_chunk_type: "cookie-echo"  */
#line 5555 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_COOKIE_ECHO; }
#line 15238 "parser_bison.c"
    break;

  case 1137: /* sctp_chunk_type: "cookie-ack"  */
#line 5556 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_COOKIE_ACK; }
#line 15244 "parser_bison.c"
    break;

  case 1138: /* sctp_chunk_type: "ecne"  */
#line 5557 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ECNE; }
#line 15250 "parser_bison.c"
    break;

  case 1139: /* sctp_chunk_type: "cwr"  */
#line 5558 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_CWR; }
#line 15256 "parser_bison.c"
    break;

  case 1140: /* sctp_chunk_type: "shutdown-complete"  */
#line 5559 "parser_bison.y"
                                                  { (yyval.val) = SCTP_CHUNK_TYPE_SHUTDOWN_COMPLETE; }
#line 15262 "parser_bison.c"
    break;

  case 1141: /* sctp_chunk_type: "asconf-ack"  */
#line 5560 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ASCONF_ACK; }
#line 15268 "parser_bison.c"
    break;

  case 1142: /* sctp_chunk_type: "forward-tsn"  */
#line 5561 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_FORWARD_TSN; }
#line 15274 "parser_bison.c"
    break;

  case 1143: /* sctp_chunk_type: "asconf"  */
#line 5562 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_TYPE_ASCONF; }
#line 15280 "parser_bison.c"
    break;

  case 1144: /* sctp_chunk_common_field: "type"  */
#line 5565 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_TYPE; }
#line 15286 "parser_bison.c"
    break;

  case 1145: /* sctp_chunk_common_field: "flags"  */
#line 5566 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_FLAGS; }
#line 15292 "parser_bison.c"
    break;

  case 1146: /* sctp_chunk_common_field: "length"  */
#line 5567 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_COMMON_LENGTH; }
#line 15298 "parser_bison.c"
    break;

  case 1147: /* sctp_chunk_data_field: "tsn"  */
#line 5570 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_TSN; }
#line 15304 "parser_bison.c"
    break;

  case 1148: /* sctp_chunk_data_field: "stream"  */
#line 5571 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_STREAM; }
#line 15310 "parser_bison.c"
    break;

  case 1149: /* sctp_chunk_data_field: "ssn"  */
#line 5572 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_SSN; }
#line 15316 "parser_bison.c"
    break;

  case 1150: /* sctp_chunk_data_field: "ppid"  */
#line 5573 "parser_bison.y"
                                        { (yyval.val) = SCTP_CHUNK_DATA_PPID; }
#line 15322 "parser_bison.c"
    break;

  case 1151: /* sctp_chunk_init_field: "init-tag"  */
#line 5576 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_TAG; }
#line 15328 "parser_bison.c"
    break;

  case 1152: /* sctp_chunk_init_field: "a-rwnd"  */
#line 5577 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_RWND; }
#line 15334 "parser_bison.c"
    break;

  case 1153: /* sctp_chunk_init_field: "num-outbound-streams"  */
#line 5578 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_OSTREAMS; }
#line 15340 "parser_bison.c"
    break;

  case 1154: /* sctp_chunk_init_field: "num-inbound-streams"  */
#line 5579 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_ISTREAMS; }
#line 15346 "parser_bison.c"
    break;

  case 1155: /* sctp_chunk_init_field: "initial-tsn"  */
#line 5580 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_INIT_TSN; }
#line 15352 "parser_bison.c"
    break;

  case 1156: /* sctp_chunk_sack_field: "cum-tsn-ack"  */
#line 5583 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_CTSN_ACK; }
#line 15358 "parser_bison.c"
    break;

  case 1157: /* sctp_chunk_sack_field: "a-rwnd"  */
#line 5584 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_RWND; }
#line 15364 "parser_bison.c"
    break;

  case 1158: /* sctp_chunk_sack_field: "num-gap-ack-blocks"  */
#line 5585 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_GACK_BLOCKS; }
#line 15370 "parser_bison.c"
    break;

  case 1159: /* sctp_chunk_sack_field: "num-dup-tsns"  */
#line 5586 "parser_bison.y"
                                                { (yyval.val) = SCTP_CHUNK_SACK_DUP_TSNS; }
#line 15376 "parser_bison.c"
    break;

  case 1160: /* sctp_chunk_alloc: sctp_chunk_type  */
#line 5590 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), (yyvsp[0].val), SCTP_CHUNK_COMMON_TYPE);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 15385 "parser_bison.c"
    break;

  case 1161: /* sctp_chunk_alloc: sctp_chunk_type sctp_chunk_common_field  */
#line 5595 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 15393 "parser_bison.c"
    break;

  case 1162: /* sctp_chunk_alloc: "data" sctp_chunk_data_field  */
#line 5599 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_DATA, (yyvsp[0].val));
			}
#line 15401 "parser_bison.c"
    break;

  case 1163: /* sctp_chunk_alloc: "init" sctp_chunk_init_field  */
#line 5603 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_INIT, (yyvsp[0].val));
			}
#line 15409 "parser_bison.c"
    break;

  case 1164: /* sctp_chunk_alloc: "init-ack" sctp_chunk_init_field  */
#line 5607 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_INIT_ACK, (yyvsp[0].val));
			}
#line 15417 "parser_bison.c"
    break;

  case 1165: /* sctp_chunk_alloc: "sack" sctp_chunk_sack_field  */
#line 5611 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_SACK, (yyvsp[0].val));
			}
#line 15425 "parser_bison.c"
    break;

  case 1166: /* sctp_chunk_alloc: "shutdown" "cum-tsn-ack"  */
#line 5615 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_SHUTDOWN,
							   SCTP_CHUNK_SHUTDOWN_CTSN_ACK);
			}
#line 15434 "parser_bison.c"
    break;

  case 1167: /* sctp_chunk_alloc: "ecne" "lowest-tsn"  */
#line 5620 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ECNE,
							   SCTP_CHUNK_ECNE_CWR_MIN_TSN);
			}
#line 15443 "parser_bison.c"
    break;

  case 1168: /* sctp_chunk_alloc: "cwr" "lowest-tsn"  */
#line 5625 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_CWR,
							   SCTP_CHUNK_ECNE_CWR_MIN_TSN);
			}
#line 15452 "parser_bison.c"
    break;

  case 1169: /* sctp_chunk_alloc: "asconf-ack" "seqno"  */
#line 5630 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ASCONF_ACK,
							   SCTP_CHUNK_ASCONF_SEQNO);
			}
#line 15461 "parser_bison.c"
    break;

  case 1170: /* sctp_chunk_alloc: "forward-tsn" "new-cum-tsn"  */
#line 5635 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_FORWARD_TSN,
							   SCTP_CHUNK_FORWARD_TSN_NCTSN);
			}
#line 15470 "parser_bison.c"
    break;

  case 1171: /* sctp_chunk_alloc: "asconf" "seqno"  */
#line 5640 "parser_bison.y"
                        {
				(yyval.expr) = sctp_chunk_expr_alloc(&(yyloc), SCTP_CHUNK_TYPE_ASCONF,
							   SCTP_CHUNK_ASCONF_SEQNO);
			}
#line 15479 "parser_bison.c"
    break;

  case 1172: /* sctp_hdr_expr: "sctp" sctp_hdr_field close_scope_sctp  */
#line 5647 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_sctp, (yyvsp[-1].val));
			}
#line 15487 "parser_bison.c"
    break;

  case 1173: /* sctp_hdr_expr: "sctp" "chunk" sctp_chunk_alloc close_scope_sctp_chunk close_scope_sctp  */
#line 5651 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 15495 "parser_bison.c"
    break;

  case 1174: /* sctp_hdr_field: "sport"  */
#line 5656 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_SPORT; }
#line 15501 "parser_bison.c"
    break;

  case 1175: /* sctp_hdr_field: "dport"  */
#line 5657 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_DPORT; }
#line 15507 "parser_bison.c"
    break;

  case 1176: /* sctp_hdr_field: "vtag"  */
#line 5658 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_VTAG; }
#line 15513 "parser_bison.c"
    break;

  case 1177: /* sctp_hdr_field: "checksum"  */
#line 5659 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_CHECKSUM; }
#line 15519 "parser_bison.c"
    break;

  case 1178: /* th_hdr_expr: "th" th_hdr_field  */
#line 5663 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_th, (yyvsp[0].val));
				if ((yyval.expr))
					(yyval.expr)->payload.is_raw = true;
			}
#line 15529 "parser_bison.c"
    break;

  case 1179: /* th_hdr_field: "sport"  */
#line 5670 "parser_bison.y"
                                                { (yyval.val) = THDR_SPORT; }
#line 15535 "parser_bison.c"
    break;

  case 1180: /* th_hdr_field: "dport"  */
#line 5671 "parser_bison.y"
                                                { (yyval.val) = THDR_DPORT; }
#line 15541 "parser_bison.c"
    break;

  case 1189: /* hbh_hdr_expr: "hbh" hbh_hdr_field  */
#line 5685 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_hbh, (yyvsp[0].val));
			}
#line 15549 "parser_bison.c"
    break;

  case 1190: /* hbh_hdr_field: "nexthdr"  */
#line 5690 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_NEXTHDR; }
#line 15555 "parser_bison.c"
    break;

  case 1191: /* hbh_hdr_field: "hdrlength"  */
#line 5691 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_HDRLENGTH; }
#line 15561 "parser_bison.c"
    break;

  case 1192: /* rt_hdr_expr: "rt" rt_hdr_field close_scope_rt  */
#line 5695 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt, (yyvsp[-1].val));
			}
#line 15569 "parser_bison.c"
    break;

  case 1193: /* rt_hdr_field: "nexthdr"  */
#line 5700 "parser_bison.y"
                                                { (yyval.val) = RTHDR_NEXTHDR; }
#line 15575 "parser_bison.c"
    break;

  case 1194: /* rt_hdr_field: "hdrlength"  */
#line 5701 "parser_bison.y"
                                                { (yyval.val) = RTHDR_HDRLENGTH; }
#line 15581 "parser_bison.c"
    break;

  case 1195: /* rt_hdr_field: "type"  */
#line 5702 "parser_bison.y"
                                                { (yyval.val) = RTHDR_TYPE; }
#line 15587 "parser_bison.c"
    break;

  case 1196: /* rt_hdr_field: "seg-left"  */
#line 5703 "parser_bison.y"
                                                { (yyval.val) = RTHDR_SEG_LEFT; }
#line 15593 "parser_bison.c"
    break;

  case 1197: /* rt0_hdr_expr: "rt0" rt0_hdr_field  */
#line 5707 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt0, (yyvsp[0].val));
			}
#line 15601 "parser_bison.c"
    break;

  case 1198: /* rt0_hdr_field: "addr" '[' "number" ']'  */
#line 5713 "parser_bison.y"
                        {
				(yyval.val) = RT0HDR_ADDR_1 + (yyvsp[-1].val) - 1;
			}
#line 15609 "parser_bison.c"
    break;

  case 1199: /* rt2_hdr_expr: "rt2" rt2_hdr_field  */
#line 5719 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt2, (yyvsp[0].val));
			}
#line 15617 "parser_bison.c"
    break;

  case 1200: /* rt2_hdr_field: "addr"  */
#line 5724 "parser_bison.y"
                                                { (yyval.val) = RT2HDR_ADDR; }
#line 15623 "parser_bison.c"
    break;

  case 1201: /* rt4_hdr_expr: "srh" rt4_hdr_field  */
#line 5728 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt4, (yyvsp[0].val));
			}
#line 15631 "parser_bison.c"
    break;

  case 1202: /* rt4_hdr_field: "last-entry"  */
#line 5733 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_LASTENT; }
#line 15637 "parser_bison.c"
    break;

  case 1203: /* rt4_hdr_field: "flags"  */
#line 5734 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_FLAGS; }
#line 15643 "parser_bison.c"
    break;

  case 1204: /* rt4_hdr_field: "tag"  */
#line 5735 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_TAG; }
#line 15649 "parser_bison.c"
    break;

  case 1205: /* rt4_hdr_field: "sid" '[' "number" ']'  */
#line 5737 "parser_bison.y"
                        {
				(yyval.val) = RT4HDR_SID_1 + (yyvsp[-1].val) - 1;
			}
#line 15657 "parser_bison.c"
    break;

  case 1206: /* frag_hdr_expr: "frag" frag_hdr_field  */
#line 5743 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_frag, (yyvsp[0].val));
			}
#line 15665 "parser_bison.c"
    break;

  case 1207: /* frag_hdr_field: "nexthdr"  */
#line 5748 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_NEXTHDR; }
#line 15671 "parser_bison.c"
    break;

  case 1208: /* frag_hdr_field: "reserved"  */
#line 5749 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED; }
#line 15677 "parser_bison.c"
    break;

  case 1209: /* frag_hdr_field: "frag-off"  */
#line 5750 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_FRAG_OFF; }
#line 15683 "parser_bison.c"
    break;

  case 1210: /* frag_hdr_field: "reserved2"  */
#line 5751 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED2; }
#line 15689 "parser_bison.c"
    break;

  case 1211: /* frag_hdr_field: "more-fragments"  */
#line 5752 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_MFRAGS; }
#line 15695 "parser_bison.c"
    break;

  case 1212: /* frag_hdr_field: "id"  */
#line 5753 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_ID; }
#line 15701 "parser_bison.c"
    break;

  case 1213: /* dst_hdr_expr: "dst" dst_hdr_field  */
#line 5757 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_dst, (yyvsp[0].val));
			}
#line 15709 "parser_bison.c"
    break;

  case 1214: /* dst_hdr_field: "nexthdr"  */
#line 5762 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_NEXTHDR; }
#line 15715 "parser_bison.c"
    break;

  case 1215: /* dst_hdr_field: "hdrlength"  */
#line 5763 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_HDRLENGTH; }
#line 15721 "parser_bison.c"
    break;

  case 1216: /* mh_hdr_expr: "mh" mh_hdr_field  */
#line 5767 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_mh, (yyvsp[0].val));
			}
#line 15729 "parser_bison.c"
    break;

  case 1217: /* mh_hdr_field: "nexthdr"  */
#line 5772 "parser_bison.y"
                                                { (yyval.val) = MHHDR_NEXTHDR; }
#line 15735 "parser_bison.c"
    break;

  case 1218: /* mh_hdr_field: "hdrlength"  */
#line 5773 "parser_bison.y"
                                                { (yyval.val) = MHHDR_HDRLENGTH; }
#line 15741 "parser_bison.c"
    break;

  case 1219: /* mh_hdr_field: "type"  */
#line 5774 "parser_bison.y"
                                                { (yyval.val) = MHHDR_TYPE; }
#line 15747 "parser_bison.c"
    break;

  case 1220: /* mh_hdr_field: "reserved"  */
#line 5775 "parser_bison.y"
                                                { (yyval.val) = MHHDR_RESERVED; }
#line 15753 "parser_bison.c"
    break;

  case 1221: /* mh_hdr_field: "checksum"  */
#line 5776 "parser_bison.y"
                                                { (yyval.val) = MHHDR_CHECKSUM; }
#line 15759 "parser_bison.c"
    break;

  case 1222: /* exthdr_exists_expr: "exthdr" exthdr_key  */
#line 5780 "parser_bison.y"
                        {
				const struct exthdr_desc *desc;

				desc = exthdr_find_proto((yyvsp[0].val));

				/* Assume that NEXTHDR template is always
				 * the fist one in list of templates.
				 */
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), desc, 1);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 15775 "parser_bison.c"
    break;

  case 1223: /* exthdr_key: "hbh"  */
#line 5793 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_HOPOPTS; }
#line 15781 "parser_bison.c"
    break;

  case 1224: /* exthdr_key: "rt" close_scope_rt  */
#line 5794 "parser_bison.y"
                                                        { (yyval.val) = IPPROTO_ROUTING; }
#line 15787 "parser_bison.c"
    break;

  case 1225: /* exthdr_key: "frag"  */
#line 5795 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_FRAGMENT; }
#line 15793 "parser_bison.c"
    break;

  case 1226: /* exthdr_key: "dst"  */
#line 5796 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_DSTOPTS; }
#line 15799 "parser_bison.c"
    break;

  case 1227: /* exthdr_key: "mh"  */
#line 5797 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_MH; }
#line 15805 "parser_bison.c"
    break;


#line 15809 "parser_bison.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, nft, scanner, state, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= TOKEN_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == TOKEN_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, nft, scanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, nft, scanner, state, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, nft, scanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 5800 "parser_bison.y"

